#ifndef _H_A5A70E733C067D4480BD9D1CBF28482C_ExecuteAction__H_
#define _H_A5A70E733C067D4480BD9D1CBF28482C_ExecuteAction__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_.h"


namespace plansys2_msgs
{
    namespace action
    {
        namespace dds_
        {
            struct  ExecuteAction_Goal_
            {
                struct _arguments__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _arguments__seq_uniq_ > _arguments__seq;
                typedef DDS_DCPSUStrSeq_var< _arguments__seq > _arguments__seq_var;
                typedef DDS_DCPSUStrSeq_out< _arguments__seq > _arguments__seq_out;
                ::DDS::String_mgr action_;
                _arguments__seq arguments_;
            };

            typedef DDS_DCPSStruct_var<ExecuteAction_Goal_> ExecuteAction_Goal__var;
            typedef DDS_DCPSStruct_out < ExecuteAction_Goal_> ExecuteAction_Goal__out;

            struct  ExecuteAction_SendGoal_Request_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_id_;
                ::plansys2_msgs::action::dds_::ExecuteAction_Goal_ goal_;
            };

            typedef DDS_DCPSStruct_var<ExecuteAction_SendGoal_Request_> ExecuteAction_SendGoal_Request__var;
            typedef DDS_DCPSStruct_out < ExecuteAction_SendGoal_Request_> ExecuteAction_SendGoal_Request__out;

            struct  ExecuteAction_SendGoal_Response_
            {
                ::DDS::Boolean accepted_;
                ::builtin_interfaces::msg::dds_::Time_ stamp_;
            };

            typedef DDS_DCPSStruct_var<ExecuteAction_SendGoal_Response_> ExecuteAction_SendGoal_Response__var;
            typedef ExecuteAction_SendGoal_Response_& ExecuteAction_SendGoal_Response__out;

            struct  Sample_ExecuteAction_SendGoal_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::action::dds_::ExecuteAction_SendGoal_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ExecuteAction_SendGoal_Request_> Sample_ExecuteAction_SendGoal_Request__var;
            typedef DDS_DCPSStruct_out < Sample_ExecuteAction_SendGoal_Request_> Sample_ExecuteAction_SendGoal_Request__out;

            struct  Sample_ExecuteAction_SendGoal_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::action::dds_::ExecuteAction_SendGoal_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ExecuteAction_SendGoal_Response_> Sample_ExecuteAction_SendGoal_Response__var;
            typedef Sample_ExecuteAction_SendGoal_Response_& Sample_ExecuteAction_SendGoal_Response__out;

            struct  ExecuteAction_Result_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<ExecuteAction_Result_> ExecuteAction_Result__var;
            typedef DDS_DCPSStruct_out < ExecuteAction_Result_> ExecuteAction_Result__out;

            struct  ExecuteAction_GetResult_Request_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_id_;
            };

            typedef DDS_DCPSStruct_var<ExecuteAction_GetResult_Request_> ExecuteAction_GetResult_Request__var;
            typedef ExecuteAction_GetResult_Request_& ExecuteAction_GetResult_Request__out;

            struct  ExecuteAction_GetResult_Response_
            {
                ::DDS::Octet status_;
                ::plansys2_msgs::action::dds_::ExecuteAction_Result_ result_;
            };

            typedef DDS_DCPSStruct_var<ExecuteAction_GetResult_Response_> ExecuteAction_GetResult_Response__var;
            typedef DDS_DCPSStruct_out < ExecuteAction_GetResult_Response_> ExecuteAction_GetResult_Response__out;

            struct  Sample_ExecuteAction_GetResult_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::action::dds_::ExecuteAction_GetResult_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ExecuteAction_GetResult_Request_> Sample_ExecuteAction_GetResult_Request__var;
            typedef Sample_ExecuteAction_GetResult_Request_& Sample_ExecuteAction_GetResult_Request__out;

            struct  Sample_ExecuteAction_GetResult_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::action::dds_::ExecuteAction_GetResult_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ExecuteAction_GetResult_Response_> Sample_ExecuteAction_GetResult_Response__var;
            typedef DDS_DCPSStruct_out < Sample_ExecuteAction_GetResult_Response_> Sample_ExecuteAction_GetResult_Response__out;

            struct  ExecuteAction_Feedback_
            {
                ::DDS::Float progress_;
            };

            typedef DDS_DCPSStruct_var<ExecuteAction_Feedback_> ExecuteAction_Feedback__var;
            typedef ExecuteAction_Feedback_& ExecuteAction_Feedback__out;

            struct  ExecuteAction_FeedbackMessage_
            {
                ::unique_identifier_msgs::msg::dds_::UUID_ goal_id_;
                ::plansys2_msgs::action::dds_::ExecuteAction_Feedback_ feedback_;
            };

            typedef DDS_DCPSStruct_var<ExecuteAction_FeedbackMessage_> ExecuteAction_FeedbackMessage__var;
            typedef ExecuteAction_FeedbackMessage_& ExecuteAction_FeedbackMessage__out;

        }

    }

}

#endif /* _H_A5A70E733C067D4480BD9D1CBF28482C_ExecuteAction__H_ */
