// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from plansys2_msgs:action/ExecuteAction.idl
// generated code does not contain a copyright notice
#include "plansys2_msgs/action/execute_action__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `action`
// Member `arguments`
#include "rosidl_generator_c/string_functions.h"

bool
plansys2_msgs__action__ExecuteAction_Goal__init(plansys2_msgs__action__ExecuteAction_Goal * msg)
{
  if (!msg) {
    return false;
  }
  // action
  if (!rosidl_generator_c__String__init(&msg->action)) {
    plansys2_msgs__action__ExecuteAction_Goal__fini(msg);
    return false;
  }
  // arguments
  if (!rosidl_generator_c__String__Sequence__init(&msg->arguments, 0)) {
    plansys2_msgs__action__ExecuteAction_Goal__fini(msg);
    return false;
  }
  return true;
}

void
plansys2_msgs__action__ExecuteAction_Goal__fini(plansys2_msgs__action__ExecuteAction_Goal * msg)
{
  if (!msg) {
    return;
  }
  // action
  rosidl_generator_c__String__fini(&msg->action);
  // arguments
  rosidl_generator_c__String__Sequence__fini(&msg->arguments);
}

plansys2_msgs__action__ExecuteAction_Goal *
plansys2_msgs__action__ExecuteAction_Goal__create()
{
  plansys2_msgs__action__ExecuteAction_Goal * msg = (plansys2_msgs__action__ExecuteAction_Goal *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_Goal));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(plansys2_msgs__action__ExecuteAction_Goal));
  bool success = plansys2_msgs__action__ExecuteAction_Goal__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
plansys2_msgs__action__ExecuteAction_Goal__destroy(plansys2_msgs__action__ExecuteAction_Goal * msg)
{
  if (msg) {
    plansys2_msgs__action__ExecuteAction_Goal__fini(msg);
  }
  free(msg);
}


bool
plansys2_msgs__action__ExecuteAction_Goal__Sequence__init(plansys2_msgs__action__ExecuteAction_Goal__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  plansys2_msgs__action__ExecuteAction_Goal * data = NULL;
  if (size) {
    data = (plansys2_msgs__action__ExecuteAction_Goal *)calloc(size, sizeof(plansys2_msgs__action__ExecuteAction_Goal));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = plansys2_msgs__action__ExecuteAction_Goal__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        plansys2_msgs__action__ExecuteAction_Goal__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
plansys2_msgs__action__ExecuteAction_Goal__Sequence__fini(plansys2_msgs__action__ExecuteAction_Goal__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      plansys2_msgs__action__ExecuteAction_Goal__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

plansys2_msgs__action__ExecuteAction_Goal__Sequence *
plansys2_msgs__action__ExecuteAction_Goal__Sequence__create(size_t size)
{
  plansys2_msgs__action__ExecuteAction_Goal__Sequence * array = (plansys2_msgs__action__ExecuteAction_Goal__Sequence *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_Goal__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = plansys2_msgs__action__ExecuteAction_Goal__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
plansys2_msgs__action__ExecuteAction_Goal__Sequence__destroy(plansys2_msgs__action__ExecuteAction_Goal__Sequence * array)
{
  if (array) {
    plansys2_msgs__action__ExecuteAction_Goal__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `error_info`
// already included above
// #include "rosidl_generator_c/string_functions.h"

bool
plansys2_msgs__action__ExecuteAction_Result__init(plansys2_msgs__action__ExecuteAction_Result * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // error_info
  if (!rosidl_generator_c__String__init(&msg->error_info)) {
    plansys2_msgs__action__ExecuteAction_Result__fini(msg);
    return false;
  }
  return true;
}

void
plansys2_msgs__action__ExecuteAction_Result__fini(plansys2_msgs__action__ExecuteAction_Result * msg)
{
  if (!msg) {
    return;
  }
  // success
  // error_info
  rosidl_generator_c__String__fini(&msg->error_info);
}

plansys2_msgs__action__ExecuteAction_Result *
plansys2_msgs__action__ExecuteAction_Result__create()
{
  plansys2_msgs__action__ExecuteAction_Result * msg = (plansys2_msgs__action__ExecuteAction_Result *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_Result));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(plansys2_msgs__action__ExecuteAction_Result));
  bool success = plansys2_msgs__action__ExecuteAction_Result__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
plansys2_msgs__action__ExecuteAction_Result__destroy(plansys2_msgs__action__ExecuteAction_Result * msg)
{
  if (msg) {
    plansys2_msgs__action__ExecuteAction_Result__fini(msg);
  }
  free(msg);
}


bool
plansys2_msgs__action__ExecuteAction_Result__Sequence__init(plansys2_msgs__action__ExecuteAction_Result__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  plansys2_msgs__action__ExecuteAction_Result * data = NULL;
  if (size) {
    data = (plansys2_msgs__action__ExecuteAction_Result *)calloc(size, sizeof(plansys2_msgs__action__ExecuteAction_Result));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = plansys2_msgs__action__ExecuteAction_Result__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        plansys2_msgs__action__ExecuteAction_Result__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
plansys2_msgs__action__ExecuteAction_Result__Sequence__fini(plansys2_msgs__action__ExecuteAction_Result__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      plansys2_msgs__action__ExecuteAction_Result__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

plansys2_msgs__action__ExecuteAction_Result__Sequence *
plansys2_msgs__action__ExecuteAction_Result__Sequence__create(size_t size)
{
  plansys2_msgs__action__ExecuteAction_Result__Sequence * array = (plansys2_msgs__action__ExecuteAction_Result__Sequence *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_Result__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = plansys2_msgs__action__ExecuteAction_Result__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
plansys2_msgs__action__ExecuteAction_Result__Sequence__destroy(plansys2_msgs__action__ExecuteAction_Result__Sequence * array)
{
  if (array) {
    plansys2_msgs__action__ExecuteAction_Result__Sequence__fini(array);
  }
  free(array);
}


bool
plansys2_msgs__action__ExecuteAction_Feedback__init(plansys2_msgs__action__ExecuteAction_Feedback * msg)
{
  if (!msg) {
    return false;
  }
  // progress
  return true;
}

void
plansys2_msgs__action__ExecuteAction_Feedback__fini(plansys2_msgs__action__ExecuteAction_Feedback * msg)
{
  if (!msg) {
    return;
  }
  // progress
}

plansys2_msgs__action__ExecuteAction_Feedback *
plansys2_msgs__action__ExecuteAction_Feedback__create()
{
  plansys2_msgs__action__ExecuteAction_Feedback * msg = (plansys2_msgs__action__ExecuteAction_Feedback *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_Feedback));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(plansys2_msgs__action__ExecuteAction_Feedback));
  bool success = plansys2_msgs__action__ExecuteAction_Feedback__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
plansys2_msgs__action__ExecuteAction_Feedback__destroy(plansys2_msgs__action__ExecuteAction_Feedback * msg)
{
  if (msg) {
    plansys2_msgs__action__ExecuteAction_Feedback__fini(msg);
  }
  free(msg);
}


bool
plansys2_msgs__action__ExecuteAction_Feedback__Sequence__init(plansys2_msgs__action__ExecuteAction_Feedback__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  plansys2_msgs__action__ExecuteAction_Feedback * data = NULL;
  if (size) {
    data = (plansys2_msgs__action__ExecuteAction_Feedback *)calloc(size, sizeof(plansys2_msgs__action__ExecuteAction_Feedback));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = plansys2_msgs__action__ExecuteAction_Feedback__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        plansys2_msgs__action__ExecuteAction_Feedback__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
plansys2_msgs__action__ExecuteAction_Feedback__Sequence__fini(plansys2_msgs__action__ExecuteAction_Feedback__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      plansys2_msgs__action__ExecuteAction_Feedback__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

plansys2_msgs__action__ExecuteAction_Feedback__Sequence *
plansys2_msgs__action__ExecuteAction_Feedback__Sequence__create(size_t size)
{
  plansys2_msgs__action__ExecuteAction_Feedback__Sequence * array = (plansys2_msgs__action__ExecuteAction_Feedback__Sequence *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_Feedback__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = plansys2_msgs__action__ExecuteAction_Feedback__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
plansys2_msgs__action__ExecuteAction_Feedback__Sequence__destroy(plansys2_msgs__action__ExecuteAction_Feedback__Sequence * array)
{
  if (array) {
    plansys2_msgs__action__ExecuteAction_Feedback__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `goal_id`
#include "unique_identifier_msgs/msg/uuid__functions.h"
// Member `goal`
// already included above
// #include "plansys2_msgs/action/execute_action__functions.h"

bool
plansys2_msgs__action__ExecuteAction_SendGoal_Request__init(plansys2_msgs__action__ExecuteAction_SendGoal_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    plansys2_msgs__action__ExecuteAction_SendGoal_Request__fini(msg);
    return false;
  }
  // goal
  if (!plansys2_msgs__action__ExecuteAction_Goal__init(&msg->goal)) {
    plansys2_msgs__action__ExecuteAction_SendGoal_Request__fini(msg);
    return false;
  }
  return true;
}

void
plansys2_msgs__action__ExecuteAction_SendGoal_Request__fini(plansys2_msgs__action__ExecuteAction_SendGoal_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // goal
  plansys2_msgs__action__ExecuteAction_Goal__fini(&msg->goal);
}

plansys2_msgs__action__ExecuteAction_SendGoal_Request *
plansys2_msgs__action__ExecuteAction_SendGoal_Request__create()
{
  plansys2_msgs__action__ExecuteAction_SendGoal_Request * msg = (plansys2_msgs__action__ExecuteAction_SendGoal_Request *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_SendGoal_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(plansys2_msgs__action__ExecuteAction_SendGoal_Request));
  bool success = plansys2_msgs__action__ExecuteAction_SendGoal_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
plansys2_msgs__action__ExecuteAction_SendGoal_Request__destroy(plansys2_msgs__action__ExecuteAction_SendGoal_Request * msg)
{
  if (msg) {
    plansys2_msgs__action__ExecuteAction_SendGoal_Request__fini(msg);
  }
  free(msg);
}


bool
plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence__init(plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  plansys2_msgs__action__ExecuteAction_SendGoal_Request * data = NULL;
  if (size) {
    data = (plansys2_msgs__action__ExecuteAction_SendGoal_Request *)calloc(size, sizeof(plansys2_msgs__action__ExecuteAction_SendGoal_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = plansys2_msgs__action__ExecuteAction_SendGoal_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        plansys2_msgs__action__ExecuteAction_SendGoal_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence__fini(plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      plansys2_msgs__action__ExecuteAction_SendGoal_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence *
plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence__create(size_t size)
{
  plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence * array = (plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence__destroy(plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence * array)
{
  if (array) {
    plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/time__functions.h"

bool
plansys2_msgs__action__ExecuteAction_SendGoal_Response__init(plansys2_msgs__action__ExecuteAction_SendGoal_Response * msg)
{
  if (!msg) {
    return false;
  }
  // accepted
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    plansys2_msgs__action__ExecuteAction_SendGoal_Response__fini(msg);
    return false;
  }
  return true;
}

void
plansys2_msgs__action__ExecuteAction_SendGoal_Response__fini(plansys2_msgs__action__ExecuteAction_SendGoal_Response * msg)
{
  if (!msg) {
    return;
  }
  // accepted
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
}

plansys2_msgs__action__ExecuteAction_SendGoal_Response *
plansys2_msgs__action__ExecuteAction_SendGoal_Response__create()
{
  plansys2_msgs__action__ExecuteAction_SendGoal_Response * msg = (plansys2_msgs__action__ExecuteAction_SendGoal_Response *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_SendGoal_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(plansys2_msgs__action__ExecuteAction_SendGoal_Response));
  bool success = plansys2_msgs__action__ExecuteAction_SendGoal_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
plansys2_msgs__action__ExecuteAction_SendGoal_Response__destroy(plansys2_msgs__action__ExecuteAction_SendGoal_Response * msg)
{
  if (msg) {
    plansys2_msgs__action__ExecuteAction_SendGoal_Response__fini(msg);
  }
  free(msg);
}


bool
plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence__init(plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  plansys2_msgs__action__ExecuteAction_SendGoal_Response * data = NULL;
  if (size) {
    data = (plansys2_msgs__action__ExecuteAction_SendGoal_Response *)calloc(size, sizeof(plansys2_msgs__action__ExecuteAction_SendGoal_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = plansys2_msgs__action__ExecuteAction_SendGoal_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        plansys2_msgs__action__ExecuteAction_SendGoal_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence__fini(plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      plansys2_msgs__action__ExecuteAction_SendGoal_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence *
plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence__create(size_t size)
{
  plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence * array = (plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence__destroy(plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence * array)
{
  if (array) {
    plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/uuid__functions.h"

bool
plansys2_msgs__action__ExecuteAction_GetResult_Request__init(plansys2_msgs__action__ExecuteAction_GetResult_Request * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    plansys2_msgs__action__ExecuteAction_GetResult_Request__fini(msg);
    return false;
  }
  return true;
}

void
plansys2_msgs__action__ExecuteAction_GetResult_Request__fini(plansys2_msgs__action__ExecuteAction_GetResult_Request * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
}

plansys2_msgs__action__ExecuteAction_GetResult_Request *
plansys2_msgs__action__ExecuteAction_GetResult_Request__create()
{
  plansys2_msgs__action__ExecuteAction_GetResult_Request * msg = (plansys2_msgs__action__ExecuteAction_GetResult_Request *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_GetResult_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(plansys2_msgs__action__ExecuteAction_GetResult_Request));
  bool success = plansys2_msgs__action__ExecuteAction_GetResult_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
plansys2_msgs__action__ExecuteAction_GetResult_Request__destroy(plansys2_msgs__action__ExecuteAction_GetResult_Request * msg)
{
  if (msg) {
    plansys2_msgs__action__ExecuteAction_GetResult_Request__fini(msg);
  }
  free(msg);
}


bool
plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence__init(plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  plansys2_msgs__action__ExecuteAction_GetResult_Request * data = NULL;
  if (size) {
    data = (plansys2_msgs__action__ExecuteAction_GetResult_Request *)calloc(size, sizeof(plansys2_msgs__action__ExecuteAction_GetResult_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = plansys2_msgs__action__ExecuteAction_GetResult_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        plansys2_msgs__action__ExecuteAction_GetResult_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence__fini(plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      plansys2_msgs__action__ExecuteAction_GetResult_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence *
plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence__create(size_t size)
{
  plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence * array = (plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence__destroy(plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence * array)
{
  if (array) {
    plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `result`
// already included above
// #include "plansys2_msgs/action/execute_action__functions.h"

bool
plansys2_msgs__action__ExecuteAction_GetResult_Response__init(plansys2_msgs__action__ExecuteAction_GetResult_Response * msg)
{
  if (!msg) {
    return false;
  }
  // status
  // result
  if (!plansys2_msgs__action__ExecuteAction_Result__init(&msg->result)) {
    plansys2_msgs__action__ExecuteAction_GetResult_Response__fini(msg);
    return false;
  }
  return true;
}

void
plansys2_msgs__action__ExecuteAction_GetResult_Response__fini(plansys2_msgs__action__ExecuteAction_GetResult_Response * msg)
{
  if (!msg) {
    return;
  }
  // status
  // result
  plansys2_msgs__action__ExecuteAction_Result__fini(&msg->result);
}

plansys2_msgs__action__ExecuteAction_GetResult_Response *
plansys2_msgs__action__ExecuteAction_GetResult_Response__create()
{
  plansys2_msgs__action__ExecuteAction_GetResult_Response * msg = (plansys2_msgs__action__ExecuteAction_GetResult_Response *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_GetResult_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(plansys2_msgs__action__ExecuteAction_GetResult_Response));
  bool success = plansys2_msgs__action__ExecuteAction_GetResult_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
plansys2_msgs__action__ExecuteAction_GetResult_Response__destroy(plansys2_msgs__action__ExecuteAction_GetResult_Response * msg)
{
  if (msg) {
    plansys2_msgs__action__ExecuteAction_GetResult_Response__fini(msg);
  }
  free(msg);
}


bool
plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence__init(plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  plansys2_msgs__action__ExecuteAction_GetResult_Response * data = NULL;
  if (size) {
    data = (plansys2_msgs__action__ExecuteAction_GetResult_Response *)calloc(size, sizeof(plansys2_msgs__action__ExecuteAction_GetResult_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = plansys2_msgs__action__ExecuteAction_GetResult_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        plansys2_msgs__action__ExecuteAction_GetResult_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence__fini(plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      plansys2_msgs__action__ExecuteAction_GetResult_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence *
plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence__create(size_t size)
{
  plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence * array = (plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence__destroy(plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence * array)
{
  if (array) {
    plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `goal_id`
// already included above
// #include "unique_identifier_msgs/msg/uuid__functions.h"
// Member `feedback`
// already included above
// #include "plansys2_msgs/action/execute_action__functions.h"

bool
plansys2_msgs__action__ExecuteAction_FeedbackMessage__init(plansys2_msgs__action__ExecuteAction_FeedbackMessage * msg)
{
  if (!msg) {
    return false;
  }
  // goal_id
  if (!unique_identifier_msgs__msg__UUID__init(&msg->goal_id)) {
    plansys2_msgs__action__ExecuteAction_FeedbackMessage__fini(msg);
    return false;
  }
  // feedback
  if (!plansys2_msgs__action__ExecuteAction_Feedback__init(&msg->feedback)) {
    plansys2_msgs__action__ExecuteAction_FeedbackMessage__fini(msg);
    return false;
  }
  return true;
}

void
plansys2_msgs__action__ExecuteAction_FeedbackMessage__fini(plansys2_msgs__action__ExecuteAction_FeedbackMessage * msg)
{
  if (!msg) {
    return;
  }
  // goal_id
  unique_identifier_msgs__msg__UUID__fini(&msg->goal_id);
  // feedback
  plansys2_msgs__action__ExecuteAction_Feedback__fini(&msg->feedback);
}

plansys2_msgs__action__ExecuteAction_FeedbackMessage *
plansys2_msgs__action__ExecuteAction_FeedbackMessage__create()
{
  plansys2_msgs__action__ExecuteAction_FeedbackMessage * msg = (plansys2_msgs__action__ExecuteAction_FeedbackMessage *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_FeedbackMessage));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(plansys2_msgs__action__ExecuteAction_FeedbackMessage));
  bool success = plansys2_msgs__action__ExecuteAction_FeedbackMessage__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
plansys2_msgs__action__ExecuteAction_FeedbackMessage__destroy(plansys2_msgs__action__ExecuteAction_FeedbackMessage * msg)
{
  if (msg) {
    plansys2_msgs__action__ExecuteAction_FeedbackMessage__fini(msg);
  }
  free(msg);
}


bool
plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence__init(plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  plansys2_msgs__action__ExecuteAction_FeedbackMessage * data = NULL;
  if (size) {
    data = (plansys2_msgs__action__ExecuteAction_FeedbackMessage *)calloc(size, sizeof(plansys2_msgs__action__ExecuteAction_FeedbackMessage));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = plansys2_msgs__action__ExecuteAction_FeedbackMessage__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        plansys2_msgs__action__ExecuteAction_FeedbackMessage__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence__fini(plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      plansys2_msgs__action__ExecuteAction_FeedbackMessage__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence *
plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence__create(size_t size)
{
  plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence * array = (plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence *)malloc(sizeof(plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence__destroy(plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence * array)
{
  if (array) {
    plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence__fini(array);
  }
  free(array);
}
