#ifndef _H_2B1C1C403874388C43FBA25AE1ED6D66_AddProblemInstance__H_
#define _H_2B1C1C403874388C43FBA25AE1ED6D66_AddProblemInstance__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  AddProblemInstance_Request_
            {
                ::DDS::String_mgr instance_;
                ::DDS::String_mgr type_;
            };

            typedef DDS_DCPSStruct_var<AddProblemInstance_Request_> AddProblemInstance_Request__var;
            typedef DDS_DCPSStruct_out < AddProblemInstance_Request_> AddProblemInstance_Request__out;

            struct  AddProblemInstance_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<AddProblemInstance_Response_> AddProblemInstance_Response__var;
            typedef DDS_DCPSStruct_out < AddProblemInstance_Response_> AddProblemInstance_Response__out;

            struct  Sample_AddProblemInstance_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::AddProblemInstance_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddProblemInstance_Request_> Sample_AddProblemInstance_Request__var;
            typedef DDS_DCPSStruct_out < Sample_AddProblemInstance_Request_> Sample_AddProblemInstance_Request__out;

            struct  Sample_AddProblemInstance_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::AddProblemInstance_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddProblemInstance_Response_> Sample_AddProblemInstance_Response__var;
            typedef DDS_DCPSStruct_out < Sample_AddProblemInstance_Response_> Sample_AddProblemInstance_Response__out;

        }

    }

}

#endif /* _H_2B1C1C403874388C43FBA25AE1ED6D66_AddProblemInstance__H_ */
