#ifndef _H_FA58509B0B3230F74FBD1F12092FB492_AddProblemPredicate_DCPS_H_
#define _H_FA58509B0B3230F74FBD1F12092FB492_AddProblemPredicate_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AddProblemPredicate_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class AddProblemPredicate_Request_TypeSupportInterface;

            typedef AddProblemPredicate_Request_TypeSupportInterface * AddProblemPredicate_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AddProblemPredicate_Request_TypeSupportInterface> AddProblemPredicate_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AddProblemPredicate_Request_TypeSupportInterface> AddProblemPredicate_Request_TypeSupportInterface_out;


            class AddProblemPredicate_Request_DataWriter;

            typedef AddProblemPredicate_Request_DataWriter * AddProblemPredicate_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AddProblemPredicate_Request_DataWriter> AddProblemPredicate_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < AddProblemPredicate_Request_DataWriter> AddProblemPredicate_Request_DataWriter_out;


            class AddProblemPredicate_Request_DataReader;

            typedef AddProblemPredicate_Request_DataReader * AddProblemPredicate_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AddProblemPredicate_Request_DataReader> AddProblemPredicate_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < AddProblemPredicate_Request_DataReader> AddProblemPredicate_Request_DataReader_out;


            class AddProblemPredicate_Request_DataReaderView;

            typedef AddProblemPredicate_Request_DataReaderView * AddProblemPredicate_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AddProblemPredicate_Request_DataReaderView> AddProblemPredicate_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AddProblemPredicate_Request_DataReaderView> AddProblemPredicate_Request_DataReaderView_out;

            struct AddProblemPredicate_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AddProblemPredicate_Request_, struct AddProblemPredicate_Request_Seq_uniq_> AddProblemPredicate_Request_Seq;
            typedef DDS_DCPSSequence_var < AddProblemPredicate_Request_Seq> AddProblemPredicate_Request_Seq_var;
            typedef DDS_DCPSSequence_out < AddProblemPredicate_Request_Seq> AddProblemPredicate_Request_Seq_out;

            class  AddProblemPredicate_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AddProblemPredicate_Request_TypeSupportInterface_ptr _ptr_type;
                typedef AddProblemPredicate_Request_TypeSupportInterface_var _var_type;

                static AddProblemPredicate_Request_TypeSupportInterface_ptr _duplicate (AddProblemPredicate_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemPredicate_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemPredicate_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AddProblemPredicate_Request_TypeSupportInterface () {};
                ~AddProblemPredicate_Request_TypeSupportInterface () {};
            private:
                AddProblemPredicate_Request_TypeSupportInterface (const AddProblemPredicate_Request_TypeSupportInterface &);
                AddProblemPredicate_Request_TypeSupportInterface & operator = (const AddProblemPredicate_Request_TypeSupportInterface &);
            };

            class  AddProblemPredicate_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AddProblemPredicate_Request_DataWriter_ptr _ptr_type;
                typedef AddProblemPredicate_Request_DataWriter_var _var_type;

                static AddProblemPredicate_Request_DataWriter_ptr _duplicate (AddProblemPredicate_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemPredicate_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemPredicate_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AddProblemPredicate_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AddProblemPredicate_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AddProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AddProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AddProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AddProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AddProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AddProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AddProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AddProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AddProblemPredicate_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemPredicate_Request_& instance_data) = 0;

            protected:
                AddProblemPredicate_Request_DataWriter () {};
                ~AddProblemPredicate_Request_DataWriter () {};
            private:
                AddProblemPredicate_Request_DataWriter (const AddProblemPredicate_Request_DataWriter &);
                AddProblemPredicate_Request_DataWriter & operator = (const AddProblemPredicate_Request_DataWriter &);
            };

            class  AddProblemPredicate_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AddProblemPredicate_Request_DataReader_ptr _ptr_type;
                typedef AddProblemPredicate_Request_DataReader_var _var_type;

                static AddProblemPredicate_Request_DataReader_ptr _duplicate (AddProblemPredicate_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemPredicate_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemPredicate_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddProblemPredicate_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemPredicate_Request_& instance) = 0;

            protected:
                AddProblemPredicate_Request_DataReader () {};
                ~AddProblemPredicate_Request_DataReader () {};
            private:
                AddProblemPredicate_Request_DataReader (const AddProblemPredicate_Request_DataReader &);
                AddProblemPredicate_Request_DataReader & operator = (const AddProblemPredicate_Request_DataReader &);
            };

            class  AddProblemPredicate_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AddProblemPredicate_Request_DataReaderView_ptr _ptr_type;
                typedef AddProblemPredicate_Request_DataReaderView_var _var_type;

                static AddProblemPredicate_Request_DataReaderView_ptr _duplicate (AddProblemPredicate_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemPredicate_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemPredicate_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddProblemPredicate_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemPredicate_Request_& instance) = 0;

            protected:
                AddProblemPredicate_Request_DataReaderView () {};
                ~AddProblemPredicate_Request_DataReaderView () {};
            private:
                AddProblemPredicate_Request_DataReaderView (const AddProblemPredicate_Request_DataReaderView &);
                AddProblemPredicate_Request_DataReaderView & operator = (const AddProblemPredicate_Request_DataReaderView &);
            };
            class AddProblemPredicate_Response_TypeSupportInterface;

            typedef AddProblemPredicate_Response_TypeSupportInterface * AddProblemPredicate_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AddProblemPredicate_Response_TypeSupportInterface> AddProblemPredicate_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AddProblemPredicate_Response_TypeSupportInterface> AddProblemPredicate_Response_TypeSupportInterface_out;


            class AddProblemPredicate_Response_DataWriter;

            typedef AddProblemPredicate_Response_DataWriter * AddProblemPredicate_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AddProblemPredicate_Response_DataWriter> AddProblemPredicate_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < AddProblemPredicate_Response_DataWriter> AddProblemPredicate_Response_DataWriter_out;


            class AddProblemPredicate_Response_DataReader;

            typedef AddProblemPredicate_Response_DataReader * AddProblemPredicate_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AddProblemPredicate_Response_DataReader> AddProblemPredicate_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < AddProblemPredicate_Response_DataReader> AddProblemPredicate_Response_DataReader_out;


            class AddProblemPredicate_Response_DataReaderView;

            typedef AddProblemPredicate_Response_DataReaderView * AddProblemPredicate_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AddProblemPredicate_Response_DataReaderView> AddProblemPredicate_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AddProblemPredicate_Response_DataReaderView> AddProblemPredicate_Response_DataReaderView_out;

            struct AddProblemPredicate_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AddProblemPredicate_Response_, struct AddProblemPredicate_Response_Seq_uniq_> AddProblemPredicate_Response_Seq;
            typedef DDS_DCPSSequence_var < AddProblemPredicate_Response_Seq> AddProblemPredicate_Response_Seq_var;
            typedef DDS_DCPSSequence_out < AddProblemPredicate_Response_Seq> AddProblemPredicate_Response_Seq_out;

            class  AddProblemPredicate_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AddProblemPredicate_Response_TypeSupportInterface_ptr _ptr_type;
                typedef AddProblemPredicate_Response_TypeSupportInterface_var _var_type;

                static AddProblemPredicate_Response_TypeSupportInterface_ptr _duplicate (AddProblemPredicate_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemPredicate_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemPredicate_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AddProblemPredicate_Response_TypeSupportInterface () {};
                ~AddProblemPredicate_Response_TypeSupportInterface () {};
            private:
                AddProblemPredicate_Response_TypeSupportInterface (const AddProblemPredicate_Response_TypeSupportInterface &);
                AddProblemPredicate_Response_TypeSupportInterface & operator = (const AddProblemPredicate_Response_TypeSupportInterface &);
            };

            class  AddProblemPredicate_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AddProblemPredicate_Response_DataWriter_ptr _ptr_type;
                typedef AddProblemPredicate_Response_DataWriter_var _var_type;

                static AddProblemPredicate_Response_DataWriter_ptr _duplicate (AddProblemPredicate_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemPredicate_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemPredicate_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AddProblemPredicate_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AddProblemPredicate_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AddProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AddProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AddProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AddProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AddProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AddProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AddProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AddProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AddProblemPredicate_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemPredicate_Response_& instance_data) = 0;

            protected:
                AddProblemPredicate_Response_DataWriter () {};
                ~AddProblemPredicate_Response_DataWriter () {};
            private:
                AddProblemPredicate_Response_DataWriter (const AddProblemPredicate_Response_DataWriter &);
                AddProblemPredicate_Response_DataWriter & operator = (const AddProblemPredicate_Response_DataWriter &);
            };

            class  AddProblemPredicate_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AddProblemPredicate_Response_DataReader_ptr _ptr_type;
                typedef AddProblemPredicate_Response_DataReader_var _var_type;

                static AddProblemPredicate_Response_DataReader_ptr _duplicate (AddProblemPredicate_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemPredicate_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemPredicate_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddProblemPredicate_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemPredicate_Response_& instance) = 0;

            protected:
                AddProblemPredicate_Response_DataReader () {};
                ~AddProblemPredicate_Response_DataReader () {};
            private:
                AddProblemPredicate_Response_DataReader (const AddProblemPredicate_Response_DataReader &);
                AddProblemPredicate_Response_DataReader & operator = (const AddProblemPredicate_Response_DataReader &);
            };

            class  AddProblemPredicate_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AddProblemPredicate_Response_DataReaderView_ptr _ptr_type;
                typedef AddProblemPredicate_Response_DataReaderView_var _var_type;

                static AddProblemPredicate_Response_DataReaderView_ptr _duplicate (AddProblemPredicate_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemPredicate_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemPredicate_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemPredicate_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddProblemPredicate_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemPredicate_Response_& instance) = 0;

            protected:
                AddProblemPredicate_Response_DataReaderView () {};
                ~AddProblemPredicate_Response_DataReaderView () {};
            private:
                AddProblemPredicate_Response_DataReaderView (const AddProblemPredicate_Response_DataReaderView &);
                AddProblemPredicate_Response_DataReaderView & operator = (const AddProblemPredicate_Response_DataReaderView &);
            };
            class Sample_AddProblemPredicate_Request_TypeSupportInterface;

            typedef Sample_AddProblemPredicate_Request_TypeSupportInterface * Sample_AddProblemPredicate_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemPredicate_Request_TypeSupportInterface> Sample_AddProblemPredicate_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemPredicate_Request_TypeSupportInterface> Sample_AddProblemPredicate_Request_TypeSupportInterface_out;


            class Sample_AddProblemPredicate_Request_DataWriter;

            typedef Sample_AddProblemPredicate_Request_DataWriter * Sample_AddProblemPredicate_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemPredicate_Request_DataWriter> Sample_AddProblemPredicate_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemPredicate_Request_DataWriter> Sample_AddProblemPredicate_Request_DataWriter_out;


            class Sample_AddProblemPredicate_Request_DataReader;

            typedef Sample_AddProblemPredicate_Request_DataReader * Sample_AddProblemPredicate_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemPredicate_Request_DataReader> Sample_AddProblemPredicate_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemPredicate_Request_DataReader> Sample_AddProblemPredicate_Request_DataReader_out;


            class Sample_AddProblemPredicate_Request_DataReaderView;

            typedef Sample_AddProblemPredicate_Request_DataReaderView * Sample_AddProblemPredicate_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemPredicate_Request_DataReaderView> Sample_AddProblemPredicate_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemPredicate_Request_DataReaderView> Sample_AddProblemPredicate_Request_DataReaderView_out;

            struct Sample_AddProblemPredicate_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AddProblemPredicate_Request_, struct Sample_AddProblemPredicate_Request_Seq_uniq_> Sample_AddProblemPredicate_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_AddProblemPredicate_Request_Seq> Sample_AddProblemPredicate_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AddProblemPredicate_Request_Seq> Sample_AddProblemPredicate_Request_Seq_out;

            class  Sample_AddProblemPredicate_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AddProblemPredicate_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AddProblemPredicate_Request_TypeSupportInterface_var _var_type;

                static Sample_AddProblemPredicate_Request_TypeSupportInterface_ptr _duplicate (Sample_AddProblemPredicate_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemPredicate_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemPredicate_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AddProblemPredicate_Request_TypeSupportInterface () {};
                ~Sample_AddProblemPredicate_Request_TypeSupportInterface () {};
            private:
                Sample_AddProblemPredicate_Request_TypeSupportInterface (const Sample_AddProblemPredicate_Request_TypeSupportInterface &);
                Sample_AddProblemPredicate_Request_TypeSupportInterface & operator = (const Sample_AddProblemPredicate_Request_TypeSupportInterface &);
            };

            class  Sample_AddProblemPredicate_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AddProblemPredicate_Request_DataWriter_ptr _ptr_type;
                typedef Sample_AddProblemPredicate_Request_DataWriter_var _var_type;

                static Sample_AddProblemPredicate_Request_DataWriter_ptr _duplicate (Sample_AddProblemPredicate_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemPredicate_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemPredicate_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AddProblemPredicate_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AddProblemPredicate_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AddProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AddProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AddProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AddProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AddProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AddProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AddProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AddProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemPredicate_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemPredicate_Request_& instance_data) = 0;

            protected:
                Sample_AddProblemPredicate_Request_DataWriter () {};
                ~Sample_AddProblemPredicate_Request_DataWriter () {};
            private:
                Sample_AddProblemPredicate_Request_DataWriter (const Sample_AddProblemPredicate_Request_DataWriter &);
                Sample_AddProblemPredicate_Request_DataWriter & operator = (const Sample_AddProblemPredicate_Request_DataWriter &);
            };

            class  Sample_AddProblemPredicate_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AddProblemPredicate_Request_DataReader_ptr _ptr_type;
                typedef Sample_AddProblemPredicate_Request_DataReader_var _var_type;

                static Sample_AddProblemPredicate_Request_DataReader_ptr _duplicate (Sample_AddProblemPredicate_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemPredicate_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemPredicate_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemPredicate_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemPredicate_Request_& instance) = 0;

            protected:
                Sample_AddProblemPredicate_Request_DataReader () {};
                ~Sample_AddProblemPredicate_Request_DataReader () {};
            private:
                Sample_AddProblemPredicate_Request_DataReader (const Sample_AddProblemPredicate_Request_DataReader &);
                Sample_AddProblemPredicate_Request_DataReader & operator = (const Sample_AddProblemPredicate_Request_DataReader &);
            };

            class  Sample_AddProblemPredicate_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AddProblemPredicate_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_AddProblemPredicate_Request_DataReaderView_var _var_type;

                static Sample_AddProblemPredicate_Request_DataReaderView_ptr _duplicate (Sample_AddProblemPredicate_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemPredicate_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemPredicate_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemPredicate_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemPredicate_Request_& instance) = 0;

            protected:
                Sample_AddProblemPredicate_Request_DataReaderView () {};
                ~Sample_AddProblemPredicate_Request_DataReaderView () {};
            private:
                Sample_AddProblemPredicate_Request_DataReaderView (const Sample_AddProblemPredicate_Request_DataReaderView &);
                Sample_AddProblemPredicate_Request_DataReaderView & operator = (const Sample_AddProblemPredicate_Request_DataReaderView &);
            };
            class Sample_AddProblemPredicate_Response_TypeSupportInterface;

            typedef Sample_AddProblemPredicate_Response_TypeSupportInterface * Sample_AddProblemPredicate_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemPredicate_Response_TypeSupportInterface> Sample_AddProblemPredicate_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemPredicate_Response_TypeSupportInterface> Sample_AddProblemPredicate_Response_TypeSupportInterface_out;


            class Sample_AddProblemPredicate_Response_DataWriter;

            typedef Sample_AddProblemPredicate_Response_DataWriter * Sample_AddProblemPredicate_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemPredicate_Response_DataWriter> Sample_AddProblemPredicate_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemPredicate_Response_DataWriter> Sample_AddProblemPredicate_Response_DataWriter_out;


            class Sample_AddProblemPredicate_Response_DataReader;

            typedef Sample_AddProblemPredicate_Response_DataReader * Sample_AddProblemPredicate_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemPredicate_Response_DataReader> Sample_AddProblemPredicate_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemPredicate_Response_DataReader> Sample_AddProblemPredicate_Response_DataReader_out;


            class Sample_AddProblemPredicate_Response_DataReaderView;

            typedef Sample_AddProblemPredicate_Response_DataReaderView * Sample_AddProblemPredicate_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemPredicate_Response_DataReaderView> Sample_AddProblemPredicate_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemPredicate_Response_DataReaderView> Sample_AddProblemPredicate_Response_DataReaderView_out;

            struct Sample_AddProblemPredicate_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AddProblemPredicate_Response_, struct Sample_AddProblemPredicate_Response_Seq_uniq_> Sample_AddProblemPredicate_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_AddProblemPredicate_Response_Seq> Sample_AddProblemPredicate_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AddProblemPredicate_Response_Seq> Sample_AddProblemPredicate_Response_Seq_out;

            class  Sample_AddProblemPredicate_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AddProblemPredicate_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AddProblemPredicate_Response_TypeSupportInterface_var _var_type;

                static Sample_AddProblemPredicate_Response_TypeSupportInterface_ptr _duplicate (Sample_AddProblemPredicate_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemPredicate_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemPredicate_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AddProblemPredicate_Response_TypeSupportInterface () {};
                ~Sample_AddProblemPredicate_Response_TypeSupportInterface () {};
            private:
                Sample_AddProblemPredicate_Response_TypeSupportInterface (const Sample_AddProblemPredicate_Response_TypeSupportInterface &);
                Sample_AddProblemPredicate_Response_TypeSupportInterface & operator = (const Sample_AddProblemPredicate_Response_TypeSupportInterface &);
            };

            class  Sample_AddProblemPredicate_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AddProblemPredicate_Response_DataWriter_ptr _ptr_type;
                typedef Sample_AddProblemPredicate_Response_DataWriter_var _var_type;

                static Sample_AddProblemPredicate_Response_DataWriter_ptr _duplicate (Sample_AddProblemPredicate_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemPredicate_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemPredicate_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AddProblemPredicate_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AddProblemPredicate_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AddProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AddProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AddProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AddProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AddProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AddProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AddProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AddProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemPredicate_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemPredicate_Response_& instance_data) = 0;

            protected:
                Sample_AddProblemPredicate_Response_DataWriter () {};
                ~Sample_AddProblemPredicate_Response_DataWriter () {};
            private:
                Sample_AddProblemPredicate_Response_DataWriter (const Sample_AddProblemPredicate_Response_DataWriter &);
                Sample_AddProblemPredicate_Response_DataWriter & operator = (const Sample_AddProblemPredicate_Response_DataWriter &);
            };

            class  Sample_AddProblemPredicate_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AddProblemPredicate_Response_DataReader_ptr _ptr_type;
                typedef Sample_AddProblemPredicate_Response_DataReader_var _var_type;

                static Sample_AddProblemPredicate_Response_DataReader_ptr _duplicate (Sample_AddProblemPredicate_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemPredicate_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemPredicate_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemPredicate_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemPredicate_Response_& instance) = 0;

            protected:
                Sample_AddProblemPredicate_Response_DataReader () {};
                ~Sample_AddProblemPredicate_Response_DataReader () {};
            private:
                Sample_AddProblemPredicate_Response_DataReader (const Sample_AddProblemPredicate_Response_DataReader &);
                Sample_AddProblemPredicate_Response_DataReader & operator = (const Sample_AddProblemPredicate_Response_DataReader &);
            };

            class  Sample_AddProblemPredicate_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AddProblemPredicate_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_AddProblemPredicate_Response_DataReaderView_var _var_type;

                static Sample_AddProblemPredicate_Response_DataReaderView_ptr _duplicate (Sample_AddProblemPredicate_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemPredicate_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemPredicate_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemPredicate_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemPredicate_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemPredicate_Response_& instance) = 0;

            protected:
                Sample_AddProblemPredicate_Response_DataReaderView () {};
                ~Sample_AddProblemPredicate_Response_DataReaderView () {};
            private:
                Sample_AddProblemPredicate_Response_DataReaderView (const Sample_AddProblemPredicate_Response_DataReaderView &);
                Sample_AddProblemPredicate_Response_DataReaderView & operator = (const Sample_AddProblemPredicate_Response_DataReaderView &);
            };
        }

    }

}

#endif
