#ifndef _H_A49BCC02C008EAC7F185A7F3F4695E4D_GetDomainActionDetails__H_
#define _H_A49BCC02C008EAC7F185A7F3F4695E4D_GetDomainActionDetails__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetDomainActionDetails_Request_
            {
                ::DDS::String_mgr action_;
            };

            typedef DDS_DCPSStruct_var<GetDomainActionDetails_Request_> GetDomainActionDetails_Request__var;
            typedef DDS_DCPSStruct_out < GetDomainActionDetails_Request_> GetDomainActionDetails_Request__out;

            struct  GetDomainActionDetails_Response_
            {
                struct _param_names__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _param_names__seq_uniq_ > _param_names__seq;
                typedef DDS_DCPSUStrSeq_var< _param_names__seq > _param_names__seq_var;
                typedef DDS_DCPSUStrSeq_out< _param_names__seq > _param_names__seq_out;
                struct _param_types__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _param_types__seq_uniq_ > _param_types__seq;
                typedef DDS_DCPSUStrSeq_var< _param_types__seq > _param_types__seq_var;
                typedef DDS_DCPSUStrSeq_out< _param_types__seq > _param_types__seq_out;
                ::DDS::String_mgr name_;
                _param_names__seq param_names_;
                _param_types__seq param_types_;
                ::DDS::String_mgr type_;
                ::DDS::String_mgr at_start_requirements_;
                ::DDS::String_mgr over_all_requirements_;
                ::DDS::String_mgr at_end_requirements_;
                ::DDS::String_mgr at_start_effects_;
                ::DDS::String_mgr at_end_effects_;
                ::DDS::Boolean success_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<GetDomainActionDetails_Response_> GetDomainActionDetails_Response__var;
            typedef DDS_DCPSStruct_out < GetDomainActionDetails_Response_> GetDomainActionDetails_Response__out;

            struct  Sample_GetDomainActionDetails_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetDomainActionDetails_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetDomainActionDetails_Request_> Sample_GetDomainActionDetails_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetDomainActionDetails_Request_> Sample_GetDomainActionDetails_Request__out;

            struct  Sample_GetDomainActionDetails_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetDomainActionDetails_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetDomainActionDetails_Response_> Sample_GetDomainActionDetails_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetDomainActionDetails_Response_> Sample_GetDomainActionDetails_Response__out;

        }

    }

}

#endif /* _H_A49BCC02C008EAC7F185A7F3F4695E4D_GetDomainActionDetails__H_ */
