#ifndef _H_A5B467F04A8C9A495A9176A275EAFD3B_GetDomainActions__H_
#define _H_A5B467F04A8C9A495A9176A275EAFD3B_GetDomainActions__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Empty_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetDomainActions_Request_
            {
                ::std_msgs::msg::dds_::Empty_ request_;
            };

            typedef DDS_DCPSStruct_var<GetDomainActions_Request_> GetDomainActions_Request__var;
            typedef GetDomainActions_Request_& GetDomainActions_Request__out;

            struct  GetDomainActions_Response_
            {
                struct _actions__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _actions__seq_uniq_ > _actions__seq;
                typedef DDS_DCPSUStrSeq_var< _actions__seq > _actions__seq_var;
                typedef DDS_DCPSUStrSeq_out< _actions__seq > _actions__seq_out;
                struct _type__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _type__seq_uniq_ > _type__seq;
                typedef DDS_DCPSUStrSeq_var< _type__seq > _type__seq_var;
                typedef DDS_DCPSUStrSeq_out< _type__seq > _type__seq_out;
                ::DDS::Boolean success_;
                _actions__seq actions_;
                _type__seq type_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<GetDomainActions_Response_> GetDomainActions_Response__var;
            typedef DDS_DCPSStruct_out < GetDomainActions_Response_> GetDomainActions_Response__out;

            struct  Sample_GetDomainActions_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetDomainActions_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetDomainActions_Request_> Sample_GetDomainActions_Request__var;
            typedef Sample_GetDomainActions_Request_& Sample_GetDomainActions_Request__out;

            struct  Sample_GetDomainActions_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetDomainActions_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetDomainActions_Response_> Sample_GetDomainActions_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetDomainActions_Response_> Sample_GetDomainActions_Response__out;

        }

    }

}

#endif /* _H_A5B467F04A8C9A495A9176A275EAFD3B_GetDomainActions__H_ */
