#ifndef _H_A5B467F04A8C9A495A9176A275EAFD3B_GetDomainActions_DCPS_H_
#define _H_A5B467F04A8C9A495A9176A275EAFD3B_GetDomainActions_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetDomainActions_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetDomainActions_Request_TypeSupportInterface;

            typedef GetDomainActions_Request_TypeSupportInterface * GetDomainActions_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActions_Request_TypeSupportInterface> GetDomainActions_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetDomainActions_Request_TypeSupportInterface> GetDomainActions_Request_TypeSupportInterface_out;


            class GetDomainActions_Request_DataWriter;

            typedef GetDomainActions_Request_DataWriter * GetDomainActions_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActions_Request_DataWriter> GetDomainActions_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetDomainActions_Request_DataWriter> GetDomainActions_Request_DataWriter_out;


            class GetDomainActions_Request_DataReader;

            typedef GetDomainActions_Request_DataReader * GetDomainActions_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActions_Request_DataReader> GetDomainActions_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetDomainActions_Request_DataReader> GetDomainActions_Request_DataReader_out;


            class GetDomainActions_Request_DataReaderView;

            typedef GetDomainActions_Request_DataReaderView * GetDomainActions_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActions_Request_DataReaderView> GetDomainActions_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetDomainActions_Request_DataReaderView> GetDomainActions_Request_DataReaderView_out;

            struct GetDomainActions_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetDomainActions_Request_, struct GetDomainActions_Request_Seq_uniq_> GetDomainActions_Request_Seq;
            typedef DDS_DCPSSequence_var < GetDomainActions_Request_Seq> GetDomainActions_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetDomainActions_Request_Seq> GetDomainActions_Request_Seq_out;

            class  GetDomainActions_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetDomainActions_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetDomainActions_Request_TypeSupportInterface_var _var_type;

                static GetDomainActions_Request_TypeSupportInterface_ptr _duplicate (GetDomainActions_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActions_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActions_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActions_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActions_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetDomainActions_Request_TypeSupportInterface () {};
                ~GetDomainActions_Request_TypeSupportInterface () {};
            private:
                GetDomainActions_Request_TypeSupportInterface (const GetDomainActions_Request_TypeSupportInterface &);
                GetDomainActions_Request_TypeSupportInterface & operator = (const GetDomainActions_Request_TypeSupportInterface &);
            };

            class  GetDomainActions_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetDomainActions_Request_DataWriter_ptr _ptr_type;
                typedef GetDomainActions_Request_DataWriter_var _var_type;

                static GetDomainActions_Request_DataWriter_ptr _duplicate (GetDomainActions_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActions_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActions_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActions_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActions_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetDomainActions_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetDomainActions_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetDomainActions_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetDomainActions_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetDomainActions_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetDomainActions_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetDomainActions_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetDomainActions_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetDomainActions_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetDomainActions_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetDomainActions_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainActions_Request_& instance_data) = 0;

            protected:
                GetDomainActions_Request_DataWriter () {};
                ~GetDomainActions_Request_DataWriter () {};
            private:
                GetDomainActions_Request_DataWriter (const GetDomainActions_Request_DataWriter &);
                GetDomainActions_Request_DataWriter & operator = (const GetDomainActions_Request_DataWriter &);
            };

            class  GetDomainActions_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetDomainActions_Request_DataReader_ptr _ptr_type;
                typedef GetDomainActions_Request_DataReader_var _var_type;

                static GetDomainActions_Request_DataReader_ptr _duplicate (GetDomainActions_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActions_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActions_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActions_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActions_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainActions_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainActions_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainActions_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainActions_Request_& instance) = 0;

            protected:
                GetDomainActions_Request_DataReader () {};
                ~GetDomainActions_Request_DataReader () {};
            private:
                GetDomainActions_Request_DataReader (const GetDomainActions_Request_DataReader &);
                GetDomainActions_Request_DataReader & operator = (const GetDomainActions_Request_DataReader &);
            };

            class  GetDomainActions_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetDomainActions_Request_DataReaderView_ptr _ptr_type;
                typedef GetDomainActions_Request_DataReaderView_var _var_type;

                static GetDomainActions_Request_DataReaderView_ptr _duplicate (GetDomainActions_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActions_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActions_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActions_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActions_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainActions_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainActions_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainActions_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainActions_Request_& instance) = 0;

            protected:
                GetDomainActions_Request_DataReaderView () {};
                ~GetDomainActions_Request_DataReaderView () {};
            private:
                GetDomainActions_Request_DataReaderView (const GetDomainActions_Request_DataReaderView &);
                GetDomainActions_Request_DataReaderView & operator = (const GetDomainActions_Request_DataReaderView &);
            };
            class GetDomainActions_Response_TypeSupportInterface;

            typedef GetDomainActions_Response_TypeSupportInterface * GetDomainActions_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActions_Response_TypeSupportInterface> GetDomainActions_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetDomainActions_Response_TypeSupportInterface> GetDomainActions_Response_TypeSupportInterface_out;


            class GetDomainActions_Response_DataWriter;

            typedef GetDomainActions_Response_DataWriter * GetDomainActions_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActions_Response_DataWriter> GetDomainActions_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetDomainActions_Response_DataWriter> GetDomainActions_Response_DataWriter_out;


            class GetDomainActions_Response_DataReader;

            typedef GetDomainActions_Response_DataReader * GetDomainActions_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActions_Response_DataReader> GetDomainActions_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetDomainActions_Response_DataReader> GetDomainActions_Response_DataReader_out;


            class GetDomainActions_Response_DataReaderView;

            typedef GetDomainActions_Response_DataReaderView * GetDomainActions_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActions_Response_DataReaderView> GetDomainActions_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetDomainActions_Response_DataReaderView> GetDomainActions_Response_DataReaderView_out;

            struct GetDomainActions_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetDomainActions_Response_, struct GetDomainActions_Response_Seq_uniq_> GetDomainActions_Response_Seq;
            typedef DDS_DCPSSequence_var < GetDomainActions_Response_Seq> GetDomainActions_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetDomainActions_Response_Seq> GetDomainActions_Response_Seq_out;

            class  GetDomainActions_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetDomainActions_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetDomainActions_Response_TypeSupportInterface_var _var_type;

                static GetDomainActions_Response_TypeSupportInterface_ptr _duplicate (GetDomainActions_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActions_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActions_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActions_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActions_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetDomainActions_Response_TypeSupportInterface () {};
                ~GetDomainActions_Response_TypeSupportInterface () {};
            private:
                GetDomainActions_Response_TypeSupportInterface (const GetDomainActions_Response_TypeSupportInterface &);
                GetDomainActions_Response_TypeSupportInterface & operator = (const GetDomainActions_Response_TypeSupportInterface &);
            };

            class  GetDomainActions_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetDomainActions_Response_DataWriter_ptr _ptr_type;
                typedef GetDomainActions_Response_DataWriter_var _var_type;

                static GetDomainActions_Response_DataWriter_ptr _duplicate (GetDomainActions_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActions_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActions_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActions_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActions_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetDomainActions_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetDomainActions_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetDomainActions_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetDomainActions_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetDomainActions_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetDomainActions_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetDomainActions_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetDomainActions_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetDomainActions_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetDomainActions_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetDomainActions_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainActions_Response_& instance_data) = 0;

            protected:
                GetDomainActions_Response_DataWriter () {};
                ~GetDomainActions_Response_DataWriter () {};
            private:
                GetDomainActions_Response_DataWriter (const GetDomainActions_Response_DataWriter &);
                GetDomainActions_Response_DataWriter & operator = (const GetDomainActions_Response_DataWriter &);
            };

            class  GetDomainActions_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetDomainActions_Response_DataReader_ptr _ptr_type;
                typedef GetDomainActions_Response_DataReader_var _var_type;

                static GetDomainActions_Response_DataReader_ptr _duplicate (GetDomainActions_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActions_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActions_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActions_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActions_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainActions_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainActions_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainActions_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainActions_Response_& instance) = 0;

            protected:
                GetDomainActions_Response_DataReader () {};
                ~GetDomainActions_Response_DataReader () {};
            private:
                GetDomainActions_Response_DataReader (const GetDomainActions_Response_DataReader &);
                GetDomainActions_Response_DataReader & operator = (const GetDomainActions_Response_DataReader &);
            };

            class  GetDomainActions_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetDomainActions_Response_DataReaderView_ptr _ptr_type;
                typedef GetDomainActions_Response_DataReaderView_var _var_type;

                static GetDomainActions_Response_DataReaderView_ptr _duplicate (GetDomainActions_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActions_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActions_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActions_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActions_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainActions_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainActions_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainActions_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainActions_Response_& instance) = 0;

            protected:
                GetDomainActions_Response_DataReaderView () {};
                ~GetDomainActions_Response_DataReaderView () {};
            private:
                GetDomainActions_Response_DataReaderView (const GetDomainActions_Response_DataReaderView &);
                GetDomainActions_Response_DataReaderView & operator = (const GetDomainActions_Response_DataReaderView &);
            };
            class Sample_GetDomainActions_Request_TypeSupportInterface;

            typedef Sample_GetDomainActions_Request_TypeSupportInterface * Sample_GetDomainActions_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActions_Request_TypeSupportInterface> Sample_GetDomainActions_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActions_Request_TypeSupportInterface> Sample_GetDomainActions_Request_TypeSupportInterface_out;


            class Sample_GetDomainActions_Request_DataWriter;

            typedef Sample_GetDomainActions_Request_DataWriter * Sample_GetDomainActions_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActions_Request_DataWriter> Sample_GetDomainActions_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActions_Request_DataWriter> Sample_GetDomainActions_Request_DataWriter_out;


            class Sample_GetDomainActions_Request_DataReader;

            typedef Sample_GetDomainActions_Request_DataReader * Sample_GetDomainActions_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActions_Request_DataReader> Sample_GetDomainActions_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActions_Request_DataReader> Sample_GetDomainActions_Request_DataReader_out;


            class Sample_GetDomainActions_Request_DataReaderView;

            typedef Sample_GetDomainActions_Request_DataReaderView * Sample_GetDomainActions_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActions_Request_DataReaderView> Sample_GetDomainActions_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActions_Request_DataReaderView> Sample_GetDomainActions_Request_DataReaderView_out;

            struct Sample_GetDomainActions_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetDomainActions_Request_, struct Sample_GetDomainActions_Request_Seq_uniq_> Sample_GetDomainActions_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetDomainActions_Request_Seq> Sample_GetDomainActions_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetDomainActions_Request_Seq> Sample_GetDomainActions_Request_Seq_out;

            class  Sample_GetDomainActions_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetDomainActions_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetDomainActions_Request_TypeSupportInterface_var _var_type;

                static Sample_GetDomainActions_Request_TypeSupportInterface_ptr _duplicate (Sample_GetDomainActions_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActions_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActions_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetDomainActions_Request_TypeSupportInterface () {};
                ~Sample_GetDomainActions_Request_TypeSupportInterface () {};
            private:
                Sample_GetDomainActions_Request_TypeSupportInterface (const Sample_GetDomainActions_Request_TypeSupportInterface &);
                Sample_GetDomainActions_Request_TypeSupportInterface & operator = (const Sample_GetDomainActions_Request_TypeSupportInterface &);
            };

            class  Sample_GetDomainActions_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetDomainActions_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetDomainActions_Request_DataWriter_var _var_type;

                static Sample_GetDomainActions_Request_DataWriter_ptr _duplicate (Sample_GetDomainActions_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActions_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActions_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetDomainActions_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetDomainActions_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetDomainActions_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetDomainActions_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetDomainActions_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetDomainActions_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetDomainActions_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetDomainActions_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetDomainActions_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetDomainActions_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainActions_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainActions_Request_& instance_data) = 0;

            protected:
                Sample_GetDomainActions_Request_DataWriter () {};
                ~Sample_GetDomainActions_Request_DataWriter () {};
            private:
                Sample_GetDomainActions_Request_DataWriter (const Sample_GetDomainActions_Request_DataWriter &);
                Sample_GetDomainActions_Request_DataWriter & operator = (const Sample_GetDomainActions_Request_DataWriter &);
            };

            class  Sample_GetDomainActions_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetDomainActions_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetDomainActions_Request_DataReader_var _var_type;

                static Sample_GetDomainActions_Request_DataReader_ptr _duplicate (Sample_GetDomainActions_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActions_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActions_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainActions_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainActions_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainActions_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainActions_Request_& instance) = 0;

            protected:
                Sample_GetDomainActions_Request_DataReader () {};
                ~Sample_GetDomainActions_Request_DataReader () {};
            private:
                Sample_GetDomainActions_Request_DataReader (const Sample_GetDomainActions_Request_DataReader &);
                Sample_GetDomainActions_Request_DataReader & operator = (const Sample_GetDomainActions_Request_DataReader &);
            };

            class  Sample_GetDomainActions_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetDomainActions_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetDomainActions_Request_DataReaderView_var _var_type;

                static Sample_GetDomainActions_Request_DataReaderView_ptr _duplicate (Sample_GetDomainActions_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActions_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActions_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainActions_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainActions_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainActions_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainActions_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainActions_Request_& instance) = 0;

            protected:
                Sample_GetDomainActions_Request_DataReaderView () {};
                ~Sample_GetDomainActions_Request_DataReaderView () {};
            private:
                Sample_GetDomainActions_Request_DataReaderView (const Sample_GetDomainActions_Request_DataReaderView &);
                Sample_GetDomainActions_Request_DataReaderView & operator = (const Sample_GetDomainActions_Request_DataReaderView &);
            };
            class Sample_GetDomainActions_Response_TypeSupportInterface;

            typedef Sample_GetDomainActions_Response_TypeSupportInterface * Sample_GetDomainActions_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActions_Response_TypeSupportInterface> Sample_GetDomainActions_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActions_Response_TypeSupportInterface> Sample_GetDomainActions_Response_TypeSupportInterface_out;


            class Sample_GetDomainActions_Response_DataWriter;

            typedef Sample_GetDomainActions_Response_DataWriter * Sample_GetDomainActions_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActions_Response_DataWriter> Sample_GetDomainActions_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActions_Response_DataWriter> Sample_GetDomainActions_Response_DataWriter_out;


            class Sample_GetDomainActions_Response_DataReader;

            typedef Sample_GetDomainActions_Response_DataReader * Sample_GetDomainActions_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActions_Response_DataReader> Sample_GetDomainActions_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActions_Response_DataReader> Sample_GetDomainActions_Response_DataReader_out;


            class Sample_GetDomainActions_Response_DataReaderView;

            typedef Sample_GetDomainActions_Response_DataReaderView * Sample_GetDomainActions_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActions_Response_DataReaderView> Sample_GetDomainActions_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActions_Response_DataReaderView> Sample_GetDomainActions_Response_DataReaderView_out;

            struct Sample_GetDomainActions_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetDomainActions_Response_, struct Sample_GetDomainActions_Response_Seq_uniq_> Sample_GetDomainActions_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetDomainActions_Response_Seq> Sample_GetDomainActions_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetDomainActions_Response_Seq> Sample_GetDomainActions_Response_Seq_out;

            class  Sample_GetDomainActions_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetDomainActions_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetDomainActions_Response_TypeSupportInterface_var _var_type;

                static Sample_GetDomainActions_Response_TypeSupportInterface_ptr _duplicate (Sample_GetDomainActions_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActions_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActions_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetDomainActions_Response_TypeSupportInterface () {};
                ~Sample_GetDomainActions_Response_TypeSupportInterface () {};
            private:
                Sample_GetDomainActions_Response_TypeSupportInterface (const Sample_GetDomainActions_Response_TypeSupportInterface &);
                Sample_GetDomainActions_Response_TypeSupportInterface & operator = (const Sample_GetDomainActions_Response_TypeSupportInterface &);
            };

            class  Sample_GetDomainActions_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetDomainActions_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetDomainActions_Response_DataWriter_var _var_type;

                static Sample_GetDomainActions_Response_DataWriter_ptr _duplicate (Sample_GetDomainActions_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActions_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActions_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetDomainActions_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetDomainActions_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetDomainActions_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetDomainActions_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetDomainActions_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetDomainActions_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetDomainActions_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetDomainActions_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetDomainActions_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetDomainActions_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainActions_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainActions_Response_& instance_data) = 0;

            protected:
                Sample_GetDomainActions_Response_DataWriter () {};
                ~Sample_GetDomainActions_Response_DataWriter () {};
            private:
                Sample_GetDomainActions_Response_DataWriter (const Sample_GetDomainActions_Response_DataWriter &);
                Sample_GetDomainActions_Response_DataWriter & operator = (const Sample_GetDomainActions_Response_DataWriter &);
            };

            class  Sample_GetDomainActions_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetDomainActions_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetDomainActions_Response_DataReader_var _var_type;

                static Sample_GetDomainActions_Response_DataReader_ptr _duplicate (Sample_GetDomainActions_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActions_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActions_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainActions_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainActions_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainActions_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainActions_Response_& instance) = 0;

            protected:
                Sample_GetDomainActions_Response_DataReader () {};
                ~Sample_GetDomainActions_Response_DataReader () {};
            private:
                Sample_GetDomainActions_Response_DataReader (const Sample_GetDomainActions_Response_DataReader &);
                Sample_GetDomainActions_Response_DataReader & operator = (const Sample_GetDomainActions_Response_DataReader &);
            };

            class  Sample_GetDomainActions_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetDomainActions_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetDomainActions_Response_DataReaderView_var _var_type;

                static Sample_GetDomainActions_Response_DataReaderView_ptr _duplicate (Sample_GetDomainActions_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActions_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActions_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActions_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainActions_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainActions_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainActions_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainActions_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainActions_Response_& instance) = 0;

            protected:
                Sample_GetDomainActions_Response_DataReaderView () {};
                ~Sample_GetDomainActions_Response_DataReaderView () {};
            private:
                Sample_GetDomainActions_Response_DataReaderView (const Sample_GetDomainActions_Response_DataReaderView &);
                Sample_GetDomainActions_Response_DataReaderView & operator = (const Sample_GetDomainActions_Response_DataReaderView &);
            };
        }

    }

}

#endif
