#ifndef _H_CAA7C433042EF734A86E829096744235_GetDomainPredicateDetails_DCPS_H_
#define _H_CAA7C433042EF734A86E829096744235_GetDomainPredicateDetails_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetDomainPredicateDetails_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetDomainPredicateDetails_Request_TypeSupportInterface;

            typedef GetDomainPredicateDetails_Request_TypeSupportInterface * GetDomainPredicateDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicateDetails_Request_TypeSupportInterface> GetDomainPredicateDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicateDetails_Request_TypeSupportInterface> GetDomainPredicateDetails_Request_TypeSupportInterface_out;


            class GetDomainPredicateDetails_Request_DataWriter;

            typedef GetDomainPredicateDetails_Request_DataWriter * GetDomainPredicateDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicateDetails_Request_DataWriter> GetDomainPredicateDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicateDetails_Request_DataWriter> GetDomainPredicateDetails_Request_DataWriter_out;


            class GetDomainPredicateDetails_Request_DataReader;

            typedef GetDomainPredicateDetails_Request_DataReader * GetDomainPredicateDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicateDetails_Request_DataReader> GetDomainPredicateDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicateDetails_Request_DataReader> GetDomainPredicateDetails_Request_DataReader_out;


            class GetDomainPredicateDetails_Request_DataReaderView;

            typedef GetDomainPredicateDetails_Request_DataReaderView * GetDomainPredicateDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicateDetails_Request_DataReaderView> GetDomainPredicateDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicateDetails_Request_DataReaderView> GetDomainPredicateDetails_Request_DataReaderView_out;

            struct GetDomainPredicateDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetDomainPredicateDetails_Request_, struct GetDomainPredicateDetails_Request_Seq_uniq_> GetDomainPredicateDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < GetDomainPredicateDetails_Request_Seq> GetDomainPredicateDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetDomainPredicateDetails_Request_Seq> GetDomainPredicateDetails_Request_Seq_out;

            class  GetDomainPredicateDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetDomainPredicateDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetDomainPredicateDetails_Request_TypeSupportInterface_var _var_type;

                static GetDomainPredicateDetails_Request_TypeSupportInterface_ptr _duplicate (GetDomainPredicateDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicateDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicateDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetDomainPredicateDetails_Request_TypeSupportInterface () {};
                ~GetDomainPredicateDetails_Request_TypeSupportInterface () {};
            private:
                GetDomainPredicateDetails_Request_TypeSupportInterface (const GetDomainPredicateDetails_Request_TypeSupportInterface &);
                GetDomainPredicateDetails_Request_TypeSupportInterface & operator = (const GetDomainPredicateDetails_Request_TypeSupportInterface &);
            };

            class  GetDomainPredicateDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetDomainPredicateDetails_Request_DataWriter_ptr _ptr_type;
                typedef GetDomainPredicateDetails_Request_DataWriter_var _var_type;

                static GetDomainPredicateDetails_Request_DataWriter_ptr _duplicate (GetDomainPredicateDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicateDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicateDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetDomainPredicateDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetDomainPredicateDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetDomainPredicateDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainPredicateDetails_Request_& instance_data) = 0;

            protected:
                GetDomainPredicateDetails_Request_DataWriter () {};
                ~GetDomainPredicateDetails_Request_DataWriter () {};
            private:
                GetDomainPredicateDetails_Request_DataWriter (const GetDomainPredicateDetails_Request_DataWriter &);
                GetDomainPredicateDetails_Request_DataWriter & operator = (const GetDomainPredicateDetails_Request_DataWriter &);
            };

            class  GetDomainPredicateDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetDomainPredicateDetails_Request_DataReader_ptr _ptr_type;
                typedef GetDomainPredicateDetails_Request_DataReader_var _var_type;

                static GetDomainPredicateDetails_Request_DataReader_ptr _duplicate (GetDomainPredicateDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicateDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicateDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainPredicateDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainPredicateDetails_Request_& instance) = 0;

            protected:
                GetDomainPredicateDetails_Request_DataReader () {};
                ~GetDomainPredicateDetails_Request_DataReader () {};
            private:
                GetDomainPredicateDetails_Request_DataReader (const GetDomainPredicateDetails_Request_DataReader &);
                GetDomainPredicateDetails_Request_DataReader & operator = (const GetDomainPredicateDetails_Request_DataReader &);
            };

            class  GetDomainPredicateDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetDomainPredicateDetails_Request_DataReaderView_ptr _ptr_type;
                typedef GetDomainPredicateDetails_Request_DataReaderView_var _var_type;

                static GetDomainPredicateDetails_Request_DataReaderView_ptr _duplicate (GetDomainPredicateDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicateDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicateDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainPredicateDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainPredicateDetails_Request_& instance) = 0;

            protected:
                GetDomainPredicateDetails_Request_DataReaderView () {};
                ~GetDomainPredicateDetails_Request_DataReaderView () {};
            private:
                GetDomainPredicateDetails_Request_DataReaderView (const GetDomainPredicateDetails_Request_DataReaderView &);
                GetDomainPredicateDetails_Request_DataReaderView & operator = (const GetDomainPredicateDetails_Request_DataReaderView &);
            };
            class GetDomainPredicateDetails_Response_TypeSupportInterface;

            typedef GetDomainPredicateDetails_Response_TypeSupportInterface * GetDomainPredicateDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicateDetails_Response_TypeSupportInterface> GetDomainPredicateDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicateDetails_Response_TypeSupportInterface> GetDomainPredicateDetails_Response_TypeSupportInterface_out;


            class GetDomainPredicateDetails_Response_DataWriter;

            typedef GetDomainPredicateDetails_Response_DataWriter * GetDomainPredicateDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicateDetails_Response_DataWriter> GetDomainPredicateDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicateDetails_Response_DataWriter> GetDomainPredicateDetails_Response_DataWriter_out;


            class GetDomainPredicateDetails_Response_DataReader;

            typedef GetDomainPredicateDetails_Response_DataReader * GetDomainPredicateDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicateDetails_Response_DataReader> GetDomainPredicateDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicateDetails_Response_DataReader> GetDomainPredicateDetails_Response_DataReader_out;


            class GetDomainPredicateDetails_Response_DataReaderView;

            typedef GetDomainPredicateDetails_Response_DataReaderView * GetDomainPredicateDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicateDetails_Response_DataReaderView> GetDomainPredicateDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicateDetails_Response_DataReaderView> GetDomainPredicateDetails_Response_DataReaderView_out;

            struct GetDomainPredicateDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetDomainPredicateDetails_Response_, struct GetDomainPredicateDetails_Response_Seq_uniq_> GetDomainPredicateDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < GetDomainPredicateDetails_Response_Seq> GetDomainPredicateDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetDomainPredicateDetails_Response_Seq> GetDomainPredicateDetails_Response_Seq_out;

            class  GetDomainPredicateDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetDomainPredicateDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetDomainPredicateDetails_Response_TypeSupportInterface_var _var_type;

                static GetDomainPredicateDetails_Response_TypeSupportInterface_ptr _duplicate (GetDomainPredicateDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicateDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicateDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetDomainPredicateDetails_Response_TypeSupportInterface () {};
                ~GetDomainPredicateDetails_Response_TypeSupportInterface () {};
            private:
                GetDomainPredicateDetails_Response_TypeSupportInterface (const GetDomainPredicateDetails_Response_TypeSupportInterface &);
                GetDomainPredicateDetails_Response_TypeSupportInterface & operator = (const GetDomainPredicateDetails_Response_TypeSupportInterface &);
            };

            class  GetDomainPredicateDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetDomainPredicateDetails_Response_DataWriter_ptr _ptr_type;
                typedef GetDomainPredicateDetails_Response_DataWriter_var _var_type;

                static GetDomainPredicateDetails_Response_DataWriter_ptr _duplicate (GetDomainPredicateDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicateDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicateDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetDomainPredicateDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetDomainPredicateDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetDomainPredicateDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainPredicateDetails_Response_& instance_data) = 0;

            protected:
                GetDomainPredicateDetails_Response_DataWriter () {};
                ~GetDomainPredicateDetails_Response_DataWriter () {};
            private:
                GetDomainPredicateDetails_Response_DataWriter (const GetDomainPredicateDetails_Response_DataWriter &);
                GetDomainPredicateDetails_Response_DataWriter & operator = (const GetDomainPredicateDetails_Response_DataWriter &);
            };

            class  GetDomainPredicateDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetDomainPredicateDetails_Response_DataReader_ptr _ptr_type;
                typedef GetDomainPredicateDetails_Response_DataReader_var _var_type;

                static GetDomainPredicateDetails_Response_DataReader_ptr _duplicate (GetDomainPredicateDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicateDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicateDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainPredicateDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainPredicateDetails_Response_& instance) = 0;

            protected:
                GetDomainPredicateDetails_Response_DataReader () {};
                ~GetDomainPredicateDetails_Response_DataReader () {};
            private:
                GetDomainPredicateDetails_Response_DataReader (const GetDomainPredicateDetails_Response_DataReader &);
                GetDomainPredicateDetails_Response_DataReader & operator = (const GetDomainPredicateDetails_Response_DataReader &);
            };

            class  GetDomainPredicateDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetDomainPredicateDetails_Response_DataReaderView_ptr _ptr_type;
                typedef GetDomainPredicateDetails_Response_DataReaderView_var _var_type;

                static GetDomainPredicateDetails_Response_DataReaderView_ptr _duplicate (GetDomainPredicateDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicateDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicateDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicateDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainPredicateDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainPredicateDetails_Response_& instance) = 0;

            protected:
                GetDomainPredicateDetails_Response_DataReaderView () {};
                ~GetDomainPredicateDetails_Response_DataReaderView () {};
            private:
                GetDomainPredicateDetails_Response_DataReaderView (const GetDomainPredicateDetails_Response_DataReaderView &);
                GetDomainPredicateDetails_Response_DataReaderView & operator = (const GetDomainPredicateDetails_Response_DataReaderView &);
            };
            class Sample_GetDomainPredicateDetails_Request_TypeSupportInterface;

            typedef Sample_GetDomainPredicateDetails_Request_TypeSupportInterface * Sample_GetDomainPredicateDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicateDetails_Request_TypeSupportInterface> Sample_GetDomainPredicateDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicateDetails_Request_TypeSupportInterface> Sample_GetDomainPredicateDetails_Request_TypeSupportInterface_out;


            class Sample_GetDomainPredicateDetails_Request_DataWriter;

            typedef Sample_GetDomainPredicateDetails_Request_DataWriter * Sample_GetDomainPredicateDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicateDetails_Request_DataWriter> Sample_GetDomainPredicateDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicateDetails_Request_DataWriter> Sample_GetDomainPredicateDetails_Request_DataWriter_out;


            class Sample_GetDomainPredicateDetails_Request_DataReader;

            typedef Sample_GetDomainPredicateDetails_Request_DataReader * Sample_GetDomainPredicateDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicateDetails_Request_DataReader> Sample_GetDomainPredicateDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicateDetails_Request_DataReader> Sample_GetDomainPredicateDetails_Request_DataReader_out;


            class Sample_GetDomainPredicateDetails_Request_DataReaderView;

            typedef Sample_GetDomainPredicateDetails_Request_DataReaderView * Sample_GetDomainPredicateDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicateDetails_Request_DataReaderView> Sample_GetDomainPredicateDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicateDetails_Request_DataReaderView> Sample_GetDomainPredicateDetails_Request_DataReaderView_out;

            struct Sample_GetDomainPredicateDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetDomainPredicateDetails_Request_, struct Sample_GetDomainPredicateDetails_Request_Seq_uniq_> Sample_GetDomainPredicateDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetDomainPredicateDetails_Request_Seq> Sample_GetDomainPredicateDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetDomainPredicateDetails_Request_Seq> Sample_GetDomainPredicateDetails_Request_Seq_out;

            class  Sample_GetDomainPredicateDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetDomainPredicateDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetDomainPredicateDetails_Request_TypeSupportInterface_var _var_type;

                static Sample_GetDomainPredicateDetails_Request_TypeSupportInterface_ptr _duplicate (Sample_GetDomainPredicateDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicateDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicateDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetDomainPredicateDetails_Request_TypeSupportInterface () {};
                ~Sample_GetDomainPredicateDetails_Request_TypeSupportInterface () {};
            private:
                Sample_GetDomainPredicateDetails_Request_TypeSupportInterface (const Sample_GetDomainPredicateDetails_Request_TypeSupportInterface &);
                Sample_GetDomainPredicateDetails_Request_TypeSupportInterface & operator = (const Sample_GetDomainPredicateDetails_Request_TypeSupportInterface &);
            };

            class  Sample_GetDomainPredicateDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetDomainPredicateDetails_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetDomainPredicateDetails_Request_DataWriter_var _var_type;

                static Sample_GetDomainPredicateDetails_Request_DataWriter_ptr _duplicate (Sample_GetDomainPredicateDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicateDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicateDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetDomainPredicateDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetDomainPredicateDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetDomainPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainPredicateDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainPredicateDetails_Request_& instance_data) = 0;

            protected:
                Sample_GetDomainPredicateDetails_Request_DataWriter () {};
                ~Sample_GetDomainPredicateDetails_Request_DataWriter () {};
            private:
                Sample_GetDomainPredicateDetails_Request_DataWriter (const Sample_GetDomainPredicateDetails_Request_DataWriter &);
                Sample_GetDomainPredicateDetails_Request_DataWriter & operator = (const Sample_GetDomainPredicateDetails_Request_DataWriter &);
            };

            class  Sample_GetDomainPredicateDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetDomainPredicateDetails_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetDomainPredicateDetails_Request_DataReader_var _var_type;

                static Sample_GetDomainPredicateDetails_Request_DataReader_ptr _duplicate (Sample_GetDomainPredicateDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicateDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicateDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainPredicateDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainPredicateDetails_Request_& instance) = 0;

            protected:
                Sample_GetDomainPredicateDetails_Request_DataReader () {};
                ~Sample_GetDomainPredicateDetails_Request_DataReader () {};
            private:
                Sample_GetDomainPredicateDetails_Request_DataReader (const Sample_GetDomainPredicateDetails_Request_DataReader &);
                Sample_GetDomainPredicateDetails_Request_DataReader & operator = (const Sample_GetDomainPredicateDetails_Request_DataReader &);
            };

            class  Sample_GetDomainPredicateDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetDomainPredicateDetails_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetDomainPredicateDetails_Request_DataReaderView_var _var_type;

                static Sample_GetDomainPredicateDetails_Request_DataReaderView_ptr _duplicate (Sample_GetDomainPredicateDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicateDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicateDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainPredicateDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainPredicateDetails_Request_& instance) = 0;

            protected:
                Sample_GetDomainPredicateDetails_Request_DataReaderView () {};
                ~Sample_GetDomainPredicateDetails_Request_DataReaderView () {};
            private:
                Sample_GetDomainPredicateDetails_Request_DataReaderView (const Sample_GetDomainPredicateDetails_Request_DataReaderView &);
                Sample_GetDomainPredicateDetails_Request_DataReaderView & operator = (const Sample_GetDomainPredicateDetails_Request_DataReaderView &);
            };
            class Sample_GetDomainPredicateDetails_Response_TypeSupportInterface;

            typedef Sample_GetDomainPredicateDetails_Response_TypeSupportInterface * Sample_GetDomainPredicateDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicateDetails_Response_TypeSupportInterface> Sample_GetDomainPredicateDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicateDetails_Response_TypeSupportInterface> Sample_GetDomainPredicateDetails_Response_TypeSupportInterface_out;


            class Sample_GetDomainPredicateDetails_Response_DataWriter;

            typedef Sample_GetDomainPredicateDetails_Response_DataWriter * Sample_GetDomainPredicateDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicateDetails_Response_DataWriter> Sample_GetDomainPredicateDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicateDetails_Response_DataWriter> Sample_GetDomainPredicateDetails_Response_DataWriter_out;


            class Sample_GetDomainPredicateDetails_Response_DataReader;

            typedef Sample_GetDomainPredicateDetails_Response_DataReader * Sample_GetDomainPredicateDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicateDetails_Response_DataReader> Sample_GetDomainPredicateDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicateDetails_Response_DataReader> Sample_GetDomainPredicateDetails_Response_DataReader_out;


            class Sample_GetDomainPredicateDetails_Response_DataReaderView;

            typedef Sample_GetDomainPredicateDetails_Response_DataReaderView * Sample_GetDomainPredicateDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicateDetails_Response_DataReaderView> Sample_GetDomainPredicateDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicateDetails_Response_DataReaderView> Sample_GetDomainPredicateDetails_Response_DataReaderView_out;

            struct Sample_GetDomainPredicateDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetDomainPredicateDetails_Response_, struct Sample_GetDomainPredicateDetails_Response_Seq_uniq_> Sample_GetDomainPredicateDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetDomainPredicateDetails_Response_Seq> Sample_GetDomainPredicateDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetDomainPredicateDetails_Response_Seq> Sample_GetDomainPredicateDetails_Response_Seq_out;

            class  Sample_GetDomainPredicateDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetDomainPredicateDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetDomainPredicateDetails_Response_TypeSupportInterface_var _var_type;

                static Sample_GetDomainPredicateDetails_Response_TypeSupportInterface_ptr _duplicate (Sample_GetDomainPredicateDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicateDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicateDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetDomainPredicateDetails_Response_TypeSupportInterface () {};
                ~Sample_GetDomainPredicateDetails_Response_TypeSupportInterface () {};
            private:
                Sample_GetDomainPredicateDetails_Response_TypeSupportInterface (const Sample_GetDomainPredicateDetails_Response_TypeSupportInterface &);
                Sample_GetDomainPredicateDetails_Response_TypeSupportInterface & operator = (const Sample_GetDomainPredicateDetails_Response_TypeSupportInterface &);
            };

            class  Sample_GetDomainPredicateDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetDomainPredicateDetails_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetDomainPredicateDetails_Response_DataWriter_var _var_type;

                static Sample_GetDomainPredicateDetails_Response_DataWriter_ptr _duplicate (Sample_GetDomainPredicateDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicateDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicateDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetDomainPredicateDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetDomainPredicateDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetDomainPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainPredicateDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainPredicateDetails_Response_& instance_data) = 0;

            protected:
                Sample_GetDomainPredicateDetails_Response_DataWriter () {};
                ~Sample_GetDomainPredicateDetails_Response_DataWriter () {};
            private:
                Sample_GetDomainPredicateDetails_Response_DataWriter (const Sample_GetDomainPredicateDetails_Response_DataWriter &);
                Sample_GetDomainPredicateDetails_Response_DataWriter & operator = (const Sample_GetDomainPredicateDetails_Response_DataWriter &);
            };

            class  Sample_GetDomainPredicateDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetDomainPredicateDetails_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetDomainPredicateDetails_Response_DataReader_var _var_type;

                static Sample_GetDomainPredicateDetails_Response_DataReader_ptr _duplicate (Sample_GetDomainPredicateDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicateDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicateDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainPredicateDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainPredicateDetails_Response_& instance) = 0;

            protected:
                Sample_GetDomainPredicateDetails_Response_DataReader () {};
                ~Sample_GetDomainPredicateDetails_Response_DataReader () {};
            private:
                Sample_GetDomainPredicateDetails_Response_DataReader (const Sample_GetDomainPredicateDetails_Response_DataReader &);
                Sample_GetDomainPredicateDetails_Response_DataReader & operator = (const Sample_GetDomainPredicateDetails_Response_DataReader &);
            };

            class  Sample_GetDomainPredicateDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetDomainPredicateDetails_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetDomainPredicateDetails_Response_DataReaderView_var _var_type;

                static Sample_GetDomainPredicateDetails_Response_DataReaderView_ptr _duplicate (Sample_GetDomainPredicateDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicateDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicateDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicateDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainPredicateDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainPredicateDetails_Response_& instance) = 0;

            protected:
                Sample_GetDomainPredicateDetails_Response_DataReaderView () {};
                ~Sample_GetDomainPredicateDetails_Response_DataReaderView () {};
            private:
                Sample_GetDomainPredicateDetails_Response_DataReaderView (const Sample_GetDomainPredicateDetails_Response_DataReaderView &);
                Sample_GetDomainPredicateDetails_Response_DataReaderView & operator = (const Sample_GetDomainPredicateDetails_Response_DataReaderView &);
            };
        }

    }

}

#endif
