#ifndef _H_CA0B17AE62AAC65E10CCB370F9DD662A_GetDomainPredicates__H_
#define _H_CA0B17AE62AAC65E10CCB370F9DD662A_GetDomainPredicates__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Empty_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetDomainPredicates_Request_
            {
                ::std_msgs::msg::dds_::Empty_ request_;
            };

            typedef DDS_DCPSStruct_var<GetDomainPredicates_Request_> GetDomainPredicates_Request__var;
            typedef GetDomainPredicates_Request_& GetDomainPredicates_Request__out;

            struct  GetDomainPredicates_Response_
            {
                struct _predicates__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _predicates__seq_uniq_ > _predicates__seq;
                typedef DDS_DCPSUStrSeq_var< _predicates__seq > _predicates__seq_var;
                typedef DDS_DCPSUStrSeq_out< _predicates__seq > _predicates__seq_out;
                ::DDS::Boolean success_;
                _predicates__seq predicates_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<GetDomainPredicates_Response_> GetDomainPredicates_Response__var;
            typedef DDS_DCPSStruct_out < GetDomainPredicates_Response_> GetDomainPredicates_Response__out;

            struct  Sample_GetDomainPredicates_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetDomainPredicates_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetDomainPredicates_Request_> Sample_GetDomainPredicates_Request__var;
            typedef Sample_GetDomainPredicates_Request_& Sample_GetDomainPredicates_Request__out;

            struct  Sample_GetDomainPredicates_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetDomainPredicates_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetDomainPredicates_Response_> Sample_GetDomainPredicates_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetDomainPredicates_Response_> Sample_GetDomainPredicates_Response__out;

        }

    }

}

#endif /* _H_CA0B17AE62AAC65E10CCB370F9DD662A_GetDomainPredicates__H_ */
