#ifndef _H_D9A7F8194895564710565D036D2A25A9_GetDomainTypes__H_
#define _H_D9A7F8194895564710565D036D2A25A9_GetDomainTypes__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Empty_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetDomainTypes_Request_
            {
                ::std_msgs::msg::dds_::Empty_ request_;
            };

            typedef DDS_DCPSStruct_var<GetDomainTypes_Request_> GetDomainTypes_Request__var;
            typedef GetDomainTypes_Request_& GetDomainTypes_Request__out;

            struct  GetDomainTypes_Response_
            {
                struct _types__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _types__seq_uniq_ > _types__seq;
                typedef DDS_DCPSUStrSeq_var< _types__seq > _types__seq_var;
                typedef DDS_DCPSUStrSeq_out< _types__seq > _types__seq_out;
                ::DDS::Boolean success_;
                _types__seq types_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<GetDomainTypes_Response_> GetDomainTypes_Response__var;
            typedef DDS_DCPSStruct_out < GetDomainTypes_Response_> GetDomainTypes_Response__out;

            struct  Sample_GetDomainTypes_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetDomainTypes_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetDomainTypes_Request_> Sample_GetDomainTypes_Request__var;
            typedef Sample_GetDomainTypes_Request_& Sample_GetDomainTypes_Request__out;

            struct  Sample_GetDomainTypes_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetDomainTypes_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetDomainTypes_Response_> Sample_GetDomainTypes_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetDomainTypes_Response_> Sample_GetDomainTypes_Response__out;

        }

    }

}

#endif /* _H_D9A7F8194895564710565D036D2A25A9_GetDomainTypes__H_ */
