#ifndef _H_D9A7F8194895564710565D036D2A25A9_GetDomainTypes_DCPS_H_
#define _H_D9A7F8194895564710565D036D2A25A9_GetDomainTypes_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetDomainTypes_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetDomainTypes_Request_TypeSupportInterface;

            typedef GetDomainTypes_Request_TypeSupportInterface * GetDomainTypes_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetDomainTypes_Request_TypeSupportInterface> GetDomainTypes_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetDomainTypes_Request_TypeSupportInterface> GetDomainTypes_Request_TypeSupportInterface_out;


            class GetDomainTypes_Request_DataWriter;

            typedef GetDomainTypes_Request_DataWriter * GetDomainTypes_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetDomainTypes_Request_DataWriter> GetDomainTypes_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetDomainTypes_Request_DataWriter> GetDomainTypes_Request_DataWriter_out;


            class GetDomainTypes_Request_DataReader;

            typedef GetDomainTypes_Request_DataReader * GetDomainTypes_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetDomainTypes_Request_DataReader> GetDomainTypes_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetDomainTypes_Request_DataReader> GetDomainTypes_Request_DataReader_out;


            class GetDomainTypes_Request_DataReaderView;

            typedef GetDomainTypes_Request_DataReaderView * GetDomainTypes_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetDomainTypes_Request_DataReaderView> GetDomainTypes_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetDomainTypes_Request_DataReaderView> GetDomainTypes_Request_DataReaderView_out;

            struct GetDomainTypes_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetDomainTypes_Request_, struct GetDomainTypes_Request_Seq_uniq_> GetDomainTypes_Request_Seq;
            typedef DDS_DCPSSequence_var < GetDomainTypes_Request_Seq> GetDomainTypes_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetDomainTypes_Request_Seq> GetDomainTypes_Request_Seq_out;

            class  GetDomainTypes_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetDomainTypes_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetDomainTypes_Request_TypeSupportInterface_var _var_type;

                static GetDomainTypes_Request_TypeSupportInterface_ptr _duplicate (GetDomainTypes_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainTypes_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainTypes_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetDomainTypes_Request_TypeSupportInterface () {};
                ~GetDomainTypes_Request_TypeSupportInterface () {};
            private:
                GetDomainTypes_Request_TypeSupportInterface (const GetDomainTypes_Request_TypeSupportInterface &);
                GetDomainTypes_Request_TypeSupportInterface & operator = (const GetDomainTypes_Request_TypeSupportInterface &);
            };

            class  GetDomainTypes_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetDomainTypes_Request_DataWriter_ptr _ptr_type;
                typedef GetDomainTypes_Request_DataWriter_var _var_type;

                static GetDomainTypes_Request_DataWriter_ptr _duplicate (GetDomainTypes_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainTypes_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainTypes_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetDomainTypes_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetDomainTypes_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetDomainTypes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetDomainTypes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetDomainTypes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetDomainTypes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetDomainTypes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetDomainTypes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetDomainTypes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetDomainTypes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetDomainTypes_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainTypes_Request_& instance_data) = 0;

            protected:
                GetDomainTypes_Request_DataWriter () {};
                ~GetDomainTypes_Request_DataWriter () {};
            private:
                GetDomainTypes_Request_DataWriter (const GetDomainTypes_Request_DataWriter &);
                GetDomainTypes_Request_DataWriter & operator = (const GetDomainTypes_Request_DataWriter &);
            };

            class  GetDomainTypes_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetDomainTypes_Request_DataReader_ptr _ptr_type;
                typedef GetDomainTypes_Request_DataReader_var _var_type;

                static GetDomainTypes_Request_DataReader_ptr _duplicate (GetDomainTypes_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainTypes_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainTypes_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainTypes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainTypes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainTypes_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainTypes_Request_& instance) = 0;

            protected:
                GetDomainTypes_Request_DataReader () {};
                ~GetDomainTypes_Request_DataReader () {};
            private:
                GetDomainTypes_Request_DataReader (const GetDomainTypes_Request_DataReader &);
                GetDomainTypes_Request_DataReader & operator = (const GetDomainTypes_Request_DataReader &);
            };

            class  GetDomainTypes_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetDomainTypes_Request_DataReaderView_ptr _ptr_type;
                typedef GetDomainTypes_Request_DataReaderView_var _var_type;

                static GetDomainTypes_Request_DataReaderView_ptr _duplicate (GetDomainTypes_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainTypes_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainTypes_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainTypes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainTypes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainTypes_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainTypes_Request_& instance) = 0;

            protected:
                GetDomainTypes_Request_DataReaderView () {};
                ~GetDomainTypes_Request_DataReaderView () {};
            private:
                GetDomainTypes_Request_DataReaderView (const GetDomainTypes_Request_DataReaderView &);
                GetDomainTypes_Request_DataReaderView & operator = (const GetDomainTypes_Request_DataReaderView &);
            };
            class GetDomainTypes_Response_TypeSupportInterface;

            typedef GetDomainTypes_Response_TypeSupportInterface * GetDomainTypes_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetDomainTypes_Response_TypeSupportInterface> GetDomainTypes_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetDomainTypes_Response_TypeSupportInterface> GetDomainTypes_Response_TypeSupportInterface_out;


            class GetDomainTypes_Response_DataWriter;

            typedef GetDomainTypes_Response_DataWriter * GetDomainTypes_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetDomainTypes_Response_DataWriter> GetDomainTypes_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetDomainTypes_Response_DataWriter> GetDomainTypes_Response_DataWriter_out;


            class GetDomainTypes_Response_DataReader;

            typedef GetDomainTypes_Response_DataReader * GetDomainTypes_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetDomainTypes_Response_DataReader> GetDomainTypes_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetDomainTypes_Response_DataReader> GetDomainTypes_Response_DataReader_out;


            class GetDomainTypes_Response_DataReaderView;

            typedef GetDomainTypes_Response_DataReaderView * GetDomainTypes_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetDomainTypes_Response_DataReaderView> GetDomainTypes_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetDomainTypes_Response_DataReaderView> GetDomainTypes_Response_DataReaderView_out;

            struct GetDomainTypes_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetDomainTypes_Response_, struct GetDomainTypes_Response_Seq_uniq_> GetDomainTypes_Response_Seq;
            typedef DDS_DCPSSequence_var < GetDomainTypes_Response_Seq> GetDomainTypes_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetDomainTypes_Response_Seq> GetDomainTypes_Response_Seq_out;

            class  GetDomainTypes_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetDomainTypes_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetDomainTypes_Response_TypeSupportInterface_var _var_type;

                static GetDomainTypes_Response_TypeSupportInterface_ptr _duplicate (GetDomainTypes_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainTypes_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainTypes_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetDomainTypes_Response_TypeSupportInterface () {};
                ~GetDomainTypes_Response_TypeSupportInterface () {};
            private:
                GetDomainTypes_Response_TypeSupportInterface (const GetDomainTypes_Response_TypeSupportInterface &);
                GetDomainTypes_Response_TypeSupportInterface & operator = (const GetDomainTypes_Response_TypeSupportInterface &);
            };

            class  GetDomainTypes_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetDomainTypes_Response_DataWriter_ptr _ptr_type;
                typedef GetDomainTypes_Response_DataWriter_var _var_type;

                static GetDomainTypes_Response_DataWriter_ptr _duplicate (GetDomainTypes_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainTypes_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainTypes_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetDomainTypes_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetDomainTypes_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetDomainTypes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetDomainTypes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetDomainTypes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetDomainTypes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetDomainTypes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetDomainTypes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetDomainTypes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetDomainTypes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetDomainTypes_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainTypes_Response_& instance_data) = 0;

            protected:
                GetDomainTypes_Response_DataWriter () {};
                ~GetDomainTypes_Response_DataWriter () {};
            private:
                GetDomainTypes_Response_DataWriter (const GetDomainTypes_Response_DataWriter &);
                GetDomainTypes_Response_DataWriter & operator = (const GetDomainTypes_Response_DataWriter &);
            };

            class  GetDomainTypes_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetDomainTypes_Response_DataReader_ptr _ptr_type;
                typedef GetDomainTypes_Response_DataReader_var _var_type;

                static GetDomainTypes_Response_DataReader_ptr _duplicate (GetDomainTypes_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainTypes_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainTypes_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainTypes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainTypes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainTypes_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainTypes_Response_& instance) = 0;

            protected:
                GetDomainTypes_Response_DataReader () {};
                ~GetDomainTypes_Response_DataReader () {};
            private:
                GetDomainTypes_Response_DataReader (const GetDomainTypes_Response_DataReader &);
                GetDomainTypes_Response_DataReader & operator = (const GetDomainTypes_Response_DataReader &);
            };

            class  GetDomainTypes_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetDomainTypes_Response_DataReaderView_ptr _ptr_type;
                typedef GetDomainTypes_Response_DataReaderView_var _var_type;

                static GetDomainTypes_Response_DataReaderView_ptr _duplicate (GetDomainTypes_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainTypes_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainTypes_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainTypes_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainTypes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainTypes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainTypes_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainTypes_Response_& instance) = 0;

            protected:
                GetDomainTypes_Response_DataReaderView () {};
                ~GetDomainTypes_Response_DataReaderView () {};
            private:
                GetDomainTypes_Response_DataReaderView (const GetDomainTypes_Response_DataReaderView &);
                GetDomainTypes_Response_DataReaderView & operator = (const GetDomainTypes_Response_DataReaderView &);
            };
            class Sample_GetDomainTypes_Request_TypeSupportInterface;

            typedef Sample_GetDomainTypes_Request_TypeSupportInterface * Sample_GetDomainTypes_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainTypes_Request_TypeSupportInterface> Sample_GetDomainTypes_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainTypes_Request_TypeSupportInterface> Sample_GetDomainTypes_Request_TypeSupportInterface_out;


            class Sample_GetDomainTypes_Request_DataWriter;

            typedef Sample_GetDomainTypes_Request_DataWriter * Sample_GetDomainTypes_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainTypes_Request_DataWriter> Sample_GetDomainTypes_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainTypes_Request_DataWriter> Sample_GetDomainTypes_Request_DataWriter_out;


            class Sample_GetDomainTypes_Request_DataReader;

            typedef Sample_GetDomainTypes_Request_DataReader * Sample_GetDomainTypes_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainTypes_Request_DataReader> Sample_GetDomainTypes_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainTypes_Request_DataReader> Sample_GetDomainTypes_Request_DataReader_out;


            class Sample_GetDomainTypes_Request_DataReaderView;

            typedef Sample_GetDomainTypes_Request_DataReaderView * Sample_GetDomainTypes_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainTypes_Request_DataReaderView> Sample_GetDomainTypes_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainTypes_Request_DataReaderView> Sample_GetDomainTypes_Request_DataReaderView_out;

            struct Sample_GetDomainTypes_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetDomainTypes_Request_, struct Sample_GetDomainTypes_Request_Seq_uniq_> Sample_GetDomainTypes_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetDomainTypes_Request_Seq> Sample_GetDomainTypes_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetDomainTypes_Request_Seq> Sample_GetDomainTypes_Request_Seq_out;

            class  Sample_GetDomainTypes_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetDomainTypes_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetDomainTypes_Request_TypeSupportInterface_var _var_type;

                static Sample_GetDomainTypes_Request_TypeSupportInterface_ptr _duplicate (Sample_GetDomainTypes_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainTypes_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainTypes_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetDomainTypes_Request_TypeSupportInterface () {};
                ~Sample_GetDomainTypes_Request_TypeSupportInterface () {};
            private:
                Sample_GetDomainTypes_Request_TypeSupportInterface (const Sample_GetDomainTypes_Request_TypeSupportInterface &);
                Sample_GetDomainTypes_Request_TypeSupportInterface & operator = (const Sample_GetDomainTypes_Request_TypeSupportInterface &);
            };

            class  Sample_GetDomainTypes_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetDomainTypes_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetDomainTypes_Request_DataWriter_var _var_type;

                static Sample_GetDomainTypes_Request_DataWriter_ptr _duplicate (Sample_GetDomainTypes_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainTypes_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainTypes_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetDomainTypes_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetDomainTypes_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetDomainTypes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetDomainTypes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetDomainTypes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetDomainTypes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetDomainTypes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetDomainTypes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetDomainTypes_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetDomainTypes_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainTypes_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainTypes_Request_& instance_data) = 0;

            protected:
                Sample_GetDomainTypes_Request_DataWriter () {};
                ~Sample_GetDomainTypes_Request_DataWriter () {};
            private:
                Sample_GetDomainTypes_Request_DataWriter (const Sample_GetDomainTypes_Request_DataWriter &);
                Sample_GetDomainTypes_Request_DataWriter & operator = (const Sample_GetDomainTypes_Request_DataWriter &);
            };

            class  Sample_GetDomainTypes_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetDomainTypes_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetDomainTypes_Request_DataReader_var _var_type;

                static Sample_GetDomainTypes_Request_DataReader_ptr _duplicate (Sample_GetDomainTypes_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainTypes_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainTypes_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainTypes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainTypes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainTypes_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainTypes_Request_& instance) = 0;

            protected:
                Sample_GetDomainTypes_Request_DataReader () {};
                ~Sample_GetDomainTypes_Request_DataReader () {};
            private:
                Sample_GetDomainTypes_Request_DataReader (const Sample_GetDomainTypes_Request_DataReader &);
                Sample_GetDomainTypes_Request_DataReader & operator = (const Sample_GetDomainTypes_Request_DataReader &);
            };

            class  Sample_GetDomainTypes_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetDomainTypes_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetDomainTypes_Request_DataReaderView_var _var_type;

                static Sample_GetDomainTypes_Request_DataReaderView_ptr _duplicate (Sample_GetDomainTypes_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainTypes_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainTypes_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainTypes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainTypes_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainTypes_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainTypes_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainTypes_Request_& instance) = 0;

            protected:
                Sample_GetDomainTypes_Request_DataReaderView () {};
                ~Sample_GetDomainTypes_Request_DataReaderView () {};
            private:
                Sample_GetDomainTypes_Request_DataReaderView (const Sample_GetDomainTypes_Request_DataReaderView &);
                Sample_GetDomainTypes_Request_DataReaderView & operator = (const Sample_GetDomainTypes_Request_DataReaderView &);
            };
            class Sample_GetDomainTypes_Response_TypeSupportInterface;

            typedef Sample_GetDomainTypes_Response_TypeSupportInterface * Sample_GetDomainTypes_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainTypes_Response_TypeSupportInterface> Sample_GetDomainTypes_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainTypes_Response_TypeSupportInterface> Sample_GetDomainTypes_Response_TypeSupportInterface_out;


            class Sample_GetDomainTypes_Response_DataWriter;

            typedef Sample_GetDomainTypes_Response_DataWriter * Sample_GetDomainTypes_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainTypes_Response_DataWriter> Sample_GetDomainTypes_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainTypes_Response_DataWriter> Sample_GetDomainTypes_Response_DataWriter_out;


            class Sample_GetDomainTypes_Response_DataReader;

            typedef Sample_GetDomainTypes_Response_DataReader * Sample_GetDomainTypes_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainTypes_Response_DataReader> Sample_GetDomainTypes_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainTypes_Response_DataReader> Sample_GetDomainTypes_Response_DataReader_out;


            class Sample_GetDomainTypes_Response_DataReaderView;

            typedef Sample_GetDomainTypes_Response_DataReaderView * Sample_GetDomainTypes_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainTypes_Response_DataReaderView> Sample_GetDomainTypes_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainTypes_Response_DataReaderView> Sample_GetDomainTypes_Response_DataReaderView_out;

            struct Sample_GetDomainTypes_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetDomainTypes_Response_, struct Sample_GetDomainTypes_Response_Seq_uniq_> Sample_GetDomainTypes_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetDomainTypes_Response_Seq> Sample_GetDomainTypes_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetDomainTypes_Response_Seq> Sample_GetDomainTypes_Response_Seq_out;

            class  Sample_GetDomainTypes_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetDomainTypes_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetDomainTypes_Response_TypeSupportInterface_var _var_type;

                static Sample_GetDomainTypes_Response_TypeSupportInterface_ptr _duplicate (Sample_GetDomainTypes_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainTypes_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainTypes_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetDomainTypes_Response_TypeSupportInterface () {};
                ~Sample_GetDomainTypes_Response_TypeSupportInterface () {};
            private:
                Sample_GetDomainTypes_Response_TypeSupportInterface (const Sample_GetDomainTypes_Response_TypeSupportInterface &);
                Sample_GetDomainTypes_Response_TypeSupportInterface & operator = (const Sample_GetDomainTypes_Response_TypeSupportInterface &);
            };

            class  Sample_GetDomainTypes_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetDomainTypes_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetDomainTypes_Response_DataWriter_var _var_type;

                static Sample_GetDomainTypes_Response_DataWriter_ptr _duplicate (Sample_GetDomainTypes_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainTypes_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainTypes_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetDomainTypes_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetDomainTypes_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetDomainTypes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetDomainTypes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetDomainTypes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetDomainTypes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetDomainTypes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetDomainTypes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetDomainTypes_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetDomainTypes_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainTypes_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainTypes_Response_& instance_data) = 0;

            protected:
                Sample_GetDomainTypes_Response_DataWriter () {};
                ~Sample_GetDomainTypes_Response_DataWriter () {};
            private:
                Sample_GetDomainTypes_Response_DataWriter (const Sample_GetDomainTypes_Response_DataWriter &);
                Sample_GetDomainTypes_Response_DataWriter & operator = (const Sample_GetDomainTypes_Response_DataWriter &);
            };

            class  Sample_GetDomainTypes_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetDomainTypes_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetDomainTypes_Response_DataReader_var _var_type;

                static Sample_GetDomainTypes_Response_DataReader_ptr _duplicate (Sample_GetDomainTypes_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainTypes_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainTypes_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainTypes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainTypes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainTypes_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainTypes_Response_& instance) = 0;

            protected:
                Sample_GetDomainTypes_Response_DataReader () {};
                ~Sample_GetDomainTypes_Response_DataReader () {};
            private:
                Sample_GetDomainTypes_Response_DataReader (const Sample_GetDomainTypes_Response_DataReader &);
                Sample_GetDomainTypes_Response_DataReader & operator = (const Sample_GetDomainTypes_Response_DataReader &);
            };

            class  Sample_GetDomainTypes_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetDomainTypes_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetDomainTypes_Response_DataReaderView_var _var_type;

                static Sample_GetDomainTypes_Response_DataReaderView_ptr _duplicate (Sample_GetDomainTypes_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainTypes_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainTypes_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainTypes_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainTypes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainTypes_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainTypes_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainTypes_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainTypes_Response_& instance) = 0;

            protected:
                Sample_GetDomainTypes_Response_DataReaderView () {};
                ~Sample_GetDomainTypes_Response_DataReaderView () {};
            private:
                Sample_GetDomainTypes_Response_DataReaderView (const Sample_GetDomainTypes_Response_DataReaderView &);
                Sample_GetDomainTypes_Response_DataReaderView & operator = (const Sample_GetDomainTypes_Response_DataReaderView &);
            };
        }

    }

}

#endif
