#ifndef _H_3CC23A1245D609B2F012BF3C57AF9D08_GetProblemGoal__H_
#define _H_3CC23A1245D609B2F012BF3C57AF9D08_GetProblemGoal__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Empty_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetProblemGoal_Request_
            {
                ::std_msgs::msg::dds_::Empty_ request_;
            };

            typedef DDS_DCPSStruct_var<GetProblemGoal_Request_> GetProblemGoal_Request__var;
            typedef GetProblemGoal_Request_& GetProblemGoal_Request__out;

            struct  GetProblemGoal_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr goal_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<GetProblemGoal_Response_> GetProblemGoal_Response__var;
            typedef DDS_DCPSStruct_out < GetProblemGoal_Response_> GetProblemGoal_Response__out;

            struct  Sample_GetProblemGoal_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetProblemGoal_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetProblemGoal_Request_> Sample_GetProblemGoal_Request__var;
            typedef Sample_GetProblemGoal_Request_& Sample_GetProblemGoal_Request__out;

            struct  Sample_GetProblemGoal_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetProblemGoal_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetProblemGoal_Response_> Sample_GetProblemGoal_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetProblemGoal_Response_> Sample_GetProblemGoal_Response__out;

        }

    }

}

#endif /* _H_3CC23A1245D609B2F012BF3C57AF9D08_GetProblemGoal__H_ */
