#ifndef _H_3CC23A1245D609B2F012BF3C57AF9D08_GetProblemGoal_DCPS_H_
#define _H_3CC23A1245D609B2F012BF3C57AF9D08_GetProblemGoal_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetProblemGoal_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetProblemGoal_Request_TypeSupportInterface;

            typedef GetProblemGoal_Request_TypeSupportInterface * GetProblemGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetProblemGoal_Request_TypeSupportInterface> GetProblemGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetProblemGoal_Request_TypeSupportInterface> GetProblemGoal_Request_TypeSupportInterface_out;


            class GetProblemGoal_Request_DataWriter;

            typedef GetProblemGoal_Request_DataWriter * GetProblemGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetProblemGoal_Request_DataWriter> GetProblemGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetProblemGoal_Request_DataWriter> GetProblemGoal_Request_DataWriter_out;


            class GetProblemGoal_Request_DataReader;

            typedef GetProblemGoal_Request_DataReader * GetProblemGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetProblemGoal_Request_DataReader> GetProblemGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetProblemGoal_Request_DataReader> GetProblemGoal_Request_DataReader_out;


            class GetProblemGoal_Request_DataReaderView;

            typedef GetProblemGoal_Request_DataReaderView * GetProblemGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetProblemGoal_Request_DataReaderView> GetProblemGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetProblemGoal_Request_DataReaderView> GetProblemGoal_Request_DataReaderView_out;

            struct GetProblemGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetProblemGoal_Request_, struct GetProblemGoal_Request_Seq_uniq_> GetProblemGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < GetProblemGoal_Request_Seq> GetProblemGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetProblemGoal_Request_Seq> GetProblemGoal_Request_Seq_out;

            class  GetProblemGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetProblemGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetProblemGoal_Request_TypeSupportInterface_var _var_type;

                static GetProblemGoal_Request_TypeSupportInterface_ptr _duplicate (GetProblemGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetProblemGoal_Request_TypeSupportInterface () {};
                ~GetProblemGoal_Request_TypeSupportInterface () {};
            private:
                GetProblemGoal_Request_TypeSupportInterface (const GetProblemGoal_Request_TypeSupportInterface &);
                GetProblemGoal_Request_TypeSupportInterface & operator = (const GetProblemGoal_Request_TypeSupportInterface &);
            };

            class  GetProblemGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetProblemGoal_Request_DataWriter_ptr _ptr_type;
                typedef GetProblemGoal_Request_DataWriter_var _var_type;

                static GetProblemGoal_Request_DataWriter_ptr _duplicate (GetProblemGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetProblemGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetProblemGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemGoal_Request_& instance_data) = 0;

            protected:
                GetProblemGoal_Request_DataWriter () {};
                ~GetProblemGoal_Request_DataWriter () {};
            private:
                GetProblemGoal_Request_DataWriter (const GetProblemGoal_Request_DataWriter &);
                GetProblemGoal_Request_DataWriter & operator = (const GetProblemGoal_Request_DataWriter &);
            };

            class  GetProblemGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetProblemGoal_Request_DataReader_ptr _ptr_type;
                typedef GetProblemGoal_Request_DataReader_var _var_type;

                static GetProblemGoal_Request_DataReader_ptr _duplicate (GetProblemGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemGoal_Request_& instance) = 0;

            protected:
                GetProblemGoal_Request_DataReader () {};
                ~GetProblemGoal_Request_DataReader () {};
            private:
                GetProblemGoal_Request_DataReader (const GetProblemGoal_Request_DataReader &);
                GetProblemGoal_Request_DataReader & operator = (const GetProblemGoal_Request_DataReader &);
            };

            class  GetProblemGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetProblemGoal_Request_DataReaderView_ptr _ptr_type;
                typedef GetProblemGoal_Request_DataReaderView_var _var_type;

                static GetProblemGoal_Request_DataReaderView_ptr _duplicate (GetProblemGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemGoal_Request_& instance) = 0;

            protected:
                GetProblemGoal_Request_DataReaderView () {};
                ~GetProblemGoal_Request_DataReaderView () {};
            private:
                GetProblemGoal_Request_DataReaderView (const GetProblemGoal_Request_DataReaderView &);
                GetProblemGoal_Request_DataReaderView & operator = (const GetProblemGoal_Request_DataReaderView &);
            };
            class GetProblemGoal_Response_TypeSupportInterface;

            typedef GetProblemGoal_Response_TypeSupportInterface * GetProblemGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetProblemGoal_Response_TypeSupportInterface> GetProblemGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetProblemGoal_Response_TypeSupportInterface> GetProblemGoal_Response_TypeSupportInterface_out;


            class GetProblemGoal_Response_DataWriter;

            typedef GetProblemGoal_Response_DataWriter * GetProblemGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetProblemGoal_Response_DataWriter> GetProblemGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetProblemGoal_Response_DataWriter> GetProblemGoal_Response_DataWriter_out;


            class GetProblemGoal_Response_DataReader;

            typedef GetProblemGoal_Response_DataReader * GetProblemGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetProblemGoal_Response_DataReader> GetProblemGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetProblemGoal_Response_DataReader> GetProblemGoal_Response_DataReader_out;


            class GetProblemGoal_Response_DataReaderView;

            typedef GetProblemGoal_Response_DataReaderView * GetProblemGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetProblemGoal_Response_DataReaderView> GetProblemGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetProblemGoal_Response_DataReaderView> GetProblemGoal_Response_DataReaderView_out;

            struct GetProblemGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetProblemGoal_Response_, struct GetProblemGoal_Response_Seq_uniq_> GetProblemGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < GetProblemGoal_Response_Seq> GetProblemGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetProblemGoal_Response_Seq> GetProblemGoal_Response_Seq_out;

            class  GetProblemGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetProblemGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetProblemGoal_Response_TypeSupportInterface_var _var_type;

                static GetProblemGoal_Response_TypeSupportInterface_ptr _duplicate (GetProblemGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetProblemGoal_Response_TypeSupportInterface () {};
                ~GetProblemGoal_Response_TypeSupportInterface () {};
            private:
                GetProblemGoal_Response_TypeSupportInterface (const GetProblemGoal_Response_TypeSupportInterface &);
                GetProblemGoal_Response_TypeSupportInterface & operator = (const GetProblemGoal_Response_TypeSupportInterface &);
            };

            class  GetProblemGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetProblemGoal_Response_DataWriter_ptr _ptr_type;
                typedef GetProblemGoal_Response_DataWriter_var _var_type;

                static GetProblemGoal_Response_DataWriter_ptr _duplicate (GetProblemGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetProblemGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetProblemGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemGoal_Response_& instance_data) = 0;

            protected:
                GetProblemGoal_Response_DataWriter () {};
                ~GetProblemGoal_Response_DataWriter () {};
            private:
                GetProblemGoal_Response_DataWriter (const GetProblemGoal_Response_DataWriter &);
                GetProblemGoal_Response_DataWriter & operator = (const GetProblemGoal_Response_DataWriter &);
            };

            class  GetProblemGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetProblemGoal_Response_DataReader_ptr _ptr_type;
                typedef GetProblemGoal_Response_DataReader_var _var_type;

                static GetProblemGoal_Response_DataReader_ptr _duplicate (GetProblemGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemGoal_Response_& instance) = 0;

            protected:
                GetProblemGoal_Response_DataReader () {};
                ~GetProblemGoal_Response_DataReader () {};
            private:
                GetProblemGoal_Response_DataReader (const GetProblemGoal_Response_DataReader &);
                GetProblemGoal_Response_DataReader & operator = (const GetProblemGoal_Response_DataReader &);
            };

            class  GetProblemGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetProblemGoal_Response_DataReaderView_ptr _ptr_type;
                typedef GetProblemGoal_Response_DataReaderView_var _var_type;

                static GetProblemGoal_Response_DataReaderView_ptr _duplicate (GetProblemGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemGoal_Response_& instance) = 0;

            protected:
                GetProblemGoal_Response_DataReaderView () {};
                ~GetProblemGoal_Response_DataReaderView () {};
            private:
                GetProblemGoal_Response_DataReaderView (const GetProblemGoal_Response_DataReaderView &);
                GetProblemGoal_Response_DataReaderView & operator = (const GetProblemGoal_Response_DataReaderView &);
            };
            class Sample_GetProblemGoal_Request_TypeSupportInterface;

            typedef Sample_GetProblemGoal_Request_TypeSupportInterface * Sample_GetProblemGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemGoal_Request_TypeSupportInterface> Sample_GetProblemGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemGoal_Request_TypeSupportInterface> Sample_GetProblemGoal_Request_TypeSupportInterface_out;


            class Sample_GetProblemGoal_Request_DataWriter;

            typedef Sample_GetProblemGoal_Request_DataWriter * Sample_GetProblemGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemGoal_Request_DataWriter> Sample_GetProblemGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemGoal_Request_DataWriter> Sample_GetProblemGoal_Request_DataWriter_out;


            class Sample_GetProblemGoal_Request_DataReader;

            typedef Sample_GetProblemGoal_Request_DataReader * Sample_GetProblemGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemGoal_Request_DataReader> Sample_GetProblemGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemGoal_Request_DataReader> Sample_GetProblemGoal_Request_DataReader_out;


            class Sample_GetProblemGoal_Request_DataReaderView;

            typedef Sample_GetProblemGoal_Request_DataReaderView * Sample_GetProblemGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemGoal_Request_DataReaderView> Sample_GetProblemGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemGoal_Request_DataReaderView> Sample_GetProblemGoal_Request_DataReaderView_out;

            struct Sample_GetProblemGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetProblemGoal_Request_, struct Sample_GetProblemGoal_Request_Seq_uniq_> Sample_GetProblemGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetProblemGoal_Request_Seq> Sample_GetProblemGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetProblemGoal_Request_Seq> Sample_GetProblemGoal_Request_Seq_out;

            class  Sample_GetProblemGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetProblemGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetProblemGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_GetProblemGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_GetProblemGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetProblemGoal_Request_TypeSupportInterface () {};
                ~Sample_GetProblemGoal_Request_TypeSupportInterface () {};
            private:
                Sample_GetProblemGoal_Request_TypeSupportInterface (const Sample_GetProblemGoal_Request_TypeSupportInterface &);
                Sample_GetProblemGoal_Request_TypeSupportInterface & operator = (const Sample_GetProblemGoal_Request_TypeSupportInterface &);
            };

            class  Sample_GetProblemGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetProblemGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetProblemGoal_Request_DataWriter_var _var_type;

                static Sample_GetProblemGoal_Request_DataWriter_ptr _duplicate (Sample_GetProblemGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetProblemGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetProblemGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemGoal_Request_& instance_data) = 0;

            protected:
                Sample_GetProblemGoal_Request_DataWriter () {};
                ~Sample_GetProblemGoal_Request_DataWriter () {};
            private:
                Sample_GetProblemGoal_Request_DataWriter (const Sample_GetProblemGoal_Request_DataWriter &);
                Sample_GetProblemGoal_Request_DataWriter & operator = (const Sample_GetProblemGoal_Request_DataWriter &);
            };

            class  Sample_GetProblemGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetProblemGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetProblemGoal_Request_DataReader_var _var_type;

                static Sample_GetProblemGoal_Request_DataReader_ptr _duplicate (Sample_GetProblemGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemGoal_Request_& instance) = 0;

            protected:
                Sample_GetProblemGoal_Request_DataReader () {};
                ~Sample_GetProblemGoal_Request_DataReader () {};
            private:
                Sample_GetProblemGoal_Request_DataReader (const Sample_GetProblemGoal_Request_DataReader &);
                Sample_GetProblemGoal_Request_DataReader & operator = (const Sample_GetProblemGoal_Request_DataReader &);
            };

            class  Sample_GetProblemGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetProblemGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetProblemGoal_Request_DataReaderView_var _var_type;

                static Sample_GetProblemGoal_Request_DataReaderView_ptr _duplicate (Sample_GetProblemGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemGoal_Request_& instance) = 0;

            protected:
                Sample_GetProblemGoal_Request_DataReaderView () {};
                ~Sample_GetProblemGoal_Request_DataReaderView () {};
            private:
                Sample_GetProblemGoal_Request_DataReaderView (const Sample_GetProblemGoal_Request_DataReaderView &);
                Sample_GetProblemGoal_Request_DataReaderView & operator = (const Sample_GetProblemGoal_Request_DataReaderView &);
            };
            class Sample_GetProblemGoal_Response_TypeSupportInterface;

            typedef Sample_GetProblemGoal_Response_TypeSupportInterface * Sample_GetProblemGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemGoal_Response_TypeSupportInterface> Sample_GetProblemGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemGoal_Response_TypeSupportInterface> Sample_GetProblemGoal_Response_TypeSupportInterface_out;


            class Sample_GetProblemGoal_Response_DataWriter;

            typedef Sample_GetProblemGoal_Response_DataWriter * Sample_GetProblemGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemGoal_Response_DataWriter> Sample_GetProblemGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemGoal_Response_DataWriter> Sample_GetProblemGoal_Response_DataWriter_out;


            class Sample_GetProblemGoal_Response_DataReader;

            typedef Sample_GetProblemGoal_Response_DataReader * Sample_GetProblemGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemGoal_Response_DataReader> Sample_GetProblemGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemGoal_Response_DataReader> Sample_GetProblemGoal_Response_DataReader_out;


            class Sample_GetProblemGoal_Response_DataReaderView;

            typedef Sample_GetProblemGoal_Response_DataReaderView * Sample_GetProblemGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemGoal_Response_DataReaderView> Sample_GetProblemGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemGoal_Response_DataReaderView> Sample_GetProblemGoal_Response_DataReaderView_out;

            struct Sample_GetProblemGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetProblemGoal_Response_, struct Sample_GetProblemGoal_Response_Seq_uniq_> Sample_GetProblemGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetProblemGoal_Response_Seq> Sample_GetProblemGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetProblemGoal_Response_Seq> Sample_GetProblemGoal_Response_Seq_out;

            class  Sample_GetProblemGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetProblemGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetProblemGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_GetProblemGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_GetProblemGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetProblemGoal_Response_TypeSupportInterface () {};
                ~Sample_GetProblemGoal_Response_TypeSupportInterface () {};
            private:
                Sample_GetProblemGoal_Response_TypeSupportInterface (const Sample_GetProblemGoal_Response_TypeSupportInterface &);
                Sample_GetProblemGoal_Response_TypeSupportInterface & operator = (const Sample_GetProblemGoal_Response_TypeSupportInterface &);
            };

            class  Sample_GetProblemGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetProblemGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetProblemGoal_Response_DataWriter_var _var_type;

                static Sample_GetProblemGoal_Response_DataWriter_ptr _duplicate (Sample_GetProblemGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetProblemGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetProblemGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemGoal_Response_& instance_data) = 0;

            protected:
                Sample_GetProblemGoal_Response_DataWriter () {};
                ~Sample_GetProblemGoal_Response_DataWriter () {};
            private:
                Sample_GetProblemGoal_Response_DataWriter (const Sample_GetProblemGoal_Response_DataWriter &);
                Sample_GetProblemGoal_Response_DataWriter & operator = (const Sample_GetProblemGoal_Response_DataWriter &);
            };

            class  Sample_GetProblemGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetProblemGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetProblemGoal_Response_DataReader_var _var_type;

                static Sample_GetProblemGoal_Response_DataReader_ptr _duplicate (Sample_GetProblemGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemGoal_Response_& instance) = 0;

            protected:
                Sample_GetProblemGoal_Response_DataReader () {};
                ~Sample_GetProblemGoal_Response_DataReader () {};
            private:
                Sample_GetProblemGoal_Response_DataReader (const Sample_GetProblemGoal_Response_DataReader &);
                Sample_GetProblemGoal_Response_DataReader & operator = (const Sample_GetProblemGoal_Response_DataReader &);
            };

            class  Sample_GetProblemGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetProblemGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetProblemGoal_Response_DataReaderView_var _var_type;

                static Sample_GetProblemGoal_Response_DataReaderView_ptr _duplicate (Sample_GetProblemGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemGoal_Response_& instance) = 0;

            protected:
                Sample_GetProblemGoal_Response_DataReaderView () {};
                ~Sample_GetProblemGoal_Response_DataReaderView () {};
            private:
                Sample_GetProblemGoal_Response_DataReaderView (const Sample_GetProblemGoal_Response_DataReaderView &);
                Sample_GetProblemGoal_Response_DataReaderView & operator = (const Sample_GetProblemGoal_Response_DataReaderView &);
            };
        }

    }

}

#endif
