#ifndef _H_D9A9D95D7BE73DB57C5D8224D62256C1_GetProblemInstanceDetails_DCPS_H_
#define _H_D9A9D95D7BE73DB57C5D8224D62256C1_GetProblemInstanceDetails_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetProblemInstanceDetails_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetProblemInstanceDetails_Request_TypeSupportInterface;

            typedef GetProblemInstanceDetails_Request_TypeSupportInterface * GetProblemInstanceDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstanceDetails_Request_TypeSupportInterface> GetProblemInstanceDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetProblemInstanceDetails_Request_TypeSupportInterface> GetProblemInstanceDetails_Request_TypeSupportInterface_out;


            class GetProblemInstanceDetails_Request_DataWriter;

            typedef GetProblemInstanceDetails_Request_DataWriter * GetProblemInstanceDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstanceDetails_Request_DataWriter> GetProblemInstanceDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetProblemInstanceDetails_Request_DataWriter> GetProblemInstanceDetails_Request_DataWriter_out;


            class GetProblemInstanceDetails_Request_DataReader;

            typedef GetProblemInstanceDetails_Request_DataReader * GetProblemInstanceDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstanceDetails_Request_DataReader> GetProblemInstanceDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetProblemInstanceDetails_Request_DataReader> GetProblemInstanceDetails_Request_DataReader_out;


            class GetProblemInstanceDetails_Request_DataReaderView;

            typedef GetProblemInstanceDetails_Request_DataReaderView * GetProblemInstanceDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstanceDetails_Request_DataReaderView> GetProblemInstanceDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetProblemInstanceDetails_Request_DataReaderView> GetProblemInstanceDetails_Request_DataReaderView_out;

            struct GetProblemInstanceDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetProblemInstanceDetails_Request_, struct GetProblemInstanceDetails_Request_Seq_uniq_> GetProblemInstanceDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < GetProblemInstanceDetails_Request_Seq> GetProblemInstanceDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetProblemInstanceDetails_Request_Seq> GetProblemInstanceDetails_Request_Seq_out;

            class  GetProblemInstanceDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetProblemInstanceDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetProblemInstanceDetails_Request_TypeSupportInterface_var _var_type;

                static GetProblemInstanceDetails_Request_TypeSupportInterface_ptr _duplicate (GetProblemInstanceDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstanceDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstanceDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetProblemInstanceDetails_Request_TypeSupportInterface () {};
                ~GetProblemInstanceDetails_Request_TypeSupportInterface () {};
            private:
                GetProblemInstanceDetails_Request_TypeSupportInterface (const GetProblemInstanceDetails_Request_TypeSupportInterface &);
                GetProblemInstanceDetails_Request_TypeSupportInterface & operator = (const GetProblemInstanceDetails_Request_TypeSupportInterface &);
            };

            class  GetProblemInstanceDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetProblemInstanceDetails_Request_DataWriter_ptr _ptr_type;
                typedef GetProblemInstanceDetails_Request_DataWriter_var _var_type;

                static GetProblemInstanceDetails_Request_DataWriter_ptr _duplicate (GetProblemInstanceDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstanceDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstanceDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetProblemInstanceDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetProblemInstanceDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetProblemInstanceDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemInstanceDetails_Request_& instance_data) = 0;

            protected:
                GetProblemInstanceDetails_Request_DataWriter () {};
                ~GetProblemInstanceDetails_Request_DataWriter () {};
            private:
                GetProblemInstanceDetails_Request_DataWriter (const GetProblemInstanceDetails_Request_DataWriter &);
                GetProblemInstanceDetails_Request_DataWriter & operator = (const GetProblemInstanceDetails_Request_DataWriter &);
            };

            class  GetProblemInstanceDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetProblemInstanceDetails_Request_DataReader_ptr _ptr_type;
                typedef GetProblemInstanceDetails_Request_DataReader_var _var_type;

                static GetProblemInstanceDetails_Request_DataReader_ptr _duplicate (GetProblemInstanceDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstanceDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstanceDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemInstanceDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemInstanceDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemInstanceDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemInstanceDetails_Request_& instance) = 0;

            protected:
                GetProblemInstanceDetails_Request_DataReader () {};
                ~GetProblemInstanceDetails_Request_DataReader () {};
            private:
                GetProblemInstanceDetails_Request_DataReader (const GetProblemInstanceDetails_Request_DataReader &);
                GetProblemInstanceDetails_Request_DataReader & operator = (const GetProblemInstanceDetails_Request_DataReader &);
            };

            class  GetProblemInstanceDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetProblemInstanceDetails_Request_DataReaderView_ptr _ptr_type;
                typedef GetProblemInstanceDetails_Request_DataReaderView_var _var_type;

                static GetProblemInstanceDetails_Request_DataReaderView_ptr _duplicate (GetProblemInstanceDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstanceDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstanceDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemInstanceDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemInstanceDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemInstanceDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemInstanceDetails_Request_& instance) = 0;

            protected:
                GetProblemInstanceDetails_Request_DataReaderView () {};
                ~GetProblemInstanceDetails_Request_DataReaderView () {};
            private:
                GetProblemInstanceDetails_Request_DataReaderView (const GetProblemInstanceDetails_Request_DataReaderView &);
                GetProblemInstanceDetails_Request_DataReaderView & operator = (const GetProblemInstanceDetails_Request_DataReaderView &);
            };
            class GetProblemInstanceDetails_Response_TypeSupportInterface;

            typedef GetProblemInstanceDetails_Response_TypeSupportInterface * GetProblemInstanceDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstanceDetails_Response_TypeSupportInterface> GetProblemInstanceDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetProblemInstanceDetails_Response_TypeSupportInterface> GetProblemInstanceDetails_Response_TypeSupportInterface_out;


            class GetProblemInstanceDetails_Response_DataWriter;

            typedef GetProblemInstanceDetails_Response_DataWriter * GetProblemInstanceDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstanceDetails_Response_DataWriter> GetProblemInstanceDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetProblemInstanceDetails_Response_DataWriter> GetProblemInstanceDetails_Response_DataWriter_out;


            class GetProblemInstanceDetails_Response_DataReader;

            typedef GetProblemInstanceDetails_Response_DataReader * GetProblemInstanceDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstanceDetails_Response_DataReader> GetProblemInstanceDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetProblemInstanceDetails_Response_DataReader> GetProblemInstanceDetails_Response_DataReader_out;


            class GetProblemInstanceDetails_Response_DataReaderView;

            typedef GetProblemInstanceDetails_Response_DataReaderView * GetProblemInstanceDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstanceDetails_Response_DataReaderView> GetProblemInstanceDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetProblemInstanceDetails_Response_DataReaderView> GetProblemInstanceDetails_Response_DataReaderView_out;

            struct GetProblemInstanceDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetProblemInstanceDetails_Response_, struct GetProblemInstanceDetails_Response_Seq_uniq_> GetProblemInstanceDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < GetProblemInstanceDetails_Response_Seq> GetProblemInstanceDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetProblemInstanceDetails_Response_Seq> GetProblemInstanceDetails_Response_Seq_out;

            class  GetProblemInstanceDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetProblemInstanceDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetProblemInstanceDetails_Response_TypeSupportInterface_var _var_type;

                static GetProblemInstanceDetails_Response_TypeSupportInterface_ptr _duplicate (GetProblemInstanceDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstanceDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstanceDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetProblemInstanceDetails_Response_TypeSupportInterface () {};
                ~GetProblemInstanceDetails_Response_TypeSupportInterface () {};
            private:
                GetProblemInstanceDetails_Response_TypeSupportInterface (const GetProblemInstanceDetails_Response_TypeSupportInterface &);
                GetProblemInstanceDetails_Response_TypeSupportInterface & operator = (const GetProblemInstanceDetails_Response_TypeSupportInterface &);
            };

            class  GetProblemInstanceDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetProblemInstanceDetails_Response_DataWriter_ptr _ptr_type;
                typedef GetProblemInstanceDetails_Response_DataWriter_var _var_type;

                static GetProblemInstanceDetails_Response_DataWriter_ptr _duplicate (GetProblemInstanceDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstanceDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstanceDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetProblemInstanceDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetProblemInstanceDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetProblemInstanceDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemInstanceDetails_Response_& instance_data) = 0;

            protected:
                GetProblemInstanceDetails_Response_DataWriter () {};
                ~GetProblemInstanceDetails_Response_DataWriter () {};
            private:
                GetProblemInstanceDetails_Response_DataWriter (const GetProblemInstanceDetails_Response_DataWriter &);
                GetProblemInstanceDetails_Response_DataWriter & operator = (const GetProblemInstanceDetails_Response_DataWriter &);
            };

            class  GetProblemInstanceDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetProblemInstanceDetails_Response_DataReader_ptr _ptr_type;
                typedef GetProblemInstanceDetails_Response_DataReader_var _var_type;

                static GetProblemInstanceDetails_Response_DataReader_ptr _duplicate (GetProblemInstanceDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstanceDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstanceDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemInstanceDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemInstanceDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemInstanceDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemInstanceDetails_Response_& instance) = 0;

            protected:
                GetProblemInstanceDetails_Response_DataReader () {};
                ~GetProblemInstanceDetails_Response_DataReader () {};
            private:
                GetProblemInstanceDetails_Response_DataReader (const GetProblemInstanceDetails_Response_DataReader &);
                GetProblemInstanceDetails_Response_DataReader & operator = (const GetProblemInstanceDetails_Response_DataReader &);
            };

            class  GetProblemInstanceDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetProblemInstanceDetails_Response_DataReaderView_ptr _ptr_type;
                typedef GetProblemInstanceDetails_Response_DataReaderView_var _var_type;

                static GetProblemInstanceDetails_Response_DataReaderView_ptr _duplicate (GetProblemInstanceDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstanceDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstanceDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstanceDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemInstanceDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemInstanceDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemInstanceDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemInstanceDetails_Response_& instance) = 0;

            protected:
                GetProblemInstanceDetails_Response_DataReaderView () {};
                ~GetProblemInstanceDetails_Response_DataReaderView () {};
            private:
                GetProblemInstanceDetails_Response_DataReaderView (const GetProblemInstanceDetails_Response_DataReaderView &);
                GetProblemInstanceDetails_Response_DataReaderView & operator = (const GetProblemInstanceDetails_Response_DataReaderView &);
            };
            class Sample_GetProblemInstanceDetails_Request_TypeSupportInterface;

            typedef Sample_GetProblemInstanceDetails_Request_TypeSupportInterface * Sample_GetProblemInstanceDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstanceDetails_Request_TypeSupportInterface> Sample_GetProblemInstanceDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstanceDetails_Request_TypeSupportInterface> Sample_GetProblemInstanceDetails_Request_TypeSupportInterface_out;


            class Sample_GetProblemInstanceDetails_Request_DataWriter;

            typedef Sample_GetProblemInstanceDetails_Request_DataWriter * Sample_GetProblemInstanceDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstanceDetails_Request_DataWriter> Sample_GetProblemInstanceDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstanceDetails_Request_DataWriter> Sample_GetProblemInstanceDetails_Request_DataWriter_out;


            class Sample_GetProblemInstanceDetails_Request_DataReader;

            typedef Sample_GetProblemInstanceDetails_Request_DataReader * Sample_GetProblemInstanceDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstanceDetails_Request_DataReader> Sample_GetProblemInstanceDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstanceDetails_Request_DataReader> Sample_GetProblemInstanceDetails_Request_DataReader_out;


            class Sample_GetProblemInstanceDetails_Request_DataReaderView;

            typedef Sample_GetProblemInstanceDetails_Request_DataReaderView * Sample_GetProblemInstanceDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstanceDetails_Request_DataReaderView> Sample_GetProblemInstanceDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstanceDetails_Request_DataReaderView> Sample_GetProblemInstanceDetails_Request_DataReaderView_out;

            struct Sample_GetProblemInstanceDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetProblemInstanceDetails_Request_, struct Sample_GetProblemInstanceDetails_Request_Seq_uniq_> Sample_GetProblemInstanceDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetProblemInstanceDetails_Request_Seq> Sample_GetProblemInstanceDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetProblemInstanceDetails_Request_Seq> Sample_GetProblemInstanceDetails_Request_Seq_out;

            class  Sample_GetProblemInstanceDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetProblemInstanceDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetProblemInstanceDetails_Request_TypeSupportInterface_var _var_type;

                static Sample_GetProblemInstanceDetails_Request_TypeSupportInterface_ptr _duplicate (Sample_GetProblemInstanceDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstanceDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstanceDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetProblemInstanceDetails_Request_TypeSupportInterface () {};
                ~Sample_GetProblemInstanceDetails_Request_TypeSupportInterface () {};
            private:
                Sample_GetProblemInstanceDetails_Request_TypeSupportInterface (const Sample_GetProblemInstanceDetails_Request_TypeSupportInterface &);
                Sample_GetProblemInstanceDetails_Request_TypeSupportInterface & operator = (const Sample_GetProblemInstanceDetails_Request_TypeSupportInterface &);
            };

            class  Sample_GetProblemInstanceDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetProblemInstanceDetails_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetProblemInstanceDetails_Request_DataWriter_var _var_type;

                static Sample_GetProblemInstanceDetails_Request_DataWriter_ptr _duplicate (Sample_GetProblemInstanceDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstanceDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstanceDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetProblemInstanceDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetProblemInstanceDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetProblemInstanceDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemInstanceDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemInstanceDetails_Request_& instance_data) = 0;

            protected:
                Sample_GetProblemInstanceDetails_Request_DataWriter () {};
                ~Sample_GetProblemInstanceDetails_Request_DataWriter () {};
            private:
                Sample_GetProblemInstanceDetails_Request_DataWriter (const Sample_GetProblemInstanceDetails_Request_DataWriter &);
                Sample_GetProblemInstanceDetails_Request_DataWriter & operator = (const Sample_GetProblemInstanceDetails_Request_DataWriter &);
            };

            class  Sample_GetProblemInstanceDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetProblemInstanceDetails_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetProblemInstanceDetails_Request_DataReader_var _var_type;

                static Sample_GetProblemInstanceDetails_Request_DataReader_ptr _duplicate (Sample_GetProblemInstanceDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstanceDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstanceDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemInstanceDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemInstanceDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemInstanceDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemInstanceDetails_Request_& instance) = 0;

            protected:
                Sample_GetProblemInstanceDetails_Request_DataReader () {};
                ~Sample_GetProblemInstanceDetails_Request_DataReader () {};
            private:
                Sample_GetProblemInstanceDetails_Request_DataReader (const Sample_GetProblemInstanceDetails_Request_DataReader &);
                Sample_GetProblemInstanceDetails_Request_DataReader & operator = (const Sample_GetProblemInstanceDetails_Request_DataReader &);
            };

            class  Sample_GetProblemInstanceDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetProblemInstanceDetails_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetProblemInstanceDetails_Request_DataReaderView_var _var_type;

                static Sample_GetProblemInstanceDetails_Request_DataReaderView_ptr _duplicate (Sample_GetProblemInstanceDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstanceDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstanceDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemInstanceDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemInstanceDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemInstanceDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemInstanceDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemInstanceDetails_Request_& instance) = 0;

            protected:
                Sample_GetProblemInstanceDetails_Request_DataReaderView () {};
                ~Sample_GetProblemInstanceDetails_Request_DataReaderView () {};
            private:
                Sample_GetProblemInstanceDetails_Request_DataReaderView (const Sample_GetProblemInstanceDetails_Request_DataReaderView &);
                Sample_GetProblemInstanceDetails_Request_DataReaderView & operator = (const Sample_GetProblemInstanceDetails_Request_DataReaderView &);
            };
            class Sample_GetProblemInstanceDetails_Response_TypeSupportInterface;

            typedef Sample_GetProblemInstanceDetails_Response_TypeSupportInterface * Sample_GetProblemInstanceDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstanceDetails_Response_TypeSupportInterface> Sample_GetProblemInstanceDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstanceDetails_Response_TypeSupportInterface> Sample_GetProblemInstanceDetails_Response_TypeSupportInterface_out;


            class Sample_GetProblemInstanceDetails_Response_DataWriter;

            typedef Sample_GetProblemInstanceDetails_Response_DataWriter * Sample_GetProblemInstanceDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstanceDetails_Response_DataWriter> Sample_GetProblemInstanceDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstanceDetails_Response_DataWriter> Sample_GetProblemInstanceDetails_Response_DataWriter_out;


            class Sample_GetProblemInstanceDetails_Response_DataReader;

            typedef Sample_GetProblemInstanceDetails_Response_DataReader * Sample_GetProblemInstanceDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstanceDetails_Response_DataReader> Sample_GetProblemInstanceDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstanceDetails_Response_DataReader> Sample_GetProblemInstanceDetails_Response_DataReader_out;


            class Sample_GetProblemInstanceDetails_Response_DataReaderView;

            typedef Sample_GetProblemInstanceDetails_Response_DataReaderView * Sample_GetProblemInstanceDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstanceDetails_Response_DataReaderView> Sample_GetProblemInstanceDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstanceDetails_Response_DataReaderView> Sample_GetProblemInstanceDetails_Response_DataReaderView_out;

            struct Sample_GetProblemInstanceDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetProblemInstanceDetails_Response_, struct Sample_GetProblemInstanceDetails_Response_Seq_uniq_> Sample_GetProblemInstanceDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetProblemInstanceDetails_Response_Seq> Sample_GetProblemInstanceDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetProblemInstanceDetails_Response_Seq> Sample_GetProblemInstanceDetails_Response_Seq_out;

            class  Sample_GetProblemInstanceDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetProblemInstanceDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetProblemInstanceDetails_Response_TypeSupportInterface_var _var_type;

                static Sample_GetProblemInstanceDetails_Response_TypeSupportInterface_ptr _duplicate (Sample_GetProblemInstanceDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstanceDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstanceDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetProblemInstanceDetails_Response_TypeSupportInterface () {};
                ~Sample_GetProblemInstanceDetails_Response_TypeSupportInterface () {};
            private:
                Sample_GetProblemInstanceDetails_Response_TypeSupportInterface (const Sample_GetProblemInstanceDetails_Response_TypeSupportInterface &);
                Sample_GetProblemInstanceDetails_Response_TypeSupportInterface & operator = (const Sample_GetProblemInstanceDetails_Response_TypeSupportInterface &);
            };

            class  Sample_GetProblemInstanceDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetProblemInstanceDetails_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetProblemInstanceDetails_Response_DataWriter_var _var_type;

                static Sample_GetProblemInstanceDetails_Response_DataWriter_ptr _duplicate (Sample_GetProblemInstanceDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstanceDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstanceDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetProblemInstanceDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetProblemInstanceDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetProblemInstanceDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemInstanceDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemInstanceDetails_Response_& instance_data) = 0;

            protected:
                Sample_GetProblemInstanceDetails_Response_DataWriter () {};
                ~Sample_GetProblemInstanceDetails_Response_DataWriter () {};
            private:
                Sample_GetProblemInstanceDetails_Response_DataWriter (const Sample_GetProblemInstanceDetails_Response_DataWriter &);
                Sample_GetProblemInstanceDetails_Response_DataWriter & operator = (const Sample_GetProblemInstanceDetails_Response_DataWriter &);
            };

            class  Sample_GetProblemInstanceDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetProblemInstanceDetails_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetProblemInstanceDetails_Response_DataReader_var _var_type;

                static Sample_GetProblemInstanceDetails_Response_DataReader_ptr _duplicate (Sample_GetProblemInstanceDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstanceDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstanceDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemInstanceDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemInstanceDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemInstanceDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemInstanceDetails_Response_& instance) = 0;

            protected:
                Sample_GetProblemInstanceDetails_Response_DataReader () {};
                ~Sample_GetProblemInstanceDetails_Response_DataReader () {};
            private:
                Sample_GetProblemInstanceDetails_Response_DataReader (const Sample_GetProblemInstanceDetails_Response_DataReader &);
                Sample_GetProblemInstanceDetails_Response_DataReader & operator = (const Sample_GetProblemInstanceDetails_Response_DataReader &);
            };

            class  Sample_GetProblemInstanceDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetProblemInstanceDetails_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetProblemInstanceDetails_Response_DataReaderView_var _var_type;

                static Sample_GetProblemInstanceDetails_Response_DataReaderView_ptr _duplicate (Sample_GetProblemInstanceDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstanceDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstanceDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstanceDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemInstanceDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemInstanceDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemInstanceDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemInstanceDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemInstanceDetails_Response_& instance) = 0;

            protected:
                Sample_GetProblemInstanceDetails_Response_DataReaderView () {};
                ~Sample_GetProblemInstanceDetails_Response_DataReaderView () {};
            private:
                Sample_GetProblemInstanceDetails_Response_DataReaderView (const Sample_GetProblemInstanceDetails_Response_DataReaderView &);
                Sample_GetProblemInstanceDetails_Response_DataReaderView & operator = (const Sample_GetProblemInstanceDetails_Response_DataReaderView &);
            };
        }

    }

}

#endif
