#ifndef _H_ADD306C40AC3DF7CA4E90AA32D1864C7_GetProblemPredicateDetails_DCPS_H_
#define _H_ADD306C40AC3DF7CA4E90AA32D1864C7_GetProblemPredicateDetails_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetProblemPredicateDetails_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetProblemPredicateDetails_Request_TypeSupportInterface;

            typedef GetProblemPredicateDetails_Request_TypeSupportInterface * GetProblemPredicateDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicateDetails_Request_TypeSupportInterface> GetProblemPredicateDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicateDetails_Request_TypeSupportInterface> GetProblemPredicateDetails_Request_TypeSupportInterface_out;


            class GetProblemPredicateDetails_Request_DataWriter;

            typedef GetProblemPredicateDetails_Request_DataWriter * GetProblemPredicateDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicateDetails_Request_DataWriter> GetProblemPredicateDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicateDetails_Request_DataWriter> GetProblemPredicateDetails_Request_DataWriter_out;


            class GetProblemPredicateDetails_Request_DataReader;

            typedef GetProblemPredicateDetails_Request_DataReader * GetProblemPredicateDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicateDetails_Request_DataReader> GetProblemPredicateDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicateDetails_Request_DataReader> GetProblemPredicateDetails_Request_DataReader_out;


            class GetProblemPredicateDetails_Request_DataReaderView;

            typedef GetProblemPredicateDetails_Request_DataReaderView * GetProblemPredicateDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicateDetails_Request_DataReaderView> GetProblemPredicateDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicateDetails_Request_DataReaderView> GetProblemPredicateDetails_Request_DataReaderView_out;

            struct GetProblemPredicateDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetProblemPredicateDetails_Request_, struct GetProblemPredicateDetails_Request_Seq_uniq_> GetProblemPredicateDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < GetProblemPredicateDetails_Request_Seq> GetProblemPredicateDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetProblemPredicateDetails_Request_Seq> GetProblemPredicateDetails_Request_Seq_out;

            class  GetProblemPredicateDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetProblemPredicateDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetProblemPredicateDetails_Request_TypeSupportInterface_var _var_type;

                static GetProblemPredicateDetails_Request_TypeSupportInterface_ptr _duplicate (GetProblemPredicateDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicateDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicateDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetProblemPredicateDetails_Request_TypeSupportInterface () {};
                ~GetProblemPredicateDetails_Request_TypeSupportInterface () {};
            private:
                GetProblemPredicateDetails_Request_TypeSupportInterface (const GetProblemPredicateDetails_Request_TypeSupportInterface &);
                GetProblemPredicateDetails_Request_TypeSupportInterface & operator = (const GetProblemPredicateDetails_Request_TypeSupportInterface &);
            };

            class  GetProblemPredicateDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetProblemPredicateDetails_Request_DataWriter_ptr _ptr_type;
                typedef GetProblemPredicateDetails_Request_DataWriter_var _var_type;

                static GetProblemPredicateDetails_Request_DataWriter_ptr _duplicate (GetProblemPredicateDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicateDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicateDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetProblemPredicateDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetProblemPredicateDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetProblemPredicateDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemPredicateDetails_Request_& instance_data) = 0;

            protected:
                GetProblemPredicateDetails_Request_DataWriter () {};
                ~GetProblemPredicateDetails_Request_DataWriter () {};
            private:
                GetProblemPredicateDetails_Request_DataWriter (const GetProblemPredicateDetails_Request_DataWriter &);
                GetProblemPredicateDetails_Request_DataWriter & operator = (const GetProblemPredicateDetails_Request_DataWriter &);
            };

            class  GetProblemPredicateDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetProblemPredicateDetails_Request_DataReader_ptr _ptr_type;
                typedef GetProblemPredicateDetails_Request_DataReader_var _var_type;

                static GetProblemPredicateDetails_Request_DataReader_ptr _duplicate (GetProblemPredicateDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicateDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicateDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemPredicateDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemPredicateDetails_Request_& instance) = 0;

            protected:
                GetProblemPredicateDetails_Request_DataReader () {};
                ~GetProblemPredicateDetails_Request_DataReader () {};
            private:
                GetProblemPredicateDetails_Request_DataReader (const GetProblemPredicateDetails_Request_DataReader &);
                GetProblemPredicateDetails_Request_DataReader & operator = (const GetProblemPredicateDetails_Request_DataReader &);
            };

            class  GetProblemPredicateDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetProblemPredicateDetails_Request_DataReaderView_ptr _ptr_type;
                typedef GetProblemPredicateDetails_Request_DataReaderView_var _var_type;

                static GetProblemPredicateDetails_Request_DataReaderView_ptr _duplicate (GetProblemPredicateDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicateDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicateDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemPredicateDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemPredicateDetails_Request_& instance) = 0;

            protected:
                GetProblemPredicateDetails_Request_DataReaderView () {};
                ~GetProblemPredicateDetails_Request_DataReaderView () {};
            private:
                GetProblemPredicateDetails_Request_DataReaderView (const GetProblemPredicateDetails_Request_DataReaderView &);
                GetProblemPredicateDetails_Request_DataReaderView & operator = (const GetProblemPredicateDetails_Request_DataReaderView &);
            };
            class GetProblemPredicateDetails_Response_TypeSupportInterface;

            typedef GetProblemPredicateDetails_Response_TypeSupportInterface * GetProblemPredicateDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicateDetails_Response_TypeSupportInterface> GetProblemPredicateDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicateDetails_Response_TypeSupportInterface> GetProblemPredicateDetails_Response_TypeSupportInterface_out;


            class GetProblemPredicateDetails_Response_DataWriter;

            typedef GetProblemPredicateDetails_Response_DataWriter * GetProblemPredicateDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicateDetails_Response_DataWriter> GetProblemPredicateDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicateDetails_Response_DataWriter> GetProblemPredicateDetails_Response_DataWriter_out;


            class GetProblemPredicateDetails_Response_DataReader;

            typedef GetProblemPredicateDetails_Response_DataReader * GetProblemPredicateDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicateDetails_Response_DataReader> GetProblemPredicateDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicateDetails_Response_DataReader> GetProblemPredicateDetails_Response_DataReader_out;


            class GetProblemPredicateDetails_Response_DataReaderView;

            typedef GetProblemPredicateDetails_Response_DataReaderView * GetProblemPredicateDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicateDetails_Response_DataReaderView> GetProblemPredicateDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicateDetails_Response_DataReaderView> GetProblemPredicateDetails_Response_DataReaderView_out;

            struct GetProblemPredicateDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetProblemPredicateDetails_Response_, struct GetProblemPredicateDetails_Response_Seq_uniq_> GetProblemPredicateDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < GetProblemPredicateDetails_Response_Seq> GetProblemPredicateDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetProblemPredicateDetails_Response_Seq> GetProblemPredicateDetails_Response_Seq_out;

            class  GetProblemPredicateDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetProblemPredicateDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetProblemPredicateDetails_Response_TypeSupportInterface_var _var_type;

                static GetProblemPredicateDetails_Response_TypeSupportInterface_ptr _duplicate (GetProblemPredicateDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicateDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicateDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetProblemPredicateDetails_Response_TypeSupportInterface () {};
                ~GetProblemPredicateDetails_Response_TypeSupportInterface () {};
            private:
                GetProblemPredicateDetails_Response_TypeSupportInterface (const GetProblemPredicateDetails_Response_TypeSupportInterface &);
                GetProblemPredicateDetails_Response_TypeSupportInterface & operator = (const GetProblemPredicateDetails_Response_TypeSupportInterface &);
            };

            class  GetProblemPredicateDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetProblemPredicateDetails_Response_DataWriter_ptr _ptr_type;
                typedef GetProblemPredicateDetails_Response_DataWriter_var _var_type;

                static GetProblemPredicateDetails_Response_DataWriter_ptr _duplicate (GetProblemPredicateDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicateDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicateDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetProblemPredicateDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetProblemPredicateDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetProblemPredicateDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemPredicateDetails_Response_& instance_data) = 0;

            protected:
                GetProblemPredicateDetails_Response_DataWriter () {};
                ~GetProblemPredicateDetails_Response_DataWriter () {};
            private:
                GetProblemPredicateDetails_Response_DataWriter (const GetProblemPredicateDetails_Response_DataWriter &);
                GetProblemPredicateDetails_Response_DataWriter & operator = (const GetProblemPredicateDetails_Response_DataWriter &);
            };

            class  GetProblemPredicateDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetProblemPredicateDetails_Response_DataReader_ptr _ptr_type;
                typedef GetProblemPredicateDetails_Response_DataReader_var _var_type;

                static GetProblemPredicateDetails_Response_DataReader_ptr _duplicate (GetProblemPredicateDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicateDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicateDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemPredicateDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemPredicateDetails_Response_& instance) = 0;

            protected:
                GetProblemPredicateDetails_Response_DataReader () {};
                ~GetProblemPredicateDetails_Response_DataReader () {};
            private:
                GetProblemPredicateDetails_Response_DataReader (const GetProblemPredicateDetails_Response_DataReader &);
                GetProblemPredicateDetails_Response_DataReader & operator = (const GetProblemPredicateDetails_Response_DataReader &);
            };

            class  GetProblemPredicateDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetProblemPredicateDetails_Response_DataReaderView_ptr _ptr_type;
                typedef GetProblemPredicateDetails_Response_DataReaderView_var _var_type;

                static GetProblemPredicateDetails_Response_DataReaderView_ptr _duplicate (GetProblemPredicateDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicateDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicateDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicateDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemPredicateDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemPredicateDetails_Response_& instance) = 0;

            protected:
                GetProblemPredicateDetails_Response_DataReaderView () {};
                ~GetProblemPredicateDetails_Response_DataReaderView () {};
            private:
                GetProblemPredicateDetails_Response_DataReaderView (const GetProblemPredicateDetails_Response_DataReaderView &);
                GetProblemPredicateDetails_Response_DataReaderView & operator = (const GetProblemPredicateDetails_Response_DataReaderView &);
            };
            class Sample_GetProblemPredicateDetails_Request_TypeSupportInterface;

            typedef Sample_GetProblemPredicateDetails_Request_TypeSupportInterface * Sample_GetProblemPredicateDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicateDetails_Request_TypeSupportInterface> Sample_GetProblemPredicateDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicateDetails_Request_TypeSupportInterface> Sample_GetProblemPredicateDetails_Request_TypeSupportInterface_out;


            class Sample_GetProblemPredicateDetails_Request_DataWriter;

            typedef Sample_GetProblemPredicateDetails_Request_DataWriter * Sample_GetProblemPredicateDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicateDetails_Request_DataWriter> Sample_GetProblemPredicateDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicateDetails_Request_DataWriter> Sample_GetProblemPredicateDetails_Request_DataWriter_out;


            class Sample_GetProblemPredicateDetails_Request_DataReader;

            typedef Sample_GetProblemPredicateDetails_Request_DataReader * Sample_GetProblemPredicateDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicateDetails_Request_DataReader> Sample_GetProblemPredicateDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicateDetails_Request_DataReader> Sample_GetProblemPredicateDetails_Request_DataReader_out;


            class Sample_GetProblemPredicateDetails_Request_DataReaderView;

            typedef Sample_GetProblemPredicateDetails_Request_DataReaderView * Sample_GetProblemPredicateDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicateDetails_Request_DataReaderView> Sample_GetProblemPredicateDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicateDetails_Request_DataReaderView> Sample_GetProblemPredicateDetails_Request_DataReaderView_out;

            struct Sample_GetProblemPredicateDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetProblemPredicateDetails_Request_, struct Sample_GetProblemPredicateDetails_Request_Seq_uniq_> Sample_GetProblemPredicateDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetProblemPredicateDetails_Request_Seq> Sample_GetProblemPredicateDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetProblemPredicateDetails_Request_Seq> Sample_GetProblemPredicateDetails_Request_Seq_out;

            class  Sample_GetProblemPredicateDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetProblemPredicateDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetProblemPredicateDetails_Request_TypeSupportInterface_var _var_type;

                static Sample_GetProblemPredicateDetails_Request_TypeSupportInterface_ptr _duplicate (Sample_GetProblemPredicateDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicateDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicateDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetProblemPredicateDetails_Request_TypeSupportInterface () {};
                ~Sample_GetProblemPredicateDetails_Request_TypeSupportInterface () {};
            private:
                Sample_GetProblemPredicateDetails_Request_TypeSupportInterface (const Sample_GetProblemPredicateDetails_Request_TypeSupportInterface &);
                Sample_GetProblemPredicateDetails_Request_TypeSupportInterface & operator = (const Sample_GetProblemPredicateDetails_Request_TypeSupportInterface &);
            };

            class  Sample_GetProblemPredicateDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetProblemPredicateDetails_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetProblemPredicateDetails_Request_DataWriter_var _var_type;

                static Sample_GetProblemPredicateDetails_Request_DataWriter_ptr _duplicate (Sample_GetProblemPredicateDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicateDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicateDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetProblemPredicateDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetProblemPredicateDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetProblemPredicateDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemPredicateDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemPredicateDetails_Request_& instance_data) = 0;

            protected:
                Sample_GetProblemPredicateDetails_Request_DataWriter () {};
                ~Sample_GetProblemPredicateDetails_Request_DataWriter () {};
            private:
                Sample_GetProblemPredicateDetails_Request_DataWriter (const Sample_GetProblemPredicateDetails_Request_DataWriter &);
                Sample_GetProblemPredicateDetails_Request_DataWriter & operator = (const Sample_GetProblemPredicateDetails_Request_DataWriter &);
            };

            class  Sample_GetProblemPredicateDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetProblemPredicateDetails_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetProblemPredicateDetails_Request_DataReader_var _var_type;

                static Sample_GetProblemPredicateDetails_Request_DataReader_ptr _duplicate (Sample_GetProblemPredicateDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicateDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicateDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemPredicateDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemPredicateDetails_Request_& instance) = 0;

            protected:
                Sample_GetProblemPredicateDetails_Request_DataReader () {};
                ~Sample_GetProblemPredicateDetails_Request_DataReader () {};
            private:
                Sample_GetProblemPredicateDetails_Request_DataReader (const Sample_GetProblemPredicateDetails_Request_DataReader &);
                Sample_GetProblemPredicateDetails_Request_DataReader & operator = (const Sample_GetProblemPredicateDetails_Request_DataReader &);
            };

            class  Sample_GetProblemPredicateDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetProblemPredicateDetails_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetProblemPredicateDetails_Request_DataReaderView_var _var_type;

                static Sample_GetProblemPredicateDetails_Request_DataReaderView_ptr _duplicate (Sample_GetProblemPredicateDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicateDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicateDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemPredicateDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemPredicateDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemPredicateDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemPredicateDetails_Request_& instance) = 0;

            protected:
                Sample_GetProblemPredicateDetails_Request_DataReaderView () {};
                ~Sample_GetProblemPredicateDetails_Request_DataReaderView () {};
            private:
                Sample_GetProblemPredicateDetails_Request_DataReaderView (const Sample_GetProblemPredicateDetails_Request_DataReaderView &);
                Sample_GetProblemPredicateDetails_Request_DataReaderView & operator = (const Sample_GetProblemPredicateDetails_Request_DataReaderView &);
            };
            class Sample_GetProblemPredicateDetails_Response_TypeSupportInterface;

            typedef Sample_GetProblemPredicateDetails_Response_TypeSupportInterface * Sample_GetProblemPredicateDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicateDetails_Response_TypeSupportInterface> Sample_GetProblemPredicateDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicateDetails_Response_TypeSupportInterface> Sample_GetProblemPredicateDetails_Response_TypeSupportInterface_out;


            class Sample_GetProblemPredicateDetails_Response_DataWriter;

            typedef Sample_GetProblemPredicateDetails_Response_DataWriter * Sample_GetProblemPredicateDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicateDetails_Response_DataWriter> Sample_GetProblemPredicateDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicateDetails_Response_DataWriter> Sample_GetProblemPredicateDetails_Response_DataWriter_out;


            class Sample_GetProblemPredicateDetails_Response_DataReader;

            typedef Sample_GetProblemPredicateDetails_Response_DataReader * Sample_GetProblemPredicateDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicateDetails_Response_DataReader> Sample_GetProblemPredicateDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicateDetails_Response_DataReader> Sample_GetProblemPredicateDetails_Response_DataReader_out;


            class Sample_GetProblemPredicateDetails_Response_DataReaderView;

            typedef Sample_GetProblemPredicateDetails_Response_DataReaderView * Sample_GetProblemPredicateDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicateDetails_Response_DataReaderView> Sample_GetProblemPredicateDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicateDetails_Response_DataReaderView> Sample_GetProblemPredicateDetails_Response_DataReaderView_out;

            struct Sample_GetProblemPredicateDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetProblemPredicateDetails_Response_, struct Sample_GetProblemPredicateDetails_Response_Seq_uniq_> Sample_GetProblemPredicateDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetProblemPredicateDetails_Response_Seq> Sample_GetProblemPredicateDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetProblemPredicateDetails_Response_Seq> Sample_GetProblemPredicateDetails_Response_Seq_out;

            class  Sample_GetProblemPredicateDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetProblemPredicateDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetProblemPredicateDetails_Response_TypeSupportInterface_var _var_type;

                static Sample_GetProblemPredicateDetails_Response_TypeSupportInterface_ptr _duplicate (Sample_GetProblemPredicateDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicateDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicateDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetProblemPredicateDetails_Response_TypeSupportInterface () {};
                ~Sample_GetProblemPredicateDetails_Response_TypeSupportInterface () {};
            private:
                Sample_GetProblemPredicateDetails_Response_TypeSupportInterface (const Sample_GetProblemPredicateDetails_Response_TypeSupportInterface &);
                Sample_GetProblemPredicateDetails_Response_TypeSupportInterface & operator = (const Sample_GetProblemPredicateDetails_Response_TypeSupportInterface &);
            };

            class  Sample_GetProblemPredicateDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetProblemPredicateDetails_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetProblemPredicateDetails_Response_DataWriter_var _var_type;

                static Sample_GetProblemPredicateDetails_Response_DataWriter_ptr _duplicate (Sample_GetProblemPredicateDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicateDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicateDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetProblemPredicateDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetProblemPredicateDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetProblemPredicateDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemPredicateDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemPredicateDetails_Response_& instance_data) = 0;

            protected:
                Sample_GetProblemPredicateDetails_Response_DataWriter () {};
                ~Sample_GetProblemPredicateDetails_Response_DataWriter () {};
            private:
                Sample_GetProblemPredicateDetails_Response_DataWriter (const Sample_GetProblemPredicateDetails_Response_DataWriter &);
                Sample_GetProblemPredicateDetails_Response_DataWriter & operator = (const Sample_GetProblemPredicateDetails_Response_DataWriter &);
            };

            class  Sample_GetProblemPredicateDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetProblemPredicateDetails_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetProblemPredicateDetails_Response_DataReader_var _var_type;

                static Sample_GetProblemPredicateDetails_Response_DataReader_ptr _duplicate (Sample_GetProblemPredicateDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicateDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicateDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemPredicateDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemPredicateDetails_Response_& instance) = 0;

            protected:
                Sample_GetProblemPredicateDetails_Response_DataReader () {};
                ~Sample_GetProblemPredicateDetails_Response_DataReader () {};
            private:
                Sample_GetProblemPredicateDetails_Response_DataReader (const Sample_GetProblemPredicateDetails_Response_DataReader &);
                Sample_GetProblemPredicateDetails_Response_DataReader & operator = (const Sample_GetProblemPredicateDetails_Response_DataReader &);
            };

            class  Sample_GetProblemPredicateDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetProblemPredicateDetails_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetProblemPredicateDetails_Response_DataReaderView_var _var_type;

                static Sample_GetProblemPredicateDetails_Response_DataReaderView_ptr _duplicate (Sample_GetProblemPredicateDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicateDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicateDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicateDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemPredicateDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemPredicateDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemPredicateDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemPredicateDetails_Response_& instance) = 0;

            protected:
                Sample_GetProblemPredicateDetails_Response_DataReaderView () {};
                ~Sample_GetProblemPredicateDetails_Response_DataReaderView () {};
            private:
                Sample_GetProblemPredicateDetails_Response_DataReaderView (const Sample_GetProblemPredicateDetails_Response_DataReaderView &);
                Sample_GetProblemPredicateDetails_Response_DataReaderView & operator = (const Sample_GetProblemPredicateDetails_Response_DataReaderView &);
            };
        }

    }

}

#endif
