#ifndef _H_4E9E96AF96218EA77108A9218262B526_GetProblemPredicates_DCPS_H_
#define _H_4E9E96AF96218EA77108A9218262B526_GetProblemPredicates_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetProblemPredicates_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetProblemPredicates_Request_TypeSupportInterface;

            typedef GetProblemPredicates_Request_TypeSupportInterface * GetProblemPredicates_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicates_Request_TypeSupportInterface> GetProblemPredicates_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicates_Request_TypeSupportInterface> GetProblemPredicates_Request_TypeSupportInterface_out;


            class GetProblemPredicates_Request_DataWriter;

            typedef GetProblemPredicates_Request_DataWriter * GetProblemPredicates_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicates_Request_DataWriter> GetProblemPredicates_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicates_Request_DataWriter> GetProblemPredicates_Request_DataWriter_out;


            class GetProblemPredicates_Request_DataReader;

            typedef GetProblemPredicates_Request_DataReader * GetProblemPredicates_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicates_Request_DataReader> GetProblemPredicates_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicates_Request_DataReader> GetProblemPredicates_Request_DataReader_out;


            class GetProblemPredicates_Request_DataReaderView;

            typedef GetProblemPredicates_Request_DataReaderView * GetProblemPredicates_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicates_Request_DataReaderView> GetProblemPredicates_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicates_Request_DataReaderView> GetProblemPredicates_Request_DataReaderView_out;

            struct GetProblemPredicates_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetProblemPredicates_Request_, struct GetProblemPredicates_Request_Seq_uniq_> GetProblemPredicates_Request_Seq;
            typedef DDS_DCPSSequence_var < GetProblemPredicates_Request_Seq> GetProblemPredicates_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetProblemPredicates_Request_Seq> GetProblemPredicates_Request_Seq_out;

            class  GetProblemPredicates_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetProblemPredicates_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetProblemPredicates_Request_TypeSupportInterface_var _var_type;

                static GetProblemPredicates_Request_TypeSupportInterface_ptr _duplicate (GetProblemPredicates_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicates_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicates_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetProblemPredicates_Request_TypeSupportInterface () {};
                ~GetProblemPredicates_Request_TypeSupportInterface () {};
            private:
                GetProblemPredicates_Request_TypeSupportInterface (const GetProblemPredicates_Request_TypeSupportInterface &);
                GetProblemPredicates_Request_TypeSupportInterface & operator = (const GetProblemPredicates_Request_TypeSupportInterface &);
            };

            class  GetProblemPredicates_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetProblemPredicates_Request_DataWriter_ptr _ptr_type;
                typedef GetProblemPredicates_Request_DataWriter_var _var_type;

                static GetProblemPredicates_Request_DataWriter_ptr _duplicate (GetProblemPredicates_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicates_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicates_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetProblemPredicates_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetProblemPredicates_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetProblemPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetProblemPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetProblemPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetProblemPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetProblemPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetProblemPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetProblemPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetProblemPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetProblemPredicates_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemPredicates_Request_& instance_data) = 0;

            protected:
                GetProblemPredicates_Request_DataWriter () {};
                ~GetProblemPredicates_Request_DataWriter () {};
            private:
                GetProblemPredicates_Request_DataWriter (const GetProblemPredicates_Request_DataWriter &);
                GetProblemPredicates_Request_DataWriter & operator = (const GetProblemPredicates_Request_DataWriter &);
            };

            class  GetProblemPredicates_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetProblemPredicates_Request_DataReader_ptr _ptr_type;
                typedef GetProblemPredicates_Request_DataReader_var _var_type;

                static GetProblemPredicates_Request_DataReader_ptr _duplicate (GetProblemPredicates_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicates_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicates_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemPredicates_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemPredicates_Request_& instance) = 0;

            protected:
                GetProblemPredicates_Request_DataReader () {};
                ~GetProblemPredicates_Request_DataReader () {};
            private:
                GetProblemPredicates_Request_DataReader (const GetProblemPredicates_Request_DataReader &);
                GetProblemPredicates_Request_DataReader & operator = (const GetProblemPredicates_Request_DataReader &);
            };

            class  GetProblemPredicates_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetProblemPredicates_Request_DataReaderView_ptr _ptr_type;
                typedef GetProblemPredicates_Request_DataReaderView_var _var_type;

                static GetProblemPredicates_Request_DataReaderView_ptr _duplicate (GetProblemPredicates_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicates_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicates_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemPredicates_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemPredicates_Request_& instance) = 0;

            protected:
                GetProblemPredicates_Request_DataReaderView () {};
                ~GetProblemPredicates_Request_DataReaderView () {};
            private:
                GetProblemPredicates_Request_DataReaderView (const GetProblemPredicates_Request_DataReaderView &);
                GetProblemPredicates_Request_DataReaderView & operator = (const GetProblemPredicates_Request_DataReaderView &);
            };
            class GetProblemPredicates_Response_TypeSupportInterface;

            typedef GetProblemPredicates_Response_TypeSupportInterface * GetProblemPredicates_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicates_Response_TypeSupportInterface> GetProblemPredicates_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicates_Response_TypeSupportInterface> GetProblemPredicates_Response_TypeSupportInterface_out;


            class GetProblemPredicates_Response_DataWriter;

            typedef GetProblemPredicates_Response_DataWriter * GetProblemPredicates_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicates_Response_DataWriter> GetProblemPredicates_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicates_Response_DataWriter> GetProblemPredicates_Response_DataWriter_out;


            class GetProblemPredicates_Response_DataReader;

            typedef GetProblemPredicates_Response_DataReader * GetProblemPredicates_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicates_Response_DataReader> GetProblemPredicates_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicates_Response_DataReader> GetProblemPredicates_Response_DataReader_out;


            class GetProblemPredicates_Response_DataReaderView;

            typedef GetProblemPredicates_Response_DataReaderView * GetProblemPredicates_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetProblemPredicates_Response_DataReaderView> GetProblemPredicates_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetProblemPredicates_Response_DataReaderView> GetProblemPredicates_Response_DataReaderView_out;

            struct GetProblemPredicates_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetProblemPredicates_Response_, struct GetProblemPredicates_Response_Seq_uniq_> GetProblemPredicates_Response_Seq;
            typedef DDS_DCPSSequence_var < GetProblemPredicates_Response_Seq> GetProblemPredicates_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetProblemPredicates_Response_Seq> GetProblemPredicates_Response_Seq_out;

            class  GetProblemPredicates_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetProblemPredicates_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetProblemPredicates_Response_TypeSupportInterface_var _var_type;

                static GetProblemPredicates_Response_TypeSupportInterface_ptr _duplicate (GetProblemPredicates_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicates_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicates_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetProblemPredicates_Response_TypeSupportInterface () {};
                ~GetProblemPredicates_Response_TypeSupportInterface () {};
            private:
                GetProblemPredicates_Response_TypeSupportInterface (const GetProblemPredicates_Response_TypeSupportInterface &);
                GetProblemPredicates_Response_TypeSupportInterface & operator = (const GetProblemPredicates_Response_TypeSupportInterface &);
            };

            class  GetProblemPredicates_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetProblemPredicates_Response_DataWriter_ptr _ptr_type;
                typedef GetProblemPredicates_Response_DataWriter_var _var_type;

                static GetProblemPredicates_Response_DataWriter_ptr _duplicate (GetProblemPredicates_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicates_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicates_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetProblemPredicates_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetProblemPredicates_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetProblemPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetProblemPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetProblemPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetProblemPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetProblemPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetProblemPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetProblemPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetProblemPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetProblemPredicates_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemPredicates_Response_& instance_data) = 0;

            protected:
                GetProblemPredicates_Response_DataWriter () {};
                ~GetProblemPredicates_Response_DataWriter () {};
            private:
                GetProblemPredicates_Response_DataWriter (const GetProblemPredicates_Response_DataWriter &);
                GetProblemPredicates_Response_DataWriter & operator = (const GetProblemPredicates_Response_DataWriter &);
            };

            class  GetProblemPredicates_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetProblemPredicates_Response_DataReader_ptr _ptr_type;
                typedef GetProblemPredicates_Response_DataReader_var _var_type;

                static GetProblemPredicates_Response_DataReader_ptr _duplicate (GetProblemPredicates_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicates_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicates_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemPredicates_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemPredicates_Response_& instance) = 0;

            protected:
                GetProblemPredicates_Response_DataReader () {};
                ~GetProblemPredicates_Response_DataReader () {};
            private:
                GetProblemPredicates_Response_DataReader (const GetProblemPredicates_Response_DataReader &);
                GetProblemPredicates_Response_DataReader & operator = (const GetProblemPredicates_Response_DataReader &);
            };

            class  GetProblemPredicates_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetProblemPredicates_Response_DataReaderView_ptr _ptr_type;
                typedef GetProblemPredicates_Response_DataReaderView_var _var_type;

                static GetProblemPredicates_Response_DataReaderView_ptr _duplicate (GetProblemPredicates_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemPredicates_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemPredicates_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemPredicates_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemPredicates_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemPredicates_Response_& instance) = 0;

            protected:
                GetProblemPredicates_Response_DataReaderView () {};
                ~GetProblemPredicates_Response_DataReaderView () {};
            private:
                GetProblemPredicates_Response_DataReaderView (const GetProblemPredicates_Response_DataReaderView &);
                GetProblemPredicates_Response_DataReaderView & operator = (const GetProblemPredicates_Response_DataReaderView &);
            };
            class Sample_GetProblemPredicates_Request_TypeSupportInterface;

            typedef Sample_GetProblemPredicates_Request_TypeSupportInterface * Sample_GetProblemPredicates_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicates_Request_TypeSupportInterface> Sample_GetProblemPredicates_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicates_Request_TypeSupportInterface> Sample_GetProblemPredicates_Request_TypeSupportInterface_out;


            class Sample_GetProblemPredicates_Request_DataWriter;

            typedef Sample_GetProblemPredicates_Request_DataWriter * Sample_GetProblemPredicates_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicates_Request_DataWriter> Sample_GetProblemPredicates_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicates_Request_DataWriter> Sample_GetProblemPredicates_Request_DataWriter_out;


            class Sample_GetProblemPredicates_Request_DataReader;

            typedef Sample_GetProblemPredicates_Request_DataReader * Sample_GetProblemPredicates_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicates_Request_DataReader> Sample_GetProblemPredicates_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicates_Request_DataReader> Sample_GetProblemPredicates_Request_DataReader_out;


            class Sample_GetProblemPredicates_Request_DataReaderView;

            typedef Sample_GetProblemPredicates_Request_DataReaderView * Sample_GetProblemPredicates_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicates_Request_DataReaderView> Sample_GetProblemPredicates_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicates_Request_DataReaderView> Sample_GetProblemPredicates_Request_DataReaderView_out;

            struct Sample_GetProblemPredicates_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetProblemPredicates_Request_, struct Sample_GetProblemPredicates_Request_Seq_uniq_> Sample_GetProblemPredicates_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetProblemPredicates_Request_Seq> Sample_GetProblemPredicates_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetProblemPredicates_Request_Seq> Sample_GetProblemPredicates_Request_Seq_out;

            class  Sample_GetProblemPredicates_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetProblemPredicates_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetProblemPredicates_Request_TypeSupportInterface_var _var_type;

                static Sample_GetProblemPredicates_Request_TypeSupportInterface_ptr _duplicate (Sample_GetProblemPredicates_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicates_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicates_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetProblemPredicates_Request_TypeSupportInterface () {};
                ~Sample_GetProblemPredicates_Request_TypeSupportInterface () {};
            private:
                Sample_GetProblemPredicates_Request_TypeSupportInterface (const Sample_GetProblemPredicates_Request_TypeSupportInterface &);
                Sample_GetProblemPredicates_Request_TypeSupportInterface & operator = (const Sample_GetProblemPredicates_Request_TypeSupportInterface &);
            };

            class  Sample_GetProblemPredicates_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetProblemPredicates_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetProblemPredicates_Request_DataWriter_var _var_type;

                static Sample_GetProblemPredicates_Request_DataWriter_ptr _duplicate (Sample_GetProblemPredicates_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicates_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicates_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetProblemPredicates_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetProblemPredicates_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetProblemPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetProblemPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetProblemPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetProblemPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetProblemPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetProblemPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetProblemPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetProblemPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemPredicates_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemPredicates_Request_& instance_data) = 0;

            protected:
                Sample_GetProblemPredicates_Request_DataWriter () {};
                ~Sample_GetProblemPredicates_Request_DataWriter () {};
            private:
                Sample_GetProblemPredicates_Request_DataWriter (const Sample_GetProblemPredicates_Request_DataWriter &);
                Sample_GetProblemPredicates_Request_DataWriter & operator = (const Sample_GetProblemPredicates_Request_DataWriter &);
            };

            class  Sample_GetProblemPredicates_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetProblemPredicates_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetProblemPredicates_Request_DataReader_var _var_type;

                static Sample_GetProblemPredicates_Request_DataReader_ptr _duplicate (Sample_GetProblemPredicates_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicates_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicates_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemPredicates_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemPredicates_Request_& instance) = 0;

            protected:
                Sample_GetProblemPredicates_Request_DataReader () {};
                ~Sample_GetProblemPredicates_Request_DataReader () {};
            private:
                Sample_GetProblemPredicates_Request_DataReader (const Sample_GetProblemPredicates_Request_DataReader &);
                Sample_GetProblemPredicates_Request_DataReader & operator = (const Sample_GetProblemPredicates_Request_DataReader &);
            };

            class  Sample_GetProblemPredicates_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetProblemPredicates_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetProblemPredicates_Request_DataReaderView_var _var_type;

                static Sample_GetProblemPredicates_Request_DataReaderView_ptr _duplicate (Sample_GetProblemPredicates_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicates_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicates_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemPredicates_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemPredicates_Request_& instance) = 0;

            protected:
                Sample_GetProblemPredicates_Request_DataReaderView () {};
                ~Sample_GetProblemPredicates_Request_DataReaderView () {};
            private:
                Sample_GetProblemPredicates_Request_DataReaderView (const Sample_GetProblemPredicates_Request_DataReaderView &);
                Sample_GetProblemPredicates_Request_DataReaderView & operator = (const Sample_GetProblemPredicates_Request_DataReaderView &);
            };
            class Sample_GetProblemPredicates_Response_TypeSupportInterface;

            typedef Sample_GetProblemPredicates_Response_TypeSupportInterface * Sample_GetProblemPredicates_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicates_Response_TypeSupportInterface> Sample_GetProblemPredicates_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicates_Response_TypeSupportInterface> Sample_GetProblemPredicates_Response_TypeSupportInterface_out;


            class Sample_GetProblemPredicates_Response_DataWriter;

            typedef Sample_GetProblemPredicates_Response_DataWriter * Sample_GetProblemPredicates_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicates_Response_DataWriter> Sample_GetProblemPredicates_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicates_Response_DataWriter> Sample_GetProblemPredicates_Response_DataWriter_out;


            class Sample_GetProblemPredicates_Response_DataReader;

            typedef Sample_GetProblemPredicates_Response_DataReader * Sample_GetProblemPredicates_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicates_Response_DataReader> Sample_GetProblemPredicates_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicates_Response_DataReader> Sample_GetProblemPredicates_Response_DataReader_out;


            class Sample_GetProblemPredicates_Response_DataReaderView;

            typedef Sample_GetProblemPredicates_Response_DataReaderView * Sample_GetProblemPredicates_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemPredicates_Response_DataReaderView> Sample_GetProblemPredicates_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemPredicates_Response_DataReaderView> Sample_GetProblemPredicates_Response_DataReaderView_out;

            struct Sample_GetProblemPredicates_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetProblemPredicates_Response_, struct Sample_GetProblemPredicates_Response_Seq_uniq_> Sample_GetProblemPredicates_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetProblemPredicates_Response_Seq> Sample_GetProblemPredicates_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetProblemPredicates_Response_Seq> Sample_GetProblemPredicates_Response_Seq_out;

            class  Sample_GetProblemPredicates_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetProblemPredicates_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetProblemPredicates_Response_TypeSupportInterface_var _var_type;

                static Sample_GetProblemPredicates_Response_TypeSupportInterface_ptr _duplicate (Sample_GetProblemPredicates_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicates_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicates_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetProblemPredicates_Response_TypeSupportInterface () {};
                ~Sample_GetProblemPredicates_Response_TypeSupportInterface () {};
            private:
                Sample_GetProblemPredicates_Response_TypeSupportInterface (const Sample_GetProblemPredicates_Response_TypeSupportInterface &);
                Sample_GetProblemPredicates_Response_TypeSupportInterface & operator = (const Sample_GetProblemPredicates_Response_TypeSupportInterface &);
            };

            class  Sample_GetProblemPredicates_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetProblemPredicates_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetProblemPredicates_Response_DataWriter_var _var_type;

                static Sample_GetProblemPredicates_Response_DataWriter_ptr _duplicate (Sample_GetProblemPredicates_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicates_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicates_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetProblemPredicates_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetProblemPredicates_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetProblemPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetProblemPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetProblemPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetProblemPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetProblemPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetProblemPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetProblemPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetProblemPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemPredicates_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemPredicates_Response_& instance_data) = 0;

            protected:
                Sample_GetProblemPredicates_Response_DataWriter () {};
                ~Sample_GetProblemPredicates_Response_DataWriter () {};
            private:
                Sample_GetProblemPredicates_Response_DataWriter (const Sample_GetProblemPredicates_Response_DataWriter &);
                Sample_GetProblemPredicates_Response_DataWriter & operator = (const Sample_GetProblemPredicates_Response_DataWriter &);
            };

            class  Sample_GetProblemPredicates_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetProblemPredicates_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetProblemPredicates_Response_DataReader_var _var_type;

                static Sample_GetProblemPredicates_Response_DataReader_ptr _duplicate (Sample_GetProblemPredicates_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicates_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicates_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemPredicates_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemPredicates_Response_& instance) = 0;

            protected:
                Sample_GetProblemPredicates_Response_DataReader () {};
                ~Sample_GetProblemPredicates_Response_DataReader () {};
            private:
                Sample_GetProblemPredicates_Response_DataReader (const Sample_GetProblemPredicates_Response_DataReader &);
                Sample_GetProblemPredicates_Response_DataReader & operator = (const Sample_GetProblemPredicates_Response_DataReader &);
            };

            class  Sample_GetProblemPredicates_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetProblemPredicates_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetProblemPredicates_Response_DataReaderView_var _var_type;

                static Sample_GetProblemPredicates_Response_DataReaderView_ptr _duplicate (Sample_GetProblemPredicates_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemPredicates_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemPredicates_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemPredicates_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemPredicates_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemPredicates_Response_& instance) = 0;

            protected:
                Sample_GetProblemPredicates_Response_DataReaderView () {};
                ~Sample_GetProblemPredicates_Response_DataReaderView () {};
            private:
                Sample_GetProblemPredicates_Response_DataReaderView (const Sample_GetProblemPredicates_Response_DataReaderView &);
                Sample_GetProblemPredicates_Response_DataReaderView & operator = (const Sample_GetProblemPredicates_Response_DataReaderView &);
            };
        }

    }

}

#endif
