#ifndef _H_B2A00693F8A3082B2928903C0AFFECB6_GetProblem_DCPS_H_
#define _H_B2A00693F8A3082B2928903C0AFFECB6_GetProblem_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetProblem_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetProblem_Request_TypeSupportInterface;

            typedef GetProblem_Request_TypeSupportInterface * GetProblem_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetProblem_Request_TypeSupportInterface> GetProblem_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetProblem_Request_TypeSupportInterface> GetProblem_Request_TypeSupportInterface_out;


            class GetProblem_Request_DataWriter;

            typedef GetProblem_Request_DataWriter * GetProblem_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetProblem_Request_DataWriter> GetProblem_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetProblem_Request_DataWriter> GetProblem_Request_DataWriter_out;


            class GetProblem_Request_DataReader;

            typedef GetProblem_Request_DataReader * GetProblem_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetProblem_Request_DataReader> GetProblem_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetProblem_Request_DataReader> GetProblem_Request_DataReader_out;


            class GetProblem_Request_DataReaderView;

            typedef GetProblem_Request_DataReaderView * GetProblem_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetProblem_Request_DataReaderView> GetProblem_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetProblem_Request_DataReaderView> GetProblem_Request_DataReaderView_out;

            struct GetProblem_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetProblem_Request_, struct GetProblem_Request_Seq_uniq_> GetProblem_Request_Seq;
            typedef DDS_DCPSSequence_var < GetProblem_Request_Seq> GetProblem_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetProblem_Request_Seq> GetProblem_Request_Seq_out;

            class  GetProblem_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetProblem_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetProblem_Request_TypeSupportInterface_var _var_type;

                static GetProblem_Request_TypeSupportInterface_ptr _duplicate (GetProblem_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblem_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetProblem_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblem_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblem_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetProblem_Request_TypeSupportInterface () {};
                ~GetProblem_Request_TypeSupportInterface () {};
            private:
                GetProblem_Request_TypeSupportInterface (const GetProblem_Request_TypeSupportInterface &);
                GetProblem_Request_TypeSupportInterface & operator = (const GetProblem_Request_TypeSupportInterface &);
            };

            class  GetProblem_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetProblem_Request_DataWriter_ptr _ptr_type;
                typedef GetProblem_Request_DataWriter_var _var_type;

                static GetProblem_Request_DataWriter_ptr _duplicate (GetProblem_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblem_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetProblem_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblem_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblem_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetProblem_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetProblem_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetProblem_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetProblem_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetProblem_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetProblem_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetProblem_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetProblem_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetProblem_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetProblem_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetProblem_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblem_Request_& instance_data) = 0;

            protected:
                GetProblem_Request_DataWriter () {};
                ~GetProblem_Request_DataWriter () {};
            private:
                GetProblem_Request_DataWriter (const GetProblem_Request_DataWriter &);
                GetProblem_Request_DataWriter & operator = (const GetProblem_Request_DataWriter &);
            };

            class  GetProblem_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetProblem_Request_DataReader_ptr _ptr_type;
                typedef GetProblem_Request_DataReader_var _var_type;

                static GetProblem_Request_DataReader_ptr _duplicate (GetProblem_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblem_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetProblem_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblem_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblem_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblem_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblem_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblem_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblem_Request_& instance) = 0;

            protected:
                GetProblem_Request_DataReader () {};
                ~GetProblem_Request_DataReader () {};
            private:
                GetProblem_Request_DataReader (const GetProblem_Request_DataReader &);
                GetProblem_Request_DataReader & operator = (const GetProblem_Request_DataReader &);
            };

            class  GetProblem_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetProblem_Request_DataReaderView_ptr _ptr_type;
                typedef GetProblem_Request_DataReaderView_var _var_type;

                static GetProblem_Request_DataReaderView_ptr _duplicate (GetProblem_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblem_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetProblem_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblem_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblem_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblem_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblem_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblem_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblem_Request_& instance) = 0;

            protected:
                GetProblem_Request_DataReaderView () {};
                ~GetProblem_Request_DataReaderView () {};
            private:
                GetProblem_Request_DataReaderView (const GetProblem_Request_DataReaderView &);
                GetProblem_Request_DataReaderView & operator = (const GetProblem_Request_DataReaderView &);
            };
            class GetProblem_Response_TypeSupportInterface;

            typedef GetProblem_Response_TypeSupportInterface * GetProblem_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetProblem_Response_TypeSupportInterface> GetProblem_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetProblem_Response_TypeSupportInterface> GetProblem_Response_TypeSupportInterface_out;


            class GetProblem_Response_DataWriter;

            typedef GetProblem_Response_DataWriter * GetProblem_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetProblem_Response_DataWriter> GetProblem_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetProblem_Response_DataWriter> GetProblem_Response_DataWriter_out;


            class GetProblem_Response_DataReader;

            typedef GetProblem_Response_DataReader * GetProblem_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetProblem_Response_DataReader> GetProblem_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetProblem_Response_DataReader> GetProblem_Response_DataReader_out;


            class GetProblem_Response_DataReaderView;

            typedef GetProblem_Response_DataReaderView * GetProblem_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetProblem_Response_DataReaderView> GetProblem_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetProblem_Response_DataReaderView> GetProblem_Response_DataReaderView_out;

            struct GetProblem_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetProblem_Response_, struct GetProblem_Response_Seq_uniq_> GetProblem_Response_Seq;
            typedef DDS_DCPSSequence_var < GetProblem_Response_Seq> GetProblem_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetProblem_Response_Seq> GetProblem_Response_Seq_out;

            class  GetProblem_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetProblem_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetProblem_Response_TypeSupportInterface_var _var_type;

                static GetProblem_Response_TypeSupportInterface_ptr _duplicate (GetProblem_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblem_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetProblem_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblem_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblem_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetProblem_Response_TypeSupportInterface () {};
                ~GetProblem_Response_TypeSupportInterface () {};
            private:
                GetProblem_Response_TypeSupportInterface (const GetProblem_Response_TypeSupportInterface &);
                GetProblem_Response_TypeSupportInterface & operator = (const GetProblem_Response_TypeSupportInterface &);
            };

            class  GetProblem_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetProblem_Response_DataWriter_ptr _ptr_type;
                typedef GetProblem_Response_DataWriter_var _var_type;

                static GetProblem_Response_DataWriter_ptr _duplicate (GetProblem_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblem_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetProblem_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblem_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblem_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetProblem_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetProblem_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetProblem_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetProblem_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetProblem_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetProblem_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetProblem_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetProblem_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetProblem_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetProblem_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetProblem_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblem_Response_& instance_data) = 0;

            protected:
                GetProblem_Response_DataWriter () {};
                ~GetProblem_Response_DataWriter () {};
            private:
                GetProblem_Response_DataWriter (const GetProblem_Response_DataWriter &);
                GetProblem_Response_DataWriter & operator = (const GetProblem_Response_DataWriter &);
            };

            class  GetProblem_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetProblem_Response_DataReader_ptr _ptr_type;
                typedef GetProblem_Response_DataReader_var _var_type;

                static GetProblem_Response_DataReader_ptr _duplicate (GetProblem_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblem_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetProblem_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblem_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblem_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblem_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblem_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblem_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblem_Response_& instance) = 0;

            protected:
                GetProblem_Response_DataReader () {};
                ~GetProblem_Response_DataReader () {};
            private:
                GetProblem_Response_DataReader (const GetProblem_Response_DataReader &);
                GetProblem_Response_DataReader & operator = (const GetProblem_Response_DataReader &);
            };

            class  GetProblem_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetProblem_Response_DataReaderView_ptr _ptr_type;
                typedef GetProblem_Response_DataReaderView_var _var_type;

                static GetProblem_Response_DataReaderView_ptr _duplicate (GetProblem_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblem_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetProblem_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblem_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblem_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblem_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblem_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblem_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblem_Response_& instance) = 0;

            protected:
                GetProblem_Response_DataReaderView () {};
                ~GetProblem_Response_DataReaderView () {};
            private:
                GetProblem_Response_DataReaderView (const GetProblem_Response_DataReaderView &);
                GetProblem_Response_DataReaderView & operator = (const GetProblem_Response_DataReaderView &);
            };
            class Sample_GetProblem_Request_TypeSupportInterface;

            typedef Sample_GetProblem_Request_TypeSupportInterface * Sample_GetProblem_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblem_Request_TypeSupportInterface> Sample_GetProblem_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblem_Request_TypeSupportInterface> Sample_GetProblem_Request_TypeSupportInterface_out;


            class Sample_GetProblem_Request_DataWriter;

            typedef Sample_GetProblem_Request_DataWriter * Sample_GetProblem_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblem_Request_DataWriter> Sample_GetProblem_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblem_Request_DataWriter> Sample_GetProblem_Request_DataWriter_out;


            class Sample_GetProblem_Request_DataReader;

            typedef Sample_GetProblem_Request_DataReader * Sample_GetProblem_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblem_Request_DataReader> Sample_GetProblem_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblem_Request_DataReader> Sample_GetProblem_Request_DataReader_out;


            class Sample_GetProblem_Request_DataReaderView;

            typedef Sample_GetProblem_Request_DataReaderView * Sample_GetProblem_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblem_Request_DataReaderView> Sample_GetProblem_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblem_Request_DataReaderView> Sample_GetProblem_Request_DataReaderView_out;

            struct Sample_GetProblem_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetProblem_Request_, struct Sample_GetProblem_Request_Seq_uniq_> Sample_GetProblem_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetProblem_Request_Seq> Sample_GetProblem_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetProblem_Request_Seq> Sample_GetProblem_Request_Seq_out;

            class  Sample_GetProblem_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetProblem_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetProblem_Request_TypeSupportInterface_var _var_type;

                static Sample_GetProblem_Request_TypeSupportInterface_ptr _duplicate (Sample_GetProblem_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblem_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblem_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetProblem_Request_TypeSupportInterface () {};
                ~Sample_GetProblem_Request_TypeSupportInterface () {};
            private:
                Sample_GetProblem_Request_TypeSupportInterface (const Sample_GetProblem_Request_TypeSupportInterface &);
                Sample_GetProblem_Request_TypeSupportInterface & operator = (const Sample_GetProblem_Request_TypeSupportInterface &);
            };

            class  Sample_GetProblem_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetProblem_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetProblem_Request_DataWriter_var _var_type;

                static Sample_GetProblem_Request_DataWriter_ptr _duplicate (Sample_GetProblem_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblem_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblem_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetProblem_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetProblem_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetProblem_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetProblem_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetProblem_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetProblem_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetProblem_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetProblem_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetProblem_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetProblem_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblem_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblem_Request_& instance_data) = 0;

            protected:
                Sample_GetProblem_Request_DataWriter () {};
                ~Sample_GetProblem_Request_DataWriter () {};
            private:
                Sample_GetProblem_Request_DataWriter (const Sample_GetProblem_Request_DataWriter &);
                Sample_GetProblem_Request_DataWriter & operator = (const Sample_GetProblem_Request_DataWriter &);
            };

            class  Sample_GetProblem_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetProblem_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetProblem_Request_DataReader_var _var_type;

                static Sample_GetProblem_Request_DataReader_ptr _duplicate (Sample_GetProblem_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblem_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblem_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblem_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblem_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblem_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblem_Request_& instance) = 0;

            protected:
                Sample_GetProblem_Request_DataReader () {};
                ~Sample_GetProblem_Request_DataReader () {};
            private:
                Sample_GetProblem_Request_DataReader (const Sample_GetProblem_Request_DataReader &);
                Sample_GetProblem_Request_DataReader & operator = (const Sample_GetProblem_Request_DataReader &);
            };

            class  Sample_GetProblem_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetProblem_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetProblem_Request_DataReaderView_var _var_type;

                static Sample_GetProblem_Request_DataReaderView_ptr _duplicate (Sample_GetProblem_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblem_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblem_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblem_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblem_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblem_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblem_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblem_Request_& instance) = 0;

            protected:
                Sample_GetProblem_Request_DataReaderView () {};
                ~Sample_GetProblem_Request_DataReaderView () {};
            private:
                Sample_GetProblem_Request_DataReaderView (const Sample_GetProblem_Request_DataReaderView &);
                Sample_GetProblem_Request_DataReaderView & operator = (const Sample_GetProblem_Request_DataReaderView &);
            };
            class Sample_GetProblem_Response_TypeSupportInterface;

            typedef Sample_GetProblem_Response_TypeSupportInterface * Sample_GetProblem_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblem_Response_TypeSupportInterface> Sample_GetProblem_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblem_Response_TypeSupportInterface> Sample_GetProblem_Response_TypeSupportInterface_out;


            class Sample_GetProblem_Response_DataWriter;

            typedef Sample_GetProblem_Response_DataWriter * Sample_GetProblem_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblem_Response_DataWriter> Sample_GetProblem_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblem_Response_DataWriter> Sample_GetProblem_Response_DataWriter_out;


            class Sample_GetProblem_Response_DataReader;

            typedef Sample_GetProblem_Response_DataReader * Sample_GetProblem_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblem_Response_DataReader> Sample_GetProblem_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblem_Response_DataReader> Sample_GetProblem_Response_DataReader_out;


            class Sample_GetProblem_Response_DataReaderView;

            typedef Sample_GetProblem_Response_DataReaderView * Sample_GetProblem_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblem_Response_DataReaderView> Sample_GetProblem_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblem_Response_DataReaderView> Sample_GetProblem_Response_DataReaderView_out;

            struct Sample_GetProblem_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetProblem_Response_, struct Sample_GetProblem_Response_Seq_uniq_> Sample_GetProblem_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetProblem_Response_Seq> Sample_GetProblem_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetProblem_Response_Seq> Sample_GetProblem_Response_Seq_out;

            class  Sample_GetProblem_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetProblem_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetProblem_Response_TypeSupportInterface_var _var_type;

                static Sample_GetProblem_Response_TypeSupportInterface_ptr _duplicate (Sample_GetProblem_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblem_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblem_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetProblem_Response_TypeSupportInterface () {};
                ~Sample_GetProblem_Response_TypeSupportInterface () {};
            private:
                Sample_GetProblem_Response_TypeSupportInterface (const Sample_GetProblem_Response_TypeSupportInterface &);
                Sample_GetProblem_Response_TypeSupportInterface & operator = (const Sample_GetProblem_Response_TypeSupportInterface &);
            };

            class  Sample_GetProblem_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetProblem_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetProblem_Response_DataWriter_var _var_type;

                static Sample_GetProblem_Response_DataWriter_ptr _duplicate (Sample_GetProblem_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblem_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblem_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetProblem_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetProblem_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetProblem_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetProblem_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetProblem_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetProblem_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetProblem_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetProblem_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetProblem_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetProblem_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblem_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblem_Response_& instance_data) = 0;

            protected:
                Sample_GetProblem_Response_DataWriter () {};
                ~Sample_GetProblem_Response_DataWriter () {};
            private:
                Sample_GetProblem_Response_DataWriter (const Sample_GetProblem_Response_DataWriter &);
                Sample_GetProblem_Response_DataWriter & operator = (const Sample_GetProblem_Response_DataWriter &);
            };

            class  Sample_GetProblem_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetProblem_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetProblem_Response_DataReader_var _var_type;

                static Sample_GetProblem_Response_DataReader_ptr _duplicate (Sample_GetProblem_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblem_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblem_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblem_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblem_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblem_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblem_Response_& instance) = 0;

            protected:
                Sample_GetProblem_Response_DataReader () {};
                ~Sample_GetProblem_Response_DataReader () {};
            private:
                Sample_GetProblem_Response_DataReader (const Sample_GetProblem_Response_DataReader &);
                Sample_GetProblem_Response_DataReader & operator = (const Sample_GetProblem_Response_DataReader &);
            };

            class  Sample_GetProblem_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetProblem_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetProblem_Response_DataReaderView_var _var_type;

                static Sample_GetProblem_Response_DataReaderView_ptr _duplicate (Sample_GetProblem_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblem_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblem_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblem_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblem_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblem_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblem_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblem_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblem_Response_& instance) = 0;

            protected:
                Sample_GetProblem_Response_DataReaderView () {};
                ~Sample_GetProblem_Response_DataReaderView () {};
            private:
                Sample_GetProblem_Response_DataReaderView (const Sample_GetProblem_Response_DataReaderView &);
                Sample_GetProblem_Response_DataReaderView & operator = (const Sample_GetProblem_Response_DataReaderView &);
            };
        }

    }

}

#endif
