#ifndef _H_8507BF1E07EEBBF24EDA265099FE8C95_RemoveProblemGoal__H_
#define _H_8507BF1E07EEBBF24EDA265099FE8C95_RemoveProblemGoal__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Empty_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  RemoveProblemGoal_Request_
            {
                ::std_msgs::msg::dds_::Empty_ request_;
            };

            typedef DDS_DCPSStruct_var<RemoveProblemGoal_Request_> RemoveProblemGoal_Request__var;
            typedef RemoveProblemGoal_Request_& RemoveProblemGoal_Request__out;

            struct  RemoveProblemGoal_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<RemoveProblemGoal_Response_> RemoveProblemGoal_Response__var;
            typedef DDS_DCPSStruct_out < RemoveProblemGoal_Response_> RemoveProblemGoal_Response__out;

            struct  Sample_RemoveProblemGoal_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::RemoveProblemGoal_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_RemoveProblemGoal_Request_> Sample_RemoveProblemGoal_Request__var;
            typedef Sample_RemoveProblemGoal_Request_& Sample_RemoveProblemGoal_Request__out;

            struct  Sample_RemoveProblemGoal_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::RemoveProblemGoal_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_RemoveProblemGoal_Response_> Sample_RemoveProblemGoal_Response__var;
            typedef DDS_DCPSStruct_out < Sample_RemoveProblemGoal_Response_> Sample_RemoveProblemGoal_Response__out;

        }

    }

}

#endif /* _H_8507BF1E07EEBBF24EDA265099FE8C95_RemoveProblemGoal__H_ */
