#ifndef _H_A5A70E733C067D4480BD9D1CBF28482C_ExecuteAction_DCPS_H_
#define _H_A5A70E733C067D4480BD9D1CBF28482C_ExecuteAction_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ExecuteAction_.h"


namespace plansys2_msgs
{
    namespace action
    {
        namespace dds_
        {
            class ExecuteAction_Goal_TypeSupportInterface;

            typedef ExecuteAction_Goal_TypeSupportInterface * ExecuteAction_Goal_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_Goal_TypeSupportInterface> ExecuteAction_Goal_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_Goal_TypeSupportInterface> ExecuteAction_Goal_TypeSupportInterface_out;


            class ExecuteAction_Goal_DataWriter;

            typedef ExecuteAction_Goal_DataWriter * ExecuteAction_Goal_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_Goal_DataWriter> ExecuteAction_Goal_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_Goal_DataWriter> ExecuteAction_Goal_DataWriter_out;


            class ExecuteAction_Goal_DataReader;

            typedef ExecuteAction_Goal_DataReader * ExecuteAction_Goal_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_Goal_DataReader> ExecuteAction_Goal_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_Goal_DataReader> ExecuteAction_Goal_DataReader_out;


            class ExecuteAction_Goal_DataReaderView;

            typedef ExecuteAction_Goal_DataReaderView * ExecuteAction_Goal_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_Goal_DataReaderView> ExecuteAction_Goal_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_Goal_DataReaderView> ExecuteAction_Goal_DataReaderView_out;

            struct ExecuteAction_Goal_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ExecuteAction_Goal_, struct ExecuteAction_Goal_Seq_uniq_> ExecuteAction_Goal_Seq;
            typedef DDS_DCPSSequence_var < ExecuteAction_Goal_Seq> ExecuteAction_Goal_Seq_var;
            typedef DDS_DCPSSequence_out < ExecuteAction_Goal_Seq> ExecuteAction_Goal_Seq_out;

            class  ExecuteAction_Goal_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecuteAction_Goal_TypeSupportInterface_ptr _ptr_type;
                typedef ExecuteAction_Goal_TypeSupportInterface_var _var_type;

                static ExecuteAction_Goal_TypeSupportInterface_ptr _duplicate (ExecuteAction_Goal_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_Goal_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_Goal_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_Goal_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_Goal_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecuteAction_Goal_TypeSupportInterface () {};
                ~ExecuteAction_Goal_TypeSupportInterface () {};
            private:
                ExecuteAction_Goal_TypeSupportInterface (const ExecuteAction_Goal_TypeSupportInterface &);
                ExecuteAction_Goal_TypeSupportInterface & operator = (const ExecuteAction_Goal_TypeSupportInterface &);
            };

            class  ExecuteAction_Goal_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecuteAction_Goal_DataWriter_ptr _ptr_type;
                typedef ExecuteAction_Goal_DataWriter_var _var_type;

                static ExecuteAction_Goal_DataWriter_ptr _duplicate (ExecuteAction_Goal_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_Goal_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_Goal_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_Goal_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_Goal_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecuteAction_Goal_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecuteAction_Goal_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecuteAction_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecuteAction_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecuteAction_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecuteAction_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecuteAction_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecuteAction_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecuteAction_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecuteAction_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_Goal_& instance_data) = 0;

            protected:
                ExecuteAction_Goal_DataWriter () {};
                ~ExecuteAction_Goal_DataWriter () {};
            private:
                ExecuteAction_Goal_DataWriter (const ExecuteAction_Goal_DataWriter &);
                ExecuteAction_Goal_DataWriter & operator = (const ExecuteAction_Goal_DataWriter &);
            };

            class  ExecuteAction_Goal_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecuteAction_Goal_DataReader_ptr _ptr_type;
                typedef ExecuteAction_Goal_DataReader_var _var_type;

                static ExecuteAction_Goal_DataReader_ptr _duplicate (ExecuteAction_Goal_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_Goal_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_Goal_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_Goal_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_Goal_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_Goal_& instance) = 0;

            protected:
                ExecuteAction_Goal_DataReader () {};
                ~ExecuteAction_Goal_DataReader () {};
            private:
                ExecuteAction_Goal_DataReader (const ExecuteAction_Goal_DataReader &);
                ExecuteAction_Goal_DataReader & operator = (const ExecuteAction_Goal_DataReader &);
            };

            class  ExecuteAction_Goal_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecuteAction_Goal_DataReaderView_ptr _ptr_type;
                typedef ExecuteAction_Goal_DataReaderView_var _var_type;

                static ExecuteAction_Goal_DataReaderView_ptr _duplicate (ExecuteAction_Goal_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_Goal_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_Goal_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_Goal_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_Goal_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_Goal_& instance) = 0;

            protected:
                ExecuteAction_Goal_DataReaderView () {};
                ~ExecuteAction_Goal_DataReaderView () {};
            private:
                ExecuteAction_Goal_DataReaderView (const ExecuteAction_Goal_DataReaderView &);
                ExecuteAction_Goal_DataReaderView & operator = (const ExecuteAction_Goal_DataReaderView &);
            };
            class ExecuteAction_SendGoal_Request_TypeSupportInterface;

            typedef ExecuteAction_SendGoal_Request_TypeSupportInterface * ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_SendGoal_Request_TypeSupportInterface> ExecuteAction_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_SendGoal_Request_TypeSupportInterface> ExecuteAction_SendGoal_Request_TypeSupportInterface_out;


            class ExecuteAction_SendGoal_Request_DataWriter;

            typedef ExecuteAction_SendGoal_Request_DataWriter * ExecuteAction_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_SendGoal_Request_DataWriter> ExecuteAction_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_SendGoal_Request_DataWriter> ExecuteAction_SendGoal_Request_DataWriter_out;


            class ExecuteAction_SendGoal_Request_DataReader;

            typedef ExecuteAction_SendGoal_Request_DataReader * ExecuteAction_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_SendGoal_Request_DataReader> ExecuteAction_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_SendGoal_Request_DataReader> ExecuteAction_SendGoal_Request_DataReader_out;


            class ExecuteAction_SendGoal_Request_DataReaderView;

            typedef ExecuteAction_SendGoal_Request_DataReaderView * ExecuteAction_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_SendGoal_Request_DataReaderView> ExecuteAction_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_SendGoal_Request_DataReaderView> ExecuteAction_SendGoal_Request_DataReaderView_out;

            struct ExecuteAction_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ExecuteAction_SendGoal_Request_, struct ExecuteAction_SendGoal_Request_Seq_uniq_> ExecuteAction_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < ExecuteAction_SendGoal_Request_Seq> ExecuteAction_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ExecuteAction_SendGoal_Request_Seq> ExecuteAction_SendGoal_Request_Seq_out;

            class  ExecuteAction_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ExecuteAction_SendGoal_Request_TypeSupportInterface_var _var_type;

                static ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr _duplicate (ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecuteAction_SendGoal_Request_TypeSupportInterface () {};
                ~ExecuteAction_SendGoal_Request_TypeSupportInterface () {};
            private:
                ExecuteAction_SendGoal_Request_TypeSupportInterface (const ExecuteAction_SendGoal_Request_TypeSupportInterface &);
                ExecuteAction_SendGoal_Request_TypeSupportInterface & operator = (const ExecuteAction_SendGoal_Request_TypeSupportInterface &);
            };

            class  ExecuteAction_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecuteAction_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef ExecuteAction_SendGoal_Request_DataWriter_var _var_type;

                static ExecuteAction_SendGoal_Request_DataWriter_ptr _duplicate (ExecuteAction_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecuteAction_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecuteAction_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_SendGoal_Request_& instance_data) = 0;

            protected:
                ExecuteAction_SendGoal_Request_DataWriter () {};
                ~ExecuteAction_SendGoal_Request_DataWriter () {};
            private:
                ExecuteAction_SendGoal_Request_DataWriter (const ExecuteAction_SendGoal_Request_DataWriter &);
                ExecuteAction_SendGoal_Request_DataWriter & operator = (const ExecuteAction_SendGoal_Request_DataWriter &);
            };

            class  ExecuteAction_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecuteAction_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef ExecuteAction_SendGoal_Request_DataReader_var _var_type;

                static ExecuteAction_SendGoal_Request_DataReader_ptr _duplicate (ExecuteAction_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_SendGoal_Request_& instance) = 0;

            protected:
                ExecuteAction_SendGoal_Request_DataReader () {};
                ~ExecuteAction_SendGoal_Request_DataReader () {};
            private:
                ExecuteAction_SendGoal_Request_DataReader (const ExecuteAction_SendGoal_Request_DataReader &);
                ExecuteAction_SendGoal_Request_DataReader & operator = (const ExecuteAction_SendGoal_Request_DataReader &);
            };

            class  ExecuteAction_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecuteAction_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef ExecuteAction_SendGoal_Request_DataReaderView_var _var_type;

                static ExecuteAction_SendGoal_Request_DataReaderView_ptr _duplicate (ExecuteAction_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_SendGoal_Request_& instance) = 0;

            protected:
                ExecuteAction_SendGoal_Request_DataReaderView () {};
                ~ExecuteAction_SendGoal_Request_DataReaderView () {};
            private:
                ExecuteAction_SendGoal_Request_DataReaderView (const ExecuteAction_SendGoal_Request_DataReaderView &);
                ExecuteAction_SendGoal_Request_DataReaderView & operator = (const ExecuteAction_SendGoal_Request_DataReaderView &);
            };
            class ExecuteAction_SendGoal_Response_TypeSupportInterface;

            typedef ExecuteAction_SendGoal_Response_TypeSupportInterface * ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_SendGoal_Response_TypeSupportInterface> ExecuteAction_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_SendGoal_Response_TypeSupportInterface> ExecuteAction_SendGoal_Response_TypeSupportInterface_out;


            class ExecuteAction_SendGoal_Response_DataWriter;

            typedef ExecuteAction_SendGoal_Response_DataWriter * ExecuteAction_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_SendGoal_Response_DataWriter> ExecuteAction_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_SendGoal_Response_DataWriter> ExecuteAction_SendGoal_Response_DataWriter_out;


            class ExecuteAction_SendGoal_Response_DataReader;

            typedef ExecuteAction_SendGoal_Response_DataReader * ExecuteAction_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_SendGoal_Response_DataReader> ExecuteAction_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_SendGoal_Response_DataReader> ExecuteAction_SendGoal_Response_DataReader_out;


            class ExecuteAction_SendGoal_Response_DataReaderView;

            typedef ExecuteAction_SendGoal_Response_DataReaderView * ExecuteAction_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_SendGoal_Response_DataReaderView> ExecuteAction_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_SendGoal_Response_DataReaderView> ExecuteAction_SendGoal_Response_DataReaderView_out;

            struct ExecuteAction_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ExecuteAction_SendGoal_Response_, struct ExecuteAction_SendGoal_Response_Seq_uniq_> ExecuteAction_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < ExecuteAction_SendGoal_Response_Seq> ExecuteAction_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ExecuteAction_SendGoal_Response_Seq> ExecuteAction_SendGoal_Response_Seq_out;

            class  ExecuteAction_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ExecuteAction_SendGoal_Response_TypeSupportInterface_var _var_type;

                static ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr _duplicate (ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecuteAction_SendGoal_Response_TypeSupportInterface () {};
                ~ExecuteAction_SendGoal_Response_TypeSupportInterface () {};
            private:
                ExecuteAction_SendGoal_Response_TypeSupportInterface (const ExecuteAction_SendGoal_Response_TypeSupportInterface &);
                ExecuteAction_SendGoal_Response_TypeSupportInterface & operator = (const ExecuteAction_SendGoal_Response_TypeSupportInterface &);
            };

            class  ExecuteAction_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecuteAction_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef ExecuteAction_SendGoal_Response_DataWriter_var _var_type;

                static ExecuteAction_SendGoal_Response_DataWriter_ptr _duplicate (ExecuteAction_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecuteAction_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecuteAction_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_SendGoal_Response_& instance_data) = 0;

            protected:
                ExecuteAction_SendGoal_Response_DataWriter () {};
                ~ExecuteAction_SendGoal_Response_DataWriter () {};
            private:
                ExecuteAction_SendGoal_Response_DataWriter (const ExecuteAction_SendGoal_Response_DataWriter &);
                ExecuteAction_SendGoal_Response_DataWriter & operator = (const ExecuteAction_SendGoal_Response_DataWriter &);
            };

            class  ExecuteAction_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecuteAction_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef ExecuteAction_SendGoal_Response_DataReader_var _var_type;

                static ExecuteAction_SendGoal_Response_DataReader_ptr _duplicate (ExecuteAction_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_SendGoal_Response_& instance) = 0;

            protected:
                ExecuteAction_SendGoal_Response_DataReader () {};
                ~ExecuteAction_SendGoal_Response_DataReader () {};
            private:
                ExecuteAction_SendGoal_Response_DataReader (const ExecuteAction_SendGoal_Response_DataReader &);
                ExecuteAction_SendGoal_Response_DataReader & operator = (const ExecuteAction_SendGoal_Response_DataReader &);
            };

            class  ExecuteAction_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecuteAction_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef ExecuteAction_SendGoal_Response_DataReaderView_var _var_type;

                static ExecuteAction_SendGoal_Response_DataReaderView_ptr _duplicate (ExecuteAction_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_SendGoal_Response_& instance) = 0;

            protected:
                ExecuteAction_SendGoal_Response_DataReaderView () {};
                ~ExecuteAction_SendGoal_Response_DataReaderView () {};
            private:
                ExecuteAction_SendGoal_Response_DataReaderView (const ExecuteAction_SendGoal_Response_DataReaderView &);
                ExecuteAction_SendGoal_Response_DataReaderView & operator = (const ExecuteAction_SendGoal_Response_DataReaderView &);
            };
            class Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface;

            typedef Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface * Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface> Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface> Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface_out;


            class Sample_ExecuteAction_SendGoal_Request_DataWriter;

            typedef Sample_ExecuteAction_SendGoal_Request_DataWriter * Sample_ExecuteAction_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_SendGoal_Request_DataWriter> Sample_ExecuteAction_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_SendGoal_Request_DataWriter> Sample_ExecuteAction_SendGoal_Request_DataWriter_out;


            class Sample_ExecuteAction_SendGoal_Request_DataReader;

            typedef Sample_ExecuteAction_SendGoal_Request_DataReader * Sample_ExecuteAction_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_SendGoal_Request_DataReader> Sample_ExecuteAction_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_SendGoal_Request_DataReader> Sample_ExecuteAction_SendGoal_Request_DataReader_out;


            class Sample_ExecuteAction_SendGoal_Request_DataReaderView;

            typedef Sample_ExecuteAction_SendGoal_Request_DataReaderView * Sample_ExecuteAction_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_SendGoal_Request_DataReaderView> Sample_ExecuteAction_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_SendGoal_Request_DataReaderView> Sample_ExecuteAction_SendGoal_Request_DataReaderView_out;

            struct Sample_ExecuteAction_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ExecuteAction_SendGoal_Request_, struct Sample_ExecuteAction_SendGoal_Request_Seq_uniq_> Sample_ExecuteAction_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ExecuteAction_SendGoal_Request_Seq> Sample_ExecuteAction_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ExecuteAction_SendGoal_Request_Seq> Sample_ExecuteAction_SendGoal_Request_Seq_out;

            class  Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface () {};
                ~Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface () {};
            private:
                Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface (const Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface &);
                Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface & operator = (const Sample_ExecuteAction_SendGoal_Request_TypeSupportInterface &);
            };

            class  Sample_ExecuteAction_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ExecuteAction_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ExecuteAction_SendGoal_Request_DataWriter_var _var_type;

                static Sample_ExecuteAction_SendGoal_Request_DataWriter_ptr _duplicate (Sample_ExecuteAction_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ExecuteAction_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ExecuteAction_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ExecuteAction_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ExecuteAction_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecuteAction_SendGoal_Request_& instance_data) = 0;

            protected:
                Sample_ExecuteAction_SendGoal_Request_DataWriter () {};
                ~Sample_ExecuteAction_SendGoal_Request_DataWriter () {};
            private:
                Sample_ExecuteAction_SendGoal_Request_DataWriter (const Sample_ExecuteAction_SendGoal_Request_DataWriter &);
                Sample_ExecuteAction_SendGoal_Request_DataWriter & operator = (const Sample_ExecuteAction_SendGoal_Request_DataWriter &);
            };

            class  Sample_ExecuteAction_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ExecuteAction_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_ExecuteAction_SendGoal_Request_DataReader_var _var_type;

                static Sample_ExecuteAction_SendGoal_Request_DataReader_ptr _duplicate (Sample_ExecuteAction_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecuteAction_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecuteAction_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecuteAction_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecuteAction_SendGoal_Request_& instance) = 0;

            protected:
                Sample_ExecuteAction_SendGoal_Request_DataReader () {};
                ~Sample_ExecuteAction_SendGoal_Request_DataReader () {};
            private:
                Sample_ExecuteAction_SendGoal_Request_DataReader (const Sample_ExecuteAction_SendGoal_Request_DataReader &);
                Sample_ExecuteAction_SendGoal_Request_DataReader & operator = (const Sample_ExecuteAction_SendGoal_Request_DataReader &);
            };

            class  Sample_ExecuteAction_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ExecuteAction_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ExecuteAction_SendGoal_Request_DataReaderView_var _var_type;

                static Sample_ExecuteAction_SendGoal_Request_DataReaderView_ptr _duplicate (Sample_ExecuteAction_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecuteAction_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecuteAction_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecuteAction_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecuteAction_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecuteAction_SendGoal_Request_& instance) = 0;

            protected:
                Sample_ExecuteAction_SendGoal_Request_DataReaderView () {};
                ~Sample_ExecuteAction_SendGoal_Request_DataReaderView () {};
            private:
                Sample_ExecuteAction_SendGoal_Request_DataReaderView (const Sample_ExecuteAction_SendGoal_Request_DataReaderView &);
                Sample_ExecuteAction_SendGoal_Request_DataReaderView & operator = (const Sample_ExecuteAction_SendGoal_Request_DataReaderView &);
            };
            class Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface;

            typedef Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface * Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface> Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface> Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface_out;


            class Sample_ExecuteAction_SendGoal_Response_DataWriter;

            typedef Sample_ExecuteAction_SendGoal_Response_DataWriter * Sample_ExecuteAction_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_SendGoal_Response_DataWriter> Sample_ExecuteAction_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_SendGoal_Response_DataWriter> Sample_ExecuteAction_SendGoal_Response_DataWriter_out;


            class Sample_ExecuteAction_SendGoal_Response_DataReader;

            typedef Sample_ExecuteAction_SendGoal_Response_DataReader * Sample_ExecuteAction_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_SendGoal_Response_DataReader> Sample_ExecuteAction_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_SendGoal_Response_DataReader> Sample_ExecuteAction_SendGoal_Response_DataReader_out;


            class Sample_ExecuteAction_SendGoal_Response_DataReaderView;

            typedef Sample_ExecuteAction_SendGoal_Response_DataReaderView * Sample_ExecuteAction_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_SendGoal_Response_DataReaderView> Sample_ExecuteAction_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_SendGoal_Response_DataReaderView> Sample_ExecuteAction_SendGoal_Response_DataReaderView_out;

            struct Sample_ExecuteAction_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ExecuteAction_SendGoal_Response_, struct Sample_ExecuteAction_SendGoal_Response_Seq_uniq_> Sample_ExecuteAction_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ExecuteAction_SendGoal_Response_Seq> Sample_ExecuteAction_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ExecuteAction_SendGoal_Response_Seq> Sample_ExecuteAction_SendGoal_Response_Seq_out;

            class  Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface () {};
                ~Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface () {};
            private:
                Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface (const Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface &);
                Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface & operator = (const Sample_ExecuteAction_SendGoal_Response_TypeSupportInterface &);
            };

            class  Sample_ExecuteAction_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ExecuteAction_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ExecuteAction_SendGoal_Response_DataWriter_var _var_type;

                static Sample_ExecuteAction_SendGoal_Response_DataWriter_ptr _duplicate (Sample_ExecuteAction_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ExecuteAction_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ExecuteAction_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ExecuteAction_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ExecuteAction_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecuteAction_SendGoal_Response_& instance_data) = 0;

            protected:
                Sample_ExecuteAction_SendGoal_Response_DataWriter () {};
                ~Sample_ExecuteAction_SendGoal_Response_DataWriter () {};
            private:
                Sample_ExecuteAction_SendGoal_Response_DataWriter (const Sample_ExecuteAction_SendGoal_Response_DataWriter &);
                Sample_ExecuteAction_SendGoal_Response_DataWriter & operator = (const Sample_ExecuteAction_SendGoal_Response_DataWriter &);
            };

            class  Sample_ExecuteAction_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ExecuteAction_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_ExecuteAction_SendGoal_Response_DataReader_var _var_type;

                static Sample_ExecuteAction_SendGoal_Response_DataReader_ptr _duplicate (Sample_ExecuteAction_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecuteAction_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecuteAction_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecuteAction_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecuteAction_SendGoal_Response_& instance) = 0;

            protected:
                Sample_ExecuteAction_SendGoal_Response_DataReader () {};
                ~Sample_ExecuteAction_SendGoal_Response_DataReader () {};
            private:
                Sample_ExecuteAction_SendGoal_Response_DataReader (const Sample_ExecuteAction_SendGoal_Response_DataReader &);
                Sample_ExecuteAction_SendGoal_Response_DataReader & operator = (const Sample_ExecuteAction_SendGoal_Response_DataReader &);
            };

            class  Sample_ExecuteAction_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ExecuteAction_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ExecuteAction_SendGoal_Response_DataReaderView_var _var_type;

                static Sample_ExecuteAction_SendGoal_Response_DataReaderView_ptr _duplicate (Sample_ExecuteAction_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecuteAction_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecuteAction_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecuteAction_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecuteAction_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecuteAction_SendGoal_Response_& instance) = 0;

            protected:
                Sample_ExecuteAction_SendGoal_Response_DataReaderView () {};
                ~Sample_ExecuteAction_SendGoal_Response_DataReaderView () {};
            private:
                Sample_ExecuteAction_SendGoal_Response_DataReaderView (const Sample_ExecuteAction_SendGoal_Response_DataReaderView &);
                Sample_ExecuteAction_SendGoal_Response_DataReaderView & operator = (const Sample_ExecuteAction_SendGoal_Response_DataReaderView &);
            };
            class ExecuteAction_Result_TypeSupportInterface;

            typedef ExecuteAction_Result_TypeSupportInterface * ExecuteAction_Result_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_Result_TypeSupportInterface> ExecuteAction_Result_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_Result_TypeSupportInterface> ExecuteAction_Result_TypeSupportInterface_out;


            class ExecuteAction_Result_DataWriter;

            typedef ExecuteAction_Result_DataWriter * ExecuteAction_Result_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_Result_DataWriter> ExecuteAction_Result_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_Result_DataWriter> ExecuteAction_Result_DataWriter_out;


            class ExecuteAction_Result_DataReader;

            typedef ExecuteAction_Result_DataReader * ExecuteAction_Result_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_Result_DataReader> ExecuteAction_Result_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_Result_DataReader> ExecuteAction_Result_DataReader_out;


            class ExecuteAction_Result_DataReaderView;

            typedef ExecuteAction_Result_DataReaderView * ExecuteAction_Result_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_Result_DataReaderView> ExecuteAction_Result_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_Result_DataReaderView> ExecuteAction_Result_DataReaderView_out;

            struct ExecuteAction_Result_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ExecuteAction_Result_, struct ExecuteAction_Result_Seq_uniq_> ExecuteAction_Result_Seq;
            typedef DDS_DCPSSequence_var < ExecuteAction_Result_Seq> ExecuteAction_Result_Seq_var;
            typedef DDS_DCPSSequence_out < ExecuteAction_Result_Seq> ExecuteAction_Result_Seq_out;

            class  ExecuteAction_Result_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecuteAction_Result_TypeSupportInterface_ptr _ptr_type;
                typedef ExecuteAction_Result_TypeSupportInterface_var _var_type;

                static ExecuteAction_Result_TypeSupportInterface_ptr _duplicate (ExecuteAction_Result_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_Result_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_Result_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_Result_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_Result_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecuteAction_Result_TypeSupportInterface () {};
                ~ExecuteAction_Result_TypeSupportInterface () {};
            private:
                ExecuteAction_Result_TypeSupportInterface (const ExecuteAction_Result_TypeSupportInterface &);
                ExecuteAction_Result_TypeSupportInterface & operator = (const ExecuteAction_Result_TypeSupportInterface &);
            };

            class  ExecuteAction_Result_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecuteAction_Result_DataWriter_ptr _ptr_type;
                typedef ExecuteAction_Result_DataWriter_var _var_type;

                static ExecuteAction_Result_DataWriter_ptr _duplicate (ExecuteAction_Result_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_Result_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_Result_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_Result_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_Result_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecuteAction_Result_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecuteAction_Result_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecuteAction_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecuteAction_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecuteAction_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecuteAction_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecuteAction_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecuteAction_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecuteAction_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecuteAction_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_Result_& instance_data) = 0;

            protected:
                ExecuteAction_Result_DataWriter () {};
                ~ExecuteAction_Result_DataWriter () {};
            private:
                ExecuteAction_Result_DataWriter (const ExecuteAction_Result_DataWriter &);
                ExecuteAction_Result_DataWriter & operator = (const ExecuteAction_Result_DataWriter &);
            };

            class  ExecuteAction_Result_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecuteAction_Result_DataReader_ptr _ptr_type;
                typedef ExecuteAction_Result_DataReader_var _var_type;

                static ExecuteAction_Result_DataReader_ptr _duplicate (ExecuteAction_Result_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_Result_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_Result_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_Result_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_Result_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_Result_& instance) = 0;

            protected:
                ExecuteAction_Result_DataReader () {};
                ~ExecuteAction_Result_DataReader () {};
            private:
                ExecuteAction_Result_DataReader (const ExecuteAction_Result_DataReader &);
                ExecuteAction_Result_DataReader & operator = (const ExecuteAction_Result_DataReader &);
            };

            class  ExecuteAction_Result_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecuteAction_Result_DataReaderView_ptr _ptr_type;
                typedef ExecuteAction_Result_DataReaderView_var _var_type;

                static ExecuteAction_Result_DataReaderView_ptr _duplicate (ExecuteAction_Result_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_Result_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_Result_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_Result_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_Result_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_Result_& instance) = 0;

            protected:
                ExecuteAction_Result_DataReaderView () {};
                ~ExecuteAction_Result_DataReaderView () {};
            private:
                ExecuteAction_Result_DataReaderView (const ExecuteAction_Result_DataReaderView &);
                ExecuteAction_Result_DataReaderView & operator = (const ExecuteAction_Result_DataReaderView &);
            };
            class ExecuteAction_GetResult_Request_TypeSupportInterface;

            typedef ExecuteAction_GetResult_Request_TypeSupportInterface * ExecuteAction_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_GetResult_Request_TypeSupportInterface> ExecuteAction_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_GetResult_Request_TypeSupportInterface> ExecuteAction_GetResult_Request_TypeSupportInterface_out;


            class ExecuteAction_GetResult_Request_DataWriter;

            typedef ExecuteAction_GetResult_Request_DataWriter * ExecuteAction_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_GetResult_Request_DataWriter> ExecuteAction_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_GetResult_Request_DataWriter> ExecuteAction_GetResult_Request_DataWriter_out;


            class ExecuteAction_GetResult_Request_DataReader;

            typedef ExecuteAction_GetResult_Request_DataReader * ExecuteAction_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_GetResult_Request_DataReader> ExecuteAction_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_GetResult_Request_DataReader> ExecuteAction_GetResult_Request_DataReader_out;


            class ExecuteAction_GetResult_Request_DataReaderView;

            typedef ExecuteAction_GetResult_Request_DataReaderView * ExecuteAction_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_GetResult_Request_DataReaderView> ExecuteAction_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_GetResult_Request_DataReaderView> ExecuteAction_GetResult_Request_DataReaderView_out;

            struct ExecuteAction_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ExecuteAction_GetResult_Request_, struct ExecuteAction_GetResult_Request_Seq_uniq_> ExecuteAction_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < ExecuteAction_GetResult_Request_Seq> ExecuteAction_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ExecuteAction_GetResult_Request_Seq> ExecuteAction_GetResult_Request_Seq_out;

            class  ExecuteAction_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecuteAction_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ExecuteAction_GetResult_Request_TypeSupportInterface_var _var_type;

                static ExecuteAction_GetResult_Request_TypeSupportInterface_ptr _duplicate (ExecuteAction_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecuteAction_GetResult_Request_TypeSupportInterface () {};
                ~ExecuteAction_GetResult_Request_TypeSupportInterface () {};
            private:
                ExecuteAction_GetResult_Request_TypeSupportInterface (const ExecuteAction_GetResult_Request_TypeSupportInterface &);
                ExecuteAction_GetResult_Request_TypeSupportInterface & operator = (const ExecuteAction_GetResult_Request_TypeSupportInterface &);
            };

            class  ExecuteAction_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecuteAction_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef ExecuteAction_GetResult_Request_DataWriter_var _var_type;

                static ExecuteAction_GetResult_Request_DataWriter_ptr _duplicate (ExecuteAction_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecuteAction_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecuteAction_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_GetResult_Request_& instance_data) = 0;

            protected:
                ExecuteAction_GetResult_Request_DataWriter () {};
                ~ExecuteAction_GetResult_Request_DataWriter () {};
            private:
                ExecuteAction_GetResult_Request_DataWriter (const ExecuteAction_GetResult_Request_DataWriter &);
                ExecuteAction_GetResult_Request_DataWriter & operator = (const ExecuteAction_GetResult_Request_DataWriter &);
            };

            class  ExecuteAction_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecuteAction_GetResult_Request_DataReader_ptr _ptr_type;
                typedef ExecuteAction_GetResult_Request_DataReader_var _var_type;

                static ExecuteAction_GetResult_Request_DataReader_ptr _duplicate (ExecuteAction_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_GetResult_Request_& instance) = 0;

            protected:
                ExecuteAction_GetResult_Request_DataReader () {};
                ~ExecuteAction_GetResult_Request_DataReader () {};
            private:
                ExecuteAction_GetResult_Request_DataReader (const ExecuteAction_GetResult_Request_DataReader &);
                ExecuteAction_GetResult_Request_DataReader & operator = (const ExecuteAction_GetResult_Request_DataReader &);
            };

            class  ExecuteAction_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecuteAction_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef ExecuteAction_GetResult_Request_DataReaderView_var _var_type;

                static ExecuteAction_GetResult_Request_DataReaderView_ptr _duplicate (ExecuteAction_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_GetResult_Request_& instance) = 0;

            protected:
                ExecuteAction_GetResult_Request_DataReaderView () {};
                ~ExecuteAction_GetResult_Request_DataReaderView () {};
            private:
                ExecuteAction_GetResult_Request_DataReaderView (const ExecuteAction_GetResult_Request_DataReaderView &);
                ExecuteAction_GetResult_Request_DataReaderView & operator = (const ExecuteAction_GetResult_Request_DataReaderView &);
            };
            class ExecuteAction_GetResult_Response_TypeSupportInterface;

            typedef ExecuteAction_GetResult_Response_TypeSupportInterface * ExecuteAction_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_GetResult_Response_TypeSupportInterface> ExecuteAction_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_GetResult_Response_TypeSupportInterface> ExecuteAction_GetResult_Response_TypeSupportInterface_out;


            class ExecuteAction_GetResult_Response_DataWriter;

            typedef ExecuteAction_GetResult_Response_DataWriter * ExecuteAction_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_GetResult_Response_DataWriter> ExecuteAction_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_GetResult_Response_DataWriter> ExecuteAction_GetResult_Response_DataWriter_out;


            class ExecuteAction_GetResult_Response_DataReader;

            typedef ExecuteAction_GetResult_Response_DataReader * ExecuteAction_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_GetResult_Response_DataReader> ExecuteAction_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_GetResult_Response_DataReader> ExecuteAction_GetResult_Response_DataReader_out;


            class ExecuteAction_GetResult_Response_DataReaderView;

            typedef ExecuteAction_GetResult_Response_DataReaderView * ExecuteAction_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_GetResult_Response_DataReaderView> ExecuteAction_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_GetResult_Response_DataReaderView> ExecuteAction_GetResult_Response_DataReaderView_out;

            struct ExecuteAction_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ExecuteAction_GetResult_Response_, struct ExecuteAction_GetResult_Response_Seq_uniq_> ExecuteAction_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < ExecuteAction_GetResult_Response_Seq> ExecuteAction_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ExecuteAction_GetResult_Response_Seq> ExecuteAction_GetResult_Response_Seq_out;

            class  ExecuteAction_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecuteAction_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ExecuteAction_GetResult_Response_TypeSupportInterface_var _var_type;

                static ExecuteAction_GetResult_Response_TypeSupportInterface_ptr _duplicate (ExecuteAction_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecuteAction_GetResult_Response_TypeSupportInterface () {};
                ~ExecuteAction_GetResult_Response_TypeSupportInterface () {};
            private:
                ExecuteAction_GetResult_Response_TypeSupportInterface (const ExecuteAction_GetResult_Response_TypeSupportInterface &);
                ExecuteAction_GetResult_Response_TypeSupportInterface & operator = (const ExecuteAction_GetResult_Response_TypeSupportInterface &);
            };

            class  ExecuteAction_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecuteAction_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef ExecuteAction_GetResult_Response_DataWriter_var _var_type;

                static ExecuteAction_GetResult_Response_DataWriter_ptr _duplicate (ExecuteAction_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecuteAction_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecuteAction_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_GetResult_Response_& instance_data) = 0;

            protected:
                ExecuteAction_GetResult_Response_DataWriter () {};
                ~ExecuteAction_GetResult_Response_DataWriter () {};
            private:
                ExecuteAction_GetResult_Response_DataWriter (const ExecuteAction_GetResult_Response_DataWriter &);
                ExecuteAction_GetResult_Response_DataWriter & operator = (const ExecuteAction_GetResult_Response_DataWriter &);
            };

            class  ExecuteAction_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecuteAction_GetResult_Response_DataReader_ptr _ptr_type;
                typedef ExecuteAction_GetResult_Response_DataReader_var _var_type;

                static ExecuteAction_GetResult_Response_DataReader_ptr _duplicate (ExecuteAction_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_GetResult_Response_& instance) = 0;

            protected:
                ExecuteAction_GetResult_Response_DataReader () {};
                ~ExecuteAction_GetResult_Response_DataReader () {};
            private:
                ExecuteAction_GetResult_Response_DataReader (const ExecuteAction_GetResult_Response_DataReader &);
                ExecuteAction_GetResult_Response_DataReader & operator = (const ExecuteAction_GetResult_Response_DataReader &);
            };

            class  ExecuteAction_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecuteAction_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef ExecuteAction_GetResult_Response_DataReaderView_var _var_type;

                static ExecuteAction_GetResult_Response_DataReaderView_ptr _duplicate (ExecuteAction_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_GetResult_Response_& instance) = 0;

            protected:
                ExecuteAction_GetResult_Response_DataReaderView () {};
                ~ExecuteAction_GetResult_Response_DataReaderView () {};
            private:
                ExecuteAction_GetResult_Response_DataReaderView (const ExecuteAction_GetResult_Response_DataReaderView &);
                ExecuteAction_GetResult_Response_DataReaderView & operator = (const ExecuteAction_GetResult_Response_DataReaderView &);
            };
            class Sample_ExecuteAction_GetResult_Request_TypeSupportInterface;

            typedef Sample_ExecuteAction_GetResult_Request_TypeSupportInterface * Sample_ExecuteAction_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_GetResult_Request_TypeSupportInterface> Sample_ExecuteAction_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_GetResult_Request_TypeSupportInterface> Sample_ExecuteAction_GetResult_Request_TypeSupportInterface_out;


            class Sample_ExecuteAction_GetResult_Request_DataWriter;

            typedef Sample_ExecuteAction_GetResult_Request_DataWriter * Sample_ExecuteAction_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_GetResult_Request_DataWriter> Sample_ExecuteAction_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_GetResult_Request_DataWriter> Sample_ExecuteAction_GetResult_Request_DataWriter_out;


            class Sample_ExecuteAction_GetResult_Request_DataReader;

            typedef Sample_ExecuteAction_GetResult_Request_DataReader * Sample_ExecuteAction_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_GetResult_Request_DataReader> Sample_ExecuteAction_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_GetResult_Request_DataReader> Sample_ExecuteAction_GetResult_Request_DataReader_out;


            class Sample_ExecuteAction_GetResult_Request_DataReaderView;

            typedef Sample_ExecuteAction_GetResult_Request_DataReaderView * Sample_ExecuteAction_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_GetResult_Request_DataReaderView> Sample_ExecuteAction_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_GetResult_Request_DataReaderView> Sample_ExecuteAction_GetResult_Request_DataReaderView_out;

            struct Sample_ExecuteAction_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ExecuteAction_GetResult_Request_, struct Sample_ExecuteAction_GetResult_Request_Seq_uniq_> Sample_ExecuteAction_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ExecuteAction_GetResult_Request_Seq> Sample_ExecuteAction_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ExecuteAction_GetResult_Request_Seq> Sample_ExecuteAction_GetResult_Request_Seq_out;

            class  Sample_ExecuteAction_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ExecuteAction_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ExecuteAction_GetResult_Request_TypeSupportInterface_var _var_type;

                static Sample_ExecuteAction_GetResult_Request_TypeSupportInterface_ptr _duplicate (Sample_ExecuteAction_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ExecuteAction_GetResult_Request_TypeSupportInterface () {};
                ~Sample_ExecuteAction_GetResult_Request_TypeSupportInterface () {};
            private:
                Sample_ExecuteAction_GetResult_Request_TypeSupportInterface (const Sample_ExecuteAction_GetResult_Request_TypeSupportInterface &);
                Sample_ExecuteAction_GetResult_Request_TypeSupportInterface & operator = (const Sample_ExecuteAction_GetResult_Request_TypeSupportInterface &);
            };

            class  Sample_ExecuteAction_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ExecuteAction_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ExecuteAction_GetResult_Request_DataWriter_var _var_type;

                static Sample_ExecuteAction_GetResult_Request_DataWriter_ptr _duplicate (Sample_ExecuteAction_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ExecuteAction_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ExecuteAction_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ExecuteAction_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ExecuteAction_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecuteAction_GetResult_Request_& instance_data) = 0;

            protected:
                Sample_ExecuteAction_GetResult_Request_DataWriter () {};
                ~Sample_ExecuteAction_GetResult_Request_DataWriter () {};
            private:
                Sample_ExecuteAction_GetResult_Request_DataWriter (const Sample_ExecuteAction_GetResult_Request_DataWriter &);
                Sample_ExecuteAction_GetResult_Request_DataWriter & operator = (const Sample_ExecuteAction_GetResult_Request_DataWriter &);
            };

            class  Sample_ExecuteAction_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ExecuteAction_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Sample_ExecuteAction_GetResult_Request_DataReader_var _var_type;

                static Sample_ExecuteAction_GetResult_Request_DataReader_ptr _duplicate (Sample_ExecuteAction_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecuteAction_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecuteAction_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecuteAction_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecuteAction_GetResult_Request_& instance) = 0;

            protected:
                Sample_ExecuteAction_GetResult_Request_DataReader () {};
                ~Sample_ExecuteAction_GetResult_Request_DataReader () {};
            private:
                Sample_ExecuteAction_GetResult_Request_DataReader (const Sample_ExecuteAction_GetResult_Request_DataReader &);
                Sample_ExecuteAction_GetResult_Request_DataReader & operator = (const Sample_ExecuteAction_GetResult_Request_DataReader &);
            };

            class  Sample_ExecuteAction_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ExecuteAction_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ExecuteAction_GetResult_Request_DataReaderView_var _var_type;

                static Sample_ExecuteAction_GetResult_Request_DataReaderView_ptr _duplicate (Sample_ExecuteAction_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecuteAction_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecuteAction_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecuteAction_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecuteAction_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecuteAction_GetResult_Request_& instance) = 0;

            protected:
                Sample_ExecuteAction_GetResult_Request_DataReaderView () {};
                ~Sample_ExecuteAction_GetResult_Request_DataReaderView () {};
            private:
                Sample_ExecuteAction_GetResult_Request_DataReaderView (const Sample_ExecuteAction_GetResult_Request_DataReaderView &);
                Sample_ExecuteAction_GetResult_Request_DataReaderView & operator = (const Sample_ExecuteAction_GetResult_Request_DataReaderView &);
            };
            class Sample_ExecuteAction_GetResult_Response_TypeSupportInterface;

            typedef Sample_ExecuteAction_GetResult_Response_TypeSupportInterface * Sample_ExecuteAction_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_GetResult_Response_TypeSupportInterface> Sample_ExecuteAction_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_GetResult_Response_TypeSupportInterface> Sample_ExecuteAction_GetResult_Response_TypeSupportInterface_out;


            class Sample_ExecuteAction_GetResult_Response_DataWriter;

            typedef Sample_ExecuteAction_GetResult_Response_DataWriter * Sample_ExecuteAction_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_GetResult_Response_DataWriter> Sample_ExecuteAction_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_GetResult_Response_DataWriter> Sample_ExecuteAction_GetResult_Response_DataWriter_out;


            class Sample_ExecuteAction_GetResult_Response_DataReader;

            typedef Sample_ExecuteAction_GetResult_Response_DataReader * Sample_ExecuteAction_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_GetResult_Response_DataReader> Sample_ExecuteAction_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_GetResult_Response_DataReader> Sample_ExecuteAction_GetResult_Response_DataReader_out;


            class Sample_ExecuteAction_GetResult_Response_DataReaderView;

            typedef Sample_ExecuteAction_GetResult_Response_DataReaderView * Sample_ExecuteAction_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecuteAction_GetResult_Response_DataReaderView> Sample_ExecuteAction_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ExecuteAction_GetResult_Response_DataReaderView> Sample_ExecuteAction_GetResult_Response_DataReaderView_out;

            struct Sample_ExecuteAction_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ExecuteAction_GetResult_Response_, struct Sample_ExecuteAction_GetResult_Response_Seq_uniq_> Sample_ExecuteAction_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ExecuteAction_GetResult_Response_Seq> Sample_ExecuteAction_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ExecuteAction_GetResult_Response_Seq> Sample_ExecuteAction_GetResult_Response_Seq_out;

            class  Sample_ExecuteAction_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ExecuteAction_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ExecuteAction_GetResult_Response_TypeSupportInterface_var _var_type;

                static Sample_ExecuteAction_GetResult_Response_TypeSupportInterface_ptr _duplicate (Sample_ExecuteAction_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ExecuteAction_GetResult_Response_TypeSupportInterface () {};
                ~Sample_ExecuteAction_GetResult_Response_TypeSupportInterface () {};
            private:
                Sample_ExecuteAction_GetResult_Response_TypeSupportInterface (const Sample_ExecuteAction_GetResult_Response_TypeSupportInterface &);
                Sample_ExecuteAction_GetResult_Response_TypeSupportInterface & operator = (const Sample_ExecuteAction_GetResult_Response_TypeSupportInterface &);
            };

            class  Sample_ExecuteAction_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ExecuteAction_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ExecuteAction_GetResult_Response_DataWriter_var _var_type;

                static Sample_ExecuteAction_GetResult_Response_DataWriter_ptr _duplicate (Sample_ExecuteAction_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ExecuteAction_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ExecuteAction_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ExecuteAction_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ExecuteAction_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecuteAction_GetResult_Response_& instance_data) = 0;

            protected:
                Sample_ExecuteAction_GetResult_Response_DataWriter () {};
                ~Sample_ExecuteAction_GetResult_Response_DataWriter () {};
            private:
                Sample_ExecuteAction_GetResult_Response_DataWriter (const Sample_ExecuteAction_GetResult_Response_DataWriter &);
                Sample_ExecuteAction_GetResult_Response_DataWriter & operator = (const Sample_ExecuteAction_GetResult_Response_DataWriter &);
            };

            class  Sample_ExecuteAction_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ExecuteAction_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Sample_ExecuteAction_GetResult_Response_DataReader_var _var_type;

                static Sample_ExecuteAction_GetResult_Response_DataReader_ptr _duplicate (Sample_ExecuteAction_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecuteAction_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecuteAction_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecuteAction_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecuteAction_GetResult_Response_& instance) = 0;

            protected:
                Sample_ExecuteAction_GetResult_Response_DataReader () {};
                ~Sample_ExecuteAction_GetResult_Response_DataReader () {};
            private:
                Sample_ExecuteAction_GetResult_Response_DataReader (const Sample_ExecuteAction_GetResult_Response_DataReader &);
                Sample_ExecuteAction_GetResult_Response_DataReader & operator = (const Sample_ExecuteAction_GetResult_Response_DataReader &);
            };

            class  Sample_ExecuteAction_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ExecuteAction_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ExecuteAction_GetResult_Response_DataReaderView_var _var_type;

                static Sample_ExecuteAction_GetResult_Response_DataReaderView_ptr _duplicate (Sample_ExecuteAction_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecuteAction_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecuteAction_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecuteAction_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecuteAction_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecuteAction_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecuteAction_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecuteAction_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecuteAction_GetResult_Response_& instance) = 0;

            protected:
                Sample_ExecuteAction_GetResult_Response_DataReaderView () {};
                ~Sample_ExecuteAction_GetResult_Response_DataReaderView () {};
            private:
                Sample_ExecuteAction_GetResult_Response_DataReaderView (const Sample_ExecuteAction_GetResult_Response_DataReaderView &);
                Sample_ExecuteAction_GetResult_Response_DataReaderView & operator = (const Sample_ExecuteAction_GetResult_Response_DataReaderView &);
            };
            class ExecuteAction_Feedback_TypeSupportInterface;

            typedef ExecuteAction_Feedback_TypeSupportInterface * ExecuteAction_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_Feedback_TypeSupportInterface> ExecuteAction_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_Feedback_TypeSupportInterface> ExecuteAction_Feedback_TypeSupportInterface_out;


            class ExecuteAction_Feedback_DataWriter;

            typedef ExecuteAction_Feedback_DataWriter * ExecuteAction_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_Feedback_DataWriter> ExecuteAction_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_Feedback_DataWriter> ExecuteAction_Feedback_DataWriter_out;


            class ExecuteAction_Feedback_DataReader;

            typedef ExecuteAction_Feedback_DataReader * ExecuteAction_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_Feedback_DataReader> ExecuteAction_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_Feedback_DataReader> ExecuteAction_Feedback_DataReader_out;


            class ExecuteAction_Feedback_DataReaderView;

            typedef ExecuteAction_Feedback_DataReaderView * ExecuteAction_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_Feedback_DataReaderView> ExecuteAction_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_Feedback_DataReaderView> ExecuteAction_Feedback_DataReaderView_out;

            struct ExecuteAction_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ExecuteAction_Feedback_, struct ExecuteAction_Feedback_Seq_uniq_> ExecuteAction_Feedback_Seq;
            typedef DDS_DCPSSequence_var < ExecuteAction_Feedback_Seq> ExecuteAction_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < ExecuteAction_Feedback_Seq> ExecuteAction_Feedback_Seq_out;

            class  ExecuteAction_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecuteAction_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef ExecuteAction_Feedback_TypeSupportInterface_var _var_type;

                static ExecuteAction_Feedback_TypeSupportInterface_ptr _duplicate (ExecuteAction_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecuteAction_Feedback_TypeSupportInterface () {};
                ~ExecuteAction_Feedback_TypeSupportInterface () {};
            private:
                ExecuteAction_Feedback_TypeSupportInterface (const ExecuteAction_Feedback_TypeSupportInterface &);
                ExecuteAction_Feedback_TypeSupportInterface & operator = (const ExecuteAction_Feedback_TypeSupportInterface &);
            };

            class  ExecuteAction_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecuteAction_Feedback_DataWriter_ptr _ptr_type;
                typedef ExecuteAction_Feedback_DataWriter_var _var_type;

                static ExecuteAction_Feedback_DataWriter_ptr _duplicate (ExecuteAction_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecuteAction_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecuteAction_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecuteAction_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecuteAction_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecuteAction_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecuteAction_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecuteAction_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecuteAction_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecuteAction_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecuteAction_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_Feedback_& instance_data) = 0;

            protected:
                ExecuteAction_Feedback_DataWriter () {};
                ~ExecuteAction_Feedback_DataWriter () {};
            private:
                ExecuteAction_Feedback_DataWriter (const ExecuteAction_Feedback_DataWriter &);
                ExecuteAction_Feedback_DataWriter & operator = (const ExecuteAction_Feedback_DataWriter &);
            };

            class  ExecuteAction_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecuteAction_Feedback_DataReader_ptr _ptr_type;
                typedef ExecuteAction_Feedback_DataReader_var _var_type;

                static ExecuteAction_Feedback_DataReader_ptr _duplicate (ExecuteAction_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_Feedback_& instance) = 0;

            protected:
                ExecuteAction_Feedback_DataReader () {};
                ~ExecuteAction_Feedback_DataReader () {};
            private:
                ExecuteAction_Feedback_DataReader (const ExecuteAction_Feedback_DataReader &);
                ExecuteAction_Feedback_DataReader & operator = (const ExecuteAction_Feedback_DataReader &);
            };

            class  ExecuteAction_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecuteAction_Feedback_DataReaderView_ptr _ptr_type;
                typedef ExecuteAction_Feedback_DataReaderView_var _var_type;

                static ExecuteAction_Feedback_DataReaderView_ptr _duplicate (ExecuteAction_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_Feedback_& instance) = 0;

            protected:
                ExecuteAction_Feedback_DataReaderView () {};
                ~ExecuteAction_Feedback_DataReaderView () {};
            private:
                ExecuteAction_Feedback_DataReaderView (const ExecuteAction_Feedback_DataReaderView &);
                ExecuteAction_Feedback_DataReaderView & operator = (const ExecuteAction_Feedback_DataReaderView &);
            };
            class ExecuteAction_FeedbackMessage_TypeSupportInterface;

            typedef ExecuteAction_FeedbackMessage_TypeSupportInterface * ExecuteAction_FeedbackMessage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_FeedbackMessage_TypeSupportInterface> ExecuteAction_FeedbackMessage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_FeedbackMessage_TypeSupportInterface> ExecuteAction_FeedbackMessage_TypeSupportInterface_out;


            class ExecuteAction_FeedbackMessage_DataWriter;

            typedef ExecuteAction_FeedbackMessage_DataWriter * ExecuteAction_FeedbackMessage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_FeedbackMessage_DataWriter> ExecuteAction_FeedbackMessage_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_FeedbackMessage_DataWriter> ExecuteAction_FeedbackMessage_DataWriter_out;


            class ExecuteAction_FeedbackMessage_DataReader;

            typedef ExecuteAction_FeedbackMessage_DataReader * ExecuteAction_FeedbackMessage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_FeedbackMessage_DataReader> ExecuteAction_FeedbackMessage_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_FeedbackMessage_DataReader> ExecuteAction_FeedbackMessage_DataReader_out;


            class ExecuteAction_FeedbackMessage_DataReaderView;

            typedef ExecuteAction_FeedbackMessage_DataReaderView * ExecuteAction_FeedbackMessage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecuteAction_FeedbackMessage_DataReaderView> ExecuteAction_FeedbackMessage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecuteAction_FeedbackMessage_DataReaderView> ExecuteAction_FeedbackMessage_DataReaderView_out;

            struct ExecuteAction_FeedbackMessage_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ExecuteAction_FeedbackMessage_, struct ExecuteAction_FeedbackMessage_Seq_uniq_> ExecuteAction_FeedbackMessage_Seq;
            typedef DDS_DCPSSequence_var < ExecuteAction_FeedbackMessage_Seq> ExecuteAction_FeedbackMessage_Seq_var;
            typedef DDS_DCPSSequence_out < ExecuteAction_FeedbackMessage_Seq> ExecuteAction_FeedbackMessage_Seq_out;

            class  ExecuteAction_FeedbackMessage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecuteAction_FeedbackMessage_TypeSupportInterface_ptr _ptr_type;
                typedef ExecuteAction_FeedbackMessage_TypeSupportInterface_var _var_type;

                static ExecuteAction_FeedbackMessage_TypeSupportInterface_ptr _duplicate (ExecuteAction_FeedbackMessage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_FeedbackMessage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_FeedbackMessage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_FeedbackMessage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_FeedbackMessage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecuteAction_FeedbackMessage_TypeSupportInterface () {};
                ~ExecuteAction_FeedbackMessage_TypeSupportInterface () {};
            private:
                ExecuteAction_FeedbackMessage_TypeSupportInterface (const ExecuteAction_FeedbackMessage_TypeSupportInterface &);
                ExecuteAction_FeedbackMessage_TypeSupportInterface & operator = (const ExecuteAction_FeedbackMessage_TypeSupportInterface &);
            };

            class  ExecuteAction_FeedbackMessage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecuteAction_FeedbackMessage_DataWriter_ptr _ptr_type;
                typedef ExecuteAction_FeedbackMessage_DataWriter_var _var_type;

                static ExecuteAction_FeedbackMessage_DataWriter_ptr _duplicate (ExecuteAction_FeedbackMessage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_FeedbackMessage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_FeedbackMessage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_FeedbackMessage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_FeedbackMessage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecuteAction_FeedbackMessage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecuteAction_FeedbackMessage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecuteAction_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecuteAction_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecuteAction_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecuteAction_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecuteAction_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecuteAction_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecuteAction_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecuteAction_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_FeedbackMessage_& instance_data) = 0;

            protected:
                ExecuteAction_FeedbackMessage_DataWriter () {};
                ~ExecuteAction_FeedbackMessage_DataWriter () {};
            private:
                ExecuteAction_FeedbackMessage_DataWriter (const ExecuteAction_FeedbackMessage_DataWriter &);
                ExecuteAction_FeedbackMessage_DataWriter & operator = (const ExecuteAction_FeedbackMessage_DataWriter &);
            };

            class  ExecuteAction_FeedbackMessage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecuteAction_FeedbackMessage_DataReader_ptr _ptr_type;
                typedef ExecuteAction_FeedbackMessage_DataReader_var _var_type;

                static ExecuteAction_FeedbackMessage_DataReader_ptr _duplicate (ExecuteAction_FeedbackMessage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_FeedbackMessage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_FeedbackMessage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_FeedbackMessage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_FeedbackMessage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_FeedbackMessage_& instance) = 0;

            protected:
                ExecuteAction_FeedbackMessage_DataReader () {};
                ~ExecuteAction_FeedbackMessage_DataReader () {};
            private:
                ExecuteAction_FeedbackMessage_DataReader (const ExecuteAction_FeedbackMessage_DataReader &);
                ExecuteAction_FeedbackMessage_DataReader & operator = (const ExecuteAction_FeedbackMessage_DataReader &);
            };

            class  ExecuteAction_FeedbackMessage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecuteAction_FeedbackMessage_DataReaderView_ptr _ptr_type;
                typedef ExecuteAction_FeedbackMessage_DataReaderView_var _var_type;

                static ExecuteAction_FeedbackMessage_DataReaderView_ptr _duplicate (ExecuteAction_FeedbackMessage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecuteAction_FeedbackMessage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecuteAction_FeedbackMessage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecuteAction_FeedbackMessage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecuteAction_FeedbackMessage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecuteAction_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecuteAction_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecuteAction_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecuteAction_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecuteAction_FeedbackMessage_& instance) = 0;

            protected:
                ExecuteAction_FeedbackMessage_DataReaderView () {};
                ~ExecuteAction_FeedbackMessage_DataReaderView () {};
            private:
                ExecuteAction_FeedbackMessage_DataReaderView (const ExecuteAction_FeedbackMessage_DataReaderView &);
                ExecuteAction_FeedbackMessage_DataReaderView & operator = (const ExecuteAction_FeedbackMessage_DataReaderView &);
            };
        }

    }

}

#endif
