#ifndef H_A5A70E733C067D4480BD9D1CBF28482C_ExecuteAction_SPLTYPES_H
#define H_A5A70E733C067D4480BD9D1CBF28482C_ExecuteAction_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_ExecuteAction_.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"



extern c_metaObject __ExecuteAction__plansys2_msgs__load (c_base base);

extern c_metaObject __ExecuteAction__plansys2_msgs_action__load (c_base base);

extern c_metaObject __ExecuteAction__plansys2_msgs_action_dds___load (c_base base);

extern const char *plansys2_msgs_action_dds__ExecuteAction_Goal__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecuteAction_Goal__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecuteAction_Goal__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecuteAction_Goal___load (c_base base);
struct _plansys2_msgs_action_dds__ExecuteAction_Goal_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecuteAction_Goal___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecuteAction_Goal_ *from, struct _plansys2_msgs_action_dds__ExecuteAction_Goal_ *to);
extern  void __plansys2_msgs_action_dds__ExecuteAction_Goal___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecuteAction_Goal_ {
    c_string action_;
    c_sequence arguments_;
};

extern const char *plansys2_msgs_action_dds__ExecuteAction_SendGoal_Request__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecuteAction_SendGoal_Request__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecuteAction_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecuteAction_SendGoal_Request___load (c_base base);
struct _plansys2_msgs_action_dds__ExecuteAction_SendGoal_Request_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecuteAction_SendGoal_Request___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecuteAction_SendGoal_Request_ *from, struct _plansys2_msgs_action_dds__ExecuteAction_SendGoal_Request_ *to);
extern  void __plansys2_msgs_action_dds__ExecuteAction_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecuteAction_SendGoal_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _plansys2_msgs_action_dds__ExecuteAction_Goal_ goal_;
};

extern const char *plansys2_msgs_action_dds__ExecuteAction_SendGoal_Response__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecuteAction_SendGoal_Response__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecuteAction_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecuteAction_SendGoal_Response___load (c_base base);
struct _plansys2_msgs_action_dds__ExecuteAction_SendGoal_Response_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecuteAction_SendGoal_Response___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecuteAction_SendGoal_Response_ *from, struct _plansys2_msgs_action_dds__ExecuteAction_SendGoal_Response_ *to);
extern  void __plansys2_msgs_action_dds__ExecuteAction_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecuteAction_SendGoal_Response_ {
    c_bool accepted_;
    struct _builtin_interfaces_msg_dds__Time_ stamp_;
};

extern const char *plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Request__metaDescriptor[];
extern const int plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Request__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Request___load (c_base base);
struct _plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Request_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Request___copyIn(c_base base, const struct plansys2_msgs::action::dds_::Sample_ExecuteAction_SendGoal_Request_ *from, struct _plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Request_ *to);
extern  void __plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _plansys2_msgs_action_dds__ExecuteAction_SendGoal_Request_ request_;
};

extern const char *plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Response__metaDescriptor[];
extern const int plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Response__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Response___load (c_base base);
struct _plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Response_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Response___copyIn(c_base base, const struct plansys2_msgs::action::dds_::Sample_ExecuteAction_SendGoal_Response_ *from, struct _plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Response_ *to);
extern  void __plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__Sample_ExecuteAction_SendGoal_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _plansys2_msgs_action_dds__ExecuteAction_SendGoal_Response_ response_;
};

extern const char *plansys2_msgs_action_dds__ExecuteAction_Result__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecuteAction_Result__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecuteAction_Result__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecuteAction_Result___load (c_base base);
struct _plansys2_msgs_action_dds__ExecuteAction_Result_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecuteAction_Result___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecuteAction_Result_ *from, struct _plansys2_msgs_action_dds__ExecuteAction_Result_ *to);
extern  void __plansys2_msgs_action_dds__ExecuteAction_Result___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecuteAction_Result_ {
    c_bool success_;
    c_string error_info_;
};

extern const char *plansys2_msgs_action_dds__ExecuteAction_GetResult_Request__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecuteAction_GetResult_Request__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecuteAction_GetResult_Request__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecuteAction_GetResult_Request___load (c_base base);
struct _plansys2_msgs_action_dds__ExecuteAction_GetResult_Request_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecuteAction_GetResult_Request___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecuteAction_GetResult_Request_ *from, struct _plansys2_msgs_action_dds__ExecuteAction_GetResult_Request_ *to);
extern  void __plansys2_msgs_action_dds__ExecuteAction_GetResult_Request___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecuteAction_GetResult_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
};

extern const char *plansys2_msgs_action_dds__ExecuteAction_GetResult_Response__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecuteAction_GetResult_Response__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecuteAction_GetResult_Response__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecuteAction_GetResult_Response___load (c_base base);
struct _plansys2_msgs_action_dds__ExecuteAction_GetResult_Response_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecuteAction_GetResult_Response___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecuteAction_GetResult_Response_ *from, struct _plansys2_msgs_action_dds__ExecuteAction_GetResult_Response_ *to);
extern  void __plansys2_msgs_action_dds__ExecuteAction_GetResult_Response___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecuteAction_GetResult_Response_ {
    c_octet status_;
    struct _plansys2_msgs_action_dds__ExecuteAction_Result_ result_;
};

extern const char *plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Request__metaDescriptor[];
extern const int plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Request__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Request__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Request___load (c_base base);
struct _plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Request_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Request___copyIn(c_base base, const struct plansys2_msgs::action::dds_::Sample_ExecuteAction_GetResult_Request_ *from, struct _plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Request_ *to);
extern  void __plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Request___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _plansys2_msgs_action_dds__ExecuteAction_GetResult_Request_ request_;
};

extern const char *plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Response__metaDescriptor[];
extern const int plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Response__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Response__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Response___load (c_base base);
struct _plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Response_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Response___copyIn(c_base base, const struct plansys2_msgs::action::dds_::Sample_ExecuteAction_GetResult_Response_ *from, struct _plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Response_ *to);
extern  void __plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Response___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__Sample_ExecuteAction_GetResult_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _plansys2_msgs_action_dds__ExecuteAction_GetResult_Response_ response_;
};

extern const char *plansys2_msgs_action_dds__ExecuteAction_Feedback__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecuteAction_Feedback__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecuteAction_Feedback__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecuteAction_Feedback___load (c_base base);
struct _plansys2_msgs_action_dds__ExecuteAction_Feedback_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecuteAction_Feedback___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecuteAction_Feedback_ *from, struct _plansys2_msgs_action_dds__ExecuteAction_Feedback_ *to);
extern  void __plansys2_msgs_action_dds__ExecuteAction_Feedback___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecuteAction_Feedback_ {
    c_float progress_;
};

extern const char *plansys2_msgs_action_dds__ExecuteAction_FeedbackMessage__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecuteAction_FeedbackMessage__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecuteAction_FeedbackMessage__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecuteAction_FeedbackMessage___load (c_base base);
struct _plansys2_msgs_action_dds__ExecuteAction_FeedbackMessage_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecuteAction_FeedbackMessage___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecuteAction_FeedbackMessage_ *from, struct _plansys2_msgs_action_dds__ExecuteAction_FeedbackMessage_ *to);
extern  void __plansys2_msgs_action_dds__ExecuteAction_FeedbackMessage___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecuteAction_FeedbackMessage_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _plansys2_msgs_action_dds__ExecuteAction_Feedback_ feedback_;
};

#undef OS_API
#endif
