#ifndef _H_5FF5A47857C5E810BA1785F509CF557F_ExecutePlan_DCPS_H_
#define _H_5FF5A47857C5E810BA1785F509CF557F_ExecutePlan_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ExecutePlan_.h"


namespace plansys2_msgs
{
    namespace action
    {
        namespace dds_
        {
            class ExecutePlan_Goal_TypeSupportInterface;

            typedef ExecutePlan_Goal_TypeSupportInterface * ExecutePlan_Goal_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_Goal_TypeSupportInterface> ExecutePlan_Goal_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_Goal_TypeSupportInterface> ExecutePlan_Goal_TypeSupportInterface_out;


            class ExecutePlan_Goal_DataWriter;

            typedef ExecutePlan_Goal_DataWriter * ExecutePlan_Goal_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_Goal_DataWriter> ExecutePlan_Goal_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_Goal_DataWriter> ExecutePlan_Goal_DataWriter_out;


            class ExecutePlan_Goal_DataReader;

            typedef ExecutePlan_Goal_DataReader * ExecutePlan_Goal_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_Goal_DataReader> ExecutePlan_Goal_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_Goal_DataReader> ExecutePlan_Goal_DataReader_out;


            class ExecutePlan_Goal_DataReaderView;

            typedef ExecutePlan_Goal_DataReaderView * ExecutePlan_Goal_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_Goal_DataReaderView> ExecutePlan_Goal_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_Goal_DataReaderView> ExecutePlan_Goal_DataReaderView_out;

            struct ExecutePlan_Goal_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ExecutePlan_Goal_, struct ExecutePlan_Goal_Seq_uniq_> ExecutePlan_Goal_Seq;
            typedef DDS_DCPSSequence_var < ExecutePlan_Goal_Seq> ExecutePlan_Goal_Seq_var;
            typedef DDS_DCPSSequence_out < ExecutePlan_Goal_Seq> ExecutePlan_Goal_Seq_out;

            class  ExecutePlan_Goal_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecutePlan_Goal_TypeSupportInterface_ptr _ptr_type;
                typedef ExecutePlan_Goal_TypeSupportInterface_var _var_type;

                static ExecutePlan_Goal_TypeSupportInterface_ptr _duplicate (ExecutePlan_Goal_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_Goal_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_Goal_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_Goal_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_Goal_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecutePlan_Goal_TypeSupportInterface () {};
                ~ExecutePlan_Goal_TypeSupportInterface () {};
            private:
                ExecutePlan_Goal_TypeSupportInterface (const ExecutePlan_Goal_TypeSupportInterface &);
                ExecutePlan_Goal_TypeSupportInterface & operator = (const ExecutePlan_Goal_TypeSupportInterface &);
            };

            class  ExecutePlan_Goal_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecutePlan_Goal_DataWriter_ptr _ptr_type;
                typedef ExecutePlan_Goal_DataWriter_var _var_type;

                static ExecutePlan_Goal_DataWriter_ptr _duplicate (ExecutePlan_Goal_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_Goal_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_Goal_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_Goal_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_Goal_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecutePlan_Goal_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecutePlan_Goal_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecutePlan_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecutePlan_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecutePlan_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecutePlan_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecutePlan_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecutePlan_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecutePlan_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecutePlan_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_Goal_& instance_data) = 0;

            protected:
                ExecutePlan_Goal_DataWriter () {};
                ~ExecutePlan_Goal_DataWriter () {};
            private:
                ExecutePlan_Goal_DataWriter (const ExecutePlan_Goal_DataWriter &);
                ExecutePlan_Goal_DataWriter & operator = (const ExecutePlan_Goal_DataWriter &);
            };

            class  ExecutePlan_Goal_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecutePlan_Goal_DataReader_ptr _ptr_type;
                typedef ExecutePlan_Goal_DataReader_var _var_type;

                static ExecutePlan_Goal_DataReader_ptr _duplicate (ExecutePlan_Goal_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_Goal_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_Goal_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_Goal_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_Goal_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_Goal_& instance) = 0;

            protected:
                ExecutePlan_Goal_DataReader () {};
                ~ExecutePlan_Goal_DataReader () {};
            private:
                ExecutePlan_Goal_DataReader (const ExecutePlan_Goal_DataReader &);
                ExecutePlan_Goal_DataReader & operator = (const ExecutePlan_Goal_DataReader &);
            };

            class  ExecutePlan_Goal_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecutePlan_Goal_DataReaderView_ptr _ptr_type;
                typedef ExecutePlan_Goal_DataReaderView_var _var_type;

                static ExecutePlan_Goal_DataReaderView_ptr _duplicate (ExecutePlan_Goal_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_Goal_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_Goal_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_Goal_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_Goal_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_Goal_& instance) = 0;

            protected:
                ExecutePlan_Goal_DataReaderView () {};
                ~ExecutePlan_Goal_DataReaderView () {};
            private:
                ExecutePlan_Goal_DataReaderView (const ExecutePlan_Goal_DataReaderView &);
                ExecutePlan_Goal_DataReaderView & operator = (const ExecutePlan_Goal_DataReaderView &);
            };
            class ExecutePlan_SendGoal_Request_TypeSupportInterface;

            typedef ExecutePlan_SendGoal_Request_TypeSupportInterface * ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_SendGoal_Request_TypeSupportInterface> ExecutePlan_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_SendGoal_Request_TypeSupportInterface> ExecutePlan_SendGoal_Request_TypeSupportInterface_out;


            class ExecutePlan_SendGoal_Request_DataWriter;

            typedef ExecutePlan_SendGoal_Request_DataWriter * ExecutePlan_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_SendGoal_Request_DataWriter> ExecutePlan_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_SendGoal_Request_DataWriter> ExecutePlan_SendGoal_Request_DataWriter_out;


            class ExecutePlan_SendGoal_Request_DataReader;

            typedef ExecutePlan_SendGoal_Request_DataReader * ExecutePlan_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_SendGoal_Request_DataReader> ExecutePlan_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_SendGoal_Request_DataReader> ExecutePlan_SendGoal_Request_DataReader_out;


            class ExecutePlan_SendGoal_Request_DataReaderView;

            typedef ExecutePlan_SendGoal_Request_DataReaderView * ExecutePlan_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_SendGoal_Request_DataReaderView> ExecutePlan_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_SendGoal_Request_DataReaderView> ExecutePlan_SendGoal_Request_DataReaderView_out;

            struct ExecutePlan_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ExecutePlan_SendGoal_Request_, struct ExecutePlan_SendGoal_Request_Seq_uniq_> ExecutePlan_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < ExecutePlan_SendGoal_Request_Seq> ExecutePlan_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ExecutePlan_SendGoal_Request_Seq> ExecutePlan_SendGoal_Request_Seq_out;

            class  ExecutePlan_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ExecutePlan_SendGoal_Request_TypeSupportInterface_var _var_type;

                static ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr _duplicate (ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecutePlan_SendGoal_Request_TypeSupportInterface () {};
                ~ExecutePlan_SendGoal_Request_TypeSupportInterface () {};
            private:
                ExecutePlan_SendGoal_Request_TypeSupportInterface (const ExecutePlan_SendGoal_Request_TypeSupportInterface &);
                ExecutePlan_SendGoal_Request_TypeSupportInterface & operator = (const ExecutePlan_SendGoal_Request_TypeSupportInterface &);
            };

            class  ExecutePlan_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecutePlan_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef ExecutePlan_SendGoal_Request_DataWriter_var _var_type;

                static ExecutePlan_SendGoal_Request_DataWriter_ptr _duplicate (ExecutePlan_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecutePlan_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecutePlan_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_SendGoal_Request_& instance_data) = 0;

            protected:
                ExecutePlan_SendGoal_Request_DataWriter () {};
                ~ExecutePlan_SendGoal_Request_DataWriter () {};
            private:
                ExecutePlan_SendGoal_Request_DataWriter (const ExecutePlan_SendGoal_Request_DataWriter &);
                ExecutePlan_SendGoal_Request_DataWriter & operator = (const ExecutePlan_SendGoal_Request_DataWriter &);
            };

            class  ExecutePlan_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecutePlan_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef ExecutePlan_SendGoal_Request_DataReader_var _var_type;

                static ExecutePlan_SendGoal_Request_DataReader_ptr _duplicate (ExecutePlan_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_SendGoal_Request_& instance) = 0;

            protected:
                ExecutePlan_SendGoal_Request_DataReader () {};
                ~ExecutePlan_SendGoal_Request_DataReader () {};
            private:
                ExecutePlan_SendGoal_Request_DataReader (const ExecutePlan_SendGoal_Request_DataReader &);
                ExecutePlan_SendGoal_Request_DataReader & operator = (const ExecutePlan_SendGoal_Request_DataReader &);
            };

            class  ExecutePlan_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecutePlan_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef ExecutePlan_SendGoal_Request_DataReaderView_var _var_type;

                static ExecutePlan_SendGoal_Request_DataReaderView_ptr _duplicate (ExecutePlan_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_SendGoal_Request_& instance) = 0;

            protected:
                ExecutePlan_SendGoal_Request_DataReaderView () {};
                ~ExecutePlan_SendGoal_Request_DataReaderView () {};
            private:
                ExecutePlan_SendGoal_Request_DataReaderView (const ExecutePlan_SendGoal_Request_DataReaderView &);
                ExecutePlan_SendGoal_Request_DataReaderView & operator = (const ExecutePlan_SendGoal_Request_DataReaderView &);
            };
            class ExecutePlan_SendGoal_Response_TypeSupportInterface;

            typedef ExecutePlan_SendGoal_Response_TypeSupportInterface * ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_SendGoal_Response_TypeSupportInterface> ExecutePlan_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_SendGoal_Response_TypeSupportInterface> ExecutePlan_SendGoal_Response_TypeSupportInterface_out;


            class ExecutePlan_SendGoal_Response_DataWriter;

            typedef ExecutePlan_SendGoal_Response_DataWriter * ExecutePlan_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_SendGoal_Response_DataWriter> ExecutePlan_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_SendGoal_Response_DataWriter> ExecutePlan_SendGoal_Response_DataWriter_out;


            class ExecutePlan_SendGoal_Response_DataReader;

            typedef ExecutePlan_SendGoal_Response_DataReader * ExecutePlan_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_SendGoal_Response_DataReader> ExecutePlan_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_SendGoal_Response_DataReader> ExecutePlan_SendGoal_Response_DataReader_out;


            class ExecutePlan_SendGoal_Response_DataReaderView;

            typedef ExecutePlan_SendGoal_Response_DataReaderView * ExecutePlan_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_SendGoal_Response_DataReaderView> ExecutePlan_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_SendGoal_Response_DataReaderView> ExecutePlan_SendGoal_Response_DataReaderView_out;

            struct ExecutePlan_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ExecutePlan_SendGoal_Response_, struct ExecutePlan_SendGoal_Response_Seq_uniq_> ExecutePlan_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < ExecutePlan_SendGoal_Response_Seq> ExecutePlan_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ExecutePlan_SendGoal_Response_Seq> ExecutePlan_SendGoal_Response_Seq_out;

            class  ExecutePlan_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ExecutePlan_SendGoal_Response_TypeSupportInterface_var _var_type;

                static ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr _duplicate (ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecutePlan_SendGoal_Response_TypeSupportInterface () {};
                ~ExecutePlan_SendGoal_Response_TypeSupportInterface () {};
            private:
                ExecutePlan_SendGoal_Response_TypeSupportInterface (const ExecutePlan_SendGoal_Response_TypeSupportInterface &);
                ExecutePlan_SendGoal_Response_TypeSupportInterface & operator = (const ExecutePlan_SendGoal_Response_TypeSupportInterface &);
            };

            class  ExecutePlan_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecutePlan_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef ExecutePlan_SendGoal_Response_DataWriter_var _var_type;

                static ExecutePlan_SendGoal_Response_DataWriter_ptr _duplicate (ExecutePlan_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecutePlan_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecutePlan_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_SendGoal_Response_& instance_data) = 0;

            protected:
                ExecutePlan_SendGoal_Response_DataWriter () {};
                ~ExecutePlan_SendGoal_Response_DataWriter () {};
            private:
                ExecutePlan_SendGoal_Response_DataWriter (const ExecutePlan_SendGoal_Response_DataWriter &);
                ExecutePlan_SendGoal_Response_DataWriter & operator = (const ExecutePlan_SendGoal_Response_DataWriter &);
            };

            class  ExecutePlan_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecutePlan_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef ExecutePlan_SendGoal_Response_DataReader_var _var_type;

                static ExecutePlan_SendGoal_Response_DataReader_ptr _duplicate (ExecutePlan_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_SendGoal_Response_& instance) = 0;

            protected:
                ExecutePlan_SendGoal_Response_DataReader () {};
                ~ExecutePlan_SendGoal_Response_DataReader () {};
            private:
                ExecutePlan_SendGoal_Response_DataReader (const ExecutePlan_SendGoal_Response_DataReader &);
                ExecutePlan_SendGoal_Response_DataReader & operator = (const ExecutePlan_SendGoal_Response_DataReader &);
            };

            class  ExecutePlan_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecutePlan_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef ExecutePlan_SendGoal_Response_DataReaderView_var _var_type;

                static ExecutePlan_SendGoal_Response_DataReaderView_ptr _duplicate (ExecutePlan_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_SendGoal_Response_& instance) = 0;

            protected:
                ExecutePlan_SendGoal_Response_DataReaderView () {};
                ~ExecutePlan_SendGoal_Response_DataReaderView () {};
            private:
                ExecutePlan_SendGoal_Response_DataReaderView (const ExecutePlan_SendGoal_Response_DataReaderView &);
                ExecutePlan_SendGoal_Response_DataReaderView & operator = (const ExecutePlan_SendGoal_Response_DataReaderView &);
            };
            class Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface;

            typedef Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface * Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface> Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface> Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface_out;


            class Sample_ExecutePlan_SendGoal_Request_DataWriter;

            typedef Sample_ExecutePlan_SendGoal_Request_DataWriter * Sample_ExecutePlan_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_SendGoal_Request_DataWriter> Sample_ExecutePlan_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_SendGoal_Request_DataWriter> Sample_ExecutePlan_SendGoal_Request_DataWriter_out;


            class Sample_ExecutePlan_SendGoal_Request_DataReader;

            typedef Sample_ExecutePlan_SendGoal_Request_DataReader * Sample_ExecutePlan_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_SendGoal_Request_DataReader> Sample_ExecutePlan_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_SendGoal_Request_DataReader> Sample_ExecutePlan_SendGoal_Request_DataReader_out;


            class Sample_ExecutePlan_SendGoal_Request_DataReaderView;

            typedef Sample_ExecutePlan_SendGoal_Request_DataReaderView * Sample_ExecutePlan_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_SendGoal_Request_DataReaderView> Sample_ExecutePlan_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_SendGoal_Request_DataReaderView> Sample_ExecutePlan_SendGoal_Request_DataReaderView_out;

            struct Sample_ExecutePlan_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ExecutePlan_SendGoal_Request_, struct Sample_ExecutePlan_SendGoal_Request_Seq_uniq_> Sample_ExecutePlan_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ExecutePlan_SendGoal_Request_Seq> Sample_ExecutePlan_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ExecutePlan_SendGoal_Request_Seq> Sample_ExecutePlan_SendGoal_Request_Seq_out;

            class  Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface () {};
                ~Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface () {};
            private:
                Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface (const Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface &);
                Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface & operator = (const Sample_ExecutePlan_SendGoal_Request_TypeSupportInterface &);
            };

            class  Sample_ExecutePlan_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ExecutePlan_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ExecutePlan_SendGoal_Request_DataWriter_var _var_type;

                static Sample_ExecutePlan_SendGoal_Request_DataWriter_ptr _duplicate (Sample_ExecutePlan_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ExecutePlan_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ExecutePlan_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ExecutePlan_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ExecutePlan_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecutePlan_SendGoal_Request_& instance_data) = 0;

            protected:
                Sample_ExecutePlan_SendGoal_Request_DataWriter () {};
                ~Sample_ExecutePlan_SendGoal_Request_DataWriter () {};
            private:
                Sample_ExecutePlan_SendGoal_Request_DataWriter (const Sample_ExecutePlan_SendGoal_Request_DataWriter &);
                Sample_ExecutePlan_SendGoal_Request_DataWriter & operator = (const Sample_ExecutePlan_SendGoal_Request_DataWriter &);
            };

            class  Sample_ExecutePlan_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ExecutePlan_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_ExecutePlan_SendGoal_Request_DataReader_var _var_type;

                static Sample_ExecutePlan_SendGoal_Request_DataReader_ptr _duplicate (Sample_ExecutePlan_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecutePlan_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecutePlan_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecutePlan_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecutePlan_SendGoal_Request_& instance) = 0;

            protected:
                Sample_ExecutePlan_SendGoal_Request_DataReader () {};
                ~Sample_ExecutePlan_SendGoal_Request_DataReader () {};
            private:
                Sample_ExecutePlan_SendGoal_Request_DataReader (const Sample_ExecutePlan_SendGoal_Request_DataReader &);
                Sample_ExecutePlan_SendGoal_Request_DataReader & operator = (const Sample_ExecutePlan_SendGoal_Request_DataReader &);
            };

            class  Sample_ExecutePlan_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ExecutePlan_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ExecutePlan_SendGoal_Request_DataReaderView_var _var_type;

                static Sample_ExecutePlan_SendGoal_Request_DataReaderView_ptr _duplicate (Sample_ExecutePlan_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecutePlan_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecutePlan_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecutePlan_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecutePlan_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecutePlan_SendGoal_Request_& instance) = 0;

            protected:
                Sample_ExecutePlan_SendGoal_Request_DataReaderView () {};
                ~Sample_ExecutePlan_SendGoal_Request_DataReaderView () {};
            private:
                Sample_ExecutePlan_SendGoal_Request_DataReaderView (const Sample_ExecutePlan_SendGoal_Request_DataReaderView &);
                Sample_ExecutePlan_SendGoal_Request_DataReaderView & operator = (const Sample_ExecutePlan_SendGoal_Request_DataReaderView &);
            };
            class Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface;

            typedef Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface * Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface> Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface> Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface_out;


            class Sample_ExecutePlan_SendGoal_Response_DataWriter;

            typedef Sample_ExecutePlan_SendGoal_Response_DataWriter * Sample_ExecutePlan_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_SendGoal_Response_DataWriter> Sample_ExecutePlan_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_SendGoal_Response_DataWriter> Sample_ExecutePlan_SendGoal_Response_DataWriter_out;


            class Sample_ExecutePlan_SendGoal_Response_DataReader;

            typedef Sample_ExecutePlan_SendGoal_Response_DataReader * Sample_ExecutePlan_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_SendGoal_Response_DataReader> Sample_ExecutePlan_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_SendGoal_Response_DataReader> Sample_ExecutePlan_SendGoal_Response_DataReader_out;


            class Sample_ExecutePlan_SendGoal_Response_DataReaderView;

            typedef Sample_ExecutePlan_SendGoal_Response_DataReaderView * Sample_ExecutePlan_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_SendGoal_Response_DataReaderView> Sample_ExecutePlan_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_SendGoal_Response_DataReaderView> Sample_ExecutePlan_SendGoal_Response_DataReaderView_out;

            struct Sample_ExecutePlan_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ExecutePlan_SendGoal_Response_, struct Sample_ExecutePlan_SendGoal_Response_Seq_uniq_> Sample_ExecutePlan_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ExecutePlan_SendGoal_Response_Seq> Sample_ExecutePlan_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ExecutePlan_SendGoal_Response_Seq> Sample_ExecutePlan_SendGoal_Response_Seq_out;

            class  Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface () {};
                ~Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface () {};
            private:
                Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface (const Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface &);
                Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface & operator = (const Sample_ExecutePlan_SendGoal_Response_TypeSupportInterface &);
            };

            class  Sample_ExecutePlan_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ExecutePlan_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ExecutePlan_SendGoal_Response_DataWriter_var _var_type;

                static Sample_ExecutePlan_SendGoal_Response_DataWriter_ptr _duplicate (Sample_ExecutePlan_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ExecutePlan_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ExecutePlan_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ExecutePlan_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ExecutePlan_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecutePlan_SendGoal_Response_& instance_data) = 0;

            protected:
                Sample_ExecutePlan_SendGoal_Response_DataWriter () {};
                ~Sample_ExecutePlan_SendGoal_Response_DataWriter () {};
            private:
                Sample_ExecutePlan_SendGoal_Response_DataWriter (const Sample_ExecutePlan_SendGoal_Response_DataWriter &);
                Sample_ExecutePlan_SendGoal_Response_DataWriter & operator = (const Sample_ExecutePlan_SendGoal_Response_DataWriter &);
            };

            class  Sample_ExecutePlan_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ExecutePlan_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_ExecutePlan_SendGoal_Response_DataReader_var _var_type;

                static Sample_ExecutePlan_SendGoal_Response_DataReader_ptr _duplicate (Sample_ExecutePlan_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecutePlan_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecutePlan_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecutePlan_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecutePlan_SendGoal_Response_& instance) = 0;

            protected:
                Sample_ExecutePlan_SendGoal_Response_DataReader () {};
                ~Sample_ExecutePlan_SendGoal_Response_DataReader () {};
            private:
                Sample_ExecutePlan_SendGoal_Response_DataReader (const Sample_ExecutePlan_SendGoal_Response_DataReader &);
                Sample_ExecutePlan_SendGoal_Response_DataReader & operator = (const Sample_ExecutePlan_SendGoal_Response_DataReader &);
            };

            class  Sample_ExecutePlan_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ExecutePlan_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ExecutePlan_SendGoal_Response_DataReaderView_var _var_type;

                static Sample_ExecutePlan_SendGoal_Response_DataReaderView_ptr _duplicate (Sample_ExecutePlan_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecutePlan_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecutePlan_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecutePlan_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecutePlan_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecutePlan_SendGoal_Response_& instance) = 0;

            protected:
                Sample_ExecutePlan_SendGoal_Response_DataReaderView () {};
                ~Sample_ExecutePlan_SendGoal_Response_DataReaderView () {};
            private:
                Sample_ExecutePlan_SendGoal_Response_DataReaderView (const Sample_ExecutePlan_SendGoal_Response_DataReaderView &);
                Sample_ExecutePlan_SendGoal_Response_DataReaderView & operator = (const Sample_ExecutePlan_SendGoal_Response_DataReaderView &);
            };
            class ExecutePlan_Result_TypeSupportInterface;

            typedef ExecutePlan_Result_TypeSupportInterface * ExecutePlan_Result_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_Result_TypeSupportInterface> ExecutePlan_Result_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_Result_TypeSupportInterface> ExecutePlan_Result_TypeSupportInterface_out;


            class ExecutePlan_Result_DataWriter;

            typedef ExecutePlan_Result_DataWriter * ExecutePlan_Result_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_Result_DataWriter> ExecutePlan_Result_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_Result_DataWriter> ExecutePlan_Result_DataWriter_out;


            class ExecutePlan_Result_DataReader;

            typedef ExecutePlan_Result_DataReader * ExecutePlan_Result_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_Result_DataReader> ExecutePlan_Result_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_Result_DataReader> ExecutePlan_Result_DataReader_out;


            class ExecutePlan_Result_DataReaderView;

            typedef ExecutePlan_Result_DataReaderView * ExecutePlan_Result_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_Result_DataReaderView> ExecutePlan_Result_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_Result_DataReaderView> ExecutePlan_Result_DataReaderView_out;

            struct ExecutePlan_Result_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ExecutePlan_Result_, struct ExecutePlan_Result_Seq_uniq_> ExecutePlan_Result_Seq;
            typedef DDS_DCPSSequence_var < ExecutePlan_Result_Seq> ExecutePlan_Result_Seq_var;
            typedef DDS_DCPSSequence_out < ExecutePlan_Result_Seq> ExecutePlan_Result_Seq_out;

            class  ExecutePlan_Result_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecutePlan_Result_TypeSupportInterface_ptr _ptr_type;
                typedef ExecutePlan_Result_TypeSupportInterface_var _var_type;

                static ExecutePlan_Result_TypeSupportInterface_ptr _duplicate (ExecutePlan_Result_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_Result_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_Result_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_Result_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_Result_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecutePlan_Result_TypeSupportInterface () {};
                ~ExecutePlan_Result_TypeSupportInterface () {};
            private:
                ExecutePlan_Result_TypeSupportInterface (const ExecutePlan_Result_TypeSupportInterface &);
                ExecutePlan_Result_TypeSupportInterface & operator = (const ExecutePlan_Result_TypeSupportInterface &);
            };

            class  ExecutePlan_Result_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecutePlan_Result_DataWriter_ptr _ptr_type;
                typedef ExecutePlan_Result_DataWriter_var _var_type;

                static ExecutePlan_Result_DataWriter_ptr _duplicate (ExecutePlan_Result_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_Result_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_Result_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_Result_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_Result_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecutePlan_Result_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecutePlan_Result_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecutePlan_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecutePlan_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecutePlan_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecutePlan_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecutePlan_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecutePlan_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecutePlan_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecutePlan_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_Result_& instance_data) = 0;

            protected:
                ExecutePlan_Result_DataWriter () {};
                ~ExecutePlan_Result_DataWriter () {};
            private:
                ExecutePlan_Result_DataWriter (const ExecutePlan_Result_DataWriter &);
                ExecutePlan_Result_DataWriter & operator = (const ExecutePlan_Result_DataWriter &);
            };

            class  ExecutePlan_Result_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecutePlan_Result_DataReader_ptr _ptr_type;
                typedef ExecutePlan_Result_DataReader_var _var_type;

                static ExecutePlan_Result_DataReader_ptr _duplicate (ExecutePlan_Result_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_Result_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_Result_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_Result_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_Result_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_Result_& instance) = 0;

            protected:
                ExecutePlan_Result_DataReader () {};
                ~ExecutePlan_Result_DataReader () {};
            private:
                ExecutePlan_Result_DataReader (const ExecutePlan_Result_DataReader &);
                ExecutePlan_Result_DataReader & operator = (const ExecutePlan_Result_DataReader &);
            };

            class  ExecutePlan_Result_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecutePlan_Result_DataReaderView_ptr _ptr_type;
                typedef ExecutePlan_Result_DataReaderView_var _var_type;

                static ExecutePlan_Result_DataReaderView_ptr _duplicate (ExecutePlan_Result_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_Result_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_Result_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_Result_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_Result_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_Result_& instance) = 0;

            protected:
                ExecutePlan_Result_DataReaderView () {};
                ~ExecutePlan_Result_DataReaderView () {};
            private:
                ExecutePlan_Result_DataReaderView (const ExecutePlan_Result_DataReaderView &);
                ExecutePlan_Result_DataReaderView & operator = (const ExecutePlan_Result_DataReaderView &);
            };
            class ExecutePlan_GetResult_Request_TypeSupportInterface;

            typedef ExecutePlan_GetResult_Request_TypeSupportInterface * ExecutePlan_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_GetResult_Request_TypeSupportInterface> ExecutePlan_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_GetResult_Request_TypeSupportInterface> ExecutePlan_GetResult_Request_TypeSupportInterface_out;


            class ExecutePlan_GetResult_Request_DataWriter;

            typedef ExecutePlan_GetResult_Request_DataWriter * ExecutePlan_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_GetResult_Request_DataWriter> ExecutePlan_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_GetResult_Request_DataWriter> ExecutePlan_GetResult_Request_DataWriter_out;


            class ExecutePlan_GetResult_Request_DataReader;

            typedef ExecutePlan_GetResult_Request_DataReader * ExecutePlan_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_GetResult_Request_DataReader> ExecutePlan_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_GetResult_Request_DataReader> ExecutePlan_GetResult_Request_DataReader_out;


            class ExecutePlan_GetResult_Request_DataReaderView;

            typedef ExecutePlan_GetResult_Request_DataReaderView * ExecutePlan_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_GetResult_Request_DataReaderView> ExecutePlan_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_GetResult_Request_DataReaderView> ExecutePlan_GetResult_Request_DataReaderView_out;

            struct ExecutePlan_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ExecutePlan_GetResult_Request_, struct ExecutePlan_GetResult_Request_Seq_uniq_> ExecutePlan_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < ExecutePlan_GetResult_Request_Seq> ExecutePlan_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ExecutePlan_GetResult_Request_Seq> ExecutePlan_GetResult_Request_Seq_out;

            class  ExecutePlan_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecutePlan_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ExecutePlan_GetResult_Request_TypeSupportInterface_var _var_type;

                static ExecutePlan_GetResult_Request_TypeSupportInterface_ptr _duplicate (ExecutePlan_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecutePlan_GetResult_Request_TypeSupportInterface () {};
                ~ExecutePlan_GetResult_Request_TypeSupportInterface () {};
            private:
                ExecutePlan_GetResult_Request_TypeSupportInterface (const ExecutePlan_GetResult_Request_TypeSupportInterface &);
                ExecutePlan_GetResult_Request_TypeSupportInterface & operator = (const ExecutePlan_GetResult_Request_TypeSupportInterface &);
            };

            class  ExecutePlan_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecutePlan_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef ExecutePlan_GetResult_Request_DataWriter_var _var_type;

                static ExecutePlan_GetResult_Request_DataWriter_ptr _duplicate (ExecutePlan_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecutePlan_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecutePlan_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_GetResult_Request_& instance_data) = 0;

            protected:
                ExecutePlan_GetResult_Request_DataWriter () {};
                ~ExecutePlan_GetResult_Request_DataWriter () {};
            private:
                ExecutePlan_GetResult_Request_DataWriter (const ExecutePlan_GetResult_Request_DataWriter &);
                ExecutePlan_GetResult_Request_DataWriter & operator = (const ExecutePlan_GetResult_Request_DataWriter &);
            };

            class  ExecutePlan_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecutePlan_GetResult_Request_DataReader_ptr _ptr_type;
                typedef ExecutePlan_GetResult_Request_DataReader_var _var_type;

                static ExecutePlan_GetResult_Request_DataReader_ptr _duplicate (ExecutePlan_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_GetResult_Request_& instance) = 0;

            protected:
                ExecutePlan_GetResult_Request_DataReader () {};
                ~ExecutePlan_GetResult_Request_DataReader () {};
            private:
                ExecutePlan_GetResult_Request_DataReader (const ExecutePlan_GetResult_Request_DataReader &);
                ExecutePlan_GetResult_Request_DataReader & operator = (const ExecutePlan_GetResult_Request_DataReader &);
            };

            class  ExecutePlan_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecutePlan_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef ExecutePlan_GetResult_Request_DataReaderView_var _var_type;

                static ExecutePlan_GetResult_Request_DataReaderView_ptr _duplicate (ExecutePlan_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_GetResult_Request_& instance) = 0;

            protected:
                ExecutePlan_GetResult_Request_DataReaderView () {};
                ~ExecutePlan_GetResult_Request_DataReaderView () {};
            private:
                ExecutePlan_GetResult_Request_DataReaderView (const ExecutePlan_GetResult_Request_DataReaderView &);
                ExecutePlan_GetResult_Request_DataReaderView & operator = (const ExecutePlan_GetResult_Request_DataReaderView &);
            };
            class ExecutePlan_GetResult_Response_TypeSupportInterface;

            typedef ExecutePlan_GetResult_Response_TypeSupportInterface * ExecutePlan_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_GetResult_Response_TypeSupportInterface> ExecutePlan_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_GetResult_Response_TypeSupportInterface> ExecutePlan_GetResult_Response_TypeSupportInterface_out;


            class ExecutePlan_GetResult_Response_DataWriter;

            typedef ExecutePlan_GetResult_Response_DataWriter * ExecutePlan_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_GetResult_Response_DataWriter> ExecutePlan_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_GetResult_Response_DataWriter> ExecutePlan_GetResult_Response_DataWriter_out;


            class ExecutePlan_GetResult_Response_DataReader;

            typedef ExecutePlan_GetResult_Response_DataReader * ExecutePlan_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_GetResult_Response_DataReader> ExecutePlan_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_GetResult_Response_DataReader> ExecutePlan_GetResult_Response_DataReader_out;


            class ExecutePlan_GetResult_Response_DataReaderView;

            typedef ExecutePlan_GetResult_Response_DataReaderView * ExecutePlan_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_GetResult_Response_DataReaderView> ExecutePlan_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_GetResult_Response_DataReaderView> ExecutePlan_GetResult_Response_DataReaderView_out;

            struct ExecutePlan_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ExecutePlan_GetResult_Response_, struct ExecutePlan_GetResult_Response_Seq_uniq_> ExecutePlan_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < ExecutePlan_GetResult_Response_Seq> ExecutePlan_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ExecutePlan_GetResult_Response_Seq> ExecutePlan_GetResult_Response_Seq_out;

            class  ExecutePlan_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecutePlan_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ExecutePlan_GetResult_Response_TypeSupportInterface_var _var_type;

                static ExecutePlan_GetResult_Response_TypeSupportInterface_ptr _duplicate (ExecutePlan_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecutePlan_GetResult_Response_TypeSupportInterface () {};
                ~ExecutePlan_GetResult_Response_TypeSupportInterface () {};
            private:
                ExecutePlan_GetResult_Response_TypeSupportInterface (const ExecutePlan_GetResult_Response_TypeSupportInterface &);
                ExecutePlan_GetResult_Response_TypeSupportInterface & operator = (const ExecutePlan_GetResult_Response_TypeSupportInterface &);
            };

            class  ExecutePlan_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecutePlan_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef ExecutePlan_GetResult_Response_DataWriter_var _var_type;

                static ExecutePlan_GetResult_Response_DataWriter_ptr _duplicate (ExecutePlan_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecutePlan_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecutePlan_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_GetResult_Response_& instance_data) = 0;

            protected:
                ExecutePlan_GetResult_Response_DataWriter () {};
                ~ExecutePlan_GetResult_Response_DataWriter () {};
            private:
                ExecutePlan_GetResult_Response_DataWriter (const ExecutePlan_GetResult_Response_DataWriter &);
                ExecutePlan_GetResult_Response_DataWriter & operator = (const ExecutePlan_GetResult_Response_DataWriter &);
            };

            class  ExecutePlan_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecutePlan_GetResult_Response_DataReader_ptr _ptr_type;
                typedef ExecutePlan_GetResult_Response_DataReader_var _var_type;

                static ExecutePlan_GetResult_Response_DataReader_ptr _duplicate (ExecutePlan_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_GetResult_Response_& instance) = 0;

            protected:
                ExecutePlan_GetResult_Response_DataReader () {};
                ~ExecutePlan_GetResult_Response_DataReader () {};
            private:
                ExecutePlan_GetResult_Response_DataReader (const ExecutePlan_GetResult_Response_DataReader &);
                ExecutePlan_GetResult_Response_DataReader & operator = (const ExecutePlan_GetResult_Response_DataReader &);
            };

            class  ExecutePlan_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecutePlan_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef ExecutePlan_GetResult_Response_DataReaderView_var _var_type;

                static ExecutePlan_GetResult_Response_DataReaderView_ptr _duplicate (ExecutePlan_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_GetResult_Response_& instance) = 0;

            protected:
                ExecutePlan_GetResult_Response_DataReaderView () {};
                ~ExecutePlan_GetResult_Response_DataReaderView () {};
            private:
                ExecutePlan_GetResult_Response_DataReaderView (const ExecutePlan_GetResult_Response_DataReaderView &);
                ExecutePlan_GetResult_Response_DataReaderView & operator = (const ExecutePlan_GetResult_Response_DataReaderView &);
            };
            class Sample_ExecutePlan_GetResult_Request_TypeSupportInterface;

            typedef Sample_ExecutePlan_GetResult_Request_TypeSupportInterface * Sample_ExecutePlan_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_GetResult_Request_TypeSupportInterface> Sample_ExecutePlan_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_GetResult_Request_TypeSupportInterface> Sample_ExecutePlan_GetResult_Request_TypeSupportInterface_out;


            class Sample_ExecutePlan_GetResult_Request_DataWriter;

            typedef Sample_ExecutePlan_GetResult_Request_DataWriter * Sample_ExecutePlan_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_GetResult_Request_DataWriter> Sample_ExecutePlan_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_GetResult_Request_DataWriter> Sample_ExecutePlan_GetResult_Request_DataWriter_out;


            class Sample_ExecutePlan_GetResult_Request_DataReader;

            typedef Sample_ExecutePlan_GetResult_Request_DataReader * Sample_ExecutePlan_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_GetResult_Request_DataReader> Sample_ExecutePlan_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_GetResult_Request_DataReader> Sample_ExecutePlan_GetResult_Request_DataReader_out;


            class Sample_ExecutePlan_GetResult_Request_DataReaderView;

            typedef Sample_ExecutePlan_GetResult_Request_DataReaderView * Sample_ExecutePlan_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_GetResult_Request_DataReaderView> Sample_ExecutePlan_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_GetResult_Request_DataReaderView> Sample_ExecutePlan_GetResult_Request_DataReaderView_out;

            struct Sample_ExecutePlan_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ExecutePlan_GetResult_Request_, struct Sample_ExecutePlan_GetResult_Request_Seq_uniq_> Sample_ExecutePlan_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ExecutePlan_GetResult_Request_Seq> Sample_ExecutePlan_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ExecutePlan_GetResult_Request_Seq> Sample_ExecutePlan_GetResult_Request_Seq_out;

            class  Sample_ExecutePlan_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ExecutePlan_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ExecutePlan_GetResult_Request_TypeSupportInterface_var _var_type;

                static Sample_ExecutePlan_GetResult_Request_TypeSupportInterface_ptr _duplicate (Sample_ExecutePlan_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ExecutePlan_GetResult_Request_TypeSupportInterface () {};
                ~Sample_ExecutePlan_GetResult_Request_TypeSupportInterface () {};
            private:
                Sample_ExecutePlan_GetResult_Request_TypeSupportInterface (const Sample_ExecutePlan_GetResult_Request_TypeSupportInterface &);
                Sample_ExecutePlan_GetResult_Request_TypeSupportInterface & operator = (const Sample_ExecutePlan_GetResult_Request_TypeSupportInterface &);
            };

            class  Sample_ExecutePlan_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ExecutePlan_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ExecutePlan_GetResult_Request_DataWriter_var _var_type;

                static Sample_ExecutePlan_GetResult_Request_DataWriter_ptr _duplicate (Sample_ExecutePlan_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ExecutePlan_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ExecutePlan_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ExecutePlan_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ExecutePlan_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecutePlan_GetResult_Request_& instance_data) = 0;

            protected:
                Sample_ExecutePlan_GetResult_Request_DataWriter () {};
                ~Sample_ExecutePlan_GetResult_Request_DataWriter () {};
            private:
                Sample_ExecutePlan_GetResult_Request_DataWriter (const Sample_ExecutePlan_GetResult_Request_DataWriter &);
                Sample_ExecutePlan_GetResult_Request_DataWriter & operator = (const Sample_ExecutePlan_GetResult_Request_DataWriter &);
            };

            class  Sample_ExecutePlan_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ExecutePlan_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Sample_ExecutePlan_GetResult_Request_DataReader_var _var_type;

                static Sample_ExecutePlan_GetResult_Request_DataReader_ptr _duplicate (Sample_ExecutePlan_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecutePlan_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecutePlan_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecutePlan_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecutePlan_GetResult_Request_& instance) = 0;

            protected:
                Sample_ExecutePlan_GetResult_Request_DataReader () {};
                ~Sample_ExecutePlan_GetResult_Request_DataReader () {};
            private:
                Sample_ExecutePlan_GetResult_Request_DataReader (const Sample_ExecutePlan_GetResult_Request_DataReader &);
                Sample_ExecutePlan_GetResult_Request_DataReader & operator = (const Sample_ExecutePlan_GetResult_Request_DataReader &);
            };

            class  Sample_ExecutePlan_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ExecutePlan_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ExecutePlan_GetResult_Request_DataReaderView_var _var_type;

                static Sample_ExecutePlan_GetResult_Request_DataReaderView_ptr _duplicate (Sample_ExecutePlan_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecutePlan_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecutePlan_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecutePlan_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecutePlan_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecutePlan_GetResult_Request_& instance) = 0;

            protected:
                Sample_ExecutePlan_GetResult_Request_DataReaderView () {};
                ~Sample_ExecutePlan_GetResult_Request_DataReaderView () {};
            private:
                Sample_ExecutePlan_GetResult_Request_DataReaderView (const Sample_ExecutePlan_GetResult_Request_DataReaderView &);
                Sample_ExecutePlan_GetResult_Request_DataReaderView & operator = (const Sample_ExecutePlan_GetResult_Request_DataReaderView &);
            };
            class Sample_ExecutePlan_GetResult_Response_TypeSupportInterface;

            typedef Sample_ExecutePlan_GetResult_Response_TypeSupportInterface * Sample_ExecutePlan_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_GetResult_Response_TypeSupportInterface> Sample_ExecutePlan_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_GetResult_Response_TypeSupportInterface> Sample_ExecutePlan_GetResult_Response_TypeSupportInterface_out;


            class Sample_ExecutePlan_GetResult_Response_DataWriter;

            typedef Sample_ExecutePlan_GetResult_Response_DataWriter * Sample_ExecutePlan_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_GetResult_Response_DataWriter> Sample_ExecutePlan_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_GetResult_Response_DataWriter> Sample_ExecutePlan_GetResult_Response_DataWriter_out;


            class Sample_ExecutePlan_GetResult_Response_DataReader;

            typedef Sample_ExecutePlan_GetResult_Response_DataReader * Sample_ExecutePlan_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_GetResult_Response_DataReader> Sample_ExecutePlan_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_GetResult_Response_DataReader> Sample_ExecutePlan_GetResult_Response_DataReader_out;


            class Sample_ExecutePlan_GetResult_Response_DataReaderView;

            typedef Sample_ExecutePlan_GetResult_Response_DataReaderView * Sample_ExecutePlan_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExecutePlan_GetResult_Response_DataReaderView> Sample_ExecutePlan_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ExecutePlan_GetResult_Response_DataReaderView> Sample_ExecutePlan_GetResult_Response_DataReaderView_out;

            struct Sample_ExecutePlan_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ExecutePlan_GetResult_Response_, struct Sample_ExecutePlan_GetResult_Response_Seq_uniq_> Sample_ExecutePlan_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ExecutePlan_GetResult_Response_Seq> Sample_ExecutePlan_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ExecutePlan_GetResult_Response_Seq> Sample_ExecutePlan_GetResult_Response_Seq_out;

            class  Sample_ExecutePlan_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ExecutePlan_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ExecutePlan_GetResult_Response_TypeSupportInterface_var _var_type;

                static Sample_ExecutePlan_GetResult_Response_TypeSupportInterface_ptr _duplicate (Sample_ExecutePlan_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ExecutePlan_GetResult_Response_TypeSupportInterface () {};
                ~Sample_ExecutePlan_GetResult_Response_TypeSupportInterface () {};
            private:
                Sample_ExecutePlan_GetResult_Response_TypeSupportInterface (const Sample_ExecutePlan_GetResult_Response_TypeSupportInterface &);
                Sample_ExecutePlan_GetResult_Response_TypeSupportInterface & operator = (const Sample_ExecutePlan_GetResult_Response_TypeSupportInterface &);
            };

            class  Sample_ExecutePlan_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ExecutePlan_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ExecutePlan_GetResult_Response_DataWriter_var _var_type;

                static Sample_ExecutePlan_GetResult_Response_DataWriter_ptr _duplicate (Sample_ExecutePlan_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ExecutePlan_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ExecutePlan_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ExecutePlan_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ExecutePlan_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecutePlan_GetResult_Response_& instance_data) = 0;

            protected:
                Sample_ExecutePlan_GetResult_Response_DataWriter () {};
                ~Sample_ExecutePlan_GetResult_Response_DataWriter () {};
            private:
                Sample_ExecutePlan_GetResult_Response_DataWriter (const Sample_ExecutePlan_GetResult_Response_DataWriter &);
                Sample_ExecutePlan_GetResult_Response_DataWriter & operator = (const Sample_ExecutePlan_GetResult_Response_DataWriter &);
            };

            class  Sample_ExecutePlan_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ExecutePlan_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Sample_ExecutePlan_GetResult_Response_DataReader_var _var_type;

                static Sample_ExecutePlan_GetResult_Response_DataReader_ptr _duplicate (Sample_ExecutePlan_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecutePlan_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecutePlan_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecutePlan_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecutePlan_GetResult_Response_& instance) = 0;

            protected:
                Sample_ExecutePlan_GetResult_Response_DataReader () {};
                ~Sample_ExecutePlan_GetResult_Response_DataReader () {};
            private:
                Sample_ExecutePlan_GetResult_Response_DataReader (const Sample_ExecutePlan_GetResult_Response_DataReader &);
                Sample_ExecutePlan_GetResult_Response_DataReader & operator = (const Sample_ExecutePlan_GetResult_Response_DataReader &);
            };

            class  Sample_ExecutePlan_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ExecutePlan_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ExecutePlan_GetResult_Response_DataReaderView_var _var_type;

                static Sample_ExecutePlan_GetResult_Response_DataReaderView_ptr _duplicate (Sample_ExecutePlan_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExecutePlan_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExecutePlan_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExecutePlan_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExecutePlan_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExecutePlan_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExecutePlan_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExecutePlan_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExecutePlan_GetResult_Response_& instance) = 0;

            protected:
                Sample_ExecutePlan_GetResult_Response_DataReaderView () {};
                ~Sample_ExecutePlan_GetResult_Response_DataReaderView () {};
            private:
                Sample_ExecutePlan_GetResult_Response_DataReaderView (const Sample_ExecutePlan_GetResult_Response_DataReaderView &);
                Sample_ExecutePlan_GetResult_Response_DataReaderView & operator = (const Sample_ExecutePlan_GetResult_Response_DataReaderView &);
            };
            class ExecutePlan_Feedback_TypeSupportInterface;

            typedef ExecutePlan_Feedback_TypeSupportInterface * ExecutePlan_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_Feedback_TypeSupportInterface> ExecutePlan_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_Feedback_TypeSupportInterface> ExecutePlan_Feedback_TypeSupportInterface_out;


            class ExecutePlan_Feedback_DataWriter;

            typedef ExecutePlan_Feedback_DataWriter * ExecutePlan_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_Feedback_DataWriter> ExecutePlan_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_Feedback_DataWriter> ExecutePlan_Feedback_DataWriter_out;


            class ExecutePlan_Feedback_DataReader;

            typedef ExecutePlan_Feedback_DataReader * ExecutePlan_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_Feedback_DataReader> ExecutePlan_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_Feedback_DataReader> ExecutePlan_Feedback_DataReader_out;


            class ExecutePlan_Feedback_DataReaderView;

            typedef ExecutePlan_Feedback_DataReaderView * ExecutePlan_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_Feedback_DataReaderView> ExecutePlan_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_Feedback_DataReaderView> ExecutePlan_Feedback_DataReaderView_out;

            struct ExecutePlan_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ExecutePlan_Feedback_, struct ExecutePlan_Feedback_Seq_uniq_> ExecutePlan_Feedback_Seq;
            typedef DDS_DCPSSequence_var < ExecutePlan_Feedback_Seq> ExecutePlan_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < ExecutePlan_Feedback_Seq> ExecutePlan_Feedback_Seq_out;

            class  ExecutePlan_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecutePlan_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef ExecutePlan_Feedback_TypeSupportInterface_var _var_type;

                static ExecutePlan_Feedback_TypeSupportInterface_ptr _duplicate (ExecutePlan_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecutePlan_Feedback_TypeSupportInterface () {};
                ~ExecutePlan_Feedback_TypeSupportInterface () {};
            private:
                ExecutePlan_Feedback_TypeSupportInterface (const ExecutePlan_Feedback_TypeSupportInterface &);
                ExecutePlan_Feedback_TypeSupportInterface & operator = (const ExecutePlan_Feedback_TypeSupportInterface &);
            };

            class  ExecutePlan_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecutePlan_Feedback_DataWriter_ptr _ptr_type;
                typedef ExecutePlan_Feedback_DataWriter_var _var_type;

                static ExecutePlan_Feedback_DataWriter_ptr _duplicate (ExecutePlan_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecutePlan_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecutePlan_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecutePlan_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecutePlan_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecutePlan_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecutePlan_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecutePlan_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecutePlan_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecutePlan_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecutePlan_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_Feedback_& instance_data) = 0;

            protected:
                ExecutePlan_Feedback_DataWriter () {};
                ~ExecutePlan_Feedback_DataWriter () {};
            private:
                ExecutePlan_Feedback_DataWriter (const ExecutePlan_Feedback_DataWriter &);
                ExecutePlan_Feedback_DataWriter & operator = (const ExecutePlan_Feedback_DataWriter &);
            };

            class  ExecutePlan_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecutePlan_Feedback_DataReader_ptr _ptr_type;
                typedef ExecutePlan_Feedback_DataReader_var _var_type;

                static ExecutePlan_Feedback_DataReader_ptr _duplicate (ExecutePlan_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_Feedback_& instance) = 0;

            protected:
                ExecutePlan_Feedback_DataReader () {};
                ~ExecutePlan_Feedback_DataReader () {};
            private:
                ExecutePlan_Feedback_DataReader (const ExecutePlan_Feedback_DataReader &);
                ExecutePlan_Feedback_DataReader & operator = (const ExecutePlan_Feedback_DataReader &);
            };

            class  ExecutePlan_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecutePlan_Feedback_DataReaderView_ptr _ptr_type;
                typedef ExecutePlan_Feedback_DataReaderView_var _var_type;

                static ExecutePlan_Feedback_DataReaderView_ptr _duplicate (ExecutePlan_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_Feedback_& instance) = 0;

            protected:
                ExecutePlan_Feedback_DataReaderView () {};
                ~ExecutePlan_Feedback_DataReaderView () {};
            private:
                ExecutePlan_Feedback_DataReaderView (const ExecutePlan_Feedback_DataReaderView &);
                ExecutePlan_Feedback_DataReaderView & operator = (const ExecutePlan_Feedback_DataReaderView &);
            };
            class ExecutePlan_FeedbackMessage_TypeSupportInterface;

            typedef ExecutePlan_FeedbackMessage_TypeSupportInterface * ExecutePlan_FeedbackMessage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_FeedbackMessage_TypeSupportInterface> ExecutePlan_FeedbackMessage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_FeedbackMessage_TypeSupportInterface> ExecutePlan_FeedbackMessage_TypeSupportInterface_out;


            class ExecutePlan_FeedbackMessage_DataWriter;

            typedef ExecutePlan_FeedbackMessage_DataWriter * ExecutePlan_FeedbackMessage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_FeedbackMessage_DataWriter> ExecutePlan_FeedbackMessage_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_FeedbackMessage_DataWriter> ExecutePlan_FeedbackMessage_DataWriter_out;


            class ExecutePlan_FeedbackMessage_DataReader;

            typedef ExecutePlan_FeedbackMessage_DataReader * ExecutePlan_FeedbackMessage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_FeedbackMessage_DataReader> ExecutePlan_FeedbackMessage_DataReader_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_FeedbackMessage_DataReader> ExecutePlan_FeedbackMessage_DataReader_out;


            class ExecutePlan_FeedbackMessage_DataReaderView;

            typedef ExecutePlan_FeedbackMessage_DataReaderView * ExecutePlan_FeedbackMessage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExecutePlan_FeedbackMessage_DataReaderView> ExecutePlan_FeedbackMessage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExecutePlan_FeedbackMessage_DataReaderView> ExecutePlan_FeedbackMessage_DataReaderView_out;

            struct ExecutePlan_FeedbackMessage_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ExecutePlan_FeedbackMessage_, struct ExecutePlan_FeedbackMessage_Seq_uniq_> ExecutePlan_FeedbackMessage_Seq;
            typedef DDS_DCPSSequence_var < ExecutePlan_FeedbackMessage_Seq> ExecutePlan_FeedbackMessage_Seq_var;
            typedef DDS_DCPSSequence_out < ExecutePlan_FeedbackMessage_Seq> ExecutePlan_FeedbackMessage_Seq_out;

            class  ExecutePlan_FeedbackMessage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExecutePlan_FeedbackMessage_TypeSupportInterface_ptr _ptr_type;
                typedef ExecutePlan_FeedbackMessage_TypeSupportInterface_var _var_type;

                static ExecutePlan_FeedbackMessage_TypeSupportInterface_ptr _duplicate (ExecutePlan_FeedbackMessage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_FeedbackMessage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_FeedbackMessage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_FeedbackMessage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_FeedbackMessage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExecutePlan_FeedbackMessage_TypeSupportInterface () {};
                ~ExecutePlan_FeedbackMessage_TypeSupportInterface () {};
            private:
                ExecutePlan_FeedbackMessage_TypeSupportInterface (const ExecutePlan_FeedbackMessage_TypeSupportInterface &);
                ExecutePlan_FeedbackMessage_TypeSupportInterface & operator = (const ExecutePlan_FeedbackMessage_TypeSupportInterface &);
            };

            class  ExecutePlan_FeedbackMessage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExecutePlan_FeedbackMessage_DataWriter_ptr _ptr_type;
                typedef ExecutePlan_FeedbackMessage_DataWriter_var _var_type;

                static ExecutePlan_FeedbackMessage_DataWriter_ptr _duplicate (ExecutePlan_FeedbackMessage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_FeedbackMessage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_FeedbackMessage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_FeedbackMessage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_FeedbackMessage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExecutePlan_FeedbackMessage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExecutePlan_FeedbackMessage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExecutePlan_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExecutePlan_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExecutePlan_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExecutePlan_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExecutePlan_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExecutePlan_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExecutePlan_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExecutePlan_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_FeedbackMessage_& instance_data) = 0;

            protected:
                ExecutePlan_FeedbackMessage_DataWriter () {};
                ~ExecutePlan_FeedbackMessage_DataWriter () {};
            private:
                ExecutePlan_FeedbackMessage_DataWriter (const ExecutePlan_FeedbackMessage_DataWriter &);
                ExecutePlan_FeedbackMessage_DataWriter & operator = (const ExecutePlan_FeedbackMessage_DataWriter &);
            };

            class  ExecutePlan_FeedbackMessage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExecutePlan_FeedbackMessage_DataReader_ptr _ptr_type;
                typedef ExecutePlan_FeedbackMessage_DataReader_var _var_type;

                static ExecutePlan_FeedbackMessage_DataReader_ptr _duplicate (ExecutePlan_FeedbackMessage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_FeedbackMessage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_FeedbackMessage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_FeedbackMessage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_FeedbackMessage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_FeedbackMessage_& instance) = 0;

            protected:
                ExecutePlan_FeedbackMessage_DataReader () {};
                ~ExecutePlan_FeedbackMessage_DataReader () {};
            private:
                ExecutePlan_FeedbackMessage_DataReader (const ExecutePlan_FeedbackMessage_DataReader &);
                ExecutePlan_FeedbackMessage_DataReader & operator = (const ExecutePlan_FeedbackMessage_DataReader &);
            };

            class  ExecutePlan_FeedbackMessage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExecutePlan_FeedbackMessage_DataReaderView_ptr _ptr_type;
                typedef ExecutePlan_FeedbackMessage_DataReaderView_var _var_type;

                static ExecutePlan_FeedbackMessage_DataReaderView_ptr _duplicate (ExecutePlan_FeedbackMessage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExecutePlan_FeedbackMessage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExecutePlan_FeedbackMessage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExecutePlan_FeedbackMessage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExecutePlan_FeedbackMessage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExecutePlan_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExecutePlan_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExecutePlan_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExecutePlan_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExecutePlan_FeedbackMessage_& instance) = 0;

            protected:
                ExecutePlan_FeedbackMessage_DataReaderView () {};
                ~ExecutePlan_FeedbackMessage_DataReaderView () {};
            private:
                ExecutePlan_FeedbackMessage_DataReaderView (const ExecutePlan_FeedbackMessage_DataReaderView &);
                ExecutePlan_FeedbackMessage_DataReaderView & operator = (const ExecutePlan_FeedbackMessage_DataReaderView &);
            };
        }

    }

}

#endif
