#ifndef H_5FF5A47857C5E810BA1785F509CF557F_ExecutePlan_SPLTYPES_H
#define H_5FF5A47857C5E810BA1785F509CF557F_ExecutePlan_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_ExecutePlan_.h"
#include "std_msgs/msg/dds_opensplice/Empty_SplDcps.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"



extern c_metaObject __ExecutePlan__plansys2_msgs__load (c_base base);

extern c_metaObject __ExecutePlan__plansys2_msgs_action__load (c_base base);

extern c_metaObject __ExecutePlan__plansys2_msgs_action_dds___load (c_base base);

extern const char *plansys2_msgs_action_dds__ExecutePlan_Goal__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecutePlan_Goal__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecutePlan_Goal__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecutePlan_Goal___load (c_base base);
struct _plansys2_msgs_action_dds__ExecutePlan_Goal_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecutePlan_Goal___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecutePlan_Goal_ *from, struct _plansys2_msgs_action_dds__ExecutePlan_Goal_ *to);
extern  void __plansys2_msgs_action_dds__ExecutePlan_Goal___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecutePlan_Goal_ {
    struct _std_msgs_msg_dds__Empty_ request_;
};

extern const char *plansys2_msgs_action_dds__ExecutePlan_SendGoal_Request__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecutePlan_SendGoal_Request__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecutePlan_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecutePlan_SendGoal_Request___load (c_base base);
struct _plansys2_msgs_action_dds__ExecutePlan_SendGoal_Request_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecutePlan_SendGoal_Request___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecutePlan_SendGoal_Request_ *from, struct _plansys2_msgs_action_dds__ExecutePlan_SendGoal_Request_ *to);
extern  void __plansys2_msgs_action_dds__ExecutePlan_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecutePlan_SendGoal_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _plansys2_msgs_action_dds__ExecutePlan_Goal_ goal_;
};

extern const char *plansys2_msgs_action_dds__ExecutePlan_SendGoal_Response__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecutePlan_SendGoal_Response__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecutePlan_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecutePlan_SendGoal_Response___load (c_base base);
struct _plansys2_msgs_action_dds__ExecutePlan_SendGoal_Response_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecutePlan_SendGoal_Response___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecutePlan_SendGoal_Response_ *from, struct _plansys2_msgs_action_dds__ExecutePlan_SendGoal_Response_ *to);
extern  void __plansys2_msgs_action_dds__ExecutePlan_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecutePlan_SendGoal_Response_ {
    c_bool accepted_;
    struct _builtin_interfaces_msg_dds__Time_ stamp_;
};

extern const char *plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Request__metaDescriptor[];
extern const int plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Request__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Request___load (c_base base);
struct _plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Request_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Request___copyIn(c_base base, const struct plansys2_msgs::action::dds_::Sample_ExecutePlan_SendGoal_Request_ *from, struct _plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Request_ *to);
extern  void __plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _plansys2_msgs_action_dds__ExecutePlan_SendGoal_Request_ request_;
};

extern const char *plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Response__metaDescriptor[];
extern const int plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Response__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Response___load (c_base base);
struct _plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Response_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Response___copyIn(c_base base, const struct plansys2_msgs::action::dds_::Sample_ExecutePlan_SendGoal_Response_ *from, struct _plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Response_ *to);
extern  void __plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__Sample_ExecutePlan_SendGoal_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _plansys2_msgs_action_dds__ExecutePlan_SendGoal_Response_ response_;
};

extern const char *plansys2_msgs_action_dds__ExecutePlan_Result__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecutePlan_Result__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecutePlan_Result__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecutePlan_Result___load (c_base base);
struct _plansys2_msgs_action_dds__ExecutePlan_Result_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecutePlan_Result___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecutePlan_Result_ *from, struct _plansys2_msgs_action_dds__ExecutePlan_Result_ *to);
extern  void __plansys2_msgs_action_dds__ExecutePlan_Result___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecutePlan_Result_ {
    c_bool success_;
    c_string error_info_;
};

extern const char *plansys2_msgs_action_dds__ExecutePlan_GetResult_Request__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecutePlan_GetResult_Request__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecutePlan_GetResult_Request__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecutePlan_GetResult_Request___load (c_base base);
struct _plansys2_msgs_action_dds__ExecutePlan_GetResult_Request_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecutePlan_GetResult_Request___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecutePlan_GetResult_Request_ *from, struct _plansys2_msgs_action_dds__ExecutePlan_GetResult_Request_ *to);
extern  void __plansys2_msgs_action_dds__ExecutePlan_GetResult_Request___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecutePlan_GetResult_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
};

extern const char *plansys2_msgs_action_dds__ExecutePlan_GetResult_Response__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecutePlan_GetResult_Response__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecutePlan_GetResult_Response__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecutePlan_GetResult_Response___load (c_base base);
struct _plansys2_msgs_action_dds__ExecutePlan_GetResult_Response_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecutePlan_GetResult_Response___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecutePlan_GetResult_Response_ *from, struct _plansys2_msgs_action_dds__ExecutePlan_GetResult_Response_ *to);
extern  void __plansys2_msgs_action_dds__ExecutePlan_GetResult_Response___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecutePlan_GetResult_Response_ {
    c_octet status_;
    struct _plansys2_msgs_action_dds__ExecutePlan_Result_ result_;
};

extern const char *plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Request__metaDescriptor[];
extern const int plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Request__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Request__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Request___load (c_base base);
struct _plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Request_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Request___copyIn(c_base base, const struct plansys2_msgs::action::dds_::Sample_ExecutePlan_GetResult_Request_ *from, struct _plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Request_ *to);
extern  void __plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Request___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _plansys2_msgs_action_dds__ExecutePlan_GetResult_Request_ request_;
};

extern const char *plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Response__metaDescriptor[];
extern const int plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Response__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Response__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Response___load (c_base base);
struct _plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Response_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Response___copyIn(c_base base, const struct plansys2_msgs::action::dds_::Sample_ExecutePlan_GetResult_Response_ *from, struct _plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Response_ *to);
extern  void __plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Response___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__Sample_ExecutePlan_GetResult_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _plansys2_msgs_action_dds__ExecutePlan_GetResult_Response_ response_;
};

extern const char *plansys2_msgs_action_dds__ExecutePlan_Feedback__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecutePlan_Feedback__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecutePlan_Feedback__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecutePlan_Feedback___load (c_base base);
struct _plansys2_msgs_action_dds__ExecutePlan_Feedback_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecutePlan_Feedback___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecutePlan_Feedback_ *from, struct _plansys2_msgs_action_dds__ExecutePlan_Feedback_ *to);
extern  void __plansys2_msgs_action_dds__ExecutePlan_Feedback___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecutePlan_Feedback_ {
    c_long seq_action_;
    c_long total_actions_;
    c_string current_action_;
    c_float progress_current_action_;
};

extern const char *plansys2_msgs_action_dds__ExecutePlan_FeedbackMessage__metaDescriptor[];
extern const int plansys2_msgs_action_dds__ExecutePlan_FeedbackMessage__metaDescriptorArrLength;
extern const int plansys2_msgs_action_dds__ExecutePlan_FeedbackMessage__metaDescriptorLength;
extern c_metaObject __plansys2_msgs_action_dds__ExecutePlan_FeedbackMessage___load (c_base base);
struct _plansys2_msgs_action_dds__ExecutePlan_FeedbackMessage_ ;
extern  v_copyin_result __plansys2_msgs_action_dds__ExecutePlan_FeedbackMessage___copyIn(c_base base, const struct plansys2_msgs::action::dds_::ExecutePlan_FeedbackMessage_ *from, struct _plansys2_msgs_action_dds__ExecutePlan_FeedbackMessage_ *to);
extern  void __plansys2_msgs_action_dds__ExecutePlan_FeedbackMessage___copyOut(const void *_from, void *_to);
struct _plansys2_msgs_action_dds__ExecutePlan_FeedbackMessage_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _plansys2_msgs_action_dds__ExecutePlan_Feedback_ feedback_;
};

#undef OS_API
#endif
