// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from plansys2_msgs:action/ExecuteAction.idl
// generated code does not contain a copyright notice

#ifndef PLANSYS2_MSGS__ACTION__EXECUTE_ACTION__STRUCT_H_
#define PLANSYS2_MSGS__ACTION__EXECUTE_ACTION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'action'
// Member 'arguments'
#include "rosidl_generator_c/string.h"

// Struct defined in action/ExecuteAction in the package plansys2_msgs.
typedef struct plansys2_msgs__action__ExecuteAction_Goal
{
  rosidl_generator_c__String action;
  rosidl_generator_c__String__Sequence arguments;
} plansys2_msgs__action__ExecuteAction_Goal;

// Struct for a sequence of plansys2_msgs__action__ExecuteAction_Goal.
typedef struct plansys2_msgs__action__ExecuteAction_Goal__Sequence
{
  plansys2_msgs__action__ExecuteAction_Goal * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} plansys2_msgs__action__ExecuteAction_Goal__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'error_info'
// already included above
// #include "rosidl_generator_c/string.h"

// Struct defined in action/ExecuteAction in the package plansys2_msgs.
typedef struct plansys2_msgs__action__ExecuteAction_Result
{
  bool success;
  rosidl_generator_c__String error_info;
} plansys2_msgs__action__ExecuteAction_Result;

// Struct for a sequence of plansys2_msgs__action__ExecuteAction_Result.
typedef struct plansys2_msgs__action__ExecuteAction_Result__Sequence
{
  plansys2_msgs__action__ExecuteAction_Result * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} plansys2_msgs__action__ExecuteAction_Result__Sequence;


// Constants defined in the message

// Struct defined in action/ExecuteAction in the package plansys2_msgs.
typedef struct plansys2_msgs__action__ExecuteAction_Feedback
{
  float progress;
} plansys2_msgs__action__ExecuteAction_Feedback;

// Struct for a sequence of plansys2_msgs__action__ExecuteAction_Feedback.
typedef struct plansys2_msgs__action__ExecuteAction_Feedback__Sequence
{
  plansys2_msgs__action__ExecuteAction_Feedback * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} plansys2_msgs__action__ExecuteAction_Feedback__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/uuid__struct.h"
// Member 'goal'
#include "plansys2_msgs/action/execute_action__struct.h"

// Struct defined in action/ExecuteAction in the package plansys2_msgs.
typedef struct plansys2_msgs__action__ExecuteAction_SendGoal_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
  plansys2_msgs__action__ExecuteAction_Goal goal;
} plansys2_msgs__action__ExecuteAction_SendGoal_Request;

// Struct for a sequence of plansys2_msgs__action__ExecuteAction_SendGoal_Request.
typedef struct plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence
{
  plansys2_msgs__action__ExecuteAction_SendGoal_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} plansys2_msgs__action__ExecuteAction_SendGoal_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/time__struct.h"

// Struct defined in action/ExecuteAction in the package plansys2_msgs.
typedef struct plansys2_msgs__action__ExecuteAction_SendGoal_Response
{
  bool accepted;
  builtin_interfaces__msg__Time stamp;
} plansys2_msgs__action__ExecuteAction_SendGoal_Response;

// Struct for a sequence of plansys2_msgs__action__ExecuteAction_SendGoal_Response.
typedef struct plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence
{
  plansys2_msgs__action__ExecuteAction_SendGoal_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} plansys2_msgs__action__ExecuteAction_SendGoal_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/uuid__struct.h"

// Struct defined in action/ExecuteAction in the package plansys2_msgs.
typedef struct plansys2_msgs__action__ExecuteAction_GetResult_Request
{
  unique_identifier_msgs__msg__UUID goal_id;
} plansys2_msgs__action__ExecuteAction_GetResult_Request;

// Struct for a sequence of plansys2_msgs__action__ExecuteAction_GetResult_Request.
typedef struct plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence
{
  plansys2_msgs__action__ExecuteAction_GetResult_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} plansys2_msgs__action__ExecuteAction_GetResult_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'result'
// already included above
// #include "plansys2_msgs/action/execute_action__struct.h"

// Struct defined in action/ExecuteAction in the package plansys2_msgs.
typedef struct plansys2_msgs__action__ExecuteAction_GetResult_Response
{
  int8_t status;
  plansys2_msgs__action__ExecuteAction_Result result;
} plansys2_msgs__action__ExecuteAction_GetResult_Response;

// Struct for a sequence of plansys2_msgs__action__ExecuteAction_GetResult_Response.
typedef struct plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence
{
  plansys2_msgs__action__ExecuteAction_GetResult_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} plansys2_msgs__action__ExecuteAction_GetResult_Response__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/uuid__struct.h"
// Member 'feedback'
// already included above
// #include "plansys2_msgs/action/execute_action__struct.h"

// Struct defined in action/ExecuteAction in the package plansys2_msgs.
typedef struct plansys2_msgs__action__ExecuteAction_FeedbackMessage
{
  unique_identifier_msgs__msg__UUID goal_id;
  plansys2_msgs__action__ExecuteAction_Feedback feedback;
} plansys2_msgs__action__ExecuteAction_FeedbackMessage;

// Struct for a sequence of plansys2_msgs__action__ExecuteAction_FeedbackMessage.
typedef struct plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence
{
  plansys2_msgs__action__ExecuteAction_FeedbackMessage * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} plansys2_msgs__action__ExecuteAction_FeedbackMessage__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PLANSYS2_MSGS__ACTION__EXECUTE_ACTION__STRUCT_H_
