// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from plansys2_msgs:action/ExecuteAction.idl
// generated code does not contain a copyright notice

#ifndef PLANSYS2_MSGS__ACTION__EXECUTE_ACTION__STRUCT_HPP_
#define PLANSYS2_MSGS__ACTION__EXECUTE_ACTION__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_Goal __attribute__((deprecated))
#else
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_Goal __declspec(deprecated)
#endif

namespace plansys2_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ExecuteAction_Goal_
{
  using Type = ExecuteAction_Goal_<ContainerAllocator>;

  explicit ExecuteAction_Goal_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->action = "";
    }
  }

  explicit ExecuteAction_Goal_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : action(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->action = "";
    }
  }

  // field types and members
  using _action_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _action_type action;
  using _arguments_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _arguments_type arguments;

  // setters for named parameter idiom
  Type & set__action(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->action = _arg;
    return *this;
  }
  Type & set__arguments(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->arguments = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator> *;
  using ConstRawPtr =
    const plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_Goal
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_Goal
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExecuteAction_Goal_ & other) const
  {
    if (this->action != other.action) {
      return false;
    }
    if (this->arguments != other.arguments) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExecuteAction_Goal_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExecuteAction_Goal_

// alias to use template instance with default allocator
using ExecuteAction_Goal =
  plansys2_msgs::action::ExecuteAction_Goal_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace plansys2_msgs


#ifndef _WIN32
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_Result __attribute__((deprecated))
#else
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_Result __declspec(deprecated)
#endif

namespace plansys2_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ExecuteAction_Result_
{
  using Type = ExecuteAction_Result_<ContainerAllocator>;

  explicit ExecuteAction_Result_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->error_info = "";
    }
  }

  explicit ExecuteAction_Result_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : error_info(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->error_info = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _error_info_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _error_info_type error_info;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__error_info(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->error_info = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator> *;
  using ConstRawPtr =
    const plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_Result
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_Result
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExecuteAction_Result_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->error_info != other.error_info) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExecuteAction_Result_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExecuteAction_Result_

// alias to use template instance with default allocator
using ExecuteAction_Result =
  plansys2_msgs::action::ExecuteAction_Result_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace plansys2_msgs


#ifndef _WIN32
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_Feedback __attribute__((deprecated))
#else
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_Feedback __declspec(deprecated)
#endif

namespace plansys2_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ExecuteAction_Feedback_
{
  using Type = ExecuteAction_Feedback_<ContainerAllocator>;

  explicit ExecuteAction_Feedback_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->progress = 0.0f;
    }
  }

  explicit ExecuteAction_Feedback_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->progress = 0.0f;
    }
  }

  // field types and members
  using _progress_type =
    float;
  _progress_type progress;

  // setters for named parameter idiom
  Type & set__progress(
    const float & _arg)
  {
    this->progress = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_Feedback
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_Feedback
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExecuteAction_Feedback_ & other) const
  {
    if (this->progress != other.progress) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExecuteAction_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExecuteAction_Feedback_

// alias to use template instance with default allocator
using ExecuteAction_Feedback =
  plansys2_msgs::action::ExecuteAction_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace plansys2_msgs


// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/uuid__struct.hpp"
// Member 'goal'
#include "plansys2_msgs/action/execute_action__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_SendGoal_Request __attribute__((deprecated))
#else
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_SendGoal_Request __declspec(deprecated)
#endif

namespace plansys2_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ExecuteAction_SendGoal_Request_
{
  using Type = ExecuteAction_SendGoal_Request_<ContainerAllocator>;

  explicit ExecuteAction_SendGoal_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    goal(_init)
  {
    (void)_init;
  }

  explicit ExecuteAction_SendGoal_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    goal(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _goal_type =
    plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator>;
  _goal_type goal;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__goal(
    const plansys2_msgs::action::ExecuteAction_Goal_<ContainerAllocator> & _arg)
  {
    this->goal = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    plansys2_msgs::action::ExecuteAction_SendGoal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const plansys2_msgs::action::ExecuteAction_SendGoal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_SendGoal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_SendGoal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_SendGoal_Request
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_SendGoal_Request
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExecuteAction_SendGoal_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->goal != other.goal) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExecuteAction_SendGoal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExecuteAction_SendGoal_Request_

// alias to use template instance with default allocator
using ExecuteAction_SendGoal_Request =
  plansys2_msgs::action::ExecuteAction_SendGoal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace plansys2_msgs


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_SendGoal_Response __attribute__((deprecated))
#else
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_SendGoal_Response __declspec(deprecated)
#endif

namespace plansys2_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ExecuteAction_SendGoal_Response_
{
  using Type = ExecuteAction_SendGoal_Response_<ContainerAllocator>;

  explicit ExecuteAction_SendGoal_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  explicit ExecuteAction_SendGoal_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  // field types and members
  using _accepted_type =
    bool;
  _accepted_type accepted;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__accepted(
    const bool & _arg)
  {
    this->accepted = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    plansys2_msgs::action::ExecuteAction_SendGoal_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const plansys2_msgs::action::ExecuteAction_SendGoal_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_SendGoal_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_SendGoal_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_SendGoal_Response
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_SendGoal_Response
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_SendGoal_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExecuteAction_SendGoal_Response_ & other) const
  {
    if (this->accepted != other.accepted) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExecuteAction_SendGoal_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExecuteAction_SendGoal_Response_

// alias to use template instance with default allocator
using ExecuteAction_SendGoal_Response =
  plansys2_msgs::action::ExecuteAction_SendGoal_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace plansys2_msgs

namespace plansys2_msgs
{

namespace action
{

struct ExecuteAction_SendGoal
{
  using Request = plansys2_msgs::action::ExecuteAction_SendGoal_Request;
  using Response = plansys2_msgs::action::ExecuteAction_SendGoal_Response;
};

}  // namespace action

}  // namespace plansys2_msgs


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/uuid__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_GetResult_Request __attribute__((deprecated))
#else
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_GetResult_Request __declspec(deprecated)
#endif

namespace plansys2_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ExecuteAction_GetResult_Request_
{
  using Type = ExecuteAction_GetResult_Request_<ContainerAllocator>;

  explicit ExecuteAction_GetResult_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : goal_id(_init)
  {
    (void)_init;
  }

  explicit ExecuteAction_GetResult_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    plansys2_msgs::action::ExecuteAction_GetResult_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const plansys2_msgs::action::ExecuteAction_GetResult_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_GetResult_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_GetResult_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_GetResult_Request
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_GetResult_Request
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExecuteAction_GetResult_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExecuteAction_GetResult_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExecuteAction_GetResult_Request_

// alias to use template instance with default allocator
using ExecuteAction_GetResult_Request =
  plansys2_msgs::action::ExecuteAction_GetResult_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace plansys2_msgs


// Include directives for member types
// Member 'result'
// already included above
// #include "plansys2_msgs/action/execute_action__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_GetResult_Response __attribute__((deprecated))
#else
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_GetResult_Response __declspec(deprecated)
#endif

namespace plansys2_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ExecuteAction_GetResult_Response_
{
  using Type = ExecuteAction_GetResult_Response_<ContainerAllocator>;

  explicit ExecuteAction_GetResult_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : result(_init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit ExecuteAction_GetResult_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : result(_alloc, _init)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    int8_t;
  _status_type status;
  using _result_type =
    plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__status(
    const int8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__result(
    const plansys2_msgs::action::ExecuteAction_Result_<ContainerAllocator> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    plansys2_msgs::action::ExecuteAction_GetResult_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const plansys2_msgs::action::ExecuteAction_GetResult_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_GetResult_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_GetResult_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_GetResult_Response
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_GetResult_Response
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_GetResult_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExecuteAction_GetResult_Response_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExecuteAction_GetResult_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExecuteAction_GetResult_Response_

// alias to use template instance with default allocator
using ExecuteAction_GetResult_Response =
  plansys2_msgs::action::ExecuteAction_GetResult_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace plansys2_msgs

namespace plansys2_msgs
{

namespace action
{

struct ExecuteAction_GetResult
{
  using Request = plansys2_msgs::action::ExecuteAction_GetResult_Request;
  using Response = plansys2_msgs::action::ExecuteAction_GetResult_Response;
};

}  // namespace action

}  // namespace plansys2_msgs


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/uuid__struct.hpp"
// Member 'feedback'
// already included above
// #include "plansys2_msgs/action/execute_action__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_FeedbackMessage __attribute__((deprecated))
#else
# define DEPRECATED__plansys2_msgs__action__ExecuteAction_FeedbackMessage __declspec(deprecated)
#endif

namespace plansys2_msgs
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct ExecuteAction_FeedbackMessage_
{
  using Type = ExecuteAction_FeedbackMessage_<ContainerAllocator>;

  explicit ExecuteAction_FeedbackMessage_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    feedback(_init)
  {
    (void)_init;
  }

  explicit ExecuteAction_FeedbackMessage_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    feedback(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _feedback_type =
    plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator>;
  _feedback_type feedback;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__feedback(
    const plansys2_msgs::action::ExecuteAction_Feedback_<ContainerAllocator> & _arg)
  {
    this->feedback = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    plansys2_msgs::action::ExecuteAction_FeedbackMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const plansys2_msgs::action::ExecuteAction_FeedbackMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_FeedbackMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_FeedbackMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_FeedbackMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_FeedbackMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      plansys2_msgs::action::ExecuteAction_FeedbackMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<plansys2_msgs::action::ExecuteAction_FeedbackMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_FeedbackMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<plansys2_msgs::action::ExecuteAction_FeedbackMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_FeedbackMessage
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_FeedbackMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__plansys2_msgs__action__ExecuteAction_FeedbackMessage
    std::shared_ptr<plansys2_msgs::action::ExecuteAction_FeedbackMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ExecuteAction_FeedbackMessage_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->feedback != other.feedback) {
      return false;
    }
    return true;
  }
  bool operator!=(const ExecuteAction_FeedbackMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ExecuteAction_FeedbackMessage_

// alias to use template instance with default allocator
using ExecuteAction_FeedbackMessage =
  plansys2_msgs::action::ExecuteAction_FeedbackMessage_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace plansys2_msgs

#include "action_msgs/srv/cancel_goal.hpp"
#include "action_msgs/msg/goal_info.hpp"
#include "action_msgs/msg/goal_status_array.hpp"

namespace plansys2_msgs
{

namespace action
{

struct ExecuteAction
{
  /// The goal message defined in the action definition.
  using Goal = plansys2_msgs::action::ExecuteAction_Goal;
  /// The result message defined in the action definition.
  using Result = plansys2_msgs::action::ExecuteAction_Result;
  /// The feedback message defined in the action definition.
  using Feedback = plansys2_msgs::action::ExecuteAction_Feedback;

  struct Impl
  {
    /// The send_goal service using a wrapped version of the goal message as a request.
    using SendGoalService = plansys2_msgs::action::ExecuteAction_SendGoal;
    /// The get_result service using a wrapped version of the result message as a response.
    using GetResultService = plansys2_msgs::action::ExecuteAction_GetResult;
    /// The feedback message with generic fields which wraps the feedback message.
    using FeedbackMessage = plansys2_msgs::action::ExecuteAction_FeedbackMessage;

    /// The generic service to cancel a goal.
    using CancelGoalService = action_msgs::srv::CancelGoal;
    /// The generic message for the status of a goal.
    using GoalStatusMessage = action_msgs::msg::GoalStatusArray;
  };
};

typedef struct ExecuteAction ExecuteAction;

}  // namespace action

}  // namespace plansys2_msgs

#endif  // PLANSYS2_MSGS__ACTION__EXECUTE_ACTION__STRUCT_HPP_
