#ifndef _H_630130C86DB29C488DFE8C2A9F7FBA09_AddProblemGoal__H_
#define _H_630130C86DB29C488DFE8C2A9F7FBA09_AddProblemGoal__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  AddProblemGoal_Request_
            {
                ::DDS::String_mgr goal_;
            };

            typedef DDS_DCPSStruct_var<AddProblemGoal_Request_> AddProblemGoal_Request__var;
            typedef DDS_DCPSStruct_out < AddProblemGoal_Request_> AddProblemGoal_Request__out;

            struct  AddProblemGoal_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<AddProblemGoal_Response_> AddProblemGoal_Response__var;
            typedef DDS_DCPSStruct_out < AddProblemGoal_Response_> AddProblemGoal_Response__out;

            struct  Sample_AddProblemGoal_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::AddProblemGoal_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddProblemGoal_Request_> Sample_AddProblemGoal_Request__var;
            typedef DDS_DCPSStruct_out < Sample_AddProblemGoal_Request_> Sample_AddProblemGoal_Request__out;

            struct  Sample_AddProblemGoal_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::AddProblemGoal_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddProblemGoal_Response_> Sample_AddProblemGoal_Response__var;
            typedef DDS_DCPSStruct_out < Sample_AddProblemGoal_Response_> Sample_AddProblemGoal_Response__out;

        }

    }

}

#endif /* _H_630130C86DB29C488DFE8C2A9F7FBA09_AddProblemGoal__H_ */
