#ifndef _H_630130C86DB29C488DFE8C2A9F7FBA09_AddProblemGoal_DCPS_H_
#define _H_630130C86DB29C488DFE8C2A9F7FBA09_AddProblemGoal_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AddProblemGoal_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class AddProblemGoal_Request_TypeSupportInterface;

            typedef AddProblemGoal_Request_TypeSupportInterface * AddProblemGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AddProblemGoal_Request_TypeSupportInterface> AddProblemGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AddProblemGoal_Request_TypeSupportInterface> AddProblemGoal_Request_TypeSupportInterface_out;


            class AddProblemGoal_Request_DataWriter;

            typedef AddProblemGoal_Request_DataWriter * AddProblemGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AddProblemGoal_Request_DataWriter> AddProblemGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < AddProblemGoal_Request_DataWriter> AddProblemGoal_Request_DataWriter_out;


            class AddProblemGoal_Request_DataReader;

            typedef AddProblemGoal_Request_DataReader * AddProblemGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AddProblemGoal_Request_DataReader> AddProblemGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < AddProblemGoal_Request_DataReader> AddProblemGoal_Request_DataReader_out;


            class AddProblemGoal_Request_DataReaderView;

            typedef AddProblemGoal_Request_DataReaderView * AddProblemGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AddProblemGoal_Request_DataReaderView> AddProblemGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AddProblemGoal_Request_DataReaderView> AddProblemGoal_Request_DataReaderView_out;

            struct AddProblemGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AddProblemGoal_Request_, struct AddProblemGoal_Request_Seq_uniq_> AddProblemGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < AddProblemGoal_Request_Seq> AddProblemGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < AddProblemGoal_Request_Seq> AddProblemGoal_Request_Seq_out;

            class  AddProblemGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AddProblemGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef AddProblemGoal_Request_TypeSupportInterface_var _var_type;

                static AddProblemGoal_Request_TypeSupportInterface_ptr _duplicate (AddProblemGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AddProblemGoal_Request_TypeSupportInterface () {};
                ~AddProblemGoal_Request_TypeSupportInterface () {};
            private:
                AddProblemGoal_Request_TypeSupportInterface (const AddProblemGoal_Request_TypeSupportInterface &);
                AddProblemGoal_Request_TypeSupportInterface & operator = (const AddProblemGoal_Request_TypeSupportInterface &);
            };

            class  AddProblemGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AddProblemGoal_Request_DataWriter_ptr _ptr_type;
                typedef AddProblemGoal_Request_DataWriter_var _var_type;

                static AddProblemGoal_Request_DataWriter_ptr _duplicate (AddProblemGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AddProblemGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AddProblemGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AddProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AddProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AddProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AddProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AddProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AddProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AddProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AddProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AddProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemGoal_Request_& instance_data) = 0;

            protected:
                AddProblemGoal_Request_DataWriter () {};
                ~AddProblemGoal_Request_DataWriter () {};
            private:
                AddProblemGoal_Request_DataWriter (const AddProblemGoal_Request_DataWriter &);
                AddProblemGoal_Request_DataWriter & operator = (const AddProblemGoal_Request_DataWriter &);
            };

            class  AddProblemGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AddProblemGoal_Request_DataReader_ptr _ptr_type;
                typedef AddProblemGoal_Request_DataReader_var _var_type;

                static AddProblemGoal_Request_DataReader_ptr _duplicate (AddProblemGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemGoal_Request_& instance) = 0;

            protected:
                AddProblemGoal_Request_DataReader () {};
                ~AddProblemGoal_Request_DataReader () {};
            private:
                AddProblemGoal_Request_DataReader (const AddProblemGoal_Request_DataReader &);
                AddProblemGoal_Request_DataReader & operator = (const AddProblemGoal_Request_DataReader &);
            };

            class  AddProblemGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AddProblemGoal_Request_DataReaderView_ptr _ptr_type;
                typedef AddProblemGoal_Request_DataReaderView_var _var_type;

                static AddProblemGoal_Request_DataReaderView_ptr _duplicate (AddProblemGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemGoal_Request_& instance) = 0;

            protected:
                AddProblemGoal_Request_DataReaderView () {};
                ~AddProblemGoal_Request_DataReaderView () {};
            private:
                AddProblemGoal_Request_DataReaderView (const AddProblemGoal_Request_DataReaderView &);
                AddProblemGoal_Request_DataReaderView & operator = (const AddProblemGoal_Request_DataReaderView &);
            };
            class AddProblemGoal_Response_TypeSupportInterface;

            typedef AddProblemGoal_Response_TypeSupportInterface * AddProblemGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AddProblemGoal_Response_TypeSupportInterface> AddProblemGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AddProblemGoal_Response_TypeSupportInterface> AddProblemGoal_Response_TypeSupportInterface_out;


            class AddProblemGoal_Response_DataWriter;

            typedef AddProblemGoal_Response_DataWriter * AddProblemGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AddProblemGoal_Response_DataWriter> AddProblemGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < AddProblemGoal_Response_DataWriter> AddProblemGoal_Response_DataWriter_out;


            class AddProblemGoal_Response_DataReader;

            typedef AddProblemGoal_Response_DataReader * AddProblemGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AddProblemGoal_Response_DataReader> AddProblemGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < AddProblemGoal_Response_DataReader> AddProblemGoal_Response_DataReader_out;


            class AddProblemGoal_Response_DataReaderView;

            typedef AddProblemGoal_Response_DataReaderView * AddProblemGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AddProblemGoal_Response_DataReaderView> AddProblemGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AddProblemGoal_Response_DataReaderView> AddProblemGoal_Response_DataReaderView_out;

            struct AddProblemGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AddProblemGoal_Response_, struct AddProblemGoal_Response_Seq_uniq_> AddProblemGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < AddProblemGoal_Response_Seq> AddProblemGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < AddProblemGoal_Response_Seq> AddProblemGoal_Response_Seq_out;

            class  AddProblemGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AddProblemGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef AddProblemGoal_Response_TypeSupportInterface_var _var_type;

                static AddProblemGoal_Response_TypeSupportInterface_ptr _duplicate (AddProblemGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AddProblemGoal_Response_TypeSupportInterface () {};
                ~AddProblemGoal_Response_TypeSupportInterface () {};
            private:
                AddProblemGoal_Response_TypeSupportInterface (const AddProblemGoal_Response_TypeSupportInterface &);
                AddProblemGoal_Response_TypeSupportInterface & operator = (const AddProblemGoal_Response_TypeSupportInterface &);
            };

            class  AddProblemGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AddProblemGoal_Response_DataWriter_ptr _ptr_type;
                typedef AddProblemGoal_Response_DataWriter_var _var_type;

                static AddProblemGoal_Response_DataWriter_ptr _duplicate (AddProblemGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AddProblemGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AddProblemGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AddProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AddProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AddProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AddProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AddProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AddProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AddProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AddProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AddProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemGoal_Response_& instance_data) = 0;

            protected:
                AddProblemGoal_Response_DataWriter () {};
                ~AddProblemGoal_Response_DataWriter () {};
            private:
                AddProblemGoal_Response_DataWriter (const AddProblemGoal_Response_DataWriter &);
                AddProblemGoal_Response_DataWriter & operator = (const AddProblemGoal_Response_DataWriter &);
            };

            class  AddProblemGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AddProblemGoal_Response_DataReader_ptr _ptr_type;
                typedef AddProblemGoal_Response_DataReader_var _var_type;

                static AddProblemGoal_Response_DataReader_ptr _duplicate (AddProblemGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemGoal_Response_& instance) = 0;

            protected:
                AddProblemGoal_Response_DataReader () {};
                ~AddProblemGoal_Response_DataReader () {};
            private:
                AddProblemGoal_Response_DataReader (const AddProblemGoal_Response_DataReader &);
                AddProblemGoal_Response_DataReader & operator = (const AddProblemGoal_Response_DataReader &);
            };

            class  AddProblemGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AddProblemGoal_Response_DataReaderView_ptr _ptr_type;
                typedef AddProblemGoal_Response_DataReaderView_var _var_type;

                static AddProblemGoal_Response_DataReaderView_ptr _duplicate (AddProblemGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemGoal_Response_& instance) = 0;

            protected:
                AddProblemGoal_Response_DataReaderView () {};
                ~AddProblemGoal_Response_DataReaderView () {};
            private:
                AddProblemGoal_Response_DataReaderView (const AddProblemGoal_Response_DataReaderView &);
                AddProblemGoal_Response_DataReaderView & operator = (const AddProblemGoal_Response_DataReaderView &);
            };
            class Sample_AddProblemGoal_Request_TypeSupportInterface;

            typedef Sample_AddProblemGoal_Request_TypeSupportInterface * Sample_AddProblemGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemGoal_Request_TypeSupportInterface> Sample_AddProblemGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemGoal_Request_TypeSupportInterface> Sample_AddProblemGoal_Request_TypeSupportInterface_out;


            class Sample_AddProblemGoal_Request_DataWriter;

            typedef Sample_AddProblemGoal_Request_DataWriter * Sample_AddProblemGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemGoal_Request_DataWriter> Sample_AddProblemGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemGoal_Request_DataWriter> Sample_AddProblemGoal_Request_DataWriter_out;


            class Sample_AddProblemGoal_Request_DataReader;

            typedef Sample_AddProblemGoal_Request_DataReader * Sample_AddProblemGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemGoal_Request_DataReader> Sample_AddProblemGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemGoal_Request_DataReader> Sample_AddProblemGoal_Request_DataReader_out;


            class Sample_AddProblemGoal_Request_DataReaderView;

            typedef Sample_AddProblemGoal_Request_DataReaderView * Sample_AddProblemGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemGoal_Request_DataReaderView> Sample_AddProblemGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemGoal_Request_DataReaderView> Sample_AddProblemGoal_Request_DataReaderView_out;

            struct Sample_AddProblemGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AddProblemGoal_Request_, struct Sample_AddProblemGoal_Request_Seq_uniq_> Sample_AddProblemGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_AddProblemGoal_Request_Seq> Sample_AddProblemGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AddProblemGoal_Request_Seq> Sample_AddProblemGoal_Request_Seq_out;

            class  Sample_AddProblemGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AddProblemGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AddProblemGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_AddProblemGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_AddProblemGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AddProblemGoal_Request_TypeSupportInterface () {};
                ~Sample_AddProblemGoal_Request_TypeSupportInterface () {};
            private:
                Sample_AddProblemGoal_Request_TypeSupportInterface (const Sample_AddProblemGoal_Request_TypeSupportInterface &);
                Sample_AddProblemGoal_Request_TypeSupportInterface & operator = (const Sample_AddProblemGoal_Request_TypeSupportInterface &);
            };

            class  Sample_AddProblemGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AddProblemGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_AddProblemGoal_Request_DataWriter_var _var_type;

                static Sample_AddProblemGoal_Request_DataWriter_ptr _duplicate (Sample_AddProblemGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AddProblemGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AddProblemGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AddProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AddProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AddProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AddProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AddProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AddProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AddProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AddProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemGoal_Request_& instance_data) = 0;

            protected:
                Sample_AddProblemGoal_Request_DataWriter () {};
                ~Sample_AddProblemGoal_Request_DataWriter () {};
            private:
                Sample_AddProblemGoal_Request_DataWriter (const Sample_AddProblemGoal_Request_DataWriter &);
                Sample_AddProblemGoal_Request_DataWriter & operator = (const Sample_AddProblemGoal_Request_DataWriter &);
            };

            class  Sample_AddProblemGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AddProblemGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_AddProblemGoal_Request_DataReader_var _var_type;

                static Sample_AddProblemGoal_Request_DataReader_ptr _duplicate (Sample_AddProblemGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemGoal_Request_& instance) = 0;

            protected:
                Sample_AddProblemGoal_Request_DataReader () {};
                ~Sample_AddProblemGoal_Request_DataReader () {};
            private:
                Sample_AddProblemGoal_Request_DataReader (const Sample_AddProblemGoal_Request_DataReader &);
                Sample_AddProblemGoal_Request_DataReader & operator = (const Sample_AddProblemGoal_Request_DataReader &);
            };

            class  Sample_AddProblemGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AddProblemGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_AddProblemGoal_Request_DataReaderView_var _var_type;

                static Sample_AddProblemGoal_Request_DataReaderView_ptr _duplicate (Sample_AddProblemGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemGoal_Request_& instance) = 0;

            protected:
                Sample_AddProblemGoal_Request_DataReaderView () {};
                ~Sample_AddProblemGoal_Request_DataReaderView () {};
            private:
                Sample_AddProblemGoal_Request_DataReaderView (const Sample_AddProblemGoal_Request_DataReaderView &);
                Sample_AddProblemGoal_Request_DataReaderView & operator = (const Sample_AddProblemGoal_Request_DataReaderView &);
            };
            class Sample_AddProblemGoal_Response_TypeSupportInterface;

            typedef Sample_AddProblemGoal_Response_TypeSupportInterface * Sample_AddProblemGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemGoal_Response_TypeSupportInterface> Sample_AddProblemGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemGoal_Response_TypeSupportInterface> Sample_AddProblemGoal_Response_TypeSupportInterface_out;


            class Sample_AddProblemGoal_Response_DataWriter;

            typedef Sample_AddProblemGoal_Response_DataWriter * Sample_AddProblemGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemGoal_Response_DataWriter> Sample_AddProblemGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemGoal_Response_DataWriter> Sample_AddProblemGoal_Response_DataWriter_out;


            class Sample_AddProblemGoal_Response_DataReader;

            typedef Sample_AddProblemGoal_Response_DataReader * Sample_AddProblemGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemGoal_Response_DataReader> Sample_AddProblemGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemGoal_Response_DataReader> Sample_AddProblemGoal_Response_DataReader_out;


            class Sample_AddProblemGoal_Response_DataReaderView;

            typedef Sample_AddProblemGoal_Response_DataReaderView * Sample_AddProblemGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemGoal_Response_DataReaderView> Sample_AddProblemGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemGoal_Response_DataReaderView> Sample_AddProblemGoal_Response_DataReaderView_out;

            struct Sample_AddProblemGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AddProblemGoal_Response_, struct Sample_AddProblemGoal_Response_Seq_uniq_> Sample_AddProblemGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_AddProblemGoal_Response_Seq> Sample_AddProblemGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AddProblemGoal_Response_Seq> Sample_AddProblemGoal_Response_Seq_out;

            class  Sample_AddProblemGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AddProblemGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AddProblemGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_AddProblemGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_AddProblemGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AddProblemGoal_Response_TypeSupportInterface () {};
                ~Sample_AddProblemGoal_Response_TypeSupportInterface () {};
            private:
                Sample_AddProblemGoal_Response_TypeSupportInterface (const Sample_AddProblemGoal_Response_TypeSupportInterface &);
                Sample_AddProblemGoal_Response_TypeSupportInterface & operator = (const Sample_AddProblemGoal_Response_TypeSupportInterface &);
            };

            class  Sample_AddProblemGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AddProblemGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_AddProblemGoal_Response_DataWriter_var _var_type;

                static Sample_AddProblemGoal_Response_DataWriter_ptr _duplicate (Sample_AddProblemGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AddProblemGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AddProblemGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AddProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AddProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AddProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AddProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AddProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AddProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AddProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AddProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemGoal_Response_& instance_data) = 0;

            protected:
                Sample_AddProblemGoal_Response_DataWriter () {};
                ~Sample_AddProblemGoal_Response_DataWriter () {};
            private:
                Sample_AddProblemGoal_Response_DataWriter (const Sample_AddProblemGoal_Response_DataWriter &);
                Sample_AddProblemGoal_Response_DataWriter & operator = (const Sample_AddProblemGoal_Response_DataWriter &);
            };

            class  Sample_AddProblemGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AddProblemGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_AddProblemGoal_Response_DataReader_var _var_type;

                static Sample_AddProblemGoal_Response_DataReader_ptr _duplicate (Sample_AddProblemGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemGoal_Response_& instance) = 0;

            protected:
                Sample_AddProblemGoal_Response_DataReader () {};
                ~Sample_AddProblemGoal_Response_DataReader () {};
            private:
                Sample_AddProblemGoal_Response_DataReader (const Sample_AddProblemGoal_Response_DataReader &);
                Sample_AddProblemGoal_Response_DataReader & operator = (const Sample_AddProblemGoal_Response_DataReader &);
            };

            class  Sample_AddProblemGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AddProblemGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_AddProblemGoal_Response_DataReaderView_var _var_type;

                static Sample_AddProblemGoal_Response_DataReaderView_ptr _duplicate (Sample_AddProblemGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemGoal_Response_& instance) = 0;

            protected:
                Sample_AddProblemGoal_Response_DataReaderView () {};
                ~Sample_AddProblemGoal_Response_DataReaderView () {};
            private:
                Sample_AddProblemGoal_Response_DataReaderView (const Sample_AddProblemGoal_Response_DataReaderView &);
                Sample_AddProblemGoal_Response_DataReaderView & operator = (const Sample_AddProblemGoal_Response_DataReaderView &);
            };
        }

    }

}

#endif
