#ifndef _H_2B1C1C403874388C43FBA25AE1ED6D66_AddProblemInstance_DCPS_H_
#define _H_2B1C1C403874388C43FBA25AE1ED6D66_AddProblemInstance_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AddProblemInstance_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class AddProblemInstance_Request_TypeSupportInterface;

            typedef AddProblemInstance_Request_TypeSupportInterface * AddProblemInstance_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AddProblemInstance_Request_TypeSupportInterface> AddProblemInstance_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AddProblemInstance_Request_TypeSupportInterface> AddProblemInstance_Request_TypeSupportInterface_out;


            class AddProblemInstance_Request_DataWriter;

            typedef AddProblemInstance_Request_DataWriter * AddProblemInstance_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AddProblemInstance_Request_DataWriter> AddProblemInstance_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < AddProblemInstance_Request_DataWriter> AddProblemInstance_Request_DataWriter_out;


            class AddProblemInstance_Request_DataReader;

            typedef AddProblemInstance_Request_DataReader * AddProblemInstance_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AddProblemInstance_Request_DataReader> AddProblemInstance_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < AddProblemInstance_Request_DataReader> AddProblemInstance_Request_DataReader_out;


            class AddProblemInstance_Request_DataReaderView;

            typedef AddProblemInstance_Request_DataReaderView * AddProblemInstance_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AddProblemInstance_Request_DataReaderView> AddProblemInstance_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AddProblemInstance_Request_DataReaderView> AddProblemInstance_Request_DataReaderView_out;

            struct AddProblemInstance_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AddProblemInstance_Request_, struct AddProblemInstance_Request_Seq_uniq_> AddProblemInstance_Request_Seq;
            typedef DDS_DCPSSequence_var < AddProblemInstance_Request_Seq> AddProblemInstance_Request_Seq_var;
            typedef DDS_DCPSSequence_out < AddProblemInstance_Request_Seq> AddProblemInstance_Request_Seq_out;

            class  AddProblemInstance_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AddProblemInstance_Request_TypeSupportInterface_ptr _ptr_type;
                typedef AddProblemInstance_Request_TypeSupportInterface_var _var_type;

                static AddProblemInstance_Request_TypeSupportInterface_ptr _duplicate (AddProblemInstance_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemInstance_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemInstance_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AddProblemInstance_Request_TypeSupportInterface () {};
                ~AddProblemInstance_Request_TypeSupportInterface () {};
            private:
                AddProblemInstance_Request_TypeSupportInterface (const AddProblemInstance_Request_TypeSupportInterface &);
                AddProblemInstance_Request_TypeSupportInterface & operator = (const AddProblemInstance_Request_TypeSupportInterface &);
            };

            class  AddProblemInstance_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AddProblemInstance_Request_DataWriter_ptr _ptr_type;
                typedef AddProblemInstance_Request_DataWriter_var _var_type;

                static AddProblemInstance_Request_DataWriter_ptr _duplicate (AddProblemInstance_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemInstance_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemInstance_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AddProblemInstance_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AddProblemInstance_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AddProblemInstance_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AddProblemInstance_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AddProblemInstance_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AddProblemInstance_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AddProblemInstance_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AddProblemInstance_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AddProblemInstance_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AddProblemInstance_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AddProblemInstance_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemInstance_Request_& instance_data) = 0;

            protected:
                AddProblemInstance_Request_DataWriter () {};
                ~AddProblemInstance_Request_DataWriter () {};
            private:
                AddProblemInstance_Request_DataWriter (const AddProblemInstance_Request_DataWriter &);
                AddProblemInstance_Request_DataWriter & operator = (const AddProblemInstance_Request_DataWriter &);
            };

            class  AddProblemInstance_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AddProblemInstance_Request_DataReader_ptr _ptr_type;
                typedef AddProblemInstance_Request_DataReader_var _var_type;

                static AddProblemInstance_Request_DataReader_ptr _duplicate (AddProblemInstance_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemInstance_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemInstance_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddProblemInstance_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddProblemInstance_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddProblemInstance_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemInstance_Request_& instance) = 0;

            protected:
                AddProblemInstance_Request_DataReader () {};
                ~AddProblemInstance_Request_DataReader () {};
            private:
                AddProblemInstance_Request_DataReader (const AddProblemInstance_Request_DataReader &);
                AddProblemInstance_Request_DataReader & operator = (const AddProblemInstance_Request_DataReader &);
            };

            class  AddProblemInstance_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AddProblemInstance_Request_DataReaderView_ptr _ptr_type;
                typedef AddProblemInstance_Request_DataReaderView_var _var_type;

                static AddProblemInstance_Request_DataReaderView_ptr _duplicate (AddProblemInstance_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemInstance_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemInstance_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddProblemInstance_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddProblemInstance_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddProblemInstance_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemInstance_Request_& instance) = 0;

            protected:
                AddProblemInstance_Request_DataReaderView () {};
                ~AddProblemInstance_Request_DataReaderView () {};
            private:
                AddProblemInstance_Request_DataReaderView (const AddProblemInstance_Request_DataReaderView &);
                AddProblemInstance_Request_DataReaderView & operator = (const AddProblemInstance_Request_DataReaderView &);
            };
            class AddProblemInstance_Response_TypeSupportInterface;

            typedef AddProblemInstance_Response_TypeSupportInterface * AddProblemInstance_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AddProblemInstance_Response_TypeSupportInterface> AddProblemInstance_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AddProblemInstance_Response_TypeSupportInterface> AddProblemInstance_Response_TypeSupportInterface_out;


            class AddProblemInstance_Response_DataWriter;

            typedef AddProblemInstance_Response_DataWriter * AddProblemInstance_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AddProblemInstance_Response_DataWriter> AddProblemInstance_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < AddProblemInstance_Response_DataWriter> AddProblemInstance_Response_DataWriter_out;


            class AddProblemInstance_Response_DataReader;

            typedef AddProblemInstance_Response_DataReader * AddProblemInstance_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AddProblemInstance_Response_DataReader> AddProblemInstance_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < AddProblemInstance_Response_DataReader> AddProblemInstance_Response_DataReader_out;


            class AddProblemInstance_Response_DataReaderView;

            typedef AddProblemInstance_Response_DataReaderView * AddProblemInstance_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AddProblemInstance_Response_DataReaderView> AddProblemInstance_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AddProblemInstance_Response_DataReaderView> AddProblemInstance_Response_DataReaderView_out;

            struct AddProblemInstance_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AddProblemInstance_Response_, struct AddProblemInstance_Response_Seq_uniq_> AddProblemInstance_Response_Seq;
            typedef DDS_DCPSSequence_var < AddProblemInstance_Response_Seq> AddProblemInstance_Response_Seq_var;
            typedef DDS_DCPSSequence_out < AddProblemInstance_Response_Seq> AddProblemInstance_Response_Seq_out;

            class  AddProblemInstance_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AddProblemInstance_Response_TypeSupportInterface_ptr _ptr_type;
                typedef AddProblemInstance_Response_TypeSupportInterface_var _var_type;

                static AddProblemInstance_Response_TypeSupportInterface_ptr _duplicate (AddProblemInstance_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemInstance_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemInstance_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AddProblemInstance_Response_TypeSupportInterface () {};
                ~AddProblemInstance_Response_TypeSupportInterface () {};
            private:
                AddProblemInstance_Response_TypeSupportInterface (const AddProblemInstance_Response_TypeSupportInterface &);
                AddProblemInstance_Response_TypeSupportInterface & operator = (const AddProblemInstance_Response_TypeSupportInterface &);
            };

            class  AddProblemInstance_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AddProblemInstance_Response_DataWriter_ptr _ptr_type;
                typedef AddProblemInstance_Response_DataWriter_var _var_type;

                static AddProblemInstance_Response_DataWriter_ptr _duplicate (AddProblemInstance_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemInstance_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemInstance_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AddProblemInstance_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AddProblemInstance_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AddProblemInstance_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AddProblemInstance_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AddProblemInstance_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AddProblemInstance_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AddProblemInstance_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AddProblemInstance_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AddProblemInstance_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AddProblemInstance_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AddProblemInstance_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemInstance_Response_& instance_data) = 0;

            protected:
                AddProblemInstance_Response_DataWriter () {};
                ~AddProblemInstance_Response_DataWriter () {};
            private:
                AddProblemInstance_Response_DataWriter (const AddProblemInstance_Response_DataWriter &);
                AddProblemInstance_Response_DataWriter & operator = (const AddProblemInstance_Response_DataWriter &);
            };

            class  AddProblemInstance_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AddProblemInstance_Response_DataReader_ptr _ptr_type;
                typedef AddProblemInstance_Response_DataReader_var _var_type;

                static AddProblemInstance_Response_DataReader_ptr _duplicate (AddProblemInstance_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemInstance_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemInstance_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddProblemInstance_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddProblemInstance_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddProblemInstance_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemInstance_Response_& instance) = 0;

            protected:
                AddProblemInstance_Response_DataReader () {};
                ~AddProblemInstance_Response_DataReader () {};
            private:
                AddProblemInstance_Response_DataReader (const AddProblemInstance_Response_DataReader &);
                AddProblemInstance_Response_DataReader & operator = (const AddProblemInstance_Response_DataReader &);
            };

            class  AddProblemInstance_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AddProblemInstance_Response_DataReaderView_ptr _ptr_type;
                typedef AddProblemInstance_Response_DataReaderView_var _var_type;

                static AddProblemInstance_Response_DataReaderView_ptr _duplicate (AddProblemInstance_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddProblemInstance_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddProblemInstance_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AddProblemInstance_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddProblemInstance_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddProblemInstance_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddProblemInstance_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddProblemInstance_Response_& instance) = 0;

            protected:
                AddProblemInstance_Response_DataReaderView () {};
                ~AddProblemInstance_Response_DataReaderView () {};
            private:
                AddProblemInstance_Response_DataReaderView (const AddProblemInstance_Response_DataReaderView &);
                AddProblemInstance_Response_DataReaderView & operator = (const AddProblemInstance_Response_DataReaderView &);
            };
            class Sample_AddProblemInstance_Request_TypeSupportInterface;

            typedef Sample_AddProblemInstance_Request_TypeSupportInterface * Sample_AddProblemInstance_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemInstance_Request_TypeSupportInterface> Sample_AddProblemInstance_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemInstance_Request_TypeSupportInterface> Sample_AddProblemInstance_Request_TypeSupportInterface_out;


            class Sample_AddProblemInstance_Request_DataWriter;

            typedef Sample_AddProblemInstance_Request_DataWriter * Sample_AddProblemInstance_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemInstance_Request_DataWriter> Sample_AddProblemInstance_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemInstance_Request_DataWriter> Sample_AddProblemInstance_Request_DataWriter_out;


            class Sample_AddProblemInstance_Request_DataReader;

            typedef Sample_AddProblemInstance_Request_DataReader * Sample_AddProblemInstance_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemInstance_Request_DataReader> Sample_AddProblemInstance_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemInstance_Request_DataReader> Sample_AddProblemInstance_Request_DataReader_out;


            class Sample_AddProblemInstance_Request_DataReaderView;

            typedef Sample_AddProblemInstance_Request_DataReaderView * Sample_AddProblemInstance_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemInstance_Request_DataReaderView> Sample_AddProblemInstance_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemInstance_Request_DataReaderView> Sample_AddProblemInstance_Request_DataReaderView_out;

            struct Sample_AddProblemInstance_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AddProblemInstance_Request_, struct Sample_AddProblemInstance_Request_Seq_uniq_> Sample_AddProblemInstance_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_AddProblemInstance_Request_Seq> Sample_AddProblemInstance_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AddProblemInstance_Request_Seq> Sample_AddProblemInstance_Request_Seq_out;

            class  Sample_AddProblemInstance_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AddProblemInstance_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AddProblemInstance_Request_TypeSupportInterface_var _var_type;

                static Sample_AddProblemInstance_Request_TypeSupportInterface_ptr _duplicate (Sample_AddProblemInstance_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemInstance_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemInstance_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AddProblemInstance_Request_TypeSupportInterface () {};
                ~Sample_AddProblemInstance_Request_TypeSupportInterface () {};
            private:
                Sample_AddProblemInstance_Request_TypeSupportInterface (const Sample_AddProblemInstance_Request_TypeSupportInterface &);
                Sample_AddProblemInstance_Request_TypeSupportInterface & operator = (const Sample_AddProblemInstance_Request_TypeSupportInterface &);
            };

            class  Sample_AddProblemInstance_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AddProblemInstance_Request_DataWriter_ptr _ptr_type;
                typedef Sample_AddProblemInstance_Request_DataWriter_var _var_type;

                static Sample_AddProblemInstance_Request_DataWriter_ptr _duplicate (Sample_AddProblemInstance_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemInstance_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemInstance_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AddProblemInstance_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AddProblemInstance_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AddProblemInstance_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AddProblemInstance_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AddProblemInstance_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AddProblemInstance_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AddProblemInstance_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AddProblemInstance_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AddProblemInstance_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AddProblemInstance_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemInstance_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemInstance_Request_& instance_data) = 0;

            protected:
                Sample_AddProblemInstance_Request_DataWriter () {};
                ~Sample_AddProblemInstance_Request_DataWriter () {};
            private:
                Sample_AddProblemInstance_Request_DataWriter (const Sample_AddProblemInstance_Request_DataWriter &);
                Sample_AddProblemInstance_Request_DataWriter & operator = (const Sample_AddProblemInstance_Request_DataWriter &);
            };

            class  Sample_AddProblemInstance_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AddProblemInstance_Request_DataReader_ptr _ptr_type;
                typedef Sample_AddProblemInstance_Request_DataReader_var _var_type;

                static Sample_AddProblemInstance_Request_DataReader_ptr _duplicate (Sample_AddProblemInstance_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemInstance_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemInstance_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddProblemInstance_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddProblemInstance_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemInstance_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemInstance_Request_& instance) = 0;

            protected:
                Sample_AddProblemInstance_Request_DataReader () {};
                ~Sample_AddProblemInstance_Request_DataReader () {};
            private:
                Sample_AddProblemInstance_Request_DataReader (const Sample_AddProblemInstance_Request_DataReader &);
                Sample_AddProblemInstance_Request_DataReader & operator = (const Sample_AddProblemInstance_Request_DataReader &);
            };

            class  Sample_AddProblemInstance_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AddProblemInstance_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_AddProblemInstance_Request_DataReaderView_var _var_type;

                static Sample_AddProblemInstance_Request_DataReaderView_ptr _duplicate (Sample_AddProblemInstance_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemInstance_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemInstance_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddProblemInstance_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddProblemInstance_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddProblemInstance_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemInstance_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemInstance_Request_& instance) = 0;

            protected:
                Sample_AddProblemInstance_Request_DataReaderView () {};
                ~Sample_AddProblemInstance_Request_DataReaderView () {};
            private:
                Sample_AddProblemInstance_Request_DataReaderView (const Sample_AddProblemInstance_Request_DataReaderView &);
                Sample_AddProblemInstance_Request_DataReaderView & operator = (const Sample_AddProblemInstance_Request_DataReaderView &);
            };
            class Sample_AddProblemInstance_Response_TypeSupportInterface;

            typedef Sample_AddProblemInstance_Response_TypeSupportInterface * Sample_AddProblemInstance_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemInstance_Response_TypeSupportInterface> Sample_AddProblemInstance_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemInstance_Response_TypeSupportInterface> Sample_AddProblemInstance_Response_TypeSupportInterface_out;


            class Sample_AddProblemInstance_Response_DataWriter;

            typedef Sample_AddProblemInstance_Response_DataWriter * Sample_AddProblemInstance_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemInstance_Response_DataWriter> Sample_AddProblemInstance_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemInstance_Response_DataWriter> Sample_AddProblemInstance_Response_DataWriter_out;


            class Sample_AddProblemInstance_Response_DataReader;

            typedef Sample_AddProblemInstance_Response_DataReader * Sample_AddProblemInstance_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemInstance_Response_DataReader> Sample_AddProblemInstance_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemInstance_Response_DataReader> Sample_AddProblemInstance_Response_DataReader_out;


            class Sample_AddProblemInstance_Response_DataReaderView;

            typedef Sample_AddProblemInstance_Response_DataReaderView * Sample_AddProblemInstance_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddProblemInstance_Response_DataReaderView> Sample_AddProblemInstance_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AddProblemInstance_Response_DataReaderView> Sample_AddProblemInstance_Response_DataReaderView_out;

            struct Sample_AddProblemInstance_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AddProblemInstance_Response_, struct Sample_AddProblemInstance_Response_Seq_uniq_> Sample_AddProblemInstance_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_AddProblemInstance_Response_Seq> Sample_AddProblemInstance_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AddProblemInstance_Response_Seq> Sample_AddProblemInstance_Response_Seq_out;

            class  Sample_AddProblemInstance_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AddProblemInstance_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AddProblemInstance_Response_TypeSupportInterface_var _var_type;

                static Sample_AddProblemInstance_Response_TypeSupportInterface_ptr _duplicate (Sample_AddProblemInstance_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemInstance_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemInstance_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AddProblemInstance_Response_TypeSupportInterface () {};
                ~Sample_AddProblemInstance_Response_TypeSupportInterface () {};
            private:
                Sample_AddProblemInstance_Response_TypeSupportInterface (const Sample_AddProblemInstance_Response_TypeSupportInterface &);
                Sample_AddProblemInstance_Response_TypeSupportInterface & operator = (const Sample_AddProblemInstance_Response_TypeSupportInterface &);
            };

            class  Sample_AddProblemInstance_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AddProblemInstance_Response_DataWriter_ptr _ptr_type;
                typedef Sample_AddProblemInstance_Response_DataWriter_var _var_type;

                static Sample_AddProblemInstance_Response_DataWriter_ptr _duplicate (Sample_AddProblemInstance_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemInstance_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemInstance_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AddProblemInstance_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AddProblemInstance_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AddProblemInstance_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AddProblemInstance_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AddProblemInstance_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AddProblemInstance_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AddProblemInstance_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AddProblemInstance_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AddProblemInstance_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AddProblemInstance_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemInstance_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemInstance_Response_& instance_data) = 0;

            protected:
                Sample_AddProblemInstance_Response_DataWriter () {};
                ~Sample_AddProblemInstance_Response_DataWriter () {};
            private:
                Sample_AddProblemInstance_Response_DataWriter (const Sample_AddProblemInstance_Response_DataWriter &);
                Sample_AddProblemInstance_Response_DataWriter & operator = (const Sample_AddProblemInstance_Response_DataWriter &);
            };

            class  Sample_AddProblemInstance_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AddProblemInstance_Response_DataReader_ptr _ptr_type;
                typedef Sample_AddProblemInstance_Response_DataReader_var _var_type;

                static Sample_AddProblemInstance_Response_DataReader_ptr _duplicate (Sample_AddProblemInstance_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemInstance_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemInstance_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddProblemInstance_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddProblemInstance_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemInstance_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemInstance_Response_& instance) = 0;

            protected:
                Sample_AddProblemInstance_Response_DataReader () {};
                ~Sample_AddProblemInstance_Response_DataReader () {};
            private:
                Sample_AddProblemInstance_Response_DataReader (const Sample_AddProblemInstance_Response_DataReader &);
                Sample_AddProblemInstance_Response_DataReader & operator = (const Sample_AddProblemInstance_Response_DataReader &);
            };

            class  Sample_AddProblemInstance_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AddProblemInstance_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_AddProblemInstance_Response_DataReaderView_var _var_type;

                static Sample_AddProblemInstance_Response_DataReaderView_ptr _duplicate (Sample_AddProblemInstance_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddProblemInstance_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddProblemInstance_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddProblemInstance_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddProblemInstance_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddProblemInstance_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddProblemInstance_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddProblemInstance_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddProblemInstance_Response_& instance) = 0;

            protected:
                Sample_AddProblemInstance_Response_DataReaderView () {};
                ~Sample_AddProblemInstance_Response_DataReaderView () {};
            private:
                Sample_AddProblemInstance_Response_DataReaderView (const Sample_AddProblemInstance_Response_DataReaderView &);
                Sample_AddProblemInstance_Response_DataReaderView & operator = (const Sample_AddProblemInstance_Response_DataReaderView &);
            };
        }

    }

}

#endif
