#ifndef _H_FA58509B0B3230F74FBD1F12092FB492_AddProblemPredicate__H_
#define _H_FA58509B0B3230F74FBD1F12092FB492_AddProblemPredicate__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  AddProblemPredicate_Request_
            {
                struct _arguments__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _arguments__seq_uniq_ > _arguments__seq;
                typedef DDS_DCPSUStrSeq_var< _arguments__seq > _arguments__seq_var;
                typedef DDS_DCPSUStrSeq_out< _arguments__seq > _arguments__seq_out;
                ::DDS::String_mgr predicate_;
                _arguments__seq arguments_;
            };

            typedef DDS_DCPSStruct_var<AddProblemPredicate_Request_> AddProblemPredicate_Request__var;
            typedef DDS_DCPSStruct_out < AddProblemPredicate_Request_> AddProblemPredicate_Request__out;

            struct  AddProblemPredicate_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<AddProblemPredicate_Response_> AddProblemPredicate_Response__var;
            typedef DDS_DCPSStruct_out < AddProblemPredicate_Response_> AddProblemPredicate_Response__out;

            struct  Sample_AddProblemPredicate_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::AddProblemPredicate_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddProblemPredicate_Request_> Sample_AddProblemPredicate_Request__var;
            typedef DDS_DCPSStruct_out < Sample_AddProblemPredicate_Request_> Sample_AddProblemPredicate_Request__out;

            struct  Sample_AddProblemPredicate_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::AddProblemPredicate_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddProblemPredicate_Response_> Sample_AddProblemPredicate_Response__var;
            typedef DDS_DCPSStruct_out < Sample_AddProblemPredicate_Response_> Sample_AddProblemPredicate_Response__out;

        }

    }

}

#endif /* _H_FA58509B0B3230F74FBD1F12092FB492_AddProblemPredicate__H_ */
