#ifndef _H_9BDC7996E9A09A09DE5F869D99986067_ExistProblemPredicate__H_
#define _H_9BDC7996E9A09A09DE5F869D99986067_ExistProblemPredicate__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  ExistProblemPredicate_Request_
            {
                struct _arguments__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _arguments__seq_uniq_ > _arguments__seq;
                typedef DDS_DCPSUStrSeq_var< _arguments__seq > _arguments__seq_var;
                typedef DDS_DCPSUStrSeq_out< _arguments__seq > _arguments__seq_out;
                ::DDS::String_mgr predicate_;
                _arguments__seq arguments_;
            };

            typedef DDS_DCPSStruct_var<ExistProblemPredicate_Request_> ExistProblemPredicate_Request__var;
            typedef DDS_DCPSStruct_out < ExistProblemPredicate_Request_> ExistProblemPredicate_Request__out;

            struct  ExistProblemPredicate_Response_
            {
                ::DDS::Boolean exist_;
            };

            typedef DDS_DCPSStruct_var<ExistProblemPredicate_Response_> ExistProblemPredicate_Response__var;
            typedef ExistProblemPredicate_Response_& ExistProblemPredicate_Response__out;

            struct  Sample_ExistProblemPredicate_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::ExistProblemPredicate_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ExistProblemPredicate_Request_> Sample_ExistProblemPredicate_Request__var;
            typedef DDS_DCPSStruct_out < Sample_ExistProblemPredicate_Request_> Sample_ExistProblemPredicate_Request__out;

            struct  Sample_ExistProblemPredicate_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::ExistProblemPredicate_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ExistProblemPredicate_Response_> Sample_ExistProblemPredicate_Response__var;
            typedef Sample_ExistProblemPredicate_Response_& Sample_ExistProblemPredicate_Response__out;

        }

    }

}

#endif /* _H_9BDC7996E9A09A09DE5F869D99986067_ExistProblemPredicate__H_ */
