#ifndef _H_9BDC7996E9A09A09DE5F869D99986067_ExistProblemPredicate_DCPS_H_
#define _H_9BDC7996E9A09A09DE5F869D99986067_ExistProblemPredicate_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ExistProblemPredicate_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class ExistProblemPredicate_Request_TypeSupportInterface;

            typedef ExistProblemPredicate_Request_TypeSupportInterface * ExistProblemPredicate_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExistProblemPredicate_Request_TypeSupportInterface> ExistProblemPredicate_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExistProblemPredicate_Request_TypeSupportInterface> ExistProblemPredicate_Request_TypeSupportInterface_out;


            class ExistProblemPredicate_Request_DataWriter;

            typedef ExistProblemPredicate_Request_DataWriter * ExistProblemPredicate_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExistProblemPredicate_Request_DataWriter> ExistProblemPredicate_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExistProblemPredicate_Request_DataWriter> ExistProblemPredicate_Request_DataWriter_out;


            class ExistProblemPredicate_Request_DataReader;

            typedef ExistProblemPredicate_Request_DataReader * ExistProblemPredicate_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExistProblemPredicate_Request_DataReader> ExistProblemPredicate_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ExistProblemPredicate_Request_DataReader> ExistProblemPredicate_Request_DataReader_out;


            class ExistProblemPredicate_Request_DataReaderView;

            typedef ExistProblemPredicate_Request_DataReaderView * ExistProblemPredicate_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExistProblemPredicate_Request_DataReaderView> ExistProblemPredicate_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExistProblemPredicate_Request_DataReaderView> ExistProblemPredicate_Request_DataReaderView_out;

            struct ExistProblemPredicate_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ExistProblemPredicate_Request_, struct ExistProblemPredicate_Request_Seq_uniq_> ExistProblemPredicate_Request_Seq;
            typedef DDS_DCPSSequence_var < ExistProblemPredicate_Request_Seq> ExistProblemPredicate_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ExistProblemPredicate_Request_Seq> ExistProblemPredicate_Request_Seq_out;

            class  ExistProblemPredicate_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExistProblemPredicate_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ExistProblemPredicate_Request_TypeSupportInterface_var _var_type;

                static ExistProblemPredicate_Request_TypeSupportInterface_ptr _duplicate (ExistProblemPredicate_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExistProblemPredicate_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExistProblemPredicate_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExistProblemPredicate_Request_TypeSupportInterface () {};
                ~ExistProblemPredicate_Request_TypeSupportInterface () {};
            private:
                ExistProblemPredicate_Request_TypeSupportInterface (const ExistProblemPredicate_Request_TypeSupportInterface &);
                ExistProblemPredicate_Request_TypeSupportInterface & operator = (const ExistProblemPredicate_Request_TypeSupportInterface &);
            };

            class  ExistProblemPredicate_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExistProblemPredicate_Request_DataWriter_ptr _ptr_type;
                typedef ExistProblemPredicate_Request_DataWriter_var _var_type;

                static ExistProblemPredicate_Request_DataWriter_ptr _duplicate (ExistProblemPredicate_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExistProblemPredicate_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExistProblemPredicate_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExistProblemPredicate_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExistProblemPredicate_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExistProblemPredicate_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExistProblemPredicate_Request_& instance_data) = 0;

            protected:
                ExistProblemPredicate_Request_DataWriter () {};
                ~ExistProblemPredicate_Request_DataWriter () {};
            private:
                ExistProblemPredicate_Request_DataWriter (const ExistProblemPredicate_Request_DataWriter &);
                ExistProblemPredicate_Request_DataWriter & operator = (const ExistProblemPredicate_Request_DataWriter &);
            };

            class  ExistProblemPredicate_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExistProblemPredicate_Request_DataReader_ptr _ptr_type;
                typedef ExistProblemPredicate_Request_DataReader_var _var_type;

                static ExistProblemPredicate_Request_DataReader_ptr _duplicate (ExistProblemPredicate_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExistProblemPredicate_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExistProblemPredicate_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExistProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExistProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExistProblemPredicate_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExistProblemPredicate_Request_& instance) = 0;

            protected:
                ExistProblemPredicate_Request_DataReader () {};
                ~ExistProblemPredicate_Request_DataReader () {};
            private:
                ExistProblemPredicate_Request_DataReader (const ExistProblemPredicate_Request_DataReader &);
                ExistProblemPredicate_Request_DataReader & operator = (const ExistProblemPredicate_Request_DataReader &);
            };

            class  ExistProblemPredicate_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExistProblemPredicate_Request_DataReaderView_ptr _ptr_type;
                typedef ExistProblemPredicate_Request_DataReaderView_var _var_type;

                static ExistProblemPredicate_Request_DataReaderView_ptr _duplicate (ExistProblemPredicate_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExistProblemPredicate_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExistProblemPredicate_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExistProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExistProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExistProblemPredicate_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExistProblemPredicate_Request_& instance) = 0;

            protected:
                ExistProblemPredicate_Request_DataReaderView () {};
                ~ExistProblemPredicate_Request_DataReaderView () {};
            private:
                ExistProblemPredicate_Request_DataReaderView (const ExistProblemPredicate_Request_DataReaderView &);
                ExistProblemPredicate_Request_DataReaderView & operator = (const ExistProblemPredicate_Request_DataReaderView &);
            };
            class ExistProblemPredicate_Response_TypeSupportInterface;

            typedef ExistProblemPredicate_Response_TypeSupportInterface * ExistProblemPredicate_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExistProblemPredicate_Response_TypeSupportInterface> ExistProblemPredicate_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExistProblemPredicate_Response_TypeSupportInterface> ExistProblemPredicate_Response_TypeSupportInterface_out;


            class ExistProblemPredicate_Response_DataWriter;

            typedef ExistProblemPredicate_Response_DataWriter * ExistProblemPredicate_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExistProblemPredicate_Response_DataWriter> ExistProblemPredicate_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExistProblemPredicate_Response_DataWriter> ExistProblemPredicate_Response_DataWriter_out;


            class ExistProblemPredicate_Response_DataReader;

            typedef ExistProblemPredicate_Response_DataReader * ExistProblemPredicate_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExistProblemPredicate_Response_DataReader> ExistProblemPredicate_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ExistProblemPredicate_Response_DataReader> ExistProblemPredicate_Response_DataReader_out;


            class ExistProblemPredicate_Response_DataReaderView;

            typedef ExistProblemPredicate_Response_DataReaderView * ExistProblemPredicate_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExistProblemPredicate_Response_DataReaderView> ExistProblemPredicate_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExistProblemPredicate_Response_DataReaderView> ExistProblemPredicate_Response_DataReaderView_out;

            struct ExistProblemPredicate_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ExistProblemPredicate_Response_, struct ExistProblemPredicate_Response_Seq_uniq_> ExistProblemPredicate_Response_Seq;
            typedef DDS_DCPSSequence_var < ExistProblemPredicate_Response_Seq> ExistProblemPredicate_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ExistProblemPredicate_Response_Seq> ExistProblemPredicate_Response_Seq_out;

            class  ExistProblemPredicate_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExistProblemPredicate_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ExistProblemPredicate_Response_TypeSupportInterface_var _var_type;

                static ExistProblemPredicate_Response_TypeSupportInterface_ptr _duplicate (ExistProblemPredicate_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExistProblemPredicate_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExistProblemPredicate_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExistProblemPredicate_Response_TypeSupportInterface () {};
                ~ExistProblemPredicate_Response_TypeSupportInterface () {};
            private:
                ExistProblemPredicate_Response_TypeSupportInterface (const ExistProblemPredicate_Response_TypeSupportInterface &);
                ExistProblemPredicate_Response_TypeSupportInterface & operator = (const ExistProblemPredicate_Response_TypeSupportInterface &);
            };

            class  ExistProblemPredicate_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExistProblemPredicate_Response_DataWriter_ptr _ptr_type;
                typedef ExistProblemPredicate_Response_DataWriter_var _var_type;

                static ExistProblemPredicate_Response_DataWriter_ptr _duplicate (ExistProblemPredicate_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExistProblemPredicate_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExistProblemPredicate_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExistProblemPredicate_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExistProblemPredicate_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExistProblemPredicate_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExistProblemPredicate_Response_& instance_data) = 0;

            protected:
                ExistProblemPredicate_Response_DataWriter () {};
                ~ExistProblemPredicate_Response_DataWriter () {};
            private:
                ExistProblemPredicate_Response_DataWriter (const ExistProblemPredicate_Response_DataWriter &);
                ExistProblemPredicate_Response_DataWriter & operator = (const ExistProblemPredicate_Response_DataWriter &);
            };

            class  ExistProblemPredicate_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExistProblemPredicate_Response_DataReader_ptr _ptr_type;
                typedef ExistProblemPredicate_Response_DataReader_var _var_type;

                static ExistProblemPredicate_Response_DataReader_ptr _duplicate (ExistProblemPredicate_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExistProblemPredicate_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExistProblemPredicate_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExistProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExistProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExistProblemPredicate_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExistProblemPredicate_Response_& instance) = 0;

            protected:
                ExistProblemPredicate_Response_DataReader () {};
                ~ExistProblemPredicate_Response_DataReader () {};
            private:
                ExistProblemPredicate_Response_DataReader (const ExistProblemPredicate_Response_DataReader &);
                ExistProblemPredicate_Response_DataReader & operator = (const ExistProblemPredicate_Response_DataReader &);
            };

            class  ExistProblemPredicate_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExistProblemPredicate_Response_DataReaderView_ptr _ptr_type;
                typedef ExistProblemPredicate_Response_DataReaderView_var _var_type;

                static ExistProblemPredicate_Response_DataReaderView_ptr _duplicate (ExistProblemPredicate_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExistProblemPredicate_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExistProblemPredicate_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExistProblemPredicate_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExistProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExistProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExistProblemPredicate_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExistProblemPredicate_Response_& instance) = 0;

            protected:
                ExistProblemPredicate_Response_DataReaderView () {};
                ~ExistProblemPredicate_Response_DataReaderView () {};
            private:
                ExistProblemPredicate_Response_DataReaderView (const ExistProblemPredicate_Response_DataReaderView &);
                ExistProblemPredicate_Response_DataReaderView & operator = (const ExistProblemPredicate_Response_DataReaderView &);
            };
            class Sample_ExistProblemPredicate_Request_TypeSupportInterface;

            typedef Sample_ExistProblemPredicate_Request_TypeSupportInterface * Sample_ExistProblemPredicate_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExistProblemPredicate_Request_TypeSupportInterface> Sample_ExistProblemPredicate_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ExistProblemPredicate_Request_TypeSupportInterface> Sample_ExistProblemPredicate_Request_TypeSupportInterface_out;


            class Sample_ExistProblemPredicate_Request_DataWriter;

            typedef Sample_ExistProblemPredicate_Request_DataWriter * Sample_ExistProblemPredicate_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExistProblemPredicate_Request_DataWriter> Sample_ExistProblemPredicate_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ExistProblemPredicate_Request_DataWriter> Sample_ExistProblemPredicate_Request_DataWriter_out;


            class Sample_ExistProblemPredicate_Request_DataReader;

            typedef Sample_ExistProblemPredicate_Request_DataReader * Sample_ExistProblemPredicate_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExistProblemPredicate_Request_DataReader> Sample_ExistProblemPredicate_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ExistProblemPredicate_Request_DataReader> Sample_ExistProblemPredicate_Request_DataReader_out;


            class Sample_ExistProblemPredicate_Request_DataReaderView;

            typedef Sample_ExistProblemPredicate_Request_DataReaderView * Sample_ExistProblemPredicate_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExistProblemPredicate_Request_DataReaderView> Sample_ExistProblemPredicate_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ExistProblemPredicate_Request_DataReaderView> Sample_ExistProblemPredicate_Request_DataReaderView_out;

            struct Sample_ExistProblemPredicate_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ExistProblemPredicate_Request_, struct Sample_ExistProblemPredicate_Request_Seq_uniq_> Sample_ExistProblemPredicate_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ExistProblemPredicate_Request_Seq> Sample_ExistProblemPredicate_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ExistProblemPredicate_Request_Seq> Sample_ExistProblemPredicate_Request_Seq_out;

            class  Sample_ExistProblemPredicate_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ExistProblemPredicate_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ExistProblemPredicate_Request_TypeSupportInterface_var _var_type;

                static Sample_ExistProblemPredicate_Request_TypeSupportInterface_ptr _duplicate (Sample_ExistProblemPredicate_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExistProblemPredicate_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExistProblemPredicate_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ExistProblemPredicate_Request_TypeSupportInterface () {};
                ~Sample_ExistProblemPredicate_Request_TypeSupportInterface () {};
            private:
                Sample_ExistProblemPredicate_Request_TypeSupportInterface (const Sample_ExistProblemPredicate_Request_TypeSupportInterface &);
                Sample_ExistProblemPredicate_Request_TypeSupportInterface & operator = (const Sample_ExistProblemPredicate_Request_TypeSupportInterface &);
            };

            class  Sample_ExistProblemPredicate_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ExistProblemPredicate_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ExistProblemPredicate_Request_DataWriter_var _var_type;

                static Sample_ExistProblemPredicate_Request_DataWriter_ptr _duplicate (Sample_ExistProblemPredicate_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExistProblemPredicate_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExistProblemPredicate_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ExistProblemPredicate_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ExistProblemPredicate_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ExistProblemPredicate_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ExistProblemPredicate_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExistProblemPredicate_Request_& instance_data) = 0;

            protected:
                Sample_ExistProblemPredicate_Request_DataWriter () {};
                ~Sample_ExistProblemPredicate_Request_DataWriter () {};
            private:
                Sample_ExistProblemPredicate_Request_DataWriter (const Sample_ExistProblemPredicate_Request_DataWriter &);
                Sample_ExistProblemPredicate_Request_DataWriter & operator = (const Sample_ExistProblemPredicate_Request_DataWriter &);
            };

            class  Sample_ExistProblemPredicate_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ExistProblemPredicate_Request_DataReader_ptr _ptr_type;
                typedef Sample_ExistProblemPredicate_Request_DataReader_var _var_type;

                static Sample_ExistProblemPredicate_Request_DataReader_ptr _duplicate (Sample_ExistProblemPredicate_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExistProblemPredicate_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExistProblemPredicate_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExistProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExistProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExistProblemPredicate_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExistProblemPredicate_Request_& instance) = 0;

            protected:
                Sample_ExistProblemPredicate_Request_DataReader () {};
                ~Sample_ExistProblemPredicate_Request_DataReader () {};
            private:
                Sample_ExistProblemPredicate_Request_DataReader (const Sample_ExistProblemPredicate_Request_DataReader &);
                Sample_ExistProblemPredicate_Request_DataReader & operator = (const Sample_ExistProblemPredicate_Request_DataReader &);
            };

            class  Sample_ExistProblemPredicate_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ExistProblemPredicate_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ExistProblemPredicate_Request_DataReaderView_var _var_type;

                static Sample_ExistProblemPredicate_Request_DataReaderView_ptr _duplicate (Sample_ExistProblemPredicate_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExistProblemPredicate_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExistProblemPredicate_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExistProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExistProblemPredicate_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExistProblemPredicate_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExistProblemPredicate_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExistProblemPredicate_Request_& instance) = 0;

            protected:
                Sample_ExistProblemPredicate_Request_DataReaderView () {};
                ~Sample_ExistProblemPredicate_Request_DataReaderView () {};
            private:
                Sample_ExistProblemPredicate_Request_DataReaderView (const Sample_ExistProblemPredicate_Request_DataReaderView &);
                Sample_ExistProblemPredicate_Request_DataReaderView & operator = (const Sample_ExistProblemPredicate_Request_DataReaderView &);
            };
            class Sample_ExistProblemPredicate_Response_TypeSupportInterface;

            typedef Sample_ExistProblemPredicate_Response_TypeSupportInterface * Sample_ExistProblemPredicate_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExistProblemPredicate_Response_TypeSupportInterface> Sample_ExistProblemPredicate_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ExistProblemPredicate_Response_TypeSupportInterface> Sample_ExistProblemPredicate_Response_TypeSupportInterface_out;


            class Sample_ExistProblemPredicate_Response_DataWriter;

            typedef Sample_ExistProblemPredicate_Response_DataWriter * Sample_ExistProblemPredicate_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExistProblemPredicate_Response_DataWriter> Sample_ExistProblemPredicate_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ExistProblemPredicate_Response_DataWriter> Sample_ExistProblemPredicate_Response_DataWriter_out;


            class Sample_ExistProblemPredicate_Response_DataReader;

            typedef Sample_ExistProblemPredicate_Response_DataReader * Sample_ExistProblemPredicate_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExistProblemPredicate_Response_DataReader> Sample_ExistProblemPredicate_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ExistProblemPredicate_Response_DataReader> Sample_ExistProblemPredicate_Response_DataReader_out;


            class Sample_ExistProblemPredicate_Response_DataReaderView;

            typedef Sample_ExistProblemPredicate_Response_DataReaderView * Sample_ExistProblemPredicate_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ExistProblemPredicate_Response_DataReaderView> Sample_ExistProblemPredicate_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ExistProblemPredicate_Response_DataReaderView> Sample_ExistProblemPredicate_Response_DataReaderView_out;

            struct Sample_ExistProblemPredicate_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ExistProblemPredicate_Response_, struct Sample_ExistProblemPredicate_Response_Seq_uniq_> Sample_ExistProblemPredicate_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ExistProblemPredicate_Response_Seq> Sample_ExistProblemPredicate_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ExistProblemPredicate_Response_Seq> Sample_ExistProblemPredicate_Response_Seq_out;

            class  Sample_ExistProblemPredicate_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ExistProblemPredicate_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ExistProblemPredicate_Response_TypeSupportInterface_var _var_type;

                static Sample_ExistProblemPredicate_Response_TypeSupportInterface_ptr _duplicate (Sample_ExistProblemPredicate_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExistProblemPredicate_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExistProblemPredicate_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ExistProblemPredicate_Response_TypeSupportInterface () {};
                ~Sample_ExistProblemPredicate_Response_TypeSupportInterface () {};
            private:
                Sample_ExistProblemPredicate_Response_TypeSupportInterface (const Sample_ExistProblemPredicate_Response_TypeSupportInterface &);
                Sample_ExistProblemPredicate_Response_TypeSupportInterface & operator = (const Sample_ExistProblemPredicate_Response_TypeSupportInterface &);
            };

            class  Sample_ExistProblemPredicate_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ExistProblemPredicate_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ExistProblemPredicate_Response_DataWriter_var _var_type;

                static Sample_ExistProblemPredicate_Response_DataWriter_ptr _duplicate (Sample_ExistProblemPredicate_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExistProblemPredicate_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExistProblemPredicate_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ExistProblemPredicate_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ExistProblemPredicate_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ExistProblemPredicate_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ExistProblemPredicate_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExistProblemPredicate_Response_& instance_data) = 0;

            protected:
                Sample_ExistProblemPredicate_Response_DataWriter () {};
                ~Sample_ExistProblemPredicate_Response_DataWriter () {};
            private:
                Sample_ExistProblemPredicate_Response_DataWriter (const Sample_ExistProblemPredicate_Response_DataWriter &);
                Sample_ExistProblemPredicate_Response_DataWriter & operator = (const Sample_ExistProblemPredicate_Response_DataWriter &);
            };

            class  Sample_ExistProblemPredicate_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ExistProblemPredicate_Response_DataReader_ptr _ptr_type;
                typedef Sample_ExistProblemPredicate_Response_DataReader_var _var_type;

                static Sample_ExistProblemPredicate_Response_DataReader_ptr _duplicate (Sample_ExistProblemPredicate_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExistProblemPredicate_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExistProblemPredicate_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExistProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExistProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExistProblemPredicate_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExistProblemPredicate_Response_& instance) = 0;

            protected:
                Sample_ExistProblemPredicate_Response_DataReader () {};
                ~Sample_ExistProblemPredicate_Response_DataReader () {};
            private:
                Sample_ExistProblemPredicate_Response_DataReader (const Sample_ExistProblemPredicate_Response_DataReader &);
                Sample_ExistProblemPredicate_Response_DataReader & operator = (const Sample_ExistProblemPredicate_Response_DataReader &);
            };

            class  Sample_ExistProblemPredicate_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ExistProblemPredicate_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ExistProblemPredicate_Response_DataReaderView_var _var_type;

                static Sample_ExistProblemPredicate_Response_DataReaderView_ptr _duplicate (Sample_ExistProblemPredicate_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ExistProblemPredicate_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ExistProblemPredicate_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ExistProblemPredicate_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ExistProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ExistProblemPredicate_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ExistProblemPredicate_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ExistProblemPredicate_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ExistProblemPredicate_Response_& instance) = 0;

            protected:
                Sample_ExistProblemPredicate_Response_DataReaderView () {};
                ~Sample_ExistProblemPredicate_Response_DataReaderView () {};
            private:
                Sample_ExistProblemPredicate_Response_DataReaderView (const Sample_ExistProblemPredicate_Response_DataReaderView &);
                Sample_ExistProblemPredicate_Response_DataReaderView & operator = (const Sample_ExistProblemPredicate_Response_DataReaderView &);
            };
        }

    }

}

#endif
