#ifndef _H_A49BCC02C008EAC7F185A7F3F4695E4D_GetDomainActionDetails_DCPS_H_
#define _H_A49BCC02C008EAC7F185A7F3F4695E4D_GetDomainActionDetails_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetDomainActionDetails_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetDomainActionDetails_Request_TypeSupportInterface;

            typedef GetDomainActionDetails_Request_TypeSupportInterface * GetDomainActionDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActionDetails_Request_TypeSupportInterface> GetDomainActionDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetDomainActionDetails_Request_TypeSupportInterface> GetDomainActionDetails_Request_TypeSupportInterface_out;


            class GetDomainActionDetails_Request_DataWriter;

            typedef GetDomainActionDetails_Request_DataWriter * GetDomainActionDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActionDetails_Request_DataWriter> GetDomainActionDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetDomainActionDetails_Request_DataWriter> GetDomainActionDetails_Request_DataWriter_out;


            class GetDomainActionDetails_Request_DataReader;

            typedef GetDomainActionDetails_Request_DataReader * GetDomainActionDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActionDetails_Request_DataReader> GetDomainActionDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetDomainActionDetails_Request_DataReader> GetDomainActionDetails_Request_DataReader_out;


            class GetDomainActionDetails_Request_DataReaderView;

            typedef GetDomainActionDetails_Request_DataReaderView * GetDomainActionDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActionDetails_Request_DataReaderView> GetDomainActionDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetDomainActionDetails_Request_DataReaderView> GetDomainActionDetails_Request_DataReaderView_out;

            struct GetDomainActionDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetDomainActionDetails_Request_, struct GetDomainActionDetails_Request_Seq_uniq_> GetDomainActionDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < GetDomainActionDetails_Request_Seq> GetDomainActionDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetDomainActionDetails_Request_Seq> GetDomainActionDetails_Request_Seq_out;

            class  GetDomainActionDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetDomainActionDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetDomainActionDetails_Request_TypeSupportInterface_var _var_type;

                static GetDomainActionDetails_Request_TypeSupportInterface_ptr _duplicate (GetDomainActionDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActionDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActionDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetDomainActionDetails_Request_TypeSupportInterface () {};
                ~GetDomainActionDetails_Request_TypeSupportInterface () {};
            private:
                GetDomainActionDetails_Request_TypeSupportInterface (const GetDomainActionDetails_Request_TypeSupportInterface &);
                GetDomainActionDetails_Request_TypeSupportInterface & operator = (const GetDomainActionDetails_Request_TypeSupportInterface &);
            };

            class  GetDomainActionDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetDomainActionDetails_Request_DataWriter_ptr _ptr_type;
                typedef GetDomainActionDetails_Request_DataWriter_var _var_type;

                static GetDomainActionDetails_Request_DataWriter_ptr _duplicate (GetDomainActionDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActionDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActionDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetDomainActionDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetDomainActionDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetDomainActionDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainActionDetails_Request_& instance_data) = 0;

            protected:
                GetDomainActionDetails_Request_DataWriter () {};
                ~GetDomainActionDetails_Request_DataWriter () {};
            private:
                GetDomainActionDetails_Request_DataWriter (const GetDomainActionDetails_Request_DataWriter &);
                GetDomainActionDetails_Request_DataWriter & operator = (const GetDomainActionDetails_Request_DataWriter &);
            };

            class  GetDomainActionDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetDomainActionDetails_Request_DataReader_ptr _ptr_type;
                typedef GetDomainActionDetails_Request_DataReader_var _var_type;

                static GetDomainActionDetails_Request_DataReader_ptr _duplicate (GetDomainActionDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActionDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActionDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainActionDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainActionDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainActionDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainActionDetails_Request_& instance) = 0;

            protected:
                GetDomainActionDetails_Request_DataReader () {};
                ~GetDomainActionDetails_Request_DataReader () {};
            private:
                GetDomainActionDetails_Request_DataReader (const GetDomainActionDetails_Request_DataReader &);
                GetDomainActionDetails_Request_DataReader & operator = (const GetDomainActionDetails_Request_DataReader &);
            };

            class  GetDomainActionDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetDomainActionDetails_Request_DataReaderView_ptr _ptr_type;
                typedef GetDomainActionDetails_Request_DataReaderView_var _var_type;

                static GetDomainActionDetails_Request_DataReaderView_ptr _duplicate (GetDomainActionDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActionDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActionDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainActionDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainActionDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainActionDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainActionDetails_Request_& instance) = 0;

            protected:
                GetDomainActionDetails_Request_DataReaderView () {};
                ~GetDomainActionDetails_Request_DataReaderView () {};
            private:
                GetDomainActionDetails_Request_DataReaderView (const GetDomainActionDetails_Request_DataReaderView &);
                GetDomainActionDetails_Request_DataReaderView & operator = (const GetDomainActionDetails_Request_DataReaderView &);
            };
            class GetDomainActionDetails_Response_TypeSupportInterface;

            typedef GetDomainActionDetails_Response_TypeSupportInterface * GetDomainActionDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActionDetails_Response_TypeSupportInterface> GetDomainActionDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetDomainActionDetails_Response_TypeSupportInterface> GetDomainActionDetails_Response_TypeSupportInterface_out;


            class GetDomainActionDetails_Response_DataWriter;

            typedef GetDomainActionDetails_Response_DataWriter * GetDomainActionDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActionDetails_Response_DataWriter> GetDomainActionDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetDomainActionDetails_Response_DataWriter> GetDomainActionDetails_Response_DataWriter_out;


            class GetDomainActionDetails_Response_DataReader;

            typedef GetDomainActionDetails_Response_DataReader * GetDomainActionDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActionDetails_Response_DataReader> GetDomainActionDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetDomainActionDetails_Response_DataReader> GetDomainActionDetails_Response_DataReader_out;


            class GetDomainActionDetails_Response_DataReaderView;

            typedef GetDomainActionDetails_Response_DataReaderView * GetDomainActionDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetDomainActionDetails_Response_DataReaderView> GetDomainActionDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetDomainActionDetails_Response_DataReaderView> GetDomainActionDetails_Response_DataReaderView_out;

            struct GetDomainActionDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetDomainActionDetails_Response_, struct GetDomainActionDetails_Response_Seq_uniq_> GetDomainActionDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < GetDomainActionDetails_Response_Seq> GetDomainActionDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetDomainActionDetails_Response_Seq> GetDomainActionDetails_Response_Seq_out;

            class  GetDomainActionDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetDomainActionDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetDomainActionDetails_Response_TypeSupportInterface_var _var_type;

                static GetDomainActionDetails_Response_TypeSupportInterface_ptr _duplicate (GetDomainActionDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActionDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActionDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetDomainActionDetails_Response_TypeSupportInterface () {};
                ~GetDomainActionDetails_Response_TypeSupportInterface () {};
            private:
                GetDomainActionDetails_Response_TypeSupportInterface (const GetDomainActionDetails_Response_TypeSupportInterface &);
                GetDomainActionDetails_Response_TypeSupportInterface & operator = (const GetDomainActionDetails_Response_TypeSupportInterface &);
            };

            class  GetDomainActionDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetDomainActionDetails_Response_DataWriter_ptr _ptr_type;
                typedef GetDomainActionDetails_Response_DataWriter_var _var_type;

                static GetDomainActionDetails_Response_DataWriter_ptr _duplicate (GetDomainActionDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActionDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActionDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetDomainActionDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetDomainActionDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetDomainActionDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainActionDetails_Response_& instance_data) = 0;

            protected:
                GetDomainActionDetails_Response_DataWriter () {};
                ~GetDomainActionDetails_Response_DataWriter () {};
            private:
                GetDomainActionDetails_Response_DataWriter (const GetDomainActionDetails_Response_DataWriter &);
                GetDomainActionDetails_Response_DataWriter & operator = (const GetDomainActionDetails_Response_DataWriter &);
            };

            class  GetDomainActionDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetDomainActionDetails_Response_DataReader_ptr _ptr_type;
                typedef GetDomainActionDetails_Response_DataReader_var _var_type;

                static GetDomainActionDetails_Response_DataReader_ptr _duplicate (GetDomainActionDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActionDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActionDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainActionDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainActionDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainActionDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainActionDetails_Response_& instance) = 0;

            protected:
                GetDomainActionDetails_Response_DataReader () {};
                ~GetDomainActionDetails_Response_DataReader () {};
            private:
                GetDomainActionDetails_Response_DataReader (const GetDomainActionDetails_Response_DataReader &);
                GetDomainActionDetails_Response_DataReader & operator = (const GetDomainActionDetails_Response_DataReader &);
            };

            class  GetDomainActionDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetDomainActionDetails_Response_DataReaderView_ptr _ptr_type;
                typedef GetDomainActionDetails_Response_DataReaderView_var _var_type;

                static GetDomainActionDetails_Response_DataReaderView_ptr _duplicate (GetDomainActionDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainActionDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainActionDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainActionDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainActionDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainActionDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainActionDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainActionDetails_Response_& instance) = 0;

            protected:
                GetDomainActionDetails_Response_DataReaderView () {};
                ~GetDomainActionDetails_Response_DataReaderView () {};
            private:
                GetDomainActionDetails_Response_DataReaderView (const GetDomainActionDetails_Response_DataReaderView &);
                GetDomainActionDetails_Response_DataReaderView & operator = (const GetDomainActionDetails_Response_DataReaderView &);
            };
            class Sample_GetDomainActionDetails_Request_TypeSupportInterface;

            typedef Sample_GetDomainActionDetails_Request_TypeSupportInterface * Sample_GetDomainActionDetails_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActionDetails_Request_TypeSupportInterface> Sample_GetDomainActionDetails_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActionDetails_Request_TypeSupportInterface> Sample_GetDomainActionDetails_Request_TypeSupportInterface_out;


            class Sample_GetDomainActionDetails_Request_DataWriter;

            typedef Sample_GetDomainActionDetails_Request_DataWriter * Sample_GetDomainActionDetails_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActionDetails_Request_DataWriter> Sample_GetDomainActionDetails_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActionDetails_Request_DataWriter> Sample_GetDomainActionDetails_Request_DataWriter_out;


            class Sample_GetDomainActionDetails_Request_DataReader;

            typedef Sample_GetDomainActionDetails_Request_DataReader * Sample_GetDomainActionDetails_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActionDetails_Request_DataReader> Sample_GetDomainActionDetails_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActionDetails_Request_DataReader> Sample_GetDomainActionDetails_Request_DataReader_out;


            class Sample_GetDomainActionDetails_Request_DataReaderView;

            typedef Sample_GetDomainActionDetails_Request_DataReaderView * Sample_GetDomainActionDetails_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActionDetails_Request_DataReaderView> Sample_GetDomainActionDetails_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActionDetails_Request_DataReaderView> Sample_GetDomainActionDetails_Request_DataReaderView_out;

            struct Sample_GetDomainActionDetails_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetDomainActionDetails_Request_, struct Sample_GetDomainActionDetails_Request_Seq_uniq_> Sample_GetDomainActionDetails_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetDomainActionDetails_Request_Seq> Sample_GetDomainActionDetails_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetDomainActionDetails_Request_Seq> Sample_GetDomainActionDetails_Request_Seq_out;

            class  Sample_GetDomainActionDetails_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetDomainActionDetails_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetDomainActionDetails_Request_TypeSupportInterface_var _var_type;

                static Sample_GetDomainActionDetails_Request_TypeSupportInterface_ptr _duplicate (Sample_GetDomainActionDetails_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActionDetails_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActionDetails_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetDomainActionDetails_Request_TypeSupportInterface () {};
                ~Sample_GetDomainActionDetails_Request_TypeSupportInterface () {};
            private:
                Sample_GetDomainActionDetails_Request_TypeSupportInterface (const Sample_GetDomainActionDetails_Request_TypeSupportInterface &);
                Sample_GetDomainActionDetails_Request_TypeSupportInterface & operator = (const Sample_GetDomainActionDetails_Request_TypeSupportInterface &);
            };

            class  Sample_GetDomainActionDetails_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetDomainActionDetails_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetDomainActionDetails_Request_DataWriter_var _var_type;

                static Sample_GetDomainActionDetails_Request_DataWriter_ptr _duplicate (Sample_GetDomainActionDetails_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActionDetails_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActionDetails_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetDomainActionDetails_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetDomainActionDetails_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetDomainActionDetails_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainActionDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainActionDetails_Request_& instance_data) = 0;

            protected:
                Sample_GetDomainActionDetails_Request_DataWriter () {};
                ~Sample_GetDomainActionDetails_Request_DataWriter () {};
            private:
                Sample_GetDomainActionDetails_Request_DataWriter (const Sample_GetDomainActionDetails_Request_DataWriter &);
                Sample_GetDomainActionDetails_Request_DataWriter & operator = (const Sample_GetDomainActionDetails_Request_DataWriter &);
            };

            class  Sample_GetDomainActionDetails_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetDomainActionDetails_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetDomainActionDetails_Request_DataReader_var _var_type;

                static Sample_GetDomainActionDetails_Request_DataReader_ptr _duplicate (Sample_GetDomainActionDetails_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActionDetails_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActionDetails_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainActionDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainActionDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainActionDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainActionDetails_Request_& instance) = 0;

            protected:
                Sample_GetDomainActionDetails_Request_DataReader () {};
                ~Sample_GetDomainActionDetails_Request_DataReader () {};
            private:
                Sample_GetDomainActionDetails_Request_DataReader (const Sample_GetDomainActionDetails_Request_DataReader &);
                Sample_GetDomainActionDetails_Request_DataReader & operator = (const Sample_GetDomainActionDetails_Request_DataReader &);
            };

            class  Sample_GetDomainActionDetails_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetDomainActionDetails_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetDomainActionDetails_Request_DataReaderView_var _var_type;

                static Sample_GetDomainActionDetails_Request_DataReaderView_ptr _duplicate (Sample_GetDomainActionDetails_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActionDetails_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActionDetails_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainActionDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainActionDetails_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainActionDetails_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainActionDetails_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainActionDetails_Request_& instance) = 0;

            protected:
                Sample_GetDomainActionDetails_Request_DataReaderView () {};
                ~Sample_GetDomainActionDetails_Request_DataReaderView () {};
            private:
                Sample_GetDomainActionDetails_Request_DataReaderView (const Sample_GetDomainActionDetails_Request_DataReaderView &);
                Sample_GetDomainActionDetails_Request_DataReaderView & operator = (const Sample_GetDomainActionDetails_Request_DataReaderView &);
            };
            class Sample_GetDomainActionDetails_Response_TypeSupportInterface;

            typedef Sample_GetDomainActionDetails_Response_TypeSupportInterface * Sample_GetDomainActionDetails_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActionDetails_Response_TypeSupportInterface> Sample_GetDomainActionDetails_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActionDetails_Response_TypeSupportInterface> Sample_GetDomainActionDetails_Response_TypeSupportInterface_out;


            class Sample_GetDomainActionDetails_Response_DataWriter;

            typedef Sample_GetDomainActionDetails_Response_DataWriter * Sample_GetDomainActionDetails_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActionDetails_Response_DataWriter> Sample_GetDomainActionDetails_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActionDetails_Response_DataWriter> Sample_GetDomainActionDetails_Response_DataWriter_out;


            class Sample_GetDomainActionDetails_Response_DataReader;

            typedef Sample_GetDomainActionDetails_Response_DataReader * Sample_GetDomainActionDetails_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActionDetails_Response_DataReader> Sample_GetDomainActionDetails_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActionDetails_Response_DataReader> Sample_GetDomainActionDetails_Response_DataReader_out;


            class Sample_GetDomainActionDetails_Response_DataReaderView;

            typedef Sample_GetDomainActionDetails_Response_DataReaderView * Sample_GetDomainActionDetails_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainActionDetails_Response_DataReaderView> Sample_GetDomainActionDetails_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainActionDetails_Response_DataReaderView> Sample_GetDomainActionDetails_Response_DataReaderView_out;

            struct Sample_GetDomainActionDetails_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetDomainActionDetails_Response_, struct Sample_GetDomainActionDetails_Response_Seq_uniq_> Sample_GetDomainActionDetails_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetDomainActionDetails_Response_Seq> Sample_GetDomainActionDetails_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetDomainActionDetails_Response_Seq> Sample_GetDomainActionDetails_Response_Seq_out;

            class  Sample_GetDomainActionDetails_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetDomainActionDetails_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetDomainActionDetails_Response_TypeSupportInterface_var _var_type;

                static Sample_GetDomainActionDetails_Response_TypeSupportInterface_ptr _duplicate (Sample_GetDomainActionDetails_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActionDetails_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActionDetails_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetDomainActionDetails_Response_TypeSupportInterface () {};
                ~Sample_GetDomainActionDetails_Response_TypeSupportInterface () {};
            private:
                Sample_GetDomainActionDetails_Response_TypeSupportInterface (const Sample_GetDomainActionDetails_Response_TypeSupportInterface &);
                Sample_GetDomainActionDetails_Response_TypeSupportInterface & operator = (const Sample_GetDomainActionDetails_Response_TypeSupportInterface &);
            };

            class  Sample_GetDomainActionDetails_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetDomainActionDetails_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetDomainActionDetails_Response_DataWriter_var _var_type;

                static Sample_GetDomainActionDetails_Response_DataWriter_ptr _duplicate (Sample_GetDomainActionDetails_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActionDetails_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActionDetails_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetDomainActionDetails_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetDomainActionDetails_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetDomainActionDetails_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainActionDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainActionDetails_Response_& instance_data) = 0;

            protected:
                Sample_GetDomainActionDetails_Response_DataWriter () {};
                ~Sample_GetDomainActionDetails_Response_DataWriter () {};
            private:
                Sample_GetDomainActionDetails_Response_DataWriter (const Sample_GetDomainActionDetails_Response_DataWriter &);
                Sample_GetDomainActionDetails_Response_DataWriter & operator = (const Sample_GetDomainActionDetails_Response_DataWriter &);
            };

            class  Sample_GetDomainActionDetails_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetDomainActionDetails_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetDomainActionDetails_Response_DataReader_var _var_type;

                static Sample_GetDomainActionDetails_Response_DataReader_ptr _duplicate (Sample_GetDomainActionDetails_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActionDetails_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActionDetails_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainActionDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainActionDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainActionDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainActionDetails_Response_& instance) = 0;

            protected:
                Sample_GetDomainActionDetails_Response_DataReader () {};
                ~Sample_GetDomainActionDetails_Response_DataReader () {};
            private:
                Sample_GetDomainActionDetails_Response_DataReader (const Sample_GetDomainActionDetails_Response_DataReader &);
                Sample_GetDomainActionDetails_Response_DataReader & operator = (const Sample_GetDomainActionDetails_Response_DataReader &);
            };

            class  Sample_GetDomainActionDetails_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetDomainActionDetails_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetDomainActionDetails_Response_DataReaderView_var _var_type;

                static Sample_GetDomainActionDetails_Response_DataReaderView_ptr _duplicate (Sample_GetDomainActionDetails_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainActionDetails_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainActionDetails_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainActionDetails_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainActionDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainActionDetails_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainActionDetails_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainActionDetails_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainActionDetails_Response_& instance) = 0;

            protected:
                Sample_GetDomainActionDetails_Response_DataReaderView () {};
                ~Sample_GetDomainActionDetails_Response_DataReaderView () {};
            private:
                Sample_GetDomainActionDetails_Response_DataReaderView (const Sample_GetDomainActionDetails_Response_DataReaderView &);
                Sample_GetDomainActionDetails_Response_DataReaderView & operator = (const Sample_GetDomainActionDetails_Response_DataReaderView &);
            };
        }

    }

}

#endif
