#ifndef _H_CAA7C433042EF734A86E829096744235_GetDomainPredicateDetails__H_
#define _H_CAA7C433042EF734A86E829096744235_GetDomainPredicateDetails__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetDomainPredicateDetails_Request_
            {
                ::DDS::String_mgr predicate_;
            };

            typedef DDS_DCPSStruct_var<GetDomainPredicateDetails_Request_> GetDomainPredicateDetails_Request__var;
            typedef DDS_DCPSStruct_out < GetDomainPredicateDetails_Request_> GetDomainPredicateDetails_Request__out;

            struct  GetDomainPredicateDetails_Response_
            {
                struct _param_names__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _param_names__seq_uniq_ > _param_names__seq;
                typedef DDS_DCPSUStrSeq_var< _param_names__seq > _param_names__seq_var;
                typedef DDS_DCPSUStrSeq_out< _param_names__seq > _param_names__seq_out;
                struct _param_types__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _param_types__seq_uniq_ > _param_types__seq;
                typedef DDS_DCPSUStrSeq_var< _param_types__seq > _param_types__seq_var;
                typedef DDS_DCPSUStrSeq_out< _param_types__seq > _param_types__seq_out;
                ::DDS::String_mgr name_;
                _param_names__seq param_names_;
                _param_types__seq param_types_;
                ::DDS::Boolean success_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<GetDomainPredicateDetails_Response_> GetDomainPredicateDetails_Response__var;
            typedef DDS_DCPSStruct_out < GetDomainPredicateDetails_Response_> GetDomainPredicateDetails_Response__out;

            struct  Sample_GetDomainPredicateDetails_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetDomainPredicateDetails_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetDomainPredicateDetails_Request_> Sample_GetDomainPredicateDetails_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetDomainPredicateDetails_Request_> Sample_GetDomainPredicateDetails_Request__out;

            struct  Sample_GetDomainPredicateDetails_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetDomainPredicateDetails_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetDomainPredicateDetails_Response_> Sample_GetDomainPredicateDetails_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetDomainPredicateDetails_Response_> Sample_GetDomainPredicateDetails_Response__out;

        }

    }

}

#endif /* _H_CAA7C433042EF734A86E829096744235_GetDomainPredicateDetails__H_ */
