#ifndef _H_CA0B17AE62AAC65E10CCB370F9DD662A_GetDomainPredicates_DCPS_H_
#define _H_CA0B17AE62AAC65E10CCB370F9DD662A_GetDomainPredicates_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetDomainPredicates_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetDomainPredicates_Request_TypeSupportInterface;

            typedef GetDomainPredicates_Request_TypeSupportInterface * GetDomainPredicates_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicates_Request_TypeSupportInterface> GetDomainPredicates_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicates_Request_TypeSupportInterface> GetDomainPredicates_Request_TypeSupportInterface_out;


            class GetDomainPredicates_Request_DataWriter;

            typedef GetDomainPredicates_Request_DataWriter * GetDomainPredicates_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicates_Request_DataWriter> GetDomainPredicates_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicates_Request_DataWriter> GetDomainPredicates_Request_DataWriter_out;


            class GetDomainPredicates_Request_DataReader;

            typedef GetDomainPredicates_Request_DataReader * GetDomainPredicates_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicates_Request_DataReader> GetDomainPredicates_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicates_Request_DataReader> GetDomainPredicates_Request_DataReader_out;


            class GetDomainPredicates_Request_DataReaderView;

            typedef GetDomainPredicates_Request_DataReaderView * GetDomainPredicates_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicates_Request_DataReaderView> GetDomainPredicates_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicates_Request_DataReaderView> GetDomainPredicates_Request_DataReaderView_out;

            struct GetDomainPredicates_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetDomainPredicates_Request_, struct GetDomainPredicates_Request_Seq_uniq_> GetDomainPredicates_Request_Seq;
            typedef DDS_DCPSSequence_var < GetDomainPredicates_Request_Seq> GetDomainPredicates_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetDomainPredicates_Request_Seq> GetDomainPredicates_Request_Seq_out;

            class  GetDomainPredicates_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetDomainPredicates_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetDomainPredicates_Request_TypeSupportInterface_var _var_type;

                static GetDomainPredicates_Request_TypeSupportInterface_ptr _duplicate (GetDomainPredicates_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicates_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicates_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetDomainPredicates_Request_TypeSupportInterface () {};
                ~GetDomainPredicates_Request_TypeSupportInterface () {};
            private:
                GetDomainPredicates_Request_TypeSupportInterface (const GetDomainPredicates_Request_TypeSupportInterface &);
                GetDomainPredicates_Request_TypeSupportInterface & operator = (const GetDomainPredicates_Request_TypeSupportInterface &);
            };

            class  GetDomainPredicates_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetDomainPredicates_Request_DataWriter_ptr _ptr_type;
                typedef GetDomainPredicates_Request_DataWriter_var _var_type;

                static GetDomainPredicates_Request_DataWriter_ptr _duplicate (GetDomainPredicates_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicates_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicates_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetDomainPredicates_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetDomainPredicates_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetDomainPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetDomainPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetDomainPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetDomainPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetDomainPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetDomainPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetDomainPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetDomainPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetDomainPredicates_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainPredicates_Request_& instance_data) = 0;

            protected:
                GetDomainPredicates_Request_DataWriter () {};
                ~GetDomainPredicates_Request_DataWriter () {};
            private:
                GetDomainPredicates_Request_DataWriter (const GetDomainPredicates_Request_DataWriter &);
                GetDomainPredicates_Request_DataWriter & operator = (const GetDomainPredicates_Request_DataWriter &);
            };

            class  GetDomainPredicates_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetDomainPredicates_Request_DataReader_ptr _ptr_type;
                typedef GetDomainPredicates_Request_DataReader_var _var_type;

                static GetDomainPredicates_Request_DataReader_ptr _duplicate (GetDomainPredicates_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicates_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicates_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainPredicates_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainPredicates_Request_& instance) = 0;

            protected:
                GetDomainPredicates_Request_DataReader () {};
                ~GetDomainPredicates_Request_DataReader () {};
            private:
                GetDomainPredicates_Request_DataReader (const GetDomainPredicates_Request_DataReader &);
                GetDomainPredicates_Request_DataReader & operator = (const GetDomainPredicates_Request_DataReader &);
            };

            class  GetDomainPredicates_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetDomainPredicates_Request_DataReaderView_ptr _ptr_type;
                typedef GetDomainPredicates_Request_DataReaderView_var _var_type;

                static GetDomainPredicates_Request_DataReaderView_ptr _duplicate (GetDomainPredicates_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicates_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicates_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainPredicates_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainPredicates_Request_& instance) = 0;

            protected:
                GetDomainPredicates_Request_DataReaderView () {};
                ~GetDomainPredicates_Request_DataReaderView () {};
            private:
                GetDomainPredicates_Request_DataReaderView (const GetDomainPredicates_Request_DataReaderView &);
                GetDomainPredicates_Request_DataReaderView & operator = (const GetDomainPredicates_Request_DataReaderView &);
            };
            class GetDomainPredicates_Response_TypeSupportInterface;

            typedef GetDomainPredicates_Response_TypeSupportInterface * GetDomainPredicates_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicates_Response_TypeSupportInterface> GetDomainPredicates_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicates_Response_TypeSupportInterface> GetDomainPredicates_Response_TypeSupportInterface_out;


            class GetDomainPredicates_Response_DataWriter;

            typedef GetDomainPredicates_Response_DataWriter * GetDomainPredicates_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicates_Response_DataWriter> GetDomainPredicates_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicates_Response_DataWriter> GetDomainPredicates_Response_DataWriter_out;


            class GetDomainPredicates_Response_DataReader;

            typedef GetDomainPredicates_Response_DataReader * GetDomainPredicates_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicates_Response_DataReader> GetDomainPredicates_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicates_Response_DataReader> GetDomainPredicates_Response_DataReader_out;


            class GetDomainPredicates_Response_DataReaderView;

            typedef GetDomainPredicates_Response_DataReaderView * GetDomainPredicates_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetDomainPredicates_Response_DataReaderView> GetDomainPredicates_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetDomainPredicates_Response_DataReaderView> GetDomainPredicates_Response_DataReaderView_out;

            struct GetDomainPredicates_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetDomainPredicates_Response_, struct GetDomainPredicates_Response_Seq_uniq_> GetDomainPredicates_Response_Seq;
            typedef DDS_DCPSSequence_var < GetDomainPredicates_Response_Seq> GetDomainPredicates_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetDomainPredicates_Response_Seq> GetDomainPredicates_Response_Seq_out;

            class  GetDomainPredicates_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetDomainPredicates_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetDomainPredicates_Response_TypeSupportInterface_var _var_type;

                static GetDomainPredicates_Response_TypeSupportInterface_ptr _duplicate (GetDomainPredicates_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicates_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicates_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetDomainPredicates_Response_TypeSupportInterface () {};
                ~GetDomainPredicates_Response_TypeSupportInterface () {};
            private:
                GetDomainPredicates_Response_TypeSupportInterface (const GetDomainPredicates_Response_TypeSupportInterface &);
                GetDomainPredicates_Response_TypeSupportInterface & operator = (const GetDomainPredicates_Response_TypeSupportInterface &);
            };

            class  GetDomainPredicates_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetDomainPredicates_Response_DataWriter_ptr _ptr_type;
                typedef GetDomainPredicates_Response_DataWriter_var _var_type;

                static GetDomainPredicates_Response_DataWriter_ptr _duplicate (GetDomainPredicates_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicates_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicates_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetDomainPredicates_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetDomainPredicates_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetDomainPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetDomainPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetDomainPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetDomainPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetDomainPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetDomainPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetDomainPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetDomainPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetDomainPredicates_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainPredicates_Response_& instance_data) = 0;

            protected:
                GetDomainPredicates_Response_DataWriter () {};
                ~GetDomainPredicates_Response_DataWriter () {};
            private:
                GetDomainPredicates_Response_DataWriter (const GetDomainPredicates_Response_DataWriter &);
                GetDomainPredicates_Response_DataWriter & operator = (const GetDomainPredicates_Response_DataWriter &);
            };

            class  GetDomainPredicates_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetDomainPredicates_Response_DataReader_ptr _ptr_type;
                typedef GetDomainPredicates_Response_DataReader_var _var_type;

                static GetDomainPredicates_Response_DataReader_ptr _duplicate (GetDomainPredicates_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicates_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicates_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainPredicates_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainPredicates_Response_& instance) = 0;

            protected:
                GetDomainPredicates_Response_DataReader () {};
                ~GetDomainPredicates_Response_DataReader () {};
            private:
                GetDomainPredicates_Response_DataReader (const GetDomainPredicates_Response_DataReader &);
                GetDomainPredicates_Response_DataReader & operator = (const GetDomainPredicates_Response_DataReader &);
            };

            class  GetDomainPredicates_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetDomainPredicates_Response_DataReaderView_ptr _ptr_type;
                typedef GetDomainPredicates_Response_DataReaderView_var _var_type;

                static GetDomainPredicates_Response_DataReaderView_ptr _duplicate (GetDomainPredicates_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomainPredicates_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomainPredicates_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomainPredicates_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomainPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomainPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomainPredicates_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomainPredicates_Response_& instance) = 0;

            protected:
                GetDomainPredicates_Response_DataReaderView () {};
                ~GetDomainPredicates_Response_DataReaderView () {};
            private:
                GetDomainPredicates_Response_DataReaderView (const GetDomainPredicates_Response_DataReaderView &);
                GetDomainPredicates_Response_DataReaderView & operator = (const GetDomainPredicates_Response_DataReaderView &);
            };
            class Sample_GetDomainPredicates_Request_TypeSupportInterface;

            typedef Sample_GetDomainPredicates_Request_TypeSupportInterface * Sample_GetDomainPredicates_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicates_Request_TypeSupportInterface> Sample_GetDomainPredicates_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicates_Request_TypeSupportInterface> Sample_GetDomainPredicates_Request_TypeSupportInterface_out;


            class Sample_GetDomainPredicates_Request_DataWriter;

            typedef Sample_GetDomainPredicates_Request_DataWriter * Sample_GetDomainPredicates_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicates_Request_DataWriter> Sample_GetDomainPredicates_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicates_Request_DataWriter> Sample_GetDomainPredicates_Request_DataWriter_out;


            class Sample_GetDomainPredicates_Request_DataReader;

            typedef Sample_GetDomainPredicates_Request_DataReader * Sample_GetDomainPredicates_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicates_Request_DataReader> Sample_GetDomainPredicates_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicates_Request_DataReader> Sample_GetDomainPredicates_Request_DataReader_out;


            class Sample_GetDomainPredicates_Request_DataReaderView;

            typedef Sample_GetDomainPredicates_Request_DataReaderView * Sample_GetDomainPredicates_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicates_Request_DataReaderView> Sample_GetDomainPredicates_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicates_Request_DataReaderView> Sample_GetDomainPredicates_Request_DataReaderView_out;

            struct Sample_GetDomainPredicates_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetDomainPredicates_Request_, struct Sample_GetDomainPredicates_Request_Seq_uniq_> Sample_GetDomainPredicates_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetDomainPredicates_Request_Seq> Sample_GetDomainPredicates_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetDomainPredicates_Request_Seq> Sample_GetDomainPredicates_Request_Seq_out;

            class  Sample_GetDomainPredicates_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetDomainPredicates_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetDomainPredicates_Request_TypeSupportInterface_var _var_type;

                static Sample_GetDomainPredicates_Request_TypeSupportInterface_ptr _duplicate (Sample_GetDomainPredicates_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicates_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicates_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetDomainPredicates_Request_TypeSupportInterface () {};
                ~Sample_GetDomainPredicates_Request_TypeSupportInterface () {};
            private:
                Sample_GetDomainPredicates_Request_TypeSupportInterface (const Sample_GetDomainPredicates_Request_TypeSupportInterface &);
                Sample_GetDomainPredicates_Request_TypeSupportInterface & operator = (const Sample_GetDomainPredicates_Request_TypeSupportInterface &);
            };

            class  Sample_GetDomainPredicates_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetDomainPredicates_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetDomainPredicates_Request_DataWriter_var _var_type;

                static Sample_GetDomainPredicates_Request_DataWriter_ptr _duplicate (Sample_GetDomainPredicates_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicates_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicates_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetDomainPredicates_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetDomainPredicates_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetDomainPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetDomainPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetDomainPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetDomainPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetDomainPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetDomainPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetDomainPredicates_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetDomainPredicates_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainPredicates_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainPredicates_Request_& instance_data) = 0;

            protected:
                Sample_GetDomainPredicates_Request_DataWriter () {};
                ~Sample_GetDomainPredicates_Request_DataWriter () {};
            private:
                Sample_GetDomainPredicates_Request_DataWriter (const Sample_GetDomainPredicates_Request_DataWriter &);
                Sample_GetDomainPredicates_Request_DataWriter & operator = (const Sample_GetDomainPredicates_Request_DataWriter &);
            };

            class  Sample_GetDomainPredicates_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetDomainPredicates_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetDomainPredicates_Request_DataReader_var _var_type;

                static Sample_GetDomainPredicates_Request_DataReader_ptr _duplicate (Sample_GetDomainPredicates_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicates_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicates_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainPredicates_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainPredicates_Request_& instance) = 0;

            protected:
                Sample_GetDomainPredicates_Request_DataReader () {};
                ~Sample_GetDomainPredicates_Request_DataReader () {};
            private:
                Sample_GetDomainPredicates_Request_DataReader (const Sample_GetDomainPredicates_Request_DataReader &);
                Sample_GetDomainPredicates_Request_DataReader & operator = (const Sample_GetDomainPredicates_Request_DataReader &);
            };

            class  Sample_GetDomainPredicates_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetDomainPredicates_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetDomainPredicates_Request_DataReaderView_var _var_type;

                static Sample_GetDomainPredicates_Request_DataReaderView_ptr _duplicate (Sample_GetDomainPredicates_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicates_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicates_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainPredicates_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainPredicates_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainPredicates_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainPredicates_Request_& instance) = 0;

            protected:
                Sample_GetDomainPredicates_Request_DataReaderView () {};
                ~Sample_GetDomainPredicates_Request_DataReaderView () {};
            private:
                Sample_GetDomainPredicates_Request_DataReaderView (const Sample_GetDomainPredicates_Request_DataReaderView &);
                Sample_GetDomainPredicates_Request_DataReaderView & operator = (const Sample_GetDomainPredicates_Request_DataReaderView &);
            };
            class Sample_GetDomainPredicates_Response_TypeSupportInterface;

            typedef Sample_GetDomainPredicates_Response_TypeSupportInterface * Sample_GetDomainPredicates_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicates_Response_TypeSupportInterface> Sample_GetDomainPredicates_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicates_Response_TypeSupportInterface> Sample_GetDomainPredicates_Response_TypeSupportInterface_out;


            class Sample_GetDomainPredicates_Response_DataWriter;

            typedef Sample_GetDomainPredicates_Response_DataWriter * Sample_GetDomainPredicates_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicates_Response_DataWriter> Sample_GetDomainPredicates_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicates_Response_DataWriter> Sample_GetDomainPredicates_Response_DataWriter_out;


            class Sample_GetDomainPredicates_Response_DataReader;

            typedef Sample_GetDomainPredicates_Response_DataReader * Sample_GetDomainPredicates_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicates_Response_DataReader> Sample_GetDomainPredicates_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicates_Response_DataReader> Sample_GetDomainPredicates_Response_DataReader_out;


            class Sample_GetDomainPredicates_Response_DataReaderView;

            typedef Sample_GetDomainPredicates_Response_DataReaderView * Sample_GetDomainPredicates_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomainPredicates_Response_DataReaderView> Sample_GetDomainPredicates_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomainPredicates_Response_DataReaderView> Sample_GetDomainPredicates_Response_DataReaderView_out;

            struct Sample_GetDomainPredicates_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetDomainPredicates_Response_, struct Sample_GetDomainPredicates_Response_Seq_uniq_> Sample_GetDomainPredicates_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetDomainPredicates_Response_Seq> Sample_GetDomainPredicates_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetDomainPredicates_Response_Seq> Sample_GetDomainPredicates_Response_Seq_out;

            class  Sample_GetDomainPredicates_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetDomainPredicates_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetDomainPredicates_Response_TypeSupportInterface_var _var_type;

                static Sample_GetDomainPredicates_Response_TypeSupportInterface_ptr _duplicate (Sample_GetDomainPredicates_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicates_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicates_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetDomainPredicates_Response_TypeSupportInterface () {};
                ~Sample_GetDomainPredicates_Response_TypeSupportInterface () {};
            private:
                Sample_GetDomainPredicates_Response_TypeSupportInterface (const Sample_GetDomainPredicates_Response_TypeSupportInterface &);
                Sample_GetDomainPredicates_Response_TypeSupportInterface & operator = (const Sample_GetDomainPredicates_Response_TypeSupportInterface &);
            };

            class  Sample_GetDomainPredicates_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetDomainPredicates_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetDomainPredicates_Response_DataWriter_var _var_type;

                static Sample_GetDomainPredicates_Response_DataWriter_ptr _duplicate (Sample_GetDomainPredicates_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicates_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicates_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetDomainPredicates_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetDomainPredicates_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetDomainPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetDomainPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetDomainPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetDomainPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetDomainPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetDomainPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetDomainPredicates_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetDomainPredicates_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainPredicates_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainPredicates_Response_& instance_data) = 0;

            protected:
                Sample_GetDomainPredicates_Response_DataWriter () {};
                ~Sample_GetDomainPredicates_Response_DataWriter () {};
            private:
                Sample_GetDomainPredicates_Response_DataWriter (const Sample_GetDomainPredicates_Response_DataWriter &);
                Sample_GetDomainPredicates_Response_DataWriter & operator = (const Sample_GetDomainPredicates_Response_DataWriter &);
            };

            class  Sample_GetDomainPredicates_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetDomainPredicates_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetDomainPredicates_Response_DataReader_var _var_type;

                static Sample_GetDomainPredicates_Response_DataReader_ptr _duplicate (Sample_GetDomainPredicates_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicates_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicates_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainPredicates_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainPredicates_Response_& instance) = 0;

            protected:
                Sample_GetDomainPredicates_Response_DataReader () {};
                ~Sample_GetDomainPredicates_Response_DataReader () {};
            private:
                Sample_GetDomainPredicates_Response_DataReader (const Sample_GetDomainPredicates_Response_DataReader &);
                Sample_GetDomainPredicates_Response_DataReader & operator = (const Sample_GetDomainPredicates_Response_DataReader &);
            };

            class  Sample_GetDomainPredicates_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetDomainPredicates_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetDomainPredicates_Response_DataReaderView_var _var_type;

                static Sample_GetDomainPredicates_Response_DataReaderView_ptr _duplicate (Sample_GetDomainPredicates_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomainPredicates_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomainPredicates_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomainPredicates_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomainPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomainPredicates_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomainPredicates_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomainPredicates_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomainPredicates_Response_& instance) = 0;

            protected:
                Sample_GetDomainPredicates_Response_DataReaderView () {};
                ~Sample_GetDomainPredicates_Response_DataReaderView () {};
            private:
                Sample_GetDomainPredicates_Response_DataReaderView (const Sample_GetDomainPredicates_Response_DataReaderView &);
                Sample_GetDomainPredicates_Response_DataReaderView & operator = (const Sample_GetDomainPredicates_Response_DataReaderView &);
            };
        }

    }

}

#endif
