#ifndef _H_F7CB1AD8013BFF97CFA62EBAD7957399_GetDomain__H_
#define _H_F7CB1AD8013BFF97CFA62EBAD7957399_GetDomain__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Empty_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetDomain_Request_
            {
                ::std_msgs::msg::dds_::Empty_ request_;
            };

            typedef DDS_DCPSStruct_var<GetDomain_Request_> GetDomain_Request__var;
            typedef GetDomain_Request_& GetDomain_Request__out;

            struct  GetDomain_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr domain_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<GetDomain_Response_> GetDomain_Response__var;
            typedef DDS_DCPSStruct_out < GetDomain_Response_> GetDomain_Response__out;

            struct  Sample_GetDomain_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetDomain_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetDomain_Request_> Sample_GetDomain_Request__var;
            typedef Sample_GetDomain_Request_& Sample_GetDomain_Request__out;

            struct  Sample_GetDomain_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetDomain_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetDomain_Response_> Sample_GetDomain_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetDomain_Response_> Sample_GetDomain_Response__out;

        }

    }

}

#endif /* _H_F7CB1AD8013BFF97CFA62EBAD7957399_GetDomain__H_ */
