#ifndef _H_F7CB1AD8013BFF97CFA62EBAD7957399_GetDomain_DCPS_H_
#define _H_F7CB1AD8013BFF97CFA62EBAD7957399_GetDomain_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetDomain_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetDomain_Request_TypeSupportInterface;

            typedef GetDomain_Request_TypeSupportInterface * GetDomain_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetDomain_Request_TypeSupportInterface> GetDomain_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetDomain_Request_TypeSupportInterface> GetDomain_Request_TypeSupportInterface_out;


            class GetDomain_Request_DataWriter;

            typedef GetDomain_Request_DataWriter * GetDomain_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetDomain_Request_DataWriter> GetDomain_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetDomain_Request_DataWriter> GetDomain_Request_DataWriter_out;


            class GetDomain_Request_DataReader;

            typedef GetDomain_Request_DataReader * GetDomain_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetDomain_Request_DataReader> GetDomain_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetDomain_Request_DataReader> GetDomain_Request_DataReader_out;


            class GetDomain_Request_DataReaderView;

            typedef GetDomain_Request_DataReaderView * GetDomain_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetDomain_Request_DataReaderView> GetDomain_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetDomain_Request_DataReaderView> GetDomain_Request_DataReaderView_out;

            struct GetDomain_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetDomain_Request_, struct GetDomain_Request_Seq_uniq_> GetDomain_Request_Seq;
            typedef DDS_DCPSSequence_var < GetDomain_Request_Seq> GetDomain_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetDomain_Request_Seq> GetDomain_Request_Seq_out;

            class  GetDomain_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetDomain_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetDomain_Request_TypeSupportInterface_var _var_type;

                static GetDomain_Request_TypeSupportInterface_ptr _duplicate (GetDomain_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomain_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetDomain_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomain_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomain_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetDomain_Request_TypeSupportInterface () {};
                ~GetDomain_Request_TypeSupportInterface () {};
            private:
                GetDomain_Request_TypeSupportInterface (const GetDomain_Request_TypeSupportInterface &);
                GetDomain_Request_TypeSupportInterface & operator = (const GetDomain_Request_TypeSupportInterface &);
            };

            class  GetDomain_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetDomain_Request_DataWriter_ptr _ptr_type;
                typedef GetDomain_Request_DataWriter_var _var_type;

                static GetDomain_Request_DataWriter_ptr _duplicate (GetDomain_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomain_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetDomain_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomain_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomain_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetDomain_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetDomain_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetDomain_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetDomain_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetDomain_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetDomain_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetDomain_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetDomain_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetDomain_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetDomain_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetDomain_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomain_Request_& instance_data) = 0;

            protected:
                GetDomain_Request_DataWriter () {};
                ~GetDomain_Request_DataWriter () {};
            private:
                GetDomain_Request_DataWriter (const GetDomain_Request_DataWriter &);
                GetDomain_Request_DataWriter & operator = (const GetDomain_Request_DataWriter &);
            };

            class  GetDomain_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetDomain_Request_DataReader_ptr _ptr_type;
                typedef GetDomain_Request_DataReader_var _var_type;

                static GetDomain_Request_DataReader_ptr _duplicate (GetDomain_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomain_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetDomain_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomain_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomain_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomain_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomain_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomain_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomain_Request_& instance) = 0;

            protected:
                GetDomain_Request_DataReader () {};
                ~GetDomain_Request_DataReader () {};
            private:
                GetDomain_Request_DataReader (const GetDomain_Request_DataReader &);
                GetDomain_Request_DataReader & operator = (const GetDomain_Request_DataReader &);
            };

            class  GetDomain_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetDomain_Request_DataReaderView_ptr _ptr_type;
                typedef GetDomain_Request_DataReaderView_var _var_type;

                static GetDomain_Request_DataReaderView_ptr _duplicate (GetDomain_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomain_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetDomain_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomain_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomain_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomain_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomain_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomain_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomain_Request_& instance) = 0;

            protected:
                GetDomain_Request_DataReaderView () {};
                ~GetDomain_Request_DataReaderView () {};
            private:
                GetDomain_Request_DataReaderView (const GetDomain_Request_DataReaderView &);
                GetDomain_Request_DataReaderView & operator = (const GetDomain_Request_DataReaderView &);
            };
            class GetDomain_Response_TypeSupportInterface;

            typedef GetDomain_Response_TypeSupportInterface * GetDomain_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetDomain_Response_TypeSupportInterface> GetDomain_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetDomain_Response_TypeSupportInterface> GetDomain_Response_TypeSupportInterface_out;


            class GetDomain_Response_DataWriter;

            typedef GetDomain_Response_DataWriter * GetDomain_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetDomain_Response_DataWriter> GetDomain_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetDomain_Response_DataWriter> GetDomain_Response_DataWriter_out;


            class GetDomain_Response_DataReader;

            typedef GetDomain_Response_DataReader * GetDomain_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetDomain_Response_DataReader> GetDomain_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetDomain_Response_DataReader> GetDomain_Response_DataReader_out;


            class GetDomain_Response_DataReaderView;

            typedef GetDomain_Response_DataReaderView * GetDomain_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetDomain_Response_DataReaderView> GetDomain_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetDomain_Response_DataReaderView> GetDomain_Response_DataReaderView_out;

            struct GetDomain_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetDomain_Response_, struct GetDomain_Response_Seq_uniq_> GetDomain_Response_Seq;
            typedef DDS_DCPSSequence_var < GetDomain_Response_Seq> GetDomain_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetDomain_Response_Seq> GetDomain_Response_Seq_out;

            class  GetDomain_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetDomain_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetDomain_Response_TypeSupportInterface_var _var_type;

                static GetDomain_Response_TypeSupportInterface_ptr _duplicate (GetDomain_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomain_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetDomain_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomain_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomain_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetDomain_Response_TypeSupportInterface () {};
                ~GetDomain_Response_TypeSupportInterface () {};
            private:
                GetDomain_Response_TypeSupportInterface (const GetDomain_Response_TypeSupportInterface &);
                GetDomain_Response_TypeSupportInterface & operator = (const GetDomain_Response_TypeSupportInterface &);
            };

            class  GetDomain_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetDomain_Response_DataWriter_ptr _ptr_type;
                typedef GetDomain_Response_DataWriter_var _var_type;

                static GetDomain_Response_DataWriter_ptr _duplicate (GetDomain_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomain_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetDomain_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomain_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomain_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetDomain_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetDomain_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetDomain_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetDomain_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetDomain_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetDomain_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetDomain_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetDomain_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetDomain_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetDomain_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetDomain_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomain_Response_& instance_data) = 0;

            protected:
                GetDomain_Response_DataWriter () {};
                ~GetDomain_Response_DataWriter () {};
            private:
                GetDomain_Response_DataWriter (const GetDomain_Response_DataWriter &);
                GetDomain_Response_DataWriter & operator = (const GetDomain_Response_DataWriter &);
            };

            class  GetDomain_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetDomain_Response_DataReader_ptr _ptr_type;
                typedef GetDomain_Response_DataReader_var _var_type;

                static GetDomain_Response_DataReader_ptr _duplicate (GetDomain_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomain_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetDomain_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomain_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomain_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomain_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomain_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomain_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomain_Response_& instance) = 0;

            protected:
                GetDomain_Response_DataReader () {};
                ~GetDomain_Response_DataReader () {};
            private:
                GetDomain_Response_DataReader (const GetDomain_Response_DataReader &);
                GetDomain_Response_DataReader & operator = (const GetDomain_Response_DataReader &);
            };

            class  GetDomain_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetDomain_Response_DataReaderView_ptr _ptr_type;
                typedef GetDomain_Response_DataReaderView_var _var_type;

                static GetDomain_Response_DataReaderView_ptr _duplicate (GetDomain_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetDomain_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetDomain_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetDomain_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetDomain_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetDomain_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetDomain_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetDomain_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetDomain_Response_& instance) = 0;

            protected:
                GetDomain_Response_DataReaderView () {};
                ~GetDomain_Response_DataReaderView () {};
            private:
                GetDomain_Response_DataReaderView (const GetDomain_Response_DataReaderView &);
                GetDomain_Response_DataReaderView & operator = (const GetDomain_Response_DataReaderView &);
            };
            class Sample_GetDomain_Request_TypeSupportInterface;

            typedef Sample_GetDomain_Request_TypeSupportInterface * Sample_GetDomain_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomain_Request_TypeSupportInterface> Sample_GetDomain_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomain_Request_TypeSupportInterface> Sample_GetDomain_Request_TypeSupportInterface_out;


            class Sample_GetDomain_Request_DataWriter;

            typedef Sample_GetDomain_Request_DataWriter * Sample_GetDomain_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomain_Request_DataWriter> Sample_GetDomain_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomain_Request_DataWriter> Sample_GetDomain_Request_DataWriter_out;


            class Sample_GetDomain_Request_DataReader;

            typedef Sample_GetDomain_Request_DataReader * Sample_GetDomain_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomain_Request_DataReader> Sample_GetDomain_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomain_Request_DataReader> Sample_GetDomain_Request_DataReader_out;


            class Sample_GetDomain_Request_DataReaderView;

            typedef Sample_GetDomain_Request_DataReaderView * Sample_GetDomain_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomain_Request_DataReaderView> Sample_GetDomain_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomain_Request_DataReaderView> Sample_GetDomain_Request_DataReaderView_out;

            struct Sample_GetDomain_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetDomain_Request_, struct Sample_GetDomain_Request_Seq_uniq_> Sample_GetDomain_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetDomain_Request_Seq> Sample_GetDomain_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetDomain_Request_Seq> Sample_GetDomain_Request_Seq_out;

            class  Sample_GetDomain_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetDomain_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetDomain_Request_TypeSupportInterface_var _var_type;

                static Sample_GetDomain_Request_TypeSupportInterface_ptr _duplicate (Sample_GetDomain_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomain_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomain_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetDomain_Request_TypeSupportInterface () {};
                ~Sample_GetDomain_Request_TypeSupportInterface () {};
            private:
                Sample_GetDomain_Request_TypeSupportInterface (const Sample_GetDomain_Request_TypeSupportInterface &);
                Sample_GetDomain_Request_TypeSupportInterface & operator = (const Sample_GetDomain_Request_TypeSupportInterface &);
            };

            class  Sample_GetDomain_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetDomain_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetDomain_Request_DataWriter_var _var_type;

                static Sample_GetDomain_Request_DataWriter_ptr _duplicate (Sample_GetDomain_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomain_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomain_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetDomain_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetDomain_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetDomain_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetDomain_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetDomain_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetDomain_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetDomain_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetDomain_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetDomain_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetDomain_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomain_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomain_Request_& instance_data) = 0;

            protected:
                Sample_GetDomain_Request_DataWriter () {};
                ~Sample_GetDomain_Request_DataWriter () {};
            private:
                Sample_GetDomain_Request_DataWriter (const Sample_GetDomain_Request_DataWriter &);
                Sample_GetDomain_Request_DataWriter & operator = (const Sample_GetDomain_Request_DataWriter &);
            };

            class  Sample_GetDomain_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetDomain_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetDomain_Request_DataReader_var _var_type;

                static Sample_GetDomain_Request_DataReader_ptr _duplicate (Sample_GetDomain_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomain_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomain_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomain_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomain_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomain_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomain_Request_& instance) = 0;

            protected:
                Sample_GetDomain_Request_DataReader () {};
                ~Sample_GetDomain_Request_DataReader () {};
            private:
                Sample_GetDomain_Request_DataReader (const Sample_GetDomain_Request_DataReader &);
                Sample_GetDomain_Request_DataReader & operator = (const Sample_GetDomain_Request_DataReader &);
            };

            class  Sample_GetDomain_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetDomain_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetDomain_Request_DataReaderView_var _var_type;

                static Sample_GetDomain_Request_DataReaderView_ptr _duplicate (Sample_GetDomain_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomain_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomain_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomain_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomain_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomain_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomain_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomain_Request_& instance) = 0;

            protected:
                Sample_GetDomain_Request_DataReaderView () {};
                ~Sample_GetDomain_Request_DataReaderView () {};
            private:
                Sample_GetDomain_Request_DataReaderView (const Sample_GetDomain_Request_DataReaderView &);
                Sample_GetDomain_Request_DataReaderView & operator = (const Sample_GetDomain_Request_DataReaderView &);
            };
            class Sample_GetDomain_Response_TypeSupportInterface;

            typedef Sample_GetDomain_Response_TypeSupportInterface * Sample_GetDomain_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomain_Response_TypeSupportInterface> Sample_GetDomain_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomain_Response_TypeSupportInterface> Sample_GetDomain_Response_TypeSupportInterface_out;


            class Sample_GetDomain_Response_DataWriter;

            typedef Sample_GetDomain_Response_DataWriter * Sample_GetDomain_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomain_Response_DataWriter> Sample_GetDomain_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomain_Response_DataWriter> Sample_GetDomain_Response_DataWriter_out;


            class Sample_GetDomain_Response_DataReader;

            typedef Sample_GetDomain_Response_DataReader * Sample_GetDomain_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomain_Response_DataReader> Sample_GetDomain_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomain_Response_DataReader> Sample_GetDomain_Response_DataReader_out;


            class Sample_GetDomain_Response_DataReaderView;

            typedef Sample_GetDomain_Response_DataReaderView * Sample_GetDomain_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetDomain_Response_DataReaderView> Sample_GetDomain_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetDomain_Response_DataReaderView> Sample_GetDomain_Response_DataReaderView_out;

            struct Sample_GetDomain_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetDomain_Response_, struct Sample_GetDomain_Response_Seq_uniq_> Sample_GetDomain_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetDomain_Response_Seq> Sample_GetDomain_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetDomain_Response_Seq> Sample_GetDomain_Response_Seq_out;

            class  Sample_GetDomain_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetDomain_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetDomain_Response_TypeSupportInterface_var _var_type;

                static Sample_GetDomain_Response_TypeSupportInterface_ptr _duplicate (Sample_GetDomain_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomain_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomain_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetDomain_Response_TypeSupportInterface () {};
                ~Sample_GetDomain_Response_TypeSupportInterface () {};
            private:
                Sample_GetDomain_Response_TypeSupportInterface (const Sample_GetDomain_Response_TypeSupportInterface &);
                Sample_GetDomain_Response_TypeSupportInterface & operator = (const Sample_GetDomain_Response_TypeSupportInterface &);
            };

            class  Sample_GetDomain_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetDomain_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetDomain_Response_DataWriter_var _var_type;

                static Sample_GetDomain_Response_DataWriter_ptr _duplicate (Sample_GetDomain_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomain_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomain_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetDomain_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetDomain_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetDomain_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetDomain_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetDomain_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetDomain_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetDomain_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetDomain_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetDomain_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetDomain_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomain_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomain_Response_& instance_data) = 0;

            protected:
                Sample_GetDomain_Response_DataWriter () {};
                ~Sample_GetDomain_Response_DataWriter () {};
            private:
                Sample_GetDomain_Response_DataWriter (const Sample_GetDomain_Response_DataWriter &);
                Sample_GetDomain_Response_DataWriter & operator = (const Sample_GetDomain_Response_DataWriter &);
            };

            class  Sample_GetDomain_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetDomain_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetDomain_Response_DataReader_var _var_type;

                static Sample_GetDomain_Response_DataReader_ptr _duplicate (Sample_GetDomain_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomain_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomain_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomain_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomain_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomain_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomain_Response_& instance) = 0;

            protected:
                Sample_GetDomain_Response_DataReader () {};
                ~Sample_GetDomain_Response_DataReader () {};
            private:
                Sample_GetDomain_Response_DataReader (const Sample_GetDomain_Response_DataReader &);
                Sample_GetDomain_Response_DataReader & operator = (const Sample_GetDomain_Response_DataReader &);
            };

            class  Sample_GetDomain_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetDomain_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetDomain_Response_DataReaderView_var _var_type;

                static Sample_GetDomain_Response_DataReaderView_ptr _duplicate (Sample_GetDomain_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetDomain_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetDomain_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetDomain_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetDomain_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetDomain_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetDomain_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetDomain_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetDomain_Response_& instance) = 0;

            protected:
                Sample_GetDomain_Response_DataReaderView () {};
                ~Sample_GetDomain_Response_DataReaderView () {};
            private:
                Sample_GetDomain_Response_DataReaderView (const Sample_GetDomain_Response_DataReaderView &);
                Sample_GetDomain_Response_DataReaderView & operator = (const Sample_GetDomain_Response_DataReaderView &);
            };
        }

    }

}

#endif
