#ifndef _H_27FBF6A0263E23128F7956C1741D821F_GetPlan__H_
#define _H_27FBF6A0263E23128F7956C1741D821F_GetPlan__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetPlan_Request_
            {
                ::DDS::String_mgr domain_;
                ::DDS::String_mgr problem_;
            };

            typedef DDS_DCPSStruct_var<GetPlan_Request_> GetPlan_Request__var;
            typedef DDS_DCPSStruct_out < GetPlan_Request_> GetPlan_Request__out;

            struct  GetPlan_Response_
            {
                struct _times__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Float, struct _times__seq_uniq_ > _times__seq;
                typedef DDS_DCPSSequence_var< _times__seq > _times__seq_var;
                typedef DDS_DCPSSequence_out< _times__seq > _times__seq_out;
                struct _actions__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _actions__seq_uniq_ > _actions__seq;
                typedef DDS_DCPSUStrSeq_var< _actions__seq > _actions__seq_var;
                typedef DDS_DCPSUStrSeq_out< _actions__seq > _actions__seq_out;
                struct _durations__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Float, struct _durations__seq_uniq_ > _durations__seq;
                typedef DDS_DCPSSequence_var< _durations__seq > _durations__seq_var;
                typedef DDS_DCPSSequence_out< _durations__seq > _durations__seq_out;
                ::DDS::Boolean success_;
                _times__seq times_;
                _actions__seq actions_;
                _durations__seq durations_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<GetPlan_Response_> GetPlan_Response__var;
            typedef DDS_DCPSStruct_out < GetPlan_Response_> GetPlan_Response__out;

            struct  Sample_GetPlan_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetPlan_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetPlan_Request_> Sample_GetPlan_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetPlan_Request_> Sample_GetPlan_Request__out;

            struct  Sample_GetPlan_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetPlan_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetPlan_Response_> Sample_GetPlan_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetPlan_Response_> Sample_GetPlan_Response__out;

        }

    }

}

#endif /* _H_27FBF6A0263E23128F7956C1741D821F_GetPlan__H_ */
