#ifndef _H_D9A9D95D7BE73DB57C5D8224D62256C1_GetProblemInstanceDetails__H_
#define _H_D9A9D95D7BE73DB57C5D8224D62256C1_GetProblemInstanceDetails__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetProblemInstanceDetails_Request_
            {
                ::DDS::String_mgr instance_;
            };

            typedef DDS_DCPSStruct_var<GetProblemInstanceDetails_Request_> GetProblemInstanceDetails_Request__var;
            typedef DDS_DCPSStruct_out < GetProblemInstanceDetails_Request_> GetProblemInstanceDetails_Request__out;

            struct  GetProblemInstanceDetails_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr type_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<GetProblemInstanceDetails_Response_> GetProblemInstanceDetails_Response__var;
            typedef DDS_DCPSStruct_out < GetProblemInstanceDetails_Response_> GetProblemInstanceDetails_Response__out;

            struct  Sample_GetProblemInstanceDetails_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetProblemInstanceDetails_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetProblemInstanceDetails_Request_> Sample_GetProblemInstanceDetails_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetProblemInstanceDetails_Request_> Sample_GetProblemInstanceDetails_Request__out;

            struct  Sample_GetProblemInstanceDetails_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetProblemInstanceDetails_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetProblemInstanceDetails_Response_> Sample_GetProblemInstanceDetails_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetProblemInstanceDetails_Response_> Sample_GetProblemInstanceDetails_Response__out;

        }

    }

}

#endif /* _H_D9A9D95D7BE73DB57C5D8224D62256C1_GetProblemInstanceDetails__H_ */
