#ifndef _H_C778FF582F2A26219F7F994A47A10CAE_GetProblemInstances__H_
#define _H_C778FF582F2A26219F7F994A47A10CAE_GetProblemInstances__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Empty_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetProblemInstances_Request_
            {
                ::std_msgs::msg::dds_::Empty_ request_;
            };

            typedef DDS_DCPSStruct_var<GetProblemInstances_Request_> GetProblemInstances_Request__var;
            typedef GetProblemInstances_Request_& GetProblemInstances_Request__out;

            struct  GetProblemInstances_Response_
            {
                struct _instances__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _instances__seq_uniq_ > _instances__seq;
                typedef DDS_DCPSUStrSeq_var< _instances__seq > _instances__seq_var;
                typedef DDS_DCPSUStrSeq_out< _instances__seq > _instances__seq_out;
                struct _types__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _types__seq_uniq_ > _types__seq;
                typedef DDS_DCPSUStrSeq_var< _types__seq > _types__seq_var;
                typedef DDS_DCPSUStrSeq_out< _types__seq > _types__seq_out;
                ::DDS::Boolean success_;
                _instances__seq instances_;
                _types__seq types_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<GetProblemInstances_Response_> GetProblemInstances_Response__var;
            typedef DDS_DCPSStruct_out < GetProblemInstances_Response_> GetProblemInstances_Response__out;

            struct  Sample_GetProblemInstances_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetProblemInstances_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetProblemInstances_Request_> Sample_GetProblemInstances_Request__var;
            typedef Sample_GetProblemInstances_Request_& Sample_GetProblemInstances_Request__out;

            struct  Sample_GetProblemInstances_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetProblemInstances_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetProblemInstances_Response_> Sample_GetProblemInstances_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetProblemInstances_Response_> Sample_GetProblemInstances_Response__out;

        }

    }

}

#endif /* _H_C778FF582F2A26219F7F994A47A10CAE_GetProblemInstances__H_ */
