#ifndef _H_C778FF582F2A26219F7F994A47A10CAE_GetProblemInstances_DCPS_H_
#define _H_C778FF582F2A26219F7F994A47A10CAE_GetProblemInstances_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GetProblemInstances_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class GetProblemInstances_Request_TypeSupportInterface;

            typedef GetProblemInstances_Request_TypeSupportInterface * GetProblemInstances_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstances_Request_TypeSupportInterface> GetProblemInstances_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetProblemInstances_Request_TypeSupportInterface> GetProblemInstances_Request_TypeSupportInterface_out;


            class GetProblemInstances_Request_DataWriter;

            typedef GetProblemInstances_Request_DataWriter * GetProblemInstances_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstances_Request_DataWriter> GetProblemInstances_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetProblemInstances_Request_DataWriter> GetProblemInstances_Request_DataWriter_out;


            class GetProblemInstances_Request_DataReader;

            typedef GetProblemInstances_Request_DataReader * GetProblemInstances_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstances_Request_DataReader> GetProblemInstances_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < GetProblemInstances_Request_DataReader> GetProblemInstances_Request_DataReader_out;


            class GetProblemInstances_Request_DataReaderView;

            typedef GetProblemInstances_Request_DataReaderView * GetProblemInstances_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstances_Request_DataReaderView> GetProblemInstances_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetProblemInstances_Request_DataReaderView> GetProblemInstances_Request_DataReaderView_out;

            struct GetProblemInstances_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GetProblemInstances_Request_, struct GetProblemInstances_Request_Seq_uniq_> GetProblemInstances_Request_Seq;
            typedef DDS_DCPSSequence_var < GetProblemInstances_Request_Seq> GetProblemInstances_Request_Seq_var;
            typedef DDS_DCPSSequence_out < GetProblemInstances_Request_Seq> GetProblemInstances_Request_Seq_out;

            class  GetProblemInstances_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetProblemInstances_Request_TypeSupportInterface_ptr _ptr_type;
                typedef GetProblemInstances_Request_TypeSupportInterface_var _var_type;

                static GetProblemInstances_Request_TypeSupportInterface_ptr _duplicate (GetProblemInstances_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstances_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstances_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetProblemInstances_Request_TypeSupportInterface () {};
                ~GetProblemInstances_Request_TypeSupportInterface () {};
            private:
                GetProblemInstances_Request_TypeSupportInterface (const GetProblemInstances_Request_TypeSupportInterface &);
                GetProblemInstances_Request_TypeSupportInterface & operator = (const GetProblemInstances_Request_TypeSupportInterface &);
            };

            class  GetProblemInstances_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetProblemInstances_Request_DataWriter_ptr _ptr_type;
                typedef GetProblemInstances_Request_DataWriter_var _var_type;

                static GetProblemInstances_Request_DataWriter_ptr _duplicate (GetProblemInstances_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstances_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstances_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetProblemInstances_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetProblemInstances_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetProblemInstances_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetProblemInstances_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetProblemInstances_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetProblemInstances_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetProblemInstances_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetProblemInstances_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetProblemInstances_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetProblemInstances_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetProblemInstances_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemInstances_Request_& instance_data) = 0;

            protected:
                GetProblemInstances_Request_DataWriter () {};
                ~GetProblemInstances_Request_DataWriter () {};
            private:
                GetProblemInstances_Request_DataWriter (const GetProblemInstances_Request_DataWriter &);
                GetProblemInstances_Request_DataWriter & operator = (const GetProblemInstances_Request_DataWriter &);
            };

            class  GetProblemInstances_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetProblemInstances_Request_DataReader_ptr _ptr_type;
                typedef GetProblemInstances_Request_DataReader_var _var_type;

                static GetProblemInstances_Request_DataReader_ptr _duplicate (GetProblemInstances_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstances_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstances_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemInstances_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemInstances_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemInstances_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemInstances_Request_& instance) = 0;

            protected:
                GetProblemInstances_Request_DataReader () {};
                ~GetProblemInstances_Request_DataReader () {};
            private:
                GetProblemInstances_Request_DataReader (const GetProblemInstances_Request_DataReader &);
                GetProblemInstances_Request_DataReader & operator = (const GetProblemInstances_Request_DataReader &);
            };

            class  GetProblemInstances_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetProblemInstances_Request_DataReaderView_ptr _ptr_type;
                typedef GetProblemInstances_Request_DataReaderView_var _var_type;

                static GetProblemInstances_Request_DataReaderView_ptr _duplicate (GetProblemInstances_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstances_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstances_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemInstances_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemInstances_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemInstances_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemInstances_Request_& instance) = 0;

            protected:
                GetProblemInstances_Request_DataReaderView () {};
                ~GetProblemInstances_Request_DataReaderView () {};
            private:
                GetProblemInstances_Request_DataReaderView (const GetProblemInstances_Request_DataReaderView &);
                GetProblemInstances_Request_DataReaderView & operator = (const GetProblemInstances_Request_DataReaderView &);
            };
            class GetProblemInstances_Response_TypeSupportInterface;

            typedef GetProblemInstances_Response_TypeSupportInterface * GetProblemInstances_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstances_Response_TypeSupportInterface> GetProblemInstances_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GetProblemInstances_Response_TypeSupportInterface> GetProblemInstances_Response_TypeSupportInterface_out;


            class GetProblemInstances_Response_DataWriter;

            typedef GetProblemInstances_Response_DataWriter * GetProblemInstances_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstances_Response_DataWriter> GetProblemInstances_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < GetProblemInstances_Response_DataWriter> GetProblemInstances_Response_DataWriter_out;


            class GetProblemInstances_Response_DataReader;

            typedef GetProblemInstances_Response_DataReader * GetProblemInstances_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstances_Response_DataReader> GetProblemInstances_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < GetProblemInstances_Response_DataReader> GetProblemInstances_Response_DataReader_out;


            class GetProblemInstances_Response_DataReaderView;

            typedef GetProblemInstances_Response_DataReaderView * GetProblemInstances_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GetProblemInstances_Response_DataReaderView> GetProblemInstances_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GetProblemInstances_Response_DataReaderView> GetProblemInstances_Response_DataReaderView_out;

            struct GetProblemInstances_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GetProblemInstances_Response_, struct GetProblemInstances_Response_Seq_uniq_> GetProblemInstances_Response_Seq;
            typedef DDS_DCPSSequence_var < GetProblemInstances_Response_Seq> GetProblemInstances_Response_Seq_var;
            typedef DDS_DCPSSequence_out < GetProblemInstances_Response_Seq> GetProblemInstances_Response_Seq_out;

            class  GetProblemInstances_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GetProblemInstances_Response_TypeSupportInterface_ptr _ptr_type;
                typedef GetProblemInstances_Response_TypeSupportInterface_var _var_type;

                static GetProblemInstances_Response_TypeSupportInterface_ptr _duplicate (GetProblemInstances_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstances_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstances_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GetProblemInstances_Response_TypeSupportInterface () {};
                ~GetProblemInstances_Response_TypeSupportInterface () {};
            private:
                GetProblemInstances_Response_TypeSupportInterface (const GetProblemInstances_Response_TypeSupportInterface &);
                GetProblemInstances_Response_TypeSupportInterface & operator = (const GetProblemInstances_Response_TypeSupportInterface &);
            };

            class  GetProblemInstances_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GetProblemInstances_Response_DataWriter_ptr _ptr_type;
                typedef GetProblemInstances_Response_DataWriter_var _var_type;

                static GetProblemInstances_Response_DataWriter_ptr _duplicate (GetProblemInstances_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstances_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstances_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GetProblemInstances_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GetProblemInstances_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GetProblemInstances_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GetProblemInstances_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GetProblemInstances_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GetProblemInstances_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GetProblemInstances_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GetProblemInstances_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GetProblemInstances_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GetProblemInstances_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GetProblemInstances_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemInstances_Response_& instance_data) = 0;

            protected:
                GetProblemInstances_Response_DataWriter () {};
                ~GetProblemInstances_Response_DataWriter () {};
            private:
                GetProblemInstances_Response_DataWriter (const GetProblemInstances_Response_DataWriter &);
                GetProblemInstances_Response_DataWriter & operator = (const GetProblemInstances_Response_DataWriter &);
            };

            class  GetProblemInstances_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GetProblemInstances_Response_DataReader_ptr _ptr_type;
                typedef GetProblemInstances_Response_DataReader_var _var_type;

                static GetProblemInstances_Response_DataReader_ptr _duplicate (GetProblemInstances_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstances_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstances_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemInstances_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemInstances_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemInstances_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemInstances_Response_& instance) = 0;

            protected:
                GetProblemInstances_Response_DataReader () {};
                ~GetProblemInstances_Response_DataReader () {};
            private:
                GetProblemInstances_Response_DataReader (const GetProblemInstances_Response_DataReader &);
                GetProblemInstances_Response_DataReader & operator = (const GetProblemInstances_Response_DataReader &);
            };

            class  GetProblemInstances_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GetProblemInstances_Response_DataReaderView_ptr _ptr_type;
                typedef GetProblemInstances_Response_DataReaderView_var _var_type;

                static GetProblemInstances_Response_DataReaderView_ptr _duplicate (GetProblemInstances_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GetProblemInstances_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GetProblemInstances_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GetProblemInstances_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GetProblemInstances_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GetProblemInstances_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GetProblemInstances_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GetProblemInstances_Response_& instance) = 0;

            protected:
                GetProblemInstances_Response_DataReaderView () {};
                ~GetProblemInstances_Response_DataReaderView () {};
            private:
                GetProblemInstances_Response_DataReaderView (const GetProblemInstances_Response_DataReaderView &);
                GetProblemInstances_Response_DataReaderView & operator = (const GetProblemInstances_Response_DataReaderView &);
            };
            class Sample_GetProblemInstances_Request_TypeSupportInterface;

            typedef Sample_GetProblemInstances_Request_TypeSupportInterface * Sample_GetProblemInstances_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstances_Request_TypeSupportInterface> Sample_GetProblemInstances_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstances_Request_TypeSupportInterface> Sample_GetProblemInstances_Request_TypeSupportInterface_out;


            class Sample_GetProblemInstances_Request_DataWriter;

            typedef Sample_GetProblemInstances_Request_DataWriter * Sample_GetProblemInstances_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstances_Request_DataWriter> Sample_GetProblemInstances_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstances_Request_DataWriter> Sample_GetProblemInstances_Request_DataWriter_out;


            class Sample_GetProblemInstances_Request_DataReader;

            typedef Sample_GetProblemInstances_Request_DataReader * Sample_GetProblemInstances_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstances_Request_DataReader> Sample_GetProblemInstances_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstances_Request_DataReader> Sample_GetProblemInstances_Request_DataReader_out;


            class Sample_GetProblemInstances_Request_DataReaderView;

            typedef Sample_GetProblemInstances_Request_DataReaderView * Sample_GetProblemInstances_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstances_Request_DataReaderView> Sample_GetProblemInstances_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstances_Request_DataReaderView> Sample_GetProblemInstances_Request_DataReaderView_out;

            struct Sample_GetProblemInstances_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_GetProblemInstances_Request_, struct Sample_GetProblemInstances_Request_Seq_uniq_> Sample_GetProblemInstances_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetProblemInstances_Request_Seq> Sample_GetProblemInstances_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetProblemInstances_Request_Seq> Sample_GetProblemInstances_Request_Seq_out;

            class  Sample_GetProblemInstances_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetProblemInstances_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetProblemInstances_Request_TypeSupportInterface_var _var_type;

                static Sample_GetProblemInstances_Request_TypeSupportInterface_ptr _duplicate (Sample_GetProblemInstances_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstances_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstances_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetProblemInstances_Request_TypeSupportInterface () {};
                ~Sample_GetProblemInstances_Request_TypeSupportInterface () {};
            private:
                Sample_GetProblemInstances_Request_TypeSupportInterface (const Sample_GetProblemInstances_Request_TypeSupportInterface &);
                Sample_GetProblemInstances_Request_TypeSupportInterface & operator = (const Sample_GetProblemInstances_Request_TypeSupportInterface &);
            };

            class  Sample_GetProblemInstances_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetProblemInstances_Request_DataWriter_ptr _ptr_type;
                typedef Sample_GetProblemInstances_Request_DataWriter_var _var_type;

                static Sample_GetProblemInstances_Request_DataWriter_ptr _duplicate (Sample_GetProblemInstances_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstances_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstances_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetProblemInstances_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetProblemInstances_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetProblemInstances_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetProblemInstances_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetProblemInstances_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetProblemInstances_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetProblemInstances_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetProblemInstances_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetProblemInstances_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetProblemInstances_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemInstances_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemInstances_Request_& instance_data) = 0;

            protected:
                Sample_GetProblemInstances_Request_DataWriter () {};
                ~Sample_GetProblemInstances_Request_DataWriter () {};
            private:
                Sample_GetProblemInstances_Request_DataWriter (const Sample_GetProblemInstances_Request_DataWriter &);
                Sample_GetProblemInstances_Request_DataWriter & operator = (const Sample_GetProblemInstances_Request_DataWriter &);
            };

            class  Sample_GetProblemInstances_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetProblemInstances_Request_DataReader_ptr _ptr_type;
                typedef Sample_GetProblemInstances_Request_DataReader_var _var_type;

                static Sample_GetProblemInstances_Request_DataReader_ptr _duplicate (Sample_GetProblemInstances_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstances_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstances_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemInstances_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemInstances_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemInstances_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemInstances_Request_& instance) = 0;

            protected:
                Sample_GetProblemInstances_Request_DataReader () {};
                ~Sample_GetProblemInstances_Request_DataReader () {};
            private:
                Sample_GetProblemInstances_Request_DataReader (const Sample_GetProblemInstances_Request_DataReader &);
                Sample_GetProblemInstances_Request_DataReader & operator = (const Sample_GetProblemInstances_Request_DataReader &);
            };

            class  Sample_GetProblemInstances_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetProblemInstances_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_GetProblemInstances_Request_DataReaderView_var _var_type;

                static Sample_GetProblemInstances_Request_DataReaderView_ptr _duplicate (Sample_GetProblemInstances_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstances_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstances_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemInstances_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemInstances_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemInstances_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemInstances_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemInstances_Request_& instance) = 0;

            protected:
                Sample_GetProblemInstances_Request_DataReaderView () {};
                ~Sample_GetProblemInstances_Request_DataReaderView () {};
            private:
                Sample_GetProblemInstances_Request_DataReaderView (const Sample_GetProblemInstances_Request_DataReaderView &);
                Sample_GetProblemInstances_Request_DataReaderView & operator = (const Sample_GetProblemInstances_Request_DataReaderView &);
            };
            class Sample_GetProblemInstances_Response_TypeSupportInterface;

            typedef Sample_GetProblemInstances_Response_TypeSupportInterface * Sample_GetProblemInstances_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstances_Response_TypeSupportInterface> Sample_GetProblemInstances_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstances_Response_TypeSupportInterface> Sample_GetProblemInstances_Response_TypeSupportInterface_out;


            class Sample_GetProblemInstances_Response_DataWriter;

            typedef Sample_GetProblemInstances_Response_DataWriter * Sample_GetProblemInstances_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstances_Response_DataWriter> Sample_GetProblemInstances_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstances_Response_DataWriter> Sample_GetProblemInstances_Response_DataWriter_out;


            class Sample_GetProblemInstances_Response_DataReader;

            typedef Sample_GetProblemInstances_Response_DataReader * Sample_GetProblemInstances_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstances_Response_DataReader> Sample_GetProblemInstances_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstances_Response_DataReader> Sample_GetProblemInstances_Response_DataReader_out;


            class Sample_GetProblemInstances_Response_DataReaderView;

            typedef Sample_GetProblemInstances_Response_DataReaderView * Sample_GetProblemInstances_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_GetProblemInstances_Response_DataReaderView> Sample_GetProblemInstances_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_GetProblemInstances_Response_DataReaderView> Sample_GetProblemInstances_Response_DataReaderView_out;

            struct Sample_GetProblemInstances_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_GetProblemInstances_Response_, struct Sample_GetProblemInstances_Response_Seq_uniq_> Sample_GetProblemInstances_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_GetProblemInstances_Response_Seq> Sample_GetProblemInstances_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_GetProblemInstances_Response_Seq> Sample_GetProblemInstances_Response_Seq_out;

            class  Sample_GetProblemInstances_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_GetProblemInstances_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_GetProblemInstances_Response_TypeSupportInterface_var _var_type;

                static Sample_GetProblemInstances_Response_TypeSupportInterface_ptr _duplicate (Sample_GetProblemInstances_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstances_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstances_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_GetProblemInstances_Response_TypeSupportInterface () {};
                ~Sample_GetProblemInstances_Response_TypeSupportInterface () {};
            private:
                Sample_GetProblemInstances_Response_TypeSupportInterface (const Sample_GetProblemInstances_Response_TypeSupportInterface &);
                Sample_GetProblemInstances_Response_TypeSupportInterface & operator = (const Sample_GetProblemInstances_Response_TypeSupportInterface &);
            };

            class  Sample_GetProblemInstances_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_GetProblemInstances_Response_DataWriter_ptr _ptr_type;
                typedef Sample_GetProblemInstances_Response_DataWriter_var _var_type;

                static Sample_GetProblemInstances_Response_DataWriter_ptr _duplicate (Sample_GetProblemInstances_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstances_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstances_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_GetProblemInstances_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_GetProblemInstances_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_GetProblemInstances_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_GetProblemInstances_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_GetProblemInstances_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_GetProblemInstances_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_GetProblemInstances_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_GetProblemInstances_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_GetProblemInstances_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_GetProblemInstances_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemInstances_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemInstances_Response_& instance_data) = 0;

            protected:
                Sample_GetProblemInstances_Response_DataWriter () {};
                ~Sample_GetProblemInstances_Response_DataWriter () {};
            private:
                Sample_GetProblemInstances_Response_DataWriter (const Sample_GetProblemInstances_Response_DataWriter &);
                Sample_GetProblemInstances_Response_DataWriter & operator = (const Sample_GetProblemInstances_Response_DataWriter &);
            };

            class  Sample_GetProblemInstances_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_GetProblemInstances_Response_DataReader_ptr _ptr_type;
                typedef Sample_GetProblemInstances_Response_DataReader_var _var_type;

                static Sample_GetProblemInstances_Response_DataReader_ptr _duplicate (Sample_GetProblemInstances_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstances_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstances_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemInstances_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemInstances_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemInstances_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemInstances_Response_& instance) = 0;

            protected:
                Sample_GetProblemInstances_Response_DataReader () {};
                ~Sample_GetProblemInstances_Response_DataReader () {};
            private:
                Sample_GetProblemInstances_Response_DataReader (const Sample_GetProblemInstances_Response_DataReader &);
                Sample_GetProblemInstances_Response_DataReader & operator = (const Sample_GetProblemInstances_Response_DataReader &);
            };

            class  Sample_GetProblemInstances_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_GetProblemInstances_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_GetProblemInstances_Response_DataReaderView_var _var_type;

                static Sample_GetProblemInstances_Response_DataReaderView_ptr _duplicate (Sample_GetProblemInstances_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_GetProblemInstances_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_GetProblemInstances_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_GetProblemInstances_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_GetProblemInstances_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_GetProblemInstances_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_GetProblemInstances_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_GetProblemInstances_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_GetProblemInstances_Response_& instance) = 0;

            protected:
                Sample_GetProblemInstances_Response_DataReaderView () {};
                ~Sample_GetProblemInstances_Response_DataReaderView () {};
            private:
                Sample_GetProblemInstances_Response_DataReaderView (const Sample_GetProblemInstances_Response_DataReaderView &);
                Sample_GetProblemInstances_Response_DataReaderView & operator = (const Sample_GetProblemInstances_Response_DataReaderView &);
            };
        }

    }

}

#endif
