#ifndef _H_ADD306C40AC3DF7CA4E90AA32D1864C7_GetProblemPredicateDetails__H_
#define _H_ADD306C40AC3DF7CA4E90AA32D1864C7_GetProblemPredicateDetails__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetProblemPredicateDetails_Request_
            {
                ::DDS::String_mgr predicate_;
            };

            typedef DDS_DCPSStruct_var<GetProblemPredicateDetails_Request_> GetProblemPredicateDetails_Request__var;
            typedef DDS_DCPSStruct_out < GetProblemPredicateDetails_Request_> GetProblemPredicateDetails_Request__out;

            struct  GetProblemPredicateDetails_Response_
            {
                struct _argument_params__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _argument_params__seq_uniq_ > _argument_params__seq;
                typedef DDS_DCPSUStrSeq_var< _argument_params__seq > _argument_params__seq_var;
                typedef DDS_DCPSUStrSeq_out< _argument_params__seq > _argument_params__seq_out;
                ::DDS::Boolean success_;
                _argument_params__seq argument_params_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<GetProblemPredicateDetails_Response_> GetProblemPredicateDetails_Response__var;
            typedef DDS_DCPSStruct_out < GetProblemPredicateDetails_Response_> GetProblemPredicateDetails_Response__out;

            struct  Sample_GetProblemPredicateDetails_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetProblemPredicateDetails_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetProblemPredicateDetails_Request_> Sample_GetProblemPredicateDetails_Request__var;
            typedef DDS_DCPSStruct_out < Sample_GetProblemPredicateDetails_Request_> Sample_GetProblemPredicateDetails_Request__out;

            struct  Sample_GetProblemPredicateDetails_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetProblemPredicateDetails_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetProblemPredicateDetails_Response_> Sample_GetProblemPredicateDetails_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetProblemPredicateDetails_Response_> Sample_GetProblemPredicateDetails_Response__out;

        }

    }

}

#endif /* _H_ADD306C40AC3DF7CA4E90AA32D1864C7_GetProblemPredicateDetails__H_ */
