#ifndef _H_4E9E96AF96218EA77108A9218262B526_GetProblemPredicates__H_
#define _H_4E9E96AF96218EA77108A9218262B526_GetProblemPredicates__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Empty_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetProblemPredicates_Request_
            {
                ::std_msgs::msg::dds_::Empty_ request_;
            };

            typedef DDS_DCPSStruct_var<GetProblemPredicates_Request_> GetProblemPredicates_Request__var;
            typedef GetProblemPredicates_Request_& GetProblemPredicates_Request__out;

            struct  GetProblemPredicates_Response_
            {
                struct _predicates__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _predicates__seq_uniq_ > _predicates__seq;
                typedef DDS_DCPSUStrSeq_var< _predicates__seq > _predicates__seq_var;
                typedef DDS_DCPSUStrSeq_out< _predicates__seq > _predicates__seq_out;
                ::DDS::Boolean success_;
                _predicates__seq predicates_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<GetProblemPredicates_Response_> GetProblemPredicates_Response__var;
            typedef DDS_DCPSStruct_out < GetProblemPredicates_Response_> GetProblemPredicates_Response__out;

            struct  Sample_GetProblemPredicates_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetProblemPredicates_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetProblemPredicates_Request_> Sample_GetProblemPredicates_Request__var;
            typedef Sample_GetProblemPredicates_Request_& Sample_GetProblemPredicates_Request__out;

            struct  Sample_GetProblemPredicates_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetProblemPredicates_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetProblemPredicates_Response_> Sample_GetProblemPredicates_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetProblemPredicates_Response_> Sample_GetProblemPredicates_Response__out;

        }

    }

}

#endif /* _H_4E9E96AF96218EA77108A9218262B526_GetProblemPredicates__H_ */
