#ifndef _H_B2A00693F8A3082B2928903C0AFFECB6_GetProblem__H_
#define _H_B2A00693F8A3082B2928903C0AFFECB6_GetProblem__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Empty_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  GetProblem_Request_
            {
                ::std_msgs::msg::dds_::Empty_ request_;
            };

            typedef DDS_DCPSStruct_var<GetProblem_Request_> GetProblem_Request__var;
            typedef GetProblem_Request_& GetProblem_Request__out;

            struct  GetProblem_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr problem_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<GetProblem_Response_> GetProblem_Response__var;
            typedef DDS_DCPSStruct_out < GetProblem_Response_> GetProblem_Response__out;

            struct  Sample_GetProblem_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetProblem_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetProblem_Request_> Sample_GetProblem_Request__var;
            typedef Sample_GetProblem_Request_& Sample_GetProblem_Request__out;

            struct  Sample_GetProblem_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::GetProblem_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_GetProblem_Response_> Sample_GetProblem_Response__var;
            typedef DDS_DCPSStruct_out < Sample_GetProblem_Response_> Sample_GetProblem_Response__out;

        }

    }

}

#endif /* _H_B2A00693F8A3082B2928903C0AFFECB6_GetProblem__H_ */
