#ifndef _H_8507BF1E07EEBBF24EDA265099FE8C95_RemoveProblemGoal_DCPS_H_
#define _H_8507BF1E07EEBBF24EDA265099FE8C95_RemoveProblemGoal_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RemoveProblemGoal_.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class RemoveProblemGoal_Request_TypeSupportInterface;

            typedef RemoveProblemGoal_Request_TypeSupportInterface * RemoveProblemGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RemoveProblemGoal_Request_TypeSupportInterface> RemoveProblemGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RemoveProblemGoal_Request_TypeSupportInterface> RemoveProblemGoal_Request_TypeSupportInterface_out;


            class RemoveProblemGoal_Request_DataWriter;

            typedef RemoveProblemGoal_Request_DataWriter * RemoveProblemGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RemoveProblemGoal_Request_DataWriter> RemoveProblemGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < RemoveProblemGoal_Request_DataWriter> RemoveProblemGoal_Request_DataWriter_out;


            class RemoveProblemGoal_Request_DataReader;

            typedef RemoveProblemGoal_Request_DataReader * RemoveProblemGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RemoveProblemGoal_Request_DataReader> RemoveProblemGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < RemoveProblemGoal_Request_DataReader> RemoveProblemGoal_Request_DataReader_out;


            class RemoveProblemGoal_Request_DataReaderView;

            typedef RemoveProblemGoal_Request_DataReaderView * RemoveProblemGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RemoveProblemGoal_Request_DataReaderView> RemoveProblemGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RemoveProblemGoal_Request_DataReaderView> RemoveProblemGoal_Request_DataReaderView_out;

            struct RemoveProblemGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < RemoveProblemGoal_Request_, struct RemoveProblemGoal_Request_Seq_uniq_> RemoveProblemGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < RemoveProblemGoal_Request_Seq> RemoveProblemGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < RemoveProblemGoal_Request_Seq> RemoveProblemGoal_Request_Seq_out;

            class  RemoveProblemGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RemoveProblemGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef RemoveProblemGoal_Request_TypeSupportInterface_var _var_type;

                static RemoveProblemGoal_Request_TypeSupportInterface_ptr _duplicate (RemoveProblemGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveProblemGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveProblemGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RemoveProblemGoal_Request_TypeSupportInterface () {};
                ~RemoveProblemGoal_Request_TypeSupportInterface () {};
            private:
                RemoveProblemGoal_Request_TypeSupportInterface (const RemoveProblemGoal_Request_TypeSupportInterface &);
                RemoveProblemGoal_Request_TypeSupportInterface & operator = (const RemoveProblemGoal_Request_TypeSupportInterface &);
            };

            class  RemoveProblemGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RemoveProblemGoal_Request_DataWriter_ptr _ptr_type;
                typedef RemoveProblemGoal_Request_DataWriter_var _var_type;

                static RemoveProblemGoal_Request_DataWriter_ptr _duplicate (RemoveProblemGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveProblemGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveProblemGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RemoveProblemGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RemoveProblemGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RemoveProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RemoveProblemGoal_Request_& instance_data) = 0;

            protected:
                RemoveProblemGoal_Request_DataWriter () {};
                ~RemoveProblemGoal_Request_DataWriter () {};
            private:
                RemoveProblemGoal_Request_DataWriter (const RemoveProblemGoal_Request_DataWriter &);
                RemoveProblemGoal_Request_DataWriter & operator = (const RemoveProblemGoal_Request_DataWriter &);
            };

            class  RemoveProblemGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RemoveProblemGoal_Request_DataReader_ptr _ptr_type;
                typedef RemoveProblemGoal_Request_DataReader_var _var_type;

                static RemoveProblemGoal_Request_DataReader_ptr _duplicate (RemoveProblemGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveProblemGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveProblemGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RemoveProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RemoveProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RemoveProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RemoveProblemGoal_Request_& instance) = 0;

            protected:
                RemoveProblemGoal_Request_DataReader () {};
                ~RemoveProblemGoal_Request_DataReader () {};
            private:
                RemoveProblemGoal_Request_DataReader (const RemoveProblemGoal_Request_DataReader &);
                RemoveProblemGoal_Request_DataReader & operator = (const RemoveProblemGoal_Request_DataReader &);
            };

            class  RemoveProblemGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RemoveProblemGoal_Request_DataReaderView_ptr _ptr_type;
                typedef RemoveProblemGoal_Request_DataReaderView_var _var_type;

                static RemoveProblemGoal_Request_DataReaderView_ptr _duplicate (RemoveProblemGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveProblemGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveProblemGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RemoveProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RemoveProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RemoveProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RemoveProblemGoal_Request_& instance) = 0;

            protected:
                RemoveProblemGoal_Request_DataReaderView () {};
                ~RemoveProblemGoal_Request_DataReaderView () {};
            private:
                RemoveProblemGoal_Request_DataReaderView (const RemoveProblemGoal_Request_DataReaderView &);
                RemoveProblemGoal_Request_DataReaderView & operator = (const RemoveProblemGoal_Request_DataReaderView &);
            };
            class RemoveProblemGoal_Response_TypeSupportInterface;

            typedef RemoveProblemGoal_Response_TypeSupportInterface * RemoveProblemGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RemoveProblemGoal_Response_TypeSupportInterface> RemoveProblemGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RemoveProblemGoal_Response_TypeSupportInterface> RemoveProblemGoal_Response_TypeSupportInterface_out;


            class RemoveProblemGoal_Response_DataWriter;

            typedef RemoveProblemGoal_Response_DataWriter * RemoveProblemGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RemoveProblemGoal_Response_DataWriter> RemoveProblemGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < RemoveProblemGoal_Response_DataWriter> RemoveProblemGoal_Response_DataWriter_out;


            class RemoveProblemGoal_Response_DataReader;

            typedef RemoveProblemGoal_Response_DataReader * RemoveProblemGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RemoveProblemGoal_Response_DataReader> RemoveProblemGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < RemoveProblemGoal_Response_DataReader> RemoveProblemGoal_Response_DataReader_out;


            class RemoveProblemGoal_Response_DataReaderView;

            typedef RemoveProblemGoal_Response_DataReaderView * RemoveProblemGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RemoveProblemGoal_Response_DataReaderView> RemoveProblemGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RemoveProblemGoal_Response_DataReaderView> RemoveProblemGoal_Response_DataReaderView_out;

            struct RemoveProblemGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RemoveProblemGoal_Response_, struct RemoveProblemGoal_Response_Seq_uniq_> RemoveProblemGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < RemoveProblemGoal_Response_Seq> RemoveProblemGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < RemoveProblemGoal_Response_Seq> RemoveProblemGoal_Response_Seq_out;

            class  RemoveProblemGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RemoveProblemGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef RemoveProblemGoal_Response_TypeSupportInterface_var _var_type;

                static RemoveProblemGoal_Response_TypeSupportInterface_ptr _duplicate (RemoveProblemGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveProblemGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveProblemGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RemoveProblemGoal_Response_TypeSupportInterface () {};
                ~RemoveProblemGoal_Response_TypeSupportInterface () {};
            private:
                RemoveProblemGoal_Response_TypeSupportInterface (const RemoveProblemGoal_Response_TypeSupportInterface &);
                RemoveProblemGoal_Response_TypeSupportInterface & operator = (const RemoveProblemGoal_Response_TypeSupportInterface &);
            };

            class  RemoveProblemGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RemoveProblemGoal_Response_DataWriter_ptr _ptr_type;
                typedef RemoveProblemGoal_Response_DataWriter_var _var_type;

                static RemoveProblemGoal_Response_DataWriter_ptr _duplicate (RemoveProblemGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveProblemGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveProblemGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RemoveProblemGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RemoveProblemGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RemoveProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RemoveProblemGoal_Response_& instance_data) = 0;

            protected:
                RemoveProblemGoal_Response_DataWriter () {};
                ~RemoveProblemGoal_Response_DataWriter () {};
            private:
                RemoveProblemGoal_Response_DataWriter (const RemoveProblemGoal_Response_DataWriter &);
                RemoveProblemGoal_Response_DataWriter & operator = (const RemoveProblemGoal_Response_DataWriter &);
            };

            class  RemoveProblemGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RemoveProblemGoal_Response_DataReader_ptr _ptr_type;
                typedef RemoveProblemGoal_Response_DataReader_var _var_type;

                static RemoveProblemGoal_Response_DataReader_ptr _duplicate (RemoveProblemGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveProblemGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveProblemGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RemoveProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RemoveProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RemoveProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RemoveProblemGoal_Response_& instance) = 0;

            protected:
                RemoveProblemGoal_Response_DataReader () {};
                ~RemoveProblemGoal_Response_DataReader () {};
            private:
                RemoveProblemGoal_Response_DataReader (const RemoveProblemGoal_Response_DataReader &);
                RemoveProblemGoal_Response_DataReader & operator = (const RemoveProblemGoal_Response_DataReader &);
            };

            class  RemoveProblemGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RemoveProblemGoal_Response_DataReaderView_ptr _ptr_type;
                typedef RemoveProblemGoal_Response_DataReaderView_var _var_type;

                static RemoveProblemGoal_Response_DataReaderView_ptr _duplicate (RemoveProblemGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveProblemGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveProblemGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveProblemGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RemoveProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RemoveProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RemoveProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RemoveProblemGoal_Response_& instance) = 0;

            protected:
                RemoveProblemGoal_Response_DataReaderView () {};
                ~RemoveProblemGoal_Response_DataReaderView () {};
            private:
                RemoveProblemGoal_Response_DataReaderView (const RemoveProblemGoal_Response_DataReaderView &);
                RemoveProblemGoal_Response_DataReaderView & operator = (const RemoveProblemGoal_Response_DataReaderView &);
            };
            class Sample_RemoveProblemGoal_Request_TypeSupportInterface;

            typedef Sample_RemoveProblemGoal_Request_TypeSupportInterface * Sample_RemoveProblemGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveProblemGoal_Request_TypeSupportInterface> Sample_RemoveProblemGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveProblemGoal_Request_TypeSupportInterface> Sample_RemoveProblemGoal_Request_TypeSupportInterface_out;


            class Sample_RemoveProblemGoal_Request_DataWriter;

            typedef Sample_RemoveProblemGoal_Request_DataWriter * Sample_RemoveProblemGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveProblemGoal_Request_DataWriter> Sample_RemoveProblemGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveProblemGoal_Request_DataWriter> Sample_RemoveProblemGoal_Request_DataWriter_out;


            class Sample_RemoveProblemGoal_Request_DataReader;

            typedef Sample_RemoveProblemGoal_Request_DataReader * Sample_RemoveProblemGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveProblemGoal_Request_DataReader> Sample_RemoveProblemGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveProblemGoal_Request_DataReader> Sample_RemoveProblemGoal_Request_DataReader_out;


            class Sample_RemoveProblemGoal_Request_DataReaderView;

            typedef Sample_RemoveProblemGoal_Request_DataReaderView * Sample_RemoveProblemGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveProblemGoal_Request_DataReaderView> Sample_RemoveProblemGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveProblemGoal_Request_DataReaderView> Sample_RemoveProblemGoal_Request_DataReaderView_out;

            struct Sample_RemoveProblemGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_RemoveProblemGoal_Request_, struct Sample_RemoveProblemGoal_Request_Seq_uniq_> Sample_RemoveProblemGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_RemoveProblemGoal_Request_Seq> Sample_RemoveProblemGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_RemoveProblemGoal_Request_Seq> Sample_RemoveProblemGoal_Request_Seq_out;

            class  Sample_RemoveProblemGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_RemoveProblemGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_RemoveProblemGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_RemoveProblemGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_RemoveProblemGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveProblemGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveProblemGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_RemoveProblemGoal_Request_TypeSupportInterface () {};
                ~Sample_RemoveProblemGoal_Request_TypeSupportInterface () {};
            private:
                Sample_RemoveProblemGoal_Request_TypeSupportInterface (const Sample_RemoveProblemGoal_Request_TypeSupportInterface &);
                Sample_RemoveProblemGoal_Request_TypeSupportInterface & operator = (const Sample_RemoveProblemGoal_Request_TypeSupportInterface &);
            };

            class  Sample_RemoveProblemGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_RemoveProblemGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_RemoveProblemGoal_Request_DataWriter_var _var_type;

                static Sample_RemoveProblemGoal_Request_DataWriter_ptr _duplicate (Sample_RemoveProblemGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveProblemGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveProblemGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_RemoveProblemGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_RemoveProblemGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_RemoveProblemGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_RemoveProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_RemoveProblemGoal_Request_& instance_data) = 0;

            protected:
                Sample_RemoveProblemGoal_Request_DataWriter () {};
                ~Sample_RemoveProblemGoal_Request_DataWriter () {};
            private:
                Sample_RemoveProblemGoal_Request_DataWriter (const Sample_RemoveProblemGoal_Request_DataWriter &);
                Sample_RemoveProblemGoal_Request_DataWriter & operator = (const Sample_RemoveProblemGoal_Request_DataWriter &);
            };

            class  Sample_RemoveProblemGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_RemoveProblemGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_RemoveProblemGoal_Request_DataReader_var _var_type;

                static Sample_RemoveProblemGoal_Request_DataReader_ptr _duplicate (Sample_RemoveProblemGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveProblemGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveProblemGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_RemoveProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_RemoveProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_RemoveProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_RemoveProblemGoal_Request_& instance) = 0;

            protected:
                Sample_RemoveProblemGoal_Request_DataReader () {};
                ~Sample_RemoveProblemGoal_Request_DataReader () {};
            private:
                Sample_RemoveProblemGoal_Request_DataReader (const Sample_RemoveProblemGoal_Request_DataReader &);
                Sample_RemoveProblemGoal_Request_DataReader & operator = (const Sample_RemoveProblemGoal_Request_DataReader &);
            };

            class  Sample_RemoveProblemGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_RemoveProblemGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_RemoveProblemGoal_Request_DataReaderView_var _var_type;

                static Sample_RemoveProblemGoal_Request_DataReaderView_ptr _duplicate (Sample_RemoveProblemGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveProblemGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveProblemGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_RemoveProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_RemoveProblemGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_RemoveProblemGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_RemoveProblemGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_RemoveProblemGoal_Request_& instance) = 0;

            protected:
                Sample_RemoveProblemGoal_Request_DataReaderView () {};
                ~Sample_RemoveProblemGoal_Request_DataReaderView () {};
            private:
                Sample_RemoveProblemGoal_Request_DataReaderView (const Sample_RemoveProblemGoal_Request_DataReaderView &);
                Sample_RemoveProblemGoal_Request_DataReaderView & operator = (const Sample_RemoveProblemGoal_Request_DataReaderView &);
            };
            class Sample_RemoveProblemGoal_Response_TypeSupportInterface;

            typedef Sample_RemoveProblemGoal_Response_TypeSupportInterface * Sample_RemoveProblemGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveProblemGoal_Response_TypeSupportInterface> Sample_RemoveProblemGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveProblemGoal_Response_TypeSupportInterface> Sample_RemoveProblemGoal_Response_TypeSupportInterface_out;


            class Sample_RemoveProblemGoal_Response_DataWriter;

            typedef Sample_RemoveProblemGoal_Response_DataWriter * Sample_RemoveProblemGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveProblemGoal_Response_DataWriter> Sample_RemoveProblemGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveProblemGoal_Response_DataWriter> Sample_RemoveProblemGoal_Response_DataWriter_out;


            class Sample_RemoveProblemGoal_Response_DataReader;

            typedef Sample_RemoveProblemGoal_Response_DataReader * Sample_RemoveProblemGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveProblemGoal_Response_DataReader> Sample_RemoveProblemGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveProblemGoal_Response_DataReader> Sample_RemoveProblemGoal_Response_DataReader_out;


            class Sample_RemoveProblemGoal_Response_DataReaderView;

            typedef Sample_RemoveProblemGoal_Response_DataReaderView * Sample_RemoveProblemGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveProblemGoal_Response_DataReaderView> Sample_RemoveProblemGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveProblemGoal_Response_DataReaderView> Sample_RemoveProblemGoal_Response_DataReaderView_out;

            struct Sample_RemoveProblemGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_RemoveProblemGoal_Response_, struct Sample_RemoveProblemGoal_Response_Seq_uniq_> Sample_RemoveProblemGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_RemoveProblemGoal_Response_Seq> Sample_RemoveProblemGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_RemoveProblemGoal_Response_Seq> Sample_RemoveProblemGoal_Response_Seq_out;

            class  Sample_RemoveProblemGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_RemoveProblemGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_RemoveProblemGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_RemoveProblemGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_RemoveProblemGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveProblemGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveProblemGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_RemoveProblemGoal_Response_TypeSupportInterface () {};
                ~Sample_RemoveProblemGoal_Response_TypeSupportInterface () {};
            private:
                Sample_RemoveProblemGoal_Response_TypeSupportInterface (const Sample_RemoveProblemGoal_Response_TypeSupportInterface &);
                Sample_RemoveProblemGoal_Response_TypeSupportInterface & operator = (const Sample_RemoveProblemGoal_Response_TypeSupportInterface &);
            };

            class  Sample_RemoveProblemGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_RemoveProblemGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_RemoveProblemGoal_Response_DataWriter_var _var_type;

                static Sample_RemoveProblemGoal_Response_DataWriter_ptr _duplicate (Sample_RemoveProblemGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveProblemGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveProblemGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_RemoveProblemGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_RemoveProblemGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_RemoveProblemGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_RemoveProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_RemoveProblemGoal_Response_& instance_data) = 0;

            protected:
                Sample_RemoveProblemGoal_Response_DataWriter () {};
                ~Sample_RemoveProblemGoal_Response_DataWriter () {};
            private:
                Sample_RemoveProblemGoal_Response_DataWriter (const Sample_RemoveProblemGoal_Response_DataWriter &);
                Sample_RemoveProblemGoal_Response_DataWriter & operator = (const Sample_RemoveProblemGoal_Response_DataWriter &);
            };

            class  Sample_RemoveProblemGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_RemoveProblemGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_RemoveProblemGoal_Response_DataReader_var _var_type;

                static Sample_RemoveProblemGoal_Response_DataReader_ptr _duplicate (Sample_RemoveProblemGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveProblemGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveProblemGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_RemoveProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_RemoveProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_RemoveProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_RemoveProblemGoal_Response_& instance) = 0;

            protected:
                Sample_RemoveProblemGoal_Response_DataReader () {};
                ~Sample_RemoveProblemGoal_Response_DataReader () {};
            private:
                Sample_RemoveProblemGoal_Response_DataReader (const Sample_RemoveProblemGoal_Response_DataReader &);
                Sample_RemoveProblemGoal_Response_DataReader & operator = (const Sample_RemoveProblemGoal_Response_DataReader &);
            };

            class  Sample_RemoveProblemGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_RemoveProblemGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_RemoveProblemGoal_Response_DataReaderView_var _var_type;

                static Sample_RemoveProblemGoal_Response_DataReaderView_ptr _duplicate (Sample_RemoveProblemGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveProblemGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveProblemGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveProblemGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_RemoveProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_RemoveProblemGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_RemoveProblemGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_RemoveProblemGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_RemoveProblemGoal_Response_& instance) = 0;

            protected:
                Sample_RemoveProblemGoal_Response_DataReaderView () {};
                ~Sample_RemoveProblemGoal_Response_DataReaderView () {};
            private:
                Sample_RemoveProblemGoal_Response_DataReaderView (const Sample_RemoveProblemGoal_Response_DataReaderView &);
                Sample_RemoveProblemGoal_Response_DataReaderView & operator = (const Sample_RemoveProblemGoal_Response_DataReaderView &);
            };
        }

    }

}

#endif
