#ifndef _H_FD5854963CECF53C43BDFBF3CD089876_RemoveProblemInstance__H_
#define _H_FD5854963CECF53C43BDFBF3CD089876_RemoveProblemInstance__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  RemoveProblemInstance_Request_
            {
                ::DDS::String_mgr instance_;
            };

            typedef DDS_DCPSStruct_var<RemoveProblemInstance_Request_> RemoveProblemInstance_Request__var;
            typedef DDS_DCPSStruct_out < RemoveProblemInstance_Request_> RemoveProblemInstance_Request__out;

            struct  RemoveProblemInstance_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<RemoveProblemInstance_Response_> RemoveProblemInstance_Response__var;
            typedef DDS_DCPSStruct_out < RemoveProblemInstance_Response_> RemoveProblemInstance_Response__out;

            struct  Sample_RemoveProblemInstance_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::RemoveProblemInstance_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_RemoveProblemInstance_Request_> Sample_RemoveProblemInstance_Request__var;
            typedef DDS_DCPSStruct_out < Sample_RemoveProblemInstance_Request_> Sample_RemoveProblemInstance_Request__out;

            struct  Sample_RemoveProblemInstance_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::RemoveProblemInstance_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_RemoveProblemInstance_Response_> Sample_RemoveProblemInstance_Response__var;
            typedef DDS_DCPSStruct_out < Sample_RemoveProblemInstance_Response_> Sample_RemoveProblemInstance_Response__out;

        }

    }

}

#endif /* _H_FD5854963CECF53C43BDFBF3CD089876_RemoveProblemInstance__H_ */
