#ifndef _H_9D9C0460CAA34A8942B0D121CA9D505A_RemoveProblemPredicate__H_
#define _H_9D9C0460CAA34A8942B0D121CA9D505A_RemoveProblemPredicate__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace plansys2_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  RemoveProblemPredicate_Request_
            {
                struct _arguments__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _arguments__seq_uniq_ > _arguments__seq;
                typedef DDS_DCPSUStrSeq_var< _arguments__seq > _arguments__seq_var;
                typedef DDS_DCPSUStrSeq_out< _arguments__seq > _arguments__seq_out;
                ::DDS::String_mgr predicate_;
                _arguments__seq arguments_;
            };

            typedef DDS_DCPSStruct_var<RemoveProblemPredicate_Request_> RemoveProblemPredicate_Request__var;
            typedef DDS_DCPSStruct_out < RemoveProblemPredicate_Request_> RemoveProblemPredicate_Request__out;

            struct  RemoveProblemPredicate_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr error_info_;
            };

            typedef DDS_DCPSStruct_var<RemoveProblemPredicate_Response_> RemoveProblemPredicate_Response__var;
            typedef DDS_DCPSStruct_out < RemoveProblemPredicate_Response_> RemoveProblemPredicate_Response__out;

            struct  Sample_RemoveProblemPredicate_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::RemoveProblemPredicate_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_RemoveProblemPredicate_Request_> Sample_RemoveProblemPredicate_Request__var;
            typedef DDS_DCPSStruct_out < Sample_RemoveProblemPredicate_Request_> Sample_RemoveProblemPredicate_Request__out;

            struct  Sample_RemoveProblemPredicate_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::plansys2_msgs::srv::dds_::RemoveProblemPredicate_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_RemoveProblemPredicate_Response_> Sample_RemoveProblemPredicate_Response__var;
            typedef DDS_DCPSStruct_out < Sample_RemoveProblemPredicate_Response_> Sample_RemoveProblemPredicate_Response__out;

        }

    }

}

#endif /* _H_9D9C0460CAA34A8942B0D121CA9D505A_RemoveProblemPredicate__H_ */
